# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.2
# *
# * Copyright © 2017. Benoit Michau. ANSSI.
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License
# * as published by the Free Software Foundation; either version 2
# * of the License, or (at your option) any later version.
# * 
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# * 
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# * 02110-1301, USA.
# *
# *--------------------------------------------------------
# * File Name : pycrate_csndir/msnetcap.py
# * Created : 2017-06-15
# * Authors : Benoit Michau 
# *--------------------------------------------------------
#*/

# MS network capability
# TS 24.008, 10.5.5.12

# code automatically generated by pycrate_csn1
# change object type with type=T_BYTES
# add dict for value interpretation with dict={...}

from pycrate_csn1.csnobj import *

spare_bit = CSN1Bit(name='spare_bit')
Spare_bit = spare_bit
Spare_Bit = spare_bit
spare_bits = CSN1Bit(name='spare_bits', num=-1)
Spare_bits = spare_bits
Spare_Bits = spare_bits

GEA1_bits = CSN1Bit(name='GEA1_bits', root=True)

Extended_GEA_bits = CSN1List(name='Extended_GEA_bits', root=True, list=[
  CSN1Bit(name='GEA_2'),
  CSN1Bit(name='GEA_3'),
  CSN1Bit(name='GEA_4'),
  CSN1Bit(name='GEA_5'),
  CSN1Bit(name='GEA_6'),
  CSN1Bit(name='GEA_7')])

MS_network_capability_value_part = CSN1List(name='MS_network_capability_value_part', root=True, list=[
  CSN1Ref(obj=GEA1_bits),
  CSN1Bit(name='SM_capabilities_via_dedicated_channels'),
  CSN1Bit(name='SM_capabilities_via_GPRS_channels'),
  CSN1Bit(name='UCS2_support'),
  CSN1Bit(name='SS_Screening_Indicator', bit=2),
  CSN1Bit(name='SoLSA_Capability'),
  CSN1Bit(name='Revision_level_indicator'),
  CSN1Bit(name='PFC_feature_mode'),
  CSN1Ref(obj=Extended_GEA_bits),
  CSN1Bit(name='LCS_VA_capability'),
  CSN1Bit(name='PS_inter_RAT_HO_from_GERAN_to_UTRAN_Iu_mode_capability'),
  CSN1Bit(name='PS_inter_RAT_HO_from_GERAN_to_E_UTRAN_S1_mode_capability'),
  CSN1Bit(name='EMM_Combined_procedures_Capability'),
  CSN1Bit(name='ISR_support'),
  CSN1Bit(name='SRVCC_to_GERAN_UTRAN_capability'),
  CSN1Bit(name='EPC_capability'),
  CSN1Bit(name='NF_capability'),
  CSN1Bit(name='GERAN_network_sharing_capability'),
  CSN1Bit(name='User_plane_integrity_protection_support'),
  CSN1Bit(name='GIA_4'),
  CSN1Bit(name='GIA_5'),
  CSN1Bit(name='GIA_6'),
  CSN1Bit(name='GIA_7'),
  CSN1Ref(obj=Spare_bits)])
