# -*- coding: UTF-8 -*-
#/**
# * Software Name : pycrate
# * Version : 0.2
# *
# * Copyright © 2017. Benoit Michau. ANSSI.
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License
# * as published by the Free Software Foundation; either version 2
# * of the License, or (at your option) any later version.
# * 
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# * 
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# * 02110-1301, USA.
# *
# *--------------------------------------------------------
# * File Name : pycrate_csndir/rcvnpdunumlist.py
# * Created : 2017-06-15
# * Authors : Benoit Michau 
# *--------------------------------------------------------
#*/

# Receive N‑PDU Numbers list
# TS 24.008, 10.5.5.11

# code automatically generated by pycrate_csn1
# change object type with type=T_BYTES
# add dict for value interpretation with dict={...}

from pycrate_csn1.csnobj import *

spare_bit = CSN1Bit(name='spare_bit')
Spare_bit = spare_bit
Spare_Bit = spare_bit
spare_bits = CSN1Bit(name='spare_bits', num=-1)
Spare_bits = spare_bits
Spare_Bits = spare_bits

Receive_N_PDU_Number_value = CSN1Alt(name='Receive_N_PDU_Number_value', root=True, num=8, alt={
  '1': ('', []),
  '0': ('', [])})

nsapi = CSN1Alt(name='nsapi', klen=4, alt={
  '0110': ('', []),
  '0111': ('', []),
  '1011': ('', []),
  '0101': ('', []),
  '1100': ('', []),
  '1111': ('', []),
  '1110': ('', []),
  '1000': ('', []),
  '1010': ('', []),
  '1101': ('', []),
  '1001': ('', [])})

Receive_N_PDU_Number_list = CSN1List(name='Receive_N_PDU_Number_list', root=True, list=[
  CSN1Bit(name='sapi', bit=4),
  CSN1Bit(name='Receive_N_PDU_Number_value', bit=8),
  CSN1Alt(klen=0, alt={
    '': ('Receive N-PDU Number-list', [
    CSN1SelfRef()]),
    None: ('null', [])})])

Padding_bits = CSN1Alt(name='Padding_bits', klen=4, alt={
  '0000': ('', []),
  None: ('', [])})

Receive_N_PDU_Number_list_value = CSN1List(name='Receive_N_PDU_Number_list_value', root=True, list=[
  CSN1Ref(obj=Receive_N_PDU_Number_list),
  CSN1Ref(obj=Padding_bits)])

