# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class X2AP_CommonDataTypes:

    _name_  = u'X2AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 3]
    
    _obj_ = [
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class X2AP_Constants:

    _name_  = u'X2AP-Constants'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 4]
    
    _obj_ = [
        u'id-handoverPreparation',
        u'id-handoverCancel',
        u'id-loadIndication',
        u'id-errorIndication',
        u'id-snStatusTransfer',
        u'id-uEContextRelease',
        u'id-x2Setup',
        u'id-reset',
        u'id-eNBConfigurationUpdate',
        u'id-resourceStatusReportingInitiation',
        u'id-resourceStatusReporting',
        u'id-privateMessage',
        u'id-mobilitySettingsChange',
        u'id-rLFIndication',
        u'id-handoverReport',
        u'id-cellActivation',
        u'id-x2Release',
        u'id-x2APMessageTransfer',
        u'id-x2Removal',
        u'id-seNBAdditionPreparation',
        u'id-seNBReconfigurationCompletion',
        u'id-meNBinitiatedSeNBModificationPreparation',
        u'id-seNBinitiatedSeNBModification',
        u'id-meNBinitiatedSeNBRelease',
        u'id-seNBinitiatedSeNBRelease',
        u'id-seNBCounterCheck',
        u'id-retrieveUEContext',
        u'maxEARFCN',
        u'maxEARFCNPlusOne',
        u'newmaxEARFCN',
        u'maxInterfaces',
        u'maxCellineNB',
        u'maxnoofBands',
        u'maxnoofBearers',
        u'maxNrOfErrors',
        u'maxnoofPDCP-SN',
        u'maxnoofEPLMNs',
        u'maxnoofEPLMNsPlusOne',
        u'maxnoofForbLACs',
        u'maxnoofForbTACs',
        u'maxnoofBPLMNs',
        u'maxnoofNeighbours',
        u'maxnoofPRBs',
        u'maxPools',
        u'maxnoofCells',
        u'maxnoofMBSFN',
        u'maxFailedMeasObjects',
        u'maxnoofCellIDforMDT',
        u'maxnoofTAforMDT',
        u'maxnoofMBMSServiceAreaIdentities',
        u'maxnoofMDTPLMNs',
        u'maxnoofCoMPHypothesisSet',
        u'maxnoofCoMPCells',
        u'maxUEReport',
        u'maxCellReport',
        u'maxnoofPA',
        u'maxCSIProcess',
        u'maxCSIReport',
        u'maxSubband',
        u'id-E-RABs-Admitted-Item',
        u'id-E-RABs-Admitted-List',
        u'id-E-RAB-Item',
        u'id-E-RABs-NotAdmitted-List',
        u'id-E-RABs-ToBeSetup-Item',
        u'id-Cause',
        u'id-CellInformation',
        u'id-CellInformation-Item',
        u'id-New-eNB-UE-X2AP-ID',
        u'id-Old-eNB-UE-X2AP-ID',
        u'id-TargetCell-ID',
        u'id-TargeteNBtoSource-eNBTransparentContainer',
        u'id-TraceActivation',
        u'id-UE-ContextInformation',
        u'id-UE-HistoryInformation',
        u'id-UE-X2AP-ID',
        u'id-CriticalityDiagnostics',
        u'id-E-RABs-SubjectToStatusTransfer-List',
        u'id-E-RABs-SubjectToStatusTransfer-Item',
        u'id-ServedCells',
        u'id-GlobalENB-ID',
        u'id-TimeToWait',
        u'id-GUMMEI-ID',
        u'id-GUGroupIDList',
        u'id-ServedCellsToAdd',
        u'id-ServedCellsToModify',
        u'id-ServedCellsToDelete',
        u'id-Registration-Request',
        u'id-CellToReport',
        u'id-ReportingPeriodicity',
        u'id-CellToReport-Item',
        u'id-CellMeasurementResult',
        u'id-CellMeasurementResult-Item',
        u'id-GUGroupIDToAddList',
        u'id-GUGroupIDToDeleteList',
        u'id-SRVCCOperationPossible',
        u'id-Measurement-ID',
        u'id-ReportCharacteristics',
        u'id-ENB1-Measurement-ID',
        u'id-ENB2-Measurement-ID',
        u'id-Number-of-Antennaports',
        u'id-CompositeAvailableCapacityGroup',
        u'id-ENB1-Cell-ID',
        u'id-ENB2-Cell-ID',
        u'id-ENB2-Proposed-Mobility-Parameters',
        u'id-ENB1-Mobility-Parameters',
        u'id-ENB2-Mobility-Parameters-Modification-Range',
        u'id-FailureCellPCI',
        u'id-Re-establishmentCellECGI',
        u'id-FailureCellCRNTI',
        u'id-ShortMAC-I',
        u'id-SourceCellECGI',
        u'id-FailureCellECGI',
        u'id-HandoverReportType',
        u'id-PRACH-Configuration',
        u'id-MBSFN-Subframe-Info',
        u'id-ServedCellsToActivate',
        u'id-ActivatedCellList',
        u'id-DeactivationIndication',
        u'id-UE-RLF-Report-Container',
        u'id-ABSInformation',
        u'id-InvokeIndication',
        u'id-ABS-Status',
        u'id-PartialSuccessIndicator',
        u'id-MeasurementInitiationResult-List',
        u'id-MeasurementInitiationResult-Item',
        u'id-MeasurementFailureCause-Item',
        u'id-CompleteFailureCauseInformation-List',
        u'id-CompleteFailureCauseInformation-Item',
        u'id-CSG-Id',
        u'id-CSGMembershipStatus',
        u'id-MDTConfiguration',
        u'id-ManagementBasedMDTallowed',
        u'id-RRCConnSetupIndicator',
        u'id-NeighbourTAC',
        u'id-Time-UE-StayedInCell-EnhancedGranularity',
        u'id-RRCConnReestabIndicator',
        u'id-MBMS-Service-Area-List',
        u'id-HO-cause',
        u'id-TargetCellInUTRAN',
        u'id-MobilityInformation',
        u'id-SourceCellCRNTI',
        u'id-MultibandInfoList',
        u'id-M3Configuration',
        u'id-M4Configuration',
        u'id-M5Configuration',
        u'id-MDT-Location-Info',
        u'id-ManagementBasedMDTPLMNList',
        u'id-SignallingBasedMDTPLMNList',
        u'id-ReceiveStatusOfULPDCPSDUsExtended',
        u'id-ULCOUNTValueExtended',
        u'id-DLCOUNTValueExtended',
        u'id-eARFCNExtension',
        u'id-UL-EARFCNExtension',
        u'id-DL-EARFCNExtension',
        u'id-AdditionalSpecialSubframe-Info',
        u'id-Masked-IMEISV',
        u'id-IntendedULDLConfiguration',
        u'id-ExtendedULInterferenceOverloadInfo',
        u'id-RNL-Header',
        u'id-x2APMessage',
        u'id-ProSeAuthorized',
        u'id-ExpectedUEBehaviour',
        u'id-UE-HistoryInformationFromTheUE',
        u'id-DynamicDLTransmissionInformation',
        u'id-UE-RLF-Report-Container-for-extended-bands',
        u'id-CoMPInformation',
        u'id-ReportingPeriodicityRSRPMR',
        u'id-RSRPMRList',
        u'id-MeNB-UE-X2AP-ID',
        u'id-SeNB-UE-X2AP-ID',
        u'id-UE-SecurityCapabilities',
        u'id-SeNBSecurityKey',
        u'id-SeNBUEAggregateMaximumBitRate',
        u'id-ServingPLMN',
        u'id-E-RABs-ToBeAdded-List',
        u'id-E-RABs-ToBeAdded-Item',
        u'id-MeNBtoSeNBContainer',
        u'id-E-RABs-Admitted-ToBeAdded-List',
        u'id-E-RABs-Admitted-ToBeAdded-Item',
        u'id-SeNBtoMeNBContainer',
        u'id-ResponseInformationSeNBReconfComp',
        u'id-UE-ContextInformationSeNBModReq',
        u'id-E-RABs-ToBeAdded-ModReqItem',
        u'id-E-RABs-ToBeModified-ModReqItem',
        u'id-E-RABs-ToBeReleased-ModReqItem',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckList',
        u'id-E-RABs-Admitted-ToBeModified-ModAckList',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckList',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'id-E-RABs-Admitted-ToBeModified-ModAckItem',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckItem',
        u'id-E-RABs-ToBeReleased-ModReqd',
        u'id-E-RABs-ToBeReleased-ModReqdItem',
        u'id-SCGChangeIndication',
        u'id-E-RABs-ToBeReleased-List-RelReq',
        u'id-E-RABs-ToBeReleased-RelReqItem',
        u'id-E-RABs-ToBeReleased-List-RelConf',
        u'id-E-RABs-ToBeReleased-RelConfItem',
        u'id-E-RABs-SubjectToCounterCheck-List',
        u'id-E-RABs-SubjectToCounterCheckItem',
        u'id-CoverageModificationList',
        u'id-ReportingPeriodicityCSIR',
        u'id-CSIReportList',
        u'id-UEID',
        u'id-enhancedRNTP',
        u'id-ProSeUEtoNetworkRelaying',
        u'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'id-ULCOUNTValuePDCP-SNlength18',
        u'id-DLCOUNTValuePDCP-SNlength18',
        u'id-UE-ContextReferenceAtSeNB',
        u'id-UE-ContextKeptIndicator',
        u'id-New-eNB-UE-X2AP-ID-Extension',
        u'id-Old-eNB-UE-X2AP-ID-Extension',
        u'id-MeNB-UE-X2AP-ID-Extension',
        u'id-SeNB-UE-X2AP-ID-Extension',
        u'id-LHN-ID',
        u'id-FreqBandIndicatorPriority',
        u'id-M6Configuration',
        u'id-M7Configuration',
        u'id-Tunnel-Information-for-BBF',
        u'id-SIPTO-BearerDeactivationIndication',
        u'id-GW-TransportLayerAddress',
        u'id-Correlation-ID',
        u'id-SIPTO-Correlation-ID',
        u'id-SIPTO-L-GW-TransportLayerAddress',
        u'id-X2RemovalThreshold',
        u'id-CellReportingIndicator',
        u'id-BearerType',
        u'id-resumeID',
        u'id-UE-ContextInformationRetrieve',
        u'id-E-RABs-ToBeSetupRetrieve-Item',
        u'id-NewEUTRANCellIdentifier',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-handoverPreparation',
        u'id-handoverCancel',
        u'id-loadIndication',
        u'id-errorIndication',
        u'id-snStatusTransfer',
        u'id-uEContextRelease',
        u'id-x2Setup',
        u'id-reset',
        u'id-eNBConfigurationUpdate',
        u'id-resourceStatusReportingInitiation',
        u'id-resourceStatusReporting',
        u'id-privateMessage',
        u'id-mobilitySettingsChange',
        u'id-rLFIndication',
        u'id-handoverReport',
        u'id-cellActivation',
        u'id-x2Release',
        u'id-x2APMessageTransfer',
        u'id-x2Removal',
        u'id-seNBAdditionPreparation',
        u'id-seNBReconfigurationCompletion',
        u'id-meNBinitiatedSeNBModificationPreparation',
        u'id-seNBinitiatedSeNBModification',
        u'id-meNBinitiatedSeNBRelease',
        u'id-seNBinitiatedSeNBRelease',
        u'id-seNBCounterCheck',
        u'id-retrieveUEContext',
        u'maxEARFCN',
        u'maxEARFCNPlusOne',
        u'newmaxEARFCN',
        u'maxInterfaces',
        u'maxCellineNB',
        u'maxnoofBands',
        u'maxnoofBearers',
        u'maxNrOfErrors',
        u'maxnoofPDCP-SN',
        u'maxnoofEPLMNs',
        u'maxnoofEPLMNsPlusOne',
        u'maxnoofForbLACs',
        u'maxnoofForbTACs',
        u'maxnoofBPLMNs',
        u'maxnoofNeighbours',
        u'maxnoofPRBs',
        u'maxPools',
        u'maxnoofCells',
        u'maxnoofMBSFN',
        u'maxFailedMeasObjects',
        u'maxnoofCellIDforMDT',
        u'maxnoofTAforMDT',
        u'maxnoofMBMSServiceAreaIdentities',
        u'maxnoofMDTPLMNs',
        u'maxnoofCoMPHypothesisSet',
        u'maxnoofCoMPCells',
        u'maxUEReport',
        u'maxCellReport',
        u'maxnoofPA',
        u'maxCSIProcess',
        u'maxCSIReport',
        u'maxSubband',
        u'id-E-RABs-Admitted-Item',
        u'id-E-RABs-Admitted-List',
        u'id-E-RAB-Item',
        u'id-E-RABs-NotAdmitted-List',
        u'id-E-RABs-ToBeSetup-Item',
        u'id-Cause',
        u'id-CellInformation',
        u'id-CellInformation-Item',
        u'id-New-eNB-UE-X2AP-ID',
        u'id-Old-eNB-UE-X2AP-ID',
        u'id-TargetCell-ID',
        u'id-TargeteNBtoSource-eNBTransparentContainer',
        u'id-TraceActivation',
        u'id-UE-ContextInformation',
        u'id-UE-HistoryInformation',
        u'id-UE-X2AP-ID',
        u'id-CriticalityDiagnostics',
        u'id-E-RABs-SubjectToStatusTransfer-List',
        u'id-E-RABs-SubjectToStatusTransfer-Item',
        u'id-ServedCells',
        u'id-GlobalENB-ID',
        u'id-TimeToWait',
        u'id-GUMMEI-ID',
        u'id-GUGroupIDList',
        u'id-ServedCellsToAdd',
        u'id-ServedCellsToModify',
        u'id-ServedCellsToDelete',
        u'id-Registration-Request',
        u'id-CellToReport',
        u'id-ReportingPeriodicity',
        u'id-CellToReport-Item',
        u'id-CellMeasurementResult',
        u'id-CellMeasurementResult-Item',
        u'id-GUGroupIDToAddList',
        u'id-GUGroupIDToDeleteList',
        u'id-SRVCCOperationPossible',
        u'id-Measurement-ID',
        u'id-ReportCharacteristics',
        u'id-ENB1-Measurement-ID',
        u'id-ENB2-Measurement-ID',
        u'id-Number-of-Antennaports',
        u'id-CompositeAvailableCapacityGroup',
        u'id-ENB1-Cell-ID',
        u'id-ENB2-Cell-ID',
        u'id-ENB2-Proposed-Mobility-Parameters',
        u'id-ENB1-Mobility-Parameters',
        u'id-ENB2-Mobility-Parameters-Modification-Range',
        u'id-FailureCellPCI',
        u'id-Re-establishmentCellECGI',
        u'id-FailureCellCRNTI',
        u'id-ShortMAC-I',
        u'id-SourceCellECGI',
        u'id-FailureCellECGI',
        u'id-HandoverReportType',
        u'id-PRACH-Configuration',
        u'id-MBSFN-Subframe-Info',
        u'id-ServedCellsToActivate',
        u'id-ActivatedCellList',
        u'id-DeactivationIndication',
        u'id-UE-RLF-Report-Container',
        u'id-ABSInformation',
        u'id-InvokeIndication',
        u'id-ABS-Status',
        u'id-PartialSuccessIndicator',
        u'id-MeasurementInitiationResult-List',
        u'id-MeasurementInitiationResult-Item',
        u'id-MeasurementFailureCause-Item',
        u'id-CompleteFailureCauseInformation-List',
        u'id-CompleteFailureCauseInformation-Item',
        u'id-CSG-Id',
        u'id-CSGMembershipStatus',
        u'id-MDTConfiguration',
        u'id-ManagementBasedMDTallowed',
        u'id-RRCConnSetupIndicator',
        u'id-NeighbourTAC',
        u'id-Time-UE-StayedInCell-EnhancedGranularity',
        u'id-RRCConnReestabIndicator',
        u'id-MBMS-Service-Area-List',
        u'id-HO-cause',
        u'id-TargetCellInUTRAN',
        u'id-MobilityInformation',
        u'id-SourceCellCRNTI',
        u'id-MultibandInfoList',
        u'id-M3Configuration',
        u'id-M4Configuration',
        u'id-M5Configuration',
        u'id-MDT-Location-Info',
        u'id-ManagementBasedMDTPLMNList',
        u'id-SignallingBasedMDTPLMNList',
        u'id-ReceiveStatusOfULPDCPSDUsExtended',
        u'id-ULCOUNTValueExtended',
        u'id-DLCOUNTValueExtended',
        u'id-eARFCNExtension',
        u'id-UL-EARFCNExtension',
        u'id-DL-EARFCNExtension',
        u'id-AdditionalSpecialSubframe-Info',
        u'id-Masked-IMEISV',
        u'id-IntendedULDLConfiguration',
        u'id-ExtendedULInterferenceOverloadInfo',
        u'id-RNL-Header',
        u'id-x2APMessage',
        u'id-ProSeAuthorized',
        u'id-ExpectedUEBehaviour',
        u'id-UE-HistoryInformationFromTheUE',
        u'id-DynamicDLTransmissionInformation',
        u'id-UE-RLF-Report-Container-for-extended-bands',
        u'id-CoMPInformation',
        u'id-ReportingPeriodicityRSRPMR',
        u'id-RSRPMRList',
        u'id-MeNB-UE-X2AP-ID',
        u'id-SeNB-UE-X2AP-ID',
        u'id-UE-SecurityCapabilities',
        u'id-SeNBSecurityKey',
        u'id-SeNBUEAggregateMaximumBitRate',
        u'id-ServingPLMN',
        u'id-E-RABs-ToBeAdded-List',
        u'id-E-RABs-ToBeAdded-Item',
        u'id-MeNBtoSeNBContainer',
        u'id-E-RABs-Admitted-ToBeAdded-List',
        u'id-E-RABs-Admitted-ToBeAdded-Item',
        u'id-SeNBtoMeNBContainer',
        u'id-ResponseInformationSeNBReconfComp',
        u'id-UE-ContextInformationSeNBModReq',
        u'id-E-RABs-ToBeAdded-ModReqItem',
        u'id-E-RABs-ToBeModified-ModReqItem',
        u'id-E-RABs-ToBeReleased-ModReqItem',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckList',
        u'id-E-RABs-Admitted-ToBeModified-ModAckList',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckList',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'id-E-RABs-Admitted-ToBeModified-ModAckItem',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckItem',
        u'id-E-RABs-ToBeReleased-ModReqd',
        u'id-E-RABs-ToBeReleased-ModReqdItem',
        u'id-SCGChangeIndication',
        u'id-E-RABs-ToBeReleased-List-RelReq',
        u'id-E-RABs-ToBeReleased-RelReqItem',
        u'id-E-RABs-ToBeReleased-List-RelConf',
        u'id-E-RABs-ToBeReleased-RelConfItem',
        u'id-E-RABs-SubjectToCounterCheck-List',
        u'id-E-RABs-SubjectToCounterCheckItem',
        u'id-CoverageModificationList',
        u'id-ReportingPeriodicityCSIR',
        u'id-CSIReportList',
        u'id-UEID',
        u'id-enhancedRNTP',
        u'id-ProSeUEtoNetworkRelaying',
        u'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'id-ULCOUNTValuePDCP-SNlength18',
        u'id-DLCOUNTValuePDCP-SNlength18',
        u'id-UE-ContextReferenceAtSeNB',
        u'id-UE-ContextKeptIndicator',
        u'id-New-eNB-UE-X2AP-ID-Extension',
        u'id-Old-eNB-UE-X2AP-ID-Extension',
        u'id-MeNB-UE-X2AP-ID-Extension',
        u'id-SeNB-UE-X2AP-ID-Extension',
        u'id-LHN-ID',
        u'id-FreqBandIndicatorPriority',
        u'id-M6Configuration',
        u'id-M7Configuration',
        u'id-Tunnel-Information-for-BBF',
        u'id-SIPTO-BearerDeactivationIndication',
        u'id-GW-TransportLayerAddress',
        u'id-Correlation-ID',
        u'id-SIPTO-Correlation-ID',
        u'id-SIPTO-L-GW-TransportLayerAddress',
        u'id-X2RemovalThreshold',
        u'id-CellReportingIndicator',
        u'id-BearerType',
        u'id-resumeID',
        u'id-UE-ContextInformationRetrieve',
        u'id-E-RABs-ToBeSetupRetrieve-Item',
        u'id-NewEUTRANCellIdentifier',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-handoverPreparation >-----#
    id_handoverPreparation = INT(name=u'id-handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverPreparation._val = 0
    
    #-----< id-handoverCancel >-----#
    id_handoverCancel = INT(name=u'id-handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverCancel._val = 1
    
    #-----< id-loadIndication >-----#
    id_loadIndication = INT(name=u'id-loadIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_loadIndication._val = 2
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name=u'id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 3
    
    #-----< id-snStatusTransfer >-----#
    id_snStatusTransfer = INT(name=u'id-snStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_snStatusTransfer._val = 4
    
    #-----< id-uEContextRelease >-----#
    id_uEContextRelease = INT(name=u'id-uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_uEContextRelease._val = 5
    
    #-----< id-x2Setup >-----#
    id_x2Setup = INT(name=u'id-x2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2Setup._val = 6
    
    #-----< id-reset >-----#
    id_reset = INT(name=u'id-reset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_reset._val = 7
    
    #-----< id-eNBConfigurationUpdate >-----#
    id_eNBConfigurationUpdate = INT(name=u'id-eNBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBConfigurationUpdate._val = 8
    
    #-----< id-resourceStatusReportingInitiation >-----#
    id_resourceStatusReportingInitiation = INT(name=u'id-resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReportingInitiation._val = 9
    
    #-----< id-resourceStatusReporting >-----#
    id_resourceStatusReporting = INT(name=u'id-resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReporting._val = 10
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name=u'id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 11
    
    #-----< id-mobilitySettingsChange >-----#
    id_mobilitySettingsChange = INT(name=u'id-mobilitySettingsChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_mobilitySettingsChange._val = 12
    
    #-----< id-rLFIndication >-----#
    id_rLFIndication = INT(name=u'id-rLFIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_rLFIndication._val = 13
    
    #-----< id-handoverReport >-----#
    id_handoverReport = INT(name=u'id-handoverReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverReport._val = 14
    
    #-----< id-cellActivation >-----#
    id_cellActivation = INT(name=u'id-cellActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_cellActivation._val = 15
    
    #-----< id-x2Release >-----#
    id_x2Release = INT(name=u'id-x2Release', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2Release._val = 16
    
    #-----< id-x2APMessageTransfer >-----#
    id_x2APMessageTransfer = INT(name=u'id-x2APMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2APMessageTransfer._val = 17
    
    #-----< id-x2Removal >-----#
    id_x2Removal = INT(name=u'id-x2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2Removal._val = 18
    
    #-----< id-seNBAdditionPreparation >-----#
    id_seNBAdditionPreparation = INT(name=u'id-seNBAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBAdditionPreparation._val = 19
    
    #-----< id-seNBReconfigurationCompletion >-----#
    id_seNBReconfigurationCompletion = INT(name=u'id-seNBReconfigurationCompletion', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBReconfigurationCompletion._val = 20
    
    #-----< id-meNBinitiatedSeNBModificationPreparation >-----#
    id_meNBinitiatedSeNBModificationPreparation = INT(name=u'id-meNBinitiatedSeNBModificationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_meNBinitiatedSeNBModificationPreparation._val = 21
    
    #-----< id-seNBinitiatedSeNBModification >-----#
    id_seNBinitiatedSeNBModification = INT(name=u'id-seNBinitiatedSeNBModification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBinitiatedSeNBModification._val = 22
    
    #-----< id-meNBinitiatedSeNBRelease >-----#
    id_meNBinitiatedSeNBRelease = INT(name=u'id-meNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_meNBinitiatedSeNBRelease._val = 23
    
    #-----< id-seNBinitiatedSeNBRelease >-----#
    id_seNBinitiatedSeNBRelease = INT(name=u'id-seNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBinitiatedSeNBRelease._val = 24
    
    #-----< id-seNBCounterCheck >-----#
    id_seNBCounterCheck = INT(name=u'id-seNBCounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBCounterCheck._val = 25
    
    #-----< id-retrieveUEContext >-----#
    id_retrieveUEContext = INT(name=u'id-retrieveUEContext', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_retrieveUEContext._val = 26
    
    #-----< maxEARFCN >-----#
    maxEARFCN = INT(name=u'maxEARFCN', mode=MODE_VALUE)
    maxEARFCN._val = 65535
    
    #-----< maxEARFCNPlusOne >-----#
    maxEARFCNPlusOne = INT(name=u'maxEARFCNPlusOne', mode=MODE_VALUE)
    maxEARFCNPlusOne._val = 65536
    
    #-----< newmaxEARFCN >-----#
    newmaxEARFCN = INT(name=u'newmaxEARFCN', mode=MODE_VALUE)
    newmaxEARFCN._val = 262143
    
    #-----< maxInterfaces >-----#
    maxInterfaces = INT(name=u'maxInterfaces', mode=MODE_VALUE)
    maxInterfaces._val = 16
    
    #-----< maxCellineNB >-----#
    maxCellineNB = INT(name=u'maxCellineNB', mode=MODE_VALUE)
    maxCellineNB._val = 256
    
    #-----< maxnoofBands >-----#
    maxnoofBands = INT(name=u'maxnoofBands', mode=MODE_VALUE)
    maxnoofBands._val = 16
    
    #-----< maxnoofBearers >-----#
    maxnoofBearers = INT(name=u'maxnoofBearers', mode=MODE_VALUE)
    maxnoofBearers._val = 256
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name=u'maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxnoofPDCP-SN >-----#
    maxnoofPDCP_SN = INT(name=u'maxnoofPDCP-SN', mode=MODE_VALUE)
    maxnoofPDCP_SN._val = 16
    
    #-----< maxnoofEPLMNs >-----#
    maxnoofEPLMNs = INT(name=u'maxnoofEPLMNs', mode=MODE_VALUE)
    maxnoofEPLMNs._val = 15
    
    #-----< maxnoofEPLMNsPlusOne >-----#
    maxnoofEPLMNsPlusOne = INT(name=u'maxnoofEPLMNsPlusOne', mode=MODE_VALUE)
    maxnoofEPLMNsPlusOne._val = 16
    
    #-----< maxnoofForbLACs >-----#
    maxnoofForbLACs = INT(name=u'maxnoofForbLACs', mode=MODE_VALUE)
    maxnoofForbLACs._val = 4096
    
    #-----< maxnoofForbTACs >-----#
    maxnoofForbTACs = INT(name=u'maxnoofForbTACs', mode=MODE_VALUE)
    maxnoofForbTACs._val = 4096
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name=u'maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 6
    
    #-----< maxnoofNeighbours >-----#
    maxnoofNeighbours = INT(name=u'maxnoofNeighbours', mode=MODE_VALUE)
    maxnoofNeighbours._val = 512
    
    #-----< maxnoofPRBs >-----#
    maxnoofPRBs = INT(name=u'maxnoofPRBs', mode=MODE_VALUE)
    maxnoofPRBs._val = 110
    
    #-----< maxPools >-----#
    maxPools = INT(name=u'maxPools', mode=MODE_VALUE)
    maxPools._val = 16
    
    #-----< maxnoofCells >-----#
    maxnoofCells = INT(name=u'maxnoofCells', mode=MODE_VALUE)
    maxnoofCells._val = 16
    
    #-----< maxnoofMBSFN >-----#
    maxnoofMBSFN = INT(name=u'maxnoofMBSFN', mode=MODE_VALUE)
    maxnoofMBSFN._val = 8
    
    #-----< maxFailedMeasObjects >-----#
    maxFailedMeasObjects = INT(name=u'maxFailedMeasObjects', mode=MODE_VALUE)
    maxFailedMeasObjects._val = 32
    
    #-----< maxnoofCellIDforMDT >-----#
    maxnoofCellIDforMDT = INT(name=u'maxnoofCellIDforMDT', mode=MODE_VALUE)
    maxnoofCellIDforMDT._val = 32
    
    #-----< maxnoofTAforMDT >-----#
    maxnoofTAforMDT = INT(name=u'maxnoofTAforMDT', mode=MODE_VALUE)
    maxnoofTAforMDT._val = 8
    
    #-----< maxnoofMBMSServiceAreaIdentities >-----#
    maxnoofMBMSServiceAreaIdentities = INT(name=u'maxnoofMBMSServiceAreaIdentities', mode=MODE_VALUE)
    maxnoofMBMSServiceAreaIdentities._val = 256
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name=u'maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofCoMPHypothesisSet >-----#
    maxnoofCoMPHypothesisSet = INT(name=u'maxnoofCoMPHypothesisSet', mode=MODE_VALUE)
    maxnoofCoMPHypothesisSet._val = 256
    
    #-----< maxnoofCoMPCells >-----#
    maxnoofCoMPCells = INT(name=u'maxnoofCoMPCells', mode=MODE_VALUE)
    maxnoofCoMPCells._val = 32
    
    #-----< maxUEReport >-----#
    maxUEReport = INT(name=u'maxUEReport', mode=MODE_VALUE)
    maxUEReport._val = 128
    
    #-----< maxCellReport >-----#
    maxCellReport = INT(name=u'maxCellReport', mode=MODE_VALUE)
    maxCellReport._val = 9
    
    #-----< maxnoofPA >-----#
    maxnoofPA = INT(name=u'maxnoofPA', mode=MODE_VALUE)
    maxnoofPA._val = 3
    
    #-----< maxCSIProcess >-----#
    maxCSIProcess = INT(name=u'maxCSIProcess', mode=MODE_VALUE)
    maxCSIProcess._val = 4
    
    #-----< maxCSIReport >-----#
    maxCSIReport = INT(name=u'maxCSIReport', mode=MODE_VALUE)
    maxCSIReport._val = 2
    
    #-----< maxSubband >-----#
    maxSubband = INT(name=u'maxSubband', mode=MODE_VALUE)
    maxSubband._val = 14
    
    #-----< id-E-RABs-Admitted-Item >-----#
    id_E_RABs_Admitted_Item = INT(name=u'id-E-RABs-Admitted-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_Item._val = 0
    
    #-----< id-E-RABs-Admitted-List >-----#
    id_E_RABs_Admitted_List = INT(name=u'id-E-RABs-Admitted-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_List._val = 1
    
    #-----< id-E-RAB-Item >-----#
    id_E_RAB_Item = INT(name=u'id-E-RAB-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RAB_Item._val = 2
    
    #-----< id-E-RABs-NotAdmitted-List >-----#
    id_E_RABs_NotAdmitted_List = INT(name=u'id-E-RABs-NotAdmitted-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_NotAdmitted_List._val = 3
    
    #-----< id-E-RABs-ToBeSetup-Item >-----#
    id_E_RABs_ToBeSetup_Item = INT(name=u'id-E-RABs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeSetup_Item._val = 4
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 5
    
    #-----< id-CellInformation >-----#
    id_CellInformation = INT(name=u'id-CellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellInformation._val = 6
    
    #-----< id-CellInformation-Item >-----#
    id_CellInformation_Item = INT(name=u'id-CellInformation-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellInformation_Item._val = 7
    
    #-----< id-New-eNB-UE-X2AP-ID >-----#
    id_New_eNB_UE_X2AP_ID = INT(name=u'id-New-eNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_New_eNB_UE_X2AP_ID._val = 9
    
    #-----< id-Old-eNB-UE-X2AP-ID >-----#
    id_Old_eNB_UE_X2AP_ID = INT(name=u'id-Old-eNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Old_eNB_UE_X2AP_ID._val = 10
    
    #-----< id-TargetCell-ID >-----#
    id_TargetCell_ID = INT(name=u'id-TargetCell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetCell_ID._val = 11
    
    #-----< id-TargeteNBtoSource-eNBTransparentContainer >-----#
    id_TargeteNBtoSource_eNBTransparentContainer = INT(name=u'id-TargeteNBtoSource-eNBTransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargeteNBtoSource_eNBTransparentContainer._val = 12
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name=u'id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 13
    
    #-----< id-UE-ContextInformation >-----#
    id_UE_ContextInformation = INT(name=u'id-UE-ContextInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformation._val = 14
    
    #-----< id-UE-HistoryInformation >-----#
    id_UE_HistoryInformation = INT(name=u'id-UE-HistoryInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_HistoryInformation._val = 15
    
    #-----< id-UE-X2AP-ID >-----#
    id_UE_X2AP_ID = INT(name=u'id-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_X2AP_ID._val = 16
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 17
    
    #-----< id-E-RABs-SubjectToStatusTransfer-List >-----#
    id_E_RABs_SubjectToStatusTransfer_List = INT(name=u'id-E-RABs-SubjectToStatusTransfer-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToStatusTransfer_List._val = 18
    
    #-----< id-E-RABs-SubjectToStatusTransfer-Item >-----#
    id_E_RABs_SubjectToStatusTransfer_Item = INT(name=u'id-E-RABs-SubjectToStatusTransfer-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToStatusTransfer_Item._val = 19
    
    #-----< id-ServedCells >-----#
    id_ServedCells = INT(name=u'id-ServedCells', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCells._val = 20
    
    #-----< id-GlobalENB-ID >-----#
    id_GlobalENB_ID = INT(name=u'id-GlobalENB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalENB_ID._val = 21
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name=u'id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 22
    
    #-----< id-GUMMEI-ID >-----#
    id_GUMMEI_ID = INT(name=u'id-GUMMEI-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEI_ID._val = 23
    
    #-----< id-GUGroupIDList >-----#
    id_GUGroupIDList = INT(name=u'id-GUGroupIDList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUGroupIDList._val = 24
    
    #-----< id-ServedCellsToAdd >-----#
    id_ServedCellsToAdd = INT(name=u'id-ServedCellsToAdd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToAdd._val = 25
    
    #-----< id-ServedCellsToModify >-----#
    id_ServedCellsToModify = INT(name=u'id-ServedCellsToModify', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToModify._val = 26
    
    #-----< id-ServedCellsToDelete >-----#
    id_ServedCellsToDelete = INT(name=u'id-ServedCellsToDelete', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToDelete._val = 27
    
    #-----< id-Registration-Request >-----#
    id_Registration_Request = INT(name=u'id-Registration-Request', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Registration_Request._val = 28
    
    #-----< id-CellToReport >-----#
    id_CellToReport = INT(name=u'id-CellToReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport._val = 29
    
    #-----< id-ReportingPeriodicity >-----#
    id_ReportingPeriodicity = INT(name=u'id-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicity._val = 30
    
    #-----< id-CellToReport-Item >-----#
    id_CellToReport_Item = INT(name=u'id-CellToReport-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport_Item._val = 31
    
    #-----< id-CellMeasurementResult >-----#
    id_CellMeasurementResult = INT(name=u'id-CellMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult._val = 32
    
    #-----< id-CellMeasurementResult-Item >-----#
    id_CellMeasurementResult_Item = INT(name=u'id-CellMeasurementResult-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult_Item._val = 33
    
    #-----< id-GUGroupIDToAddList >-----#
    id_GUGroupIDToAddList = INT(name=u'id-GUGroupIDToAddList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUGroupIDToAddList._val = 34
    
    #-----< id-GUGroupIDToDeleteList >-----#
    id_GUGroupIDToDeleteList = INT(name=u'id-GUGroupIDToDeleteList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUGroupIDToDeleteList._val = 35
    
    #-----< id-SRVCCOperationPossible >-----#
    id_SRVCCOperationPossible = INT(name=u'id-SRVCCOperationPossible', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationPossible._val = 36
    
    #-----< id-Measurement-ID >-----#
    id_Measurement_ID = INT(name=u'id-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Measurement_ID._val = 37
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name=u'id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 38
    
    #-----< id-ENB1-Measurement-ID >-----#
    id_ENB1_Measurement_ID = INT(name=u'id-ENB1-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB1_Measurement_ID._val = 39
    
    #-----< id-ENB2-Measurement-ID >-----#
    id_ENB2_Measurement_ID = INT(name=u'id-ENB2-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Measurement_ID._val = 40
    
    #-----< id-Number-of-Antennaports >-----#
    id_Number_of_Antennaports = INT(name=u'id-Number-of-Antennaports', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Number_of_Antennaports._val = 41
    
    #-----< id-CompositeAvailableCapacityGroup >-----#
    id_CompositeAvailableCapacityGroup = INT(name=u'id-CompositeAvailableCapacityGroup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompositeAvailableCapacityGroup._val = 42
    
    #-----< id-ENB1-Cell-ID >-----#
    id_ENB1_Cell_ID = INT(name=u'id-ENB1-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB1_Cell_ID._val = 43
    
    #-----< id-ENB2-Cell-ID >-----#
    id_ENB2_Cell_ID = INT(name=u'id-ENB2-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Cell_ID._val = 44
    
    #-----< id-ENB2-Proposed-Mobility-Parameters >-----#
    id_ENB2_Proposed_Mobility_Parameters = INT(name=u'id-ENB2-Proposed-Mobility-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Proposed_Mobility_Parameters._val = 45
    
    #-----< id-ENB1-Mobility-Parameters >-----#
    id_ENB1_Mobility_Parameters = INT(name=u'id-ENB1-Mobility-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB1_Mobility_Parameters._val = 46
    
    #-----< id-ENB2-Mobility-Parameters-Modification-Range >-----#
    id_ENB2_Mobility_Parameters_Modification_Range = INT(name=u'id-ENB2-Mobility-Parameters-Modification-Range', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Mobility_Parameters_Modification_Range._val = 47
    
    #-----< id-FailureCellPCI >-----#
    id_FailureCellPCI = INT(name=u'id-FailureCellPCI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FailureCellPCI._val = 48
    
    #-----< id-Re-establishmentCellECGI >-----#
    id_Re_establishmentCellECGI = INT(name=u'id-Re-establishmentCellECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Re_establishmentCellECGI._val = 49
    
    #-----< id-FailureCellCRNTI >-----#
    id_FailureCellCRNTI = INT(name=u'id-FailureCellCRNTI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FailureCellCRNTI._val = 50
    
    #-----< id-ShortMAC-I >-----#
    id_ShortMAC_I = INT(name=u'id-ShortMAC-I', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ShortMAC_I._val = 51
    
    #-----< id-SourceCellECGI >-----#
    id_SourceCellECGI = INT(name=u'id-SourceCellECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceCellECGI._val = 52
    
    #-----< id-FailureCellECGI >-----#
    id_FailureCellECGI = INT(name=u'id-FailureCellECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FailureCellECGI._val = 53
    
    #-----< id-HandoverReportType >-----#
    id_HandoverReportType = INT(name=u'id-HandoverReportType', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverReportType._val = 54
    
    #-----< id-PRACH-Configuration >-----#
    id_PRACH_Configuration = INT(name=u'id-PRACH-Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_Configuration._val = 55
    
    #-----< id-MBSFN-Subframe-Info >-----#
    id_MBSFN_Subframe_Info = INT(name=u'id-MBSFN-Subframe-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Subframe_Info._val = 56
    
    #-----< id-ServedCellsToActivate >-----#
    id_ServedCellsToActivate = INT(name=u'id-ServedCellsToActivate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToActivate._val = 57
    
    #-----< id-ActivatedCellList >-----#
    id_ActivatedCellList = INT(name=u'id-ActivatedCellList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivatedCellList._val = 58
    
    #-----< id-DeactivationIndication >-----#
    id_DeactivationIndication = INT(name=u'id-DeactivationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DeactivationIndication._val = 59
    
    #-----< id-UE-RLF-Report-Container >-----#
    id_UE_RLF_Report_Container = INT(name=u'id-UE-RLF-Report-Container', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RLF_Report_Container._val = 60
    
    #-----< id-ABSInformation >-----#
    id_ABSInformation = INT(name=u'id-ABSInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ABSInformation._val = 61
    
    #-----< id-InvokeIndication >-----#
    id_InvokeIndication = INT(name=u'id-InvokeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InvokeIndication._val = 62
    
    #-----< id-ABS-Status >-----#
    id_ABS_Status = INT(name=u'id-ABS-Status', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ABS_Status._val = 63
    
    #-----< id-PartialSuccessIndicator >-----#
    id_PartialSuccessIndicator = INT(name=u'id-PartialSuccessIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PartialSuccessIndicator._val = 64
    
    #-----< id-MeasurementInitiationResult-List >-----#
    id_MeasurementInitiationResult_List = INT(name=u'id-MeasurementInitiationResult-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementInitiationResult_List._val = 65
    
    #-----< id-MeasurementInitiationResult-Item >-----#
    id_MeasurementInitiationResult_Item = INT(name=u'id-MeasurementInitiationResult-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementInitiationResult_Item._val = 66
    
    #-----< id-MeasurementFailureCause-Item >-----#
    id_MeasurementFailureCause_Item = INT(name=u'id-MeasurementFailureCause-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementFailureCause_Item._val = 67
    
    #-----< id-CompleteFailureCauseInformation-List >-----#
    id_CompleteFailureCauseInformation_List = INT(name=u'id-CompleteFailureCauseInformation-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompleteFailureCauseInformation_List._val = 68
    
    #-----< id-CompleteFailureCauseInformation-Item >-----#
    id_CompleteFailureCauseInformation_Item = INT(name=u'id-CompleteFailureCauseInformation-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompleteFailureCauseInformation_Item._val = 69
    
    #-----< id-CSG-Id >-----#
    id_CSG_Id = INT(name=u'id-CSG-Id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_Id._val = 70
    
    #-----< id-CSGMembershipStatus >-----#
    id_CSGMembershipStatus = INT(name=u'id-CSGMembershipStatus', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipStatus._val = 71
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name=u'id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 72
    
    #-----< id-ManagementBasedMDTallowed >-----#
    id_ManagementBasedMDTallowed = INT(name=u'id-ManagementBasedMDTallowed', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTallowed._val = 74
    
    #-----< id-RRCConnSetupIndicator >-----#
    id_RRCConnSetupIndicator = INT(name=u'id-RRCConnSetupIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCConnSetupIndicator._val = 75
    
    #-----< id-NeighbourTAC >-----#
    id_NeighbourTAC = INT(name=u'id-NeighbourTAC', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbourTAC._val = 76
    
    #-----< id-Time-UE-StayedInCell-EnhancedGranularity >-----#
    id_Time_UE_StayedInCell_EnhancedGranularity = INT(name=u'id-Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_UE_StayedInCell_EnhancedGranularity._val = 77
    
    #-----< id-RRCConnReestabIndicator >-----#
    id_RRCConnReestabIndicator = INT(name=u'id-RRCConnReestabIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCConnReestabIndicator._val = 78
    
    #-----< id-MBMS-Service-Area-List >-----#
    id_MBMS_Service_Area_List = INT(name=u'id-MBMS-Service-Area-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Service_Area_List._val = 79
    
    #-----< id-HO-cause >-----#
    id_HO_cause = INT(name=u'id-HO-cause', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HO_cause._val = 80
    
    #-----< id-TargetCellInUTRAN >-----#
    id_TargetCellInUTRAN = INT(name=u'id-TargetCellInUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetCellInUTRAN._val = 81
    
    #-----< id-MobilityInformation >-----#
    id_MobilityInformation = INT(name=u'id-MobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilityInformation._val = 82
    
    #-----< id-SourceCellCRNTI >-----#
    id_SourceCellCRNTI = INT(name=u'id-SourceCellCRNTI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceCellCRNTI._val = 83
    
    #-----< id-MultibandInfoList >-----#
    id_MultibandInfoList = INT(name=u'id-MultibandInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultibandInfoList._val = 84
    
    #-----< id-M3Configuration >-----#
    id_M3Configuration = INT(name=u'id-M3Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M3Configuration._val = 85
    
    #-----< id-M4Configuration >-----#
    id_M4Configuration = INT(name=u'id-M4Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M4Configuration._val = 86
    
    #-----< id-M5Configuration >-----#
    id_M5Configuration = INT(name=u'id-M5Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M5Configuration._val = 87
    
    #-----< id-MDT-Location-Info >-----#
    id_MDT_Location_Info = INT(name=u'id-MDT-Location-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDT_Location_Info._val = 88
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name=u'id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 89
    
    #-----< id-SignallingBasedMDTPLMNList >-----#
    id_SignallingBasedMDTPLMNList = INT(name=u'id-SignallingBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SignallingBasedMDTPLMNList._val = 90
    
    #-----< id-ReceiveStatusOfULPDCPSDUsExtended >-----#
    id_ReceiveStatusOfULPDCPSDUsExtended = INT(name=u'id-ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsExtended._val = 91
    
    #-----< id-ULCOUNTValueExtended >-----#
    id_ULCOUNTValueExtended = INT(name=u'id-ULCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValueExtended._val = 92
    
    #-----< id-DLCOUNTValueExtended >-----#
    id_DLCOUNTValueExtended = INT(name=u'id-DLCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValueExtended._val = 93
    
    #-----< id-eARFCNExtension >-----#
    id_eARFCNExtension = INT(name=u'id-eARFCNExtension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eARFCNExtension._val = 94
    
    #-----< id-UL-EARFCNExtension >-----#
    id_UL_EARFCNExtension = INT(name=u'id-UL-EARFCNExtension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_EARFCNExtension._val = 95
    
    #-----< id-DL-EARFCNExtension >-----#
    id_DL_EARFCNExtension = INT(name=u'id-DL-EARFCNExtension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_EARFCNExtension._val = 96
    
    #-----< id-AdditionalSpecialSubframe-Info >-----#
    id_AdditionalSpecialSubframe_Info = INT(name=u'id-AdditionalSpecialSubframe-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalSpecialSubframe_Info._val = 97
    
    #-----< id-Masked-IMEISV >-----#
    id_Masked_IMEISV = INT(name=u'id-Masked-IMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Masked_IMEISV._val = 98
    
    #-----< id-IntendedULDLConfiguration >-----#
    id_IntendedULDLConfiguration = INT(name=u'id-IntendedULDLConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntendedULDLConfiguration._val = 99
    
    #-----< id-ExtendedULInterferenceOverloadInfo >-----#
    id_ExtendedULInterferenceOverloadInfo = INT(name=u'id-ExtendedULInterferenceOverloadInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedULInterferenceOverloadInfo._val = 100
    
    #-----< id-RNL-Header >-----#
    id_RNL_Header = INT(name=u'id-RNL-Header', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RNL_Header._val = 101
    
    #-----< id-x2APMessage >-----#
    id_x2APMessage = INT(name=u'id-x2APMessage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_x2APMessage._val = 102
    
    #-----< id-ProSeAuthorized >-----#
    id_ProSeAuthorized = INT(name=u'id-ProSeAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeAuthorized._val = 103
    
    #-----< id-ExpectedUEBehaviour >-----#
    id_ExpectedUEBehaviour = INT(name=u'id-ExpectedUEBehaviour', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExpectedUEBehaviour._val = 104
    
    #-----< id-UE-HistoryInformationFromTheUE >-----#
    id_UE_HistoryInformationFromTheUE = INT(name=u'id-UE-HistoryInformationFromTheUE', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_HistoryInformationFromTheUE._val = 105
    
    #-----< id-DynamicDLTransmissionInformation >-----#
    id_DynamicDLTransmissionInformation = INT(name=u'id-DynamicDLTransmissionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DynamicDLTransmissionInformation._val = 106
    
    #-----< id-UE-RLF-Report-Container-for-extended-bands >-----#
    id_UE_RLF_Report_Container_for_extended_bands = INT(name=u'id-UE-RLF-Report-Container-for-extended-bands', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RLF_Report_Container_for_extended_bands._val = 107
    
    #-----< id-CoMPInformation >-----#
    id_CoMPInformation = INT(name=u'id-CoMPInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoMPInformation._val = 108
    
    #-----< id-ReportingPeriodicityRSRPMR >-----#
    id_ReportingPeriodicityRSRPMR = INT(name=u'id-ReportingPeriodicityRSRPMR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicityRSRPMR._val = 109
    
    #-----< id-RSRPMRList >-----#
    id_RSRPMRList = INT(name=u'id-RSRPMRList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RSRPMRList._val = 110
    
    #-----< id-MeNB-UE-X2AP-ID >-----#
    id_MeNB_UE_X2AP_ID = INT(name=u'id-MeNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNB_UE_X2AP_ID._val = 111
    
    #-----< id-SeNB-UE-X2AP-ID >-----#
    id_SeNB_UE_X2AP_ID = INT(name=u'id-SeNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNB_UE_X2AP_ID._val = 112
    
    #-----< id-UE-SecurityCapabilities >-----#
    id_UE_SecurityCapabilities = INT(name=u'id-UE-SecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_SecurityCapabilities._val = 113
    
    #-----< id-SeNBSecurityKey >-----#
    id_SeNBSecurityKey = INT(name=u'id-SeNBSecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNBSecurityKey._val = 114
    
    #-----< id-SeNBUEAggregateMaximumBitRate >-----#
    id_SeNBUEAggregateMaximumBitRate = INT(name=u'id-SeNBUEAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNBUEAggregateMaximumBitRate._val = 115
    
    #-----< id-ServingPLMN >-----#
    id_ServingPLMN = INT(name=u'id-ServingPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingPLMN._val = 116
    
    #-----< id-E-RABs-ToBeAdded-List >-----#
    id_E_RABs_ToBeAdded_List = INT(name=u'id-E-RABs-ToBeAdded-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_List._val = 117
    
    #-----< id-E-RABs-ToBeAdded-Item >-----#
    id_E_RABs_ToBeAdded_Item = INT(name=u'id-E-RABs-ToBeAdded-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_Item._val = 118
    
    #-----< id-MeNBtoSeNBContainer >-----#
    id_MeNBtoSeNBContainer = INT(name=u'id-MeNBtoSeNBContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNBtoSeNBContainer._val = 119
    
    #-----< id-E-RABs-Admitted-ToBeAdded-List >-----#
    id_E_RABs_Admitted_ToBeAdded_List = INT(name=u'id-E-RABs-Admitted-ToBeAdded-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_List._val = 120
    
    #-----< id-E-RABs-Admitted-ToBeAdded-Item >-----#
    id_E_RABs_Admitted_ToBeAdded_Item = INT(name=u'id-E-RABs-Admitted-ToBeAdded-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_Item._val = 121
    
    #-----< id-SeNBtoMeNBContainer >-----#
    id_SeNBtoMeNBContainer = INT(name=u'id-SeNBtoMeNBContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNBtoMeNBContainer._val = 122
    
    #-----< id-ResponseInformationSeNBReconfComp >-----#
    id_ResponseInformationSeNBReconfComp = INT(name=u'id-ResponseInformationSeNBReconfComp', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResponseInformationSeNBReconfComp._val = 123
    
    #-----< id-UE-ContextInformationSeNBModReq >-----#
    id_UE_ContextInformationSeNBModReq = INT(name=u'id-UE-ContextInformationSeNBModReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformationSeNBModReq._val = 124
    
    #-----< id-E-RABs-ToBeAdded-ModReqItem >-----#
    id_E_RABs_ToBeAdded_ModReqItem = INT(name=u'id-E-RABs-ToBeAdded-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_ModReqItem._val = 125
    
    #-----< id-E-RABs-ToBeModified-ModReqItem >-----#
    id_E_RABs_ToBeModified_ModReqItem = INT(name=u'id-E-RABs-ToBeModified-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_ModReqItem._val = 126
    
    #-----< id-E-RABs-ToBeReleased-ModReqItem >-----#
    id_E_RABs_ToBeReleased_ModReqItem = INT(name=u'id-E-RABs-ToBeReleased-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqItem._val = 127
    
    #-----< id-E-RABs-Admitted-ToBeAdded-ModAckList >-----#
    id_E_RABs_Admitted_ToBeAdded_ModAckList = INT(name=u'id-E-RABs-Admitted-ToBeAdded-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_ModAckList._val = 128
    
    #-----< id-E-RABs-Admitted-ToBeModified-ModAckList >-----#
    id_E_RABs_Admitted_ToBeModified_ModAckList = INT(name=u'id-E-RABs-Admitted-ToBeModified-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_ModAckList._val = 129
    
    #-----< id-E-RABs-Admitted-ToBeReleased-ModAckList >-----#
    id_E_RABs_Admitted_ToBeReleased_ModAckList = INT(name=u'id-E-RABs-Admitted-ToBeReleased-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_ModAckList._val = 130
    
    #-----< id-E-RABs-Admitted-ToBeAdded-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeAdded_ModAckItem = INT(name=u'id-E-RABs-Admitted-ToBeAdded-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_ModAckItem._val = 131
    
    #-----< id-E-RABs-Admitted-ToBeModified-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeModified_ModAckItem = INT(name=u'id-E-RABs-Admitted-ToBeModified-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_ModAckItem._val = 132
    
    #-----< id-E-RABs-Admitted-ToBeReleased-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeReleased_ModAckItem = INT(name=u'id-E-RABs-Admitted-ToBeReleased-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_ModAckItem._val = 133
    
    #-----< id-E-RABs-ToBeReleased-ModReqd >-----#
    id_E_RABs_ToBeReleased_ModReqd = INT(name=u'id-E-RABs-ToBeReleased-ModReqd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqd._val = 134
    
    #-----< id-E-RABs-ToBeReleased-ModReqdItem >-----#
    id_E_RABs_ToBeReleased_ModReqdItem = INT(name=u'id-E-RABs-ToBeReleased-ModReqdItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqdItem._val = 135
    
    #-----< id-SCGChangeIndication >-----#
    id_SCGChangeIndication = INT(name=u'id-SCGChangeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGChangeIndication._val = 136
    
    #-----< id-E-RABs-ToBeReleased-List-RelReq >-----#
    id_E_RABs_ToBeReleased_List_RelReq = INT(name=u'id-E-RABs-ToBeReleased-List-RelReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_List_RelReq._val = 137
    
    #-----< id-E-RABs-ToBeReleased-RelReqItem >-----#
    id_E_RABs_ToBeReleased_RelReqItem = INT(name=u'id-E-RABs-ToBeReleased-RelReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_RelReqItem._val = 138
    
    #-----< id-E-RABs-ToBeReleased-List-RelConf >-----#
    id_E_RABs_ToBeReleased_List_RelConf = INT(name=u'id-E-RABs-ToBeReleased-List-RelConf', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_List_RelConf._val = 139
    
    #-----< id-E-RABs-ToBeReleased-RelConfItem >-----#
    id_E_RABs_ToBeReleased_RelConfItem = INT(name=u'id-E-RABs-ToBeReleased-RelConfItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_RelConfItem._val = 140
    
    #-----< id-E-RABs-SubjectToCounterCheck-List >-----#
    id_E_RABs_SubjectToCounterCheck_List = INT(name=u'id-E-RABs-SubjectToCounterCheck-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToCounterCheck_List._val = 141
    
    #-----< id-E-RABs-SubjectToCounterCheckItem >-----#
    id_E_RABs_SubjectToCounterCheckItem = INT(name=u'id-E-RABs-SubjectToCounterCheckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToCounterCheckItem._val = 142
    
    #-----< id-CoverageModificationList >-----#
    id_CoverageModificationList = INT(name=u'id-CoverageModificationList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoverageModificationList._val = 143
    
    #-----< id-ReportingPeriodicityCSIR >-----#
    id_ReportingPeriodicityCSIR = INT(name=u'id-ReportingPeriodicityCSIR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicityCSIR._val = 145
    
    #-----< id-CSIReportList >-----#
    id_CSIReportList = INT(name=u'id-CSIReportList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSIReportList._val = 146
    
    #-----< id-UEID >-----#
    id_UEID = INT(name=u'id-UEID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEID._val = 147
    
    #-----< id-enhancedRNTP >-----#
    id_enhancedRNTP = INT(name=u'id-enhancedRNTP', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_enhancedRNTP._val = 148
    
    #-----< id-ProSeUEtoNetworkRelaying >-----#
    id_ProSeUEtoNetworkRelaying = INT(name=u'id-ProSeUEtoNetworkRelaying', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeUEtoNetworkRelaying._val = 149
    
    #-----< id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = INT(name=u'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._val = 150
    
    #-----< id-ULCOUNTValuePDCP-SNlength18 >-----#
    id_ULCOUNTValuePDCP_SNlength18 = INT(name=u'id-ULCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValuePDCP_SNlength18._val = 151
    
    #-----< id-DLCOUNTValuePDCP-SNlength18 >-----#
    id_DLCOUNTValuePDCP_SNlength18 = INT(name=u'id-DLCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValuePDCP_SNlength18._val = 152
    
    #-----< id-UE-ContextReferenceAtSeNB >-----#
    id_UE_ContextReferenceAtSeNB = INT(name=u'id-UE-ContextReferenceAtSeNB', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextReferenceAtSeNB._val = 153
    
    #-----< id-UE-ContextKeptIndicator >-----#
    id_UE_ContextKeptIndicator = INT(name=u'id-UE-ContextKeptIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextKeptIndicator._val = 154
    
    #-----< id-New-eNB-UE-X2AP-ID-Extension >-----#
    id_New_eNB_UE_X2AP_ID_Extension = INT(name=u'id-New-eNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_New_eNB_UE_X2AP_ID_Extension._val = 155
    
    #-----< id-Old-eNB-UE-X2AP-ID-Extension >-----#
    id_Old_eNB_UE_X2AP_ID_Extension = INT(name=u'id-Old-eNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Old_eNB_UE_X2AP_ID_Extension._val = 156
    
    #-----< id-MeNB-UE-X2AP-ID-Extension >-----#
    id_MeNB_UE_X2AP_ID_Extension = INT(name=u'id-MeNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNB_UE_X2AP_ID_Extension._val = 157
    
    #-----< id-SeNB-UE-X2AP-ID-Extension >-----#
    id_SeNB_UE_X2AP_ID_Extension = INT(name=u'id-SeNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNB_UE_X2AP_ID_Extension._val = 158
    
    #-----< id-LHN-ID >-----#
    id_LHN_ID = INT(name=u'id-LHN-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LHN_ID._val = 159
    
    #-----< id-FreqBandIndicatorPriority >-----#
    id_FreqBandIndicatorPriority = INT(name=u'id-FreqBandIndicatorPriority', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FreqBandIndicatorPriority._val = 160
    
    #-----< id-M6Configuration >-----#
    id_M6Configuration = INT(name=u'id-M6Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6Configuration._val = 161
    
    #-----< id-M7Configuration >-----#
    id_M7Configuration = INT(name=u'id-M7Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7Configuration._val = 162
    
    #-----< id-Tunnel-Information-for-BBF >-----#
    id_Tunnel_Information_for_BBF = INT(name=u'id-Tunnel-Information-for-BBF', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Tunnel_Information_for_BBF._val = 163
    
    #-----< id-SIPTO-BearerDeactivationIndication >-----#
    id_SIPTO_BearerDeactivationIndication = INT(name=u'id-SIPTO-BearerDeactivationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_BearerDeactivationIndication._val = 164
    
    #-----< id-GW-TransportLayerAddress >-----#
    id_GW_TransportLayerAddress = INT(name=u'id-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GW_TransportLayerAddress._val = 165
    
    #-----< id-Correlation-ID >-----#
    id_Correlation_ID = INT(name=u'id-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Correlation_ID._val = 166
    
    #-----< id-SIPTO-Correlation-ID >-----#
    id_SIPTO_Correlation_ID = INT(name=u'id-SIPTO-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_Correlation_ID._val = 167
    
    #-----< id-SIPTO-L-GW-TransportLayerAddress >-----#
    id_SIPTO_L_GW_TransportLayerAddress = INT(name=u'id-SIPTO-L-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_L_GW_TransportLayerAddress._val = 168
    
    #-----< id-X2RemovalThreshold >-----#
    id_X2RemovalThreshold = INT(name=u'id-X2RemovalThreshold', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_X2RemovalThreshold._val = 169
    
    #-----< id-CellReportingIndicator >-----#
    id_CellReportingIndicator = INT(name=u'id-CellReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellReportingIndicator._val = 170
    
    #-----< id-BearerType >-----#
    id_BearerType = INT(name=u'id-BearerType', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerType._val = 171
    
    #-----< id-resumeID >-----#
    id_resumeID = INT(name=u'id-resumeID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_resumeID._val = 172
    
    #-----< id-UE-ContextInformationRetrieve >-----#
    id_UE_ContextInformationRetrieve = INT(name=u'id-UE-ContextInformationRetrieve', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformationRetrieve._val = 173
    
    #-----< id-E-RABs-ToBeSetupRetrieve-Item >-----#
    id_E_RABs_ToBeSetupRetrieve_Item = INT(name=u'id-E-RABs-ToBeSetupRetrieve-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeSetupRetrieve_Item._val = 174
    
    #-----< id-NewEUTRANCellIdentifier >-----#
    id_NewEUTRANCellIdentifier = INT(name=u'id-NewEUTRANCellIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewEUTRANCellIdentifier._val = 175
    
    _all_ = [
        id_handoverPreparation,
        id_handoverCancel,
        id_loadIndication,
        id_errorIndication,
        id_snStatusTransfer,
        id_uEContextRelease,
        id_x2Setup,
        id_reset,
        id_eNBConfigurationUpdate,
        id_resourceStatusReportingInitiation,
        id_resourceStatusReporting,
        id_privateMessage,
        id_mobilitySettingsChange,
        id_rLFIndication,
        id_handoverReport,
        id_cellActivation,
        id_x2Release,
        id_x2APMessageTransfer,
        id_x2Removal,
        id_seNBAdditionPreparation,
        id_seNBReconfigurationCompletion,
        id_meNBinitiatedSeNBModificationPreparation,
        id_seNBinitiatedSeNBModification,
        id_meNBinitiatedSeNBRelease,
        id_seNBinitiatedSeNBRelease,
        id_seNBCounterCheck,
        id_retrieveUEContext,
        maxEARFCN,
        maxEARFCNPlusOne,
        newmaxEARFCN,
        maxInterfaces,
        maxCellineNB,
        maxnoofBands,
        maxnoofBearers,
        maxNrOfErrors,
        maxnoofPDCP_SN,
        maxnoofEPLMNs,
        maxnoofEPLMNsPlusOne,
        maxnoofForbLACs,
        maxnoofForbTACs,
        maxnoofBPLMNs,
        maxnoofNeighbours,
        maxnoofPRBs,
        maxPools,
        maxnoofCells,
        maxnoofMBSFN,
        maxFailedMeasObjects,
        maxnoofCellIDforMDT,
        maxnoofTAforMDT,
        maxnoofMBMSServiceAreaIdentities,
        maxnoofMDTPLMNs,
        maxnoofCoMPHypothesisSet,
        maxnoofCoMPCells,
        maxUEReport,
        maxCellReport,
        maxnoofPA,
        maxCSIProcess,
        maxCSIReport,
        maxSubband,
        id_E_RABs_Admitted_Item,
        id_E_RABs_Admitted_List,
        id_E_RAB_Item,
        id_E_RABs_NotAdmitted_List,
        id_E_RABs_ToBeSetup_Item,
        id_Cause,
        id_CellInformation,
        id_CellInformation_Item,
        id_New_eNB_UE_X2AP_ID,
        id_Old_eNB_UE_X2AP_ID,
        id_TargetCell_ID,
        id_TargeteNBtoSource_eNBTransparentContainer,
        id_TraceActivation,
        id_UE_ContextInformation,
        id_UE_HistoryInformation,
        id_UE_X2AP_ID,
        id_CriticalityDiagnostics,
        id_E_RABs_SubjectToStatusTransfer_List,
        id_E_RABs_SubjectToStatusTransfer_Item,
        id_ServedCells,
        id_GlobalENB_ID,
        id_TimeToWait,
        id_GUMMEI_ID,
        id_GUGroupIDList,
        id_ServedCellsToAdd,
        id_ServedCellsToModify,
        id_ServedCellsToDelete,
        id_Registration_Request,
        id_CellToReport,
        id_ReportingPeriodicity,
        id_CellToReport_Item,
        id_CellMeasurementResult,
        id_CellMeasurementResult_Item,
        id_GUGroupIDToAddList,
        id_GUGroupIDToDeleteList,
        id_SRVCCOperationPossible,
        id_Measurement_ID,
        id_ReportCharacteristics,
        id_ENB1_Measurement_ID,
        id_ENB2_Measurement_ID,
        id_Number_of_Antennaports,
        id_CompositeAvailableCapacityGroup,
        id_ENB1_Cell_ID,
        id_ENB2_Cell_ID,
        id_ENB2_Proposed_Mobility_Parameters,
        id_ENB1_Mobility_Parameters,
        id_ENB2_Mobility_Parameters_Modification_Range,
        id_FailureCellPCI,
        id_Re_establishmentCellECGI,
        id_FailureCellCRNTI,
        id_ShortMAC_I,
        id_SourceCellECGI,
        id_FailureCellECGI,
        id_HandoverReportType,
        id_PRACH_Configuration,
        id_MBSFN_Subframe_Info,
        id_ServedCellsToActivate,
        id_ActivatedCellList,
        id_DeactivationIndication,
        id_UE_RLF_Report_Container,
        id_ABSInformation,
        id_InvokeIndication,
        id_ABS_Status,
        id_PartialSuccessIndicator,
        id_MeasurementInitiationResult_List,
        id_MeasurementInitiationResult_Item,
        id_MeasurementFailureCause_Item,
        id_CompleteFailureCauseInformation_List,
        id_CompleteFailureCauseInformation_Item,
        id_CSG_Id,
        id_CSGMembershipStatus,
        id_MDTConfiguration,
        id_ManagementBasedMDTallowed,
        id_RRCConnSetupIndicator,
        id_NeighbourTAC,
        id_Time_UE_StayedInCell_EnhancedGranularity,
        id_RRCConnReestabIndicator,
        id_MBMS_Service_Area_List,
        id_HO_cause,
        id_TargetCellInUTRAN,
        id_MobilityInformation,
        id_SourceCellCRNTI,
        id_MultibandInfoList,
        id_M3Configuration,
        id_M4Configuration,
        id_M5Configuration,
        id_MDT_Location_Info,
        id_ManagementBasedMDTPLMNList,
        id_SignallingBasedMDTPLMNList,
        id_ReceiveStatusOfULPDCPSDUsExtended,
        id_ULCOUNTValueExtended,
        id_DLCOUNTValueExtended,
        id_eARFCNExtension,
        id_UL_EARFCNExtension,
        id_DL_EARFCNExtension,
        id_AdditionalSpecialSubframe_Info,
        id_Masked_IMEISV,
        id_IntendedULDLConfiguration,
        id_ExtendedULInterferenceOverloadInfo,
        id_RNL_Header,
        id_x2APMessage,
        id_ProSeAuthorized,
        id_ExpectedUEBehaviour,
        id_UE_HistoryInformationFromTheUE,
        id_DynamicDLTransmissionInformation,
        id_UE_RLF_Report_Container_for_extended_bands,
        id_CoMPInformation,
        id_ReportingPeriodicityRSRPMR,
        id_RSRPMRList,
        id_MeNB_UE_X2AP_ID,
        id_SeNB_UE_X2AP_ID,
        id_UE_SecurityCapabilities,
        id_SeNBSecurityKey,
        id_SeNBUEAggregateMaximumBitRate,
        id_ServingPLMN,
        id_E_RABs_ToBeAdded_List,
        id_E_RABs_ToBeAdded_Item,
        id_MeNBtoSeNBContainer,
        id_E_RABs_Admitted_ToBeAdded_List,
        id_E_RABs_Admitted_ToBeAdded_Item,
        id_SeNBtoMeNBContainer,
        id_ResponseInformationSeNBReconfComp,
        id_UE_ContextInformationSeNBModReq,
        id_E_RABs_ToBeAdded_ModReqItem,
        id_E_RABs_ToBeModified_ModReqItem,
        id_E_RABs_ToBeReleased_ModReqItem,
        id_E_RABs_Admitted_ToBeAdded_ModAckList,
        id_E_RABs_Admitted_ToBeModified_ModAckList,
        id_E_RABs_Admitted_ToBeReleased_ModAckList,
        id_E_RABs_Admitted_ToBeAdded_ModAckItem,
        id_E_RABs_Admitted_ToBeModified_ModAckItem,
        id_E_RABs_Admitted_ToBeReleased_ModAckItem,
        id_E_RABs_ToBeReleased_ModReqd,
        id_E_RABs_ToBeReleased_ModReqdItem,
        id_SCGChangeIndication,
        id_E_RABs_ToBeReleased_List_RelReq,
        id_E_RABs_ToBeReleased_RelReqItem,
        id_E_RABs_ToBeReleased_List_RelConf,
        id_E_RABs_ToBeReleased_RelConfItem,
        id_E_RABs_SubjectToCounterCheck_List,
        id_E_RABs_SubjectToCounterCheckItem,
        id_CoverageModificationList,
        id_ReportingPeriodicityCSIR,
        id_CSIReportList,
        id_UEID,
        id_enhancedRNTP,
        id_ProSeUEtoNetworkRelaying,
        id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        id_ULCOUNTValuePDCP_SNlength18,
        id_DLCOUNTValuePDCP_SNlength18,
        id_UE_ContextReferenceAtSeNB,
        id_UE_ContextKeptIndicator,
        id_New_eNB_UE_X2AP_ID_Extension,
        id_Old_eNB_UE_X2AP_ID_Extension,
        id_MeNB_UE_X2AP_ID_Extension,
        id_SeNB_UE_X2AP_ID_Extension,
        id_LHN_ID,
        id_FreqBandIndicatorPriority,
        id_M6Configuration,
        id_M7Configuration,
        id_Tunnel_Information_for_BBF,
        id_SIPTO_BearerDeactivationIndication,
        id_GW_TransportLayerAddress,
        id_Correlation_ID,
        id_SIPTO_Correlation_ID,
        id_SIPTO_L_GW_TransportLayerAddress,
        id_X2RemovalThreshold,
        id_CellReportingIndicator,
        id_BearerType,
        id_resumeID,
        id_UE_ContextInformationRetrieve,
        id_E_RABs_ToBeSetupRetrieve_Item,
        id_NewEUTRANCellIdentifier,
    ]

class X2AP_Containers:

    _name_  = u'X2AP-Containers'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 5]
    
    _obj_ = [
        u'X2AP-PROTOCOL-IES',
        u'X2AP-PROTOCOL-IES-PAIR',
        u'X2AP-PROTOCOL-EXTENSION',
        u'X2AP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'X2AP-PROTOCOL-IES',
        u'X2AP-PROTOCOL-IES-PAIR',
        u'X2AP-PROTOCOL-EXTENSION',
        u'X2AP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'X2AP-PROTOCOL-IES',
        u'X2AP-PROTOCOL-IES-PAIR',
        u'X2AP-PROTOCOL-EXTENSION',
        u'X2AP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< X2AP-PROTOCOL-IES >-----#
    X2AP_PROTOCOL_IES = CLASS(name=u'X2AP-PROTOCOL-IES', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _X2AP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _X2AP_PROTOCOL_IES_id),
        (u'criticality', _X2AP_PROTOCOL_IES_criticality),
        (u'Value', _X2AP_PROTOCOL_IES_Value),
        (u'presence', _X2AP_PROTOCOL_IES_presence),
        ])
    
    #-----< X2AP-PROTOCOL-IES-PAIR >-----#
    X2AP_PROTOCOL_IES_PAIR = CLASS(name=u'X2AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _X2AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _X2AP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _X2AP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _X2AP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _X2AP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _X2AP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _X2AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< X2AP-PROTOCOL-EXTENSION >-----#
    X2AP_PROTOCOL_EXTENSION = CLASS(name=u'X2AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _X2AP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _X2AP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _X2AP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _X2AP_PROTOCOL_EXTENSION_id),
        (u'criticality', _X2AP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _X2AP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _X2AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< X2AP-PRIVATE-IES >-----#
    X2AP_PRIVATE_IES = CLASS(name=u'X2AP-PRIVATE-IES', mode=MODE_TYPE)
    _X2AP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'PrivateIE-ID')))
    _X2AP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _X2AP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _X2AP_PRIVATE_IES_id),
        (u'criticality', _X2AP_PRIVATE_IES_criticality),
        (u'Value', _X2AP_PRIVATE_IES_Value),
        (u'presence', _X2AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name=u'ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name=u'ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _X2AP_PROTOCOL_IES_id,
        _X2AP_PROTOCOL_IES_criticality,
        _X2AP_PROTOCOL_IES_Value,
        _X2AP_PROTOCOL_IES_presence,
        X2AP_PROTOCOL_IES,
        _X2AP_PROTOCOL_IES_PAIR_id,
        _X2AP_PROTOCOL_IES_PAIR_firstCriticality,
        _X2AP_PROTOCOL_IES_PAIR_FirstValue,
        _X2AP_PROTOCOL_IES_PAIR_secondCriticality,
        _X2AP_PROTOCOL_IES_PAIR_SecondValue,
        _X2AP_PROTOCOL_IES_PAIR_presence,
        X2AP_PROTOCOL_IES_PAIR,
        _X2AP_PROTOCOL_EXTENSION_id,
        _X2AP_PROTOCOL_EXTENSION_criticality,
        _X2AP_PROTOCOL_EXTENSION_Extension,
        _X2AP_PROTOCOL_EXTENSION_presence,
        X2AP_PROTOCOL_EXTENSION,
        _X2AP_PRIVATE_IES_id,
        _X2AP_PRIVATE_IES_criticality,
        _X2AP_PRIVATE_IES_Value,
        _X2AP_PRIVATE_IES_presence,
        X2AP_PRIVATE_IES,
    ]

class X2AP_IEs:

    _name_  = u'X2AP-IEs'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 2]
    
    _obj_ = [
        u'ABSInformation',
        u'ABSInformationFDD',
        u'ABSInformationFDD-ExtIEs',
        u'ABSInformationTDD',
        u'ABSInformationTDD-ExtIEs',
        u'ABS-Status',
        u'ABS-Status-ExtIEs',
        u'AdditionalSpecialSubframe-Info',
        u'AdditionalSpecialSubframe-Info-ExtIEs',
        u'AdditionalSpecialSubframePatterns',
        u'AllocationAndRetentionPriority',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AreaScopeOfMDT',
        u'AS-SecurityInformation',
        u'AS-SecurityInformation-ExtIEs',
        u'BearerType',
        u'BenefitMetric',
        u'BitRate',
        u'BroadcastPLMNs-Item',
        u'CapacityValue',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CellBasedMDT',
        u'CellBasedMDT-ExtIEs',
        u'CellCapacityClassValue',
        u'CellDeploymentStatusIndicator',
        u'CellIdListforMDT',
        u'CellReplacingInfo',
        u'CellReplacingInfo-ExtIEs',
        u'CellReportingIndicator',
        u'Cell-Size',
        u'CellType',
        u'CellType-ExtIEs',
        u'CoMPHypothesisSet',
        u'CoMPHypothesisSetItem',
        u'CoMPHypothesisSetItem-ExtIEs',
        u'CoMPInformation',
        u'CoMPInformation-ExtIEs',
        u'CoMPInformationItem',
        u'CoMPInformationItem-ExtIEs',
        u'CoMPInformationStartTime',
        u'CoMPInformationStartTime-ExtIEs',
        u'CompositeAvailableCapacity',
        u'CompositeAvailableCapacity-ExtIEs',
        u'CompositeAvailableCapacityGroup',
        u'CompositeAvailableCapacityGroup-ExtIEs',
        u'Correlation-ID',
        u'COUNTvalue',
        u'COUNTvalue-ExtIEs',
        u'COUNTValueExtended',
        u'COUNTValueExtended-ExtIEs',
        u'COUNTvaluePDCP-SNlength18',
        u'COUNTvaluePDCP-SNlength18-ExtIEs',
        u'CoverageModificationList',
        u'CoverageModification-Item',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'CRNTI',
        u'CSGMembershipStatus',
        u'CSG-Id',
        u'CSIReportList',
        u'CSIReportList-ExtIEs',
        u'CSIReportPerCSIProcess',
        u'CSIReportPerCSIProcess-ExtIEs',
        u'CSIReportPerCSIProcessItem',
        u'CSIReportPerCSIProcessItem-ExtIEs',
        u'CyclicPrefixDL',
        u'CyclicPrefixUL',
        u'DeactivationIndication',
        u'DL-ABS-status',
        u'DL-Forwarding',
        u'DL-GBR-PRB-usage',
        u'DL-non-GBR-PRB-usage',
        u'DL-Total-PRB-usage',
        u'DynamicDLTransmissionInformation',
        u'DynamicNAICSInformation',
        u'DynamicNAICSInformation-ExtIEs',
        u'EARFCN',
        u'EARFCNExtension',
        u'ECGI',
        u'ECGI-ExtIEs',
        u'EnhancedRNTP',
        u'EnhancedRNTP-ExtIEs',
        u'EnhancedRNTPStartTime',
        u'EnhancedRNTPStartTime-ExtIEs',
        u'ENB-ID',
        u'EncryptionAlgorithms',
        u'EPLMNs',
        u'E-RAB-ID',
        u'E-RAB-Level-QoS-Parameters',
        u'E-RAB-Level-QoS-Parameters-ExtIEs',
        u'E-RAB-List',
        u'E-RAB-ItemIEs',
        u'E-RAB-Item',
        u'E-RAB-Item-ExtIEs',
        u'EUTRA-Mode-Info',
        u'EUTRANCellIdentifier',
        u'EUTRANTraceID',
        u'EventType',
        u'ExpectedUEBehaviour',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEActivityBehaviour',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExpectedActivityPeriod',
        u'ExpectedIdlePeriod',
        u'ExpectedHOInterval',
        u'ExtendedULInterferenceOverloadInfo',
        u'ExtendedULInterferenceOverloadInfo-ExtIEs',
        u'FDD-Info',
        u'FDD-Info-ExtIEs',
        u'ForbiddenInterRATs',
        u'ForbiddenTAs',
        u'ForbiddenTAs-Item',
        u'ForbiddenTAs-Item-ExtIEs',
        u'ForbiddenTACs',
        u'ForbiddenLAs',
        u'ForbiddenLAs-Item',
        u'ForbiddenLAs-Item-ExtIEs',
        u'ForbiddenLACs',
        u'Fourframes',
        u'FreqBandIndicator',
        u'FreqBandIndicatorPriority',
        u'GBR-QosInformation',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID',
        u'GlobalENB-ID-ExtIEs',
        u'GTPtunnelEndpoint',
        u'GTPtunnelEndpoint-ExtIEs',
        u'GTP-TEI',
        u'GUGroupIDList',
        u'GU-Group-ID',
        u'GU-Group-ID-ExtIEs',
        u'GUMMEI',
        u'GUMMEI-ExtIEs',
        u'HandoverReportType',
        u'HandoverRestrictionList',
        u'HandoverRestrictionList-ExtIEs',
        u'HFN',
        u'HFNModified',
        u'HFNforPDCP-SNlength18',
        u'HWLoadIndicator',
        u'HWLoadIndicator-ExtIEs',
        u'IntegrityProtectionAlgorithms',
        u'InterfacesToTrace',
        u'InvokeIndication',
        u'Key-eNodeB-Star',
        u'LAC',
        u'LastVisitedCell-Item',
        u'LastVisitedEUTRANCellInformation',
        u'LastVisitedEUTRANCellInformation-ExtIEs',
        u'LastVisitedGERANCellInformation',
        u'LastVisitedUTRANCellInformation',
        u'LHN-ID',
        u'Links-to-log',
        u'LoadIndicator',
        u'LocationReportingInformation',
        u'LocationReportingInformation-ExtIEs',
        u'M1PeriodicReporting',
        u'M1PeriodicReporting-ExtIEs',
        u'M1ReportingTrigger',
        u'M1ThresholdEventA2',
        u'M1ThresholdEventA2-ExtIEs',
        u'M3Configuration',
        u'M3Configuration-ExtIEs',
        u'M3period',
        u'M4Configuration',
        u'M4Configuration-ExtIEs',
        u'M4period',
        u'M5Configuration',
        u'M5Configuration-ExtIEs',
        u'M5period',
        u'M6Configuration',
        u'M6Configuration-ExtIEs',
        u'M6report-interval',
        u'M6delay-threshold',
        u'M7Configuration',
        u'M7Configuration-ExtIEs',
        u'M7period',
        u'ManagementBasedMDTallowed',
        u'Masked-IMEISV',
        u'MDT-Activation',
        u'MDT-Configuration',
        u'MDT-Configuration-ExtIEs',
        u'MDTPLMNList',
        u'MDT-Location-Info',
        u'Measurement-ID',
        u'MeasurementsToActivate',
        u'MeasurementThresholdA2',
        u'MeNBtoSeNBContainer',
        u'MME-Group-ID',
        u'MME-Code',
        u'MBMS-Service-Area-Identity-List',
        u'MBMS-Service-Area-Identity',
        u'MBSFN-Subframe-Infolist',
        u'MBSFN-Subframe-Info',
        u'MBSFN-Subframe-Info-ExtIEs',
        u'MobilityParametersModificationRange',
        u'MobilityParametersInformation',
        u'MultibandInfoList',
        u'BandInfo',
        u'BandInfo-ExtIEs',
        u'Neighbour-Information',
        u'Neighbour-Information-ExtIEs',
        u'NextHopChainingCount',
        u'Number-of-Antennaports',
        u'Oneframe',
        u'PA-Values',
        u'PDCP-SN',
        u'PDCP-SNExtended',
        u'PDCP-SNlength18',
        u'PCI',
        u'PLMN-Identity',
        u'Port-Number',
        u'PRACH-Configuration',
        u'PRACH-Configuration-ExtIEs',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'ProSeAuthorized',
        u'ProSeAuthorized-ExtIEs',
        u'ProSeDirectDiscovery',
        u'ProSeDirectCommunication',
        u'ProSeUEtoNetworkRelaying',
        u'QCI',
        u'RadioframeAllocationOffset',
        u'RadioframeAllocationPeriod',
        u'RadioResourceStatus',
        u'RadioResourceStatus-ExtIEs',
        u'ReceiveStatusofULPDCPSDUs',
        u'ReceiveStatusOfULPDCPSDUsExtended',
        u'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'Registration-Request',
        u'RelativeNarrowbandTxPower',
        u'RelativeNarrowbandTxPower-ExtIEs',
        u'ReplacingCellsList',
        u'ReplacingCellsList-Item',
        u'ReportAmountMDT',
        u'ReportArea',
        u'ReportCharacteristics',
        u'ReportingPeriodicityCSIR',
        u'ReportingPeriodicityRSRPMR',
        u'ReportIntervalMDT',
        u'ResumeID',
        u'RNTP-Threshold',
        u'RRC-Context',
        u'RRCConnReestabIndicator',
        u'RRCConnSetupIndicator',
        u'RSRPMeasurementResult',
        u'RSRPMeasurementResult-ExtIEs',
        u'RSRPMRList',
        u'RSRPMRList-ExtIEs',
        u'S1TNLLoadIndicator',
        u'S1TNLLoadIndicator-ExtIEs',
        u'SCGChangeIndication',
        u'SeNBSecurityKey',
        u'SeNBtoMeNBContainer',
        u'ServedCells',
        u'ServedCell-ExtIEs',
        u'ServedCell-Information',
        u'ServedCell-Information-ExtIEs',
        u'SIPTOBearerDeactivationIndication',
        u'ShortMAC-I',
        u'SourceOfUEActivityBehaviourInformation',
        u'SpecialSubframe-Info',
        u'SpecialSubframe-Info-ExtIEs',
        u'SpecialSubframePatterns',
        u'SubbandCQI',
        u'SRVCCOperationPossible',
        u'SubbandCQI-ExtIEs',
        u'SubbandCQICodeword0',
        u'SubbandCQICodeword1',
        u'SubbandCQIList',
        u'SubbandCQIItem',
        u'SubbandCQIItem-ExtIEs',
        u'SubbandSize',
        u'SubscriberProfileIDforRFP',
        u'SubframeAllocation',
        u'SubframeAssignment',
        u'TABasedMDT',
        u'TABasedMDT-ExtIEs',
        u'TAC',
        u'TAIBasedMDT',
        u'TAIBasedMDT-ExtIEs',
        u'TAIListforMDT',
        u'TAI-Item',
        u'TAI-Item-ExtIEs',
        u'TAListforMDT',
        u'TargetCellInUTRAN',
        u'TargeteNBtoSource-eNBTransparentContainer',
        u'TDD-Info',
        u'TDD-Info-ExtIEs',
        u'Threshold-RSRP',
        u'Threshold-RSRQ',
        u'TimeToWait',
        u'Time-UE-StayedInCell',
        u'Time-UE-StayedInCell-EnhancedGranularity',
        u'TraceActivation',
        u'TraceActivation-ExtIEs',
        u'TraceCollectionEntityIPAddress',
        u'TraceDepth',
        u'Transmission-Bandwidth',
        u'TransportLayerAddress',
        u'TunnelInformation',
        u'Tunnel-Information-ExtIEs',
        u'TypeOfError',
        u'UEAggregateMaximumBitRate',
        u'UEAggregate-MaximumBitrate-ExtIEs',
        u'UE-ContextKeptIndicator',
        u'UEID',
        u'UE-HistoryInformation',
        u'UE-HistoryInformationFromTheUE',
        u'UE-S1AP-ID',
        u'UE-X2AP-ID',
        u'UE-X2AP-ID-Extension',
        u'UE-RLF-Report-Container',
        u'UE-RLF-Report-Container-for-extended-bands',
        u'UESecurityCapabilities',
        u'UESecurityCapabilities-ExtIEs',
        u'UL-GBR-PRB-usage',
        u'UL-HighInterferenceIndicationInfo',
        u'UL-HighInterferenceIndicationInfo-Item',
        u'UL-HighInterferenceIndicationInfo-Item-ExtIEs',
        u'UL-HighInterferenceIndication',
        u'UL-InterferenceOverloadIndication',
        u'UL-InterferenceOverloadIndication-Item',
        u'UL-non-GBR-PRB-usage',
        u'UL-Total-PRB-usage',
        u'UsableABSInformation',
        u'UsableABSInformationFDD',
        u'UsableABSInformationFDD-ExtIEs',
        u'UsableABSInformationTDD',
        u'UsableABSInformationTDD-ExtIEs',
        u'WidebandCQI',
        u'WidebandCQI-ExtIEs',
        u'WidebandCQICodeword1',
        u'X2BenefitValue',
        ]
    _type_ = [
        u'ABSInformation',
        u'ABSInformationFDD',
        u'ABSInformationTDD',
        u'ABS-Status',
        u'AdditionalSpecialSubframe-Info',
        u'AdditionalSpecialSubframePatterns',
        u'AllocationAndRetentionPriority',
        u'AreaScopeOfMDT',
        u'AS-SecurityInformation',
        u'BearerType',
        u'BenefitMetric',
        u'BitRate',
        u'BroadcastPLMNs-Item',
        u'CapacityValue',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CellBasedMDT',
        u'CellCapacityClassValue',
        u'CellDeploymentStatusIndicator',
        u'CellIdListforMDT',
        u'CellReplacingInfo',
        u'CellReportingIndicator',
        u'Cell-Size',
        u'CellType',
        u'CoMPHypothesisSet',
        u'CoMPHypothesisSetItem',
        u'CoMPInformation',
        u'CoMPInformationItem',
        u'CoMPInformationStartTime',
        u'CompositeAvailableCapacity',
        u'CompositeAvailableCapacityGroup',
        u'Correlation-ID',
        u'COUNTvalue',
        u'COUNTValueExtended',
        u'COUNTvaluePDCP-SNlength18',
        u'CoverageModificationList',
        u'CoverageModification-Item',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'CRNTI',
        u'CSGMembershipStatus',
        u'CSG-Id',
        u'CSIReportList',
        u'CSIReportPerCSIProcess',
        u'CSIReportPerCSIProcessItem',
        u'CyclicPrefixDL',
        u'CyclicPrefixUL',
        u'DeactivationIndication',
        u'DL-ABS-status',
        u'DL-Forwarding',
        u'DL-GBR-PRB-usage',
        u'DL-non-GBR-PRB-usage',
        u'DL-Total-PRB-usage',
        u'DynamicDLTransmissionInformation',
        u'DynamicNAICSInformation',
        u'EARFCN',
        u'EARFCNExtension',
        u'ECGI',
        u'EnhancedRNTP',
        u'EnhancedRNTPStartTime',
        u'ENB-ID',
        u'EncryptionAlgorithms',
        u'EPLMNs',
        u'E-RAB-ID',
        u'E-RAB-Level-QoS-Parameters',
        u'E-RAB-List',
        u'E-RAB-Item',
        u'EUTRA-Mode-Info',
        u'EUTRANCellIdentifier',
        u'EUTRANTraceID',
        u'EventType',
        u'ExpectedUEBehaviour',
        u'ExpectedUEActivityBehaviour',
        u'ExpectedActivityPeriod',
        u'ExpectedIdlePeriod',
        u'ExpectedHOInterval',
        u'ExtendedULInterferenceOverloadInfo',
        u'FDD-Info',
        u'ForbiddenInterRATs',
        u'ForbiddenTAs',
        u'ForbiddenTAs-Item',
        u'ForbiddenTACs',
        u'ForbiddenLAs',
        u'ForbiddenLAs-Item',
        u'ForbiddenLACs',
        u'Fourframes',
        u'FreqBandIndicator',
        u'FreqBandIndicatorPriority',
        u'GBR-QosInformation',
        u'GlobalENB-ID',
        u'GTPtunnelEndpoint',
        u'GTP-TEI',
        u'GUGroupIDList',
        u'GU-Group-ID',
        u'GUMMEI',
        u'HandoverReportType',
        u'HandoverRestrictionList',
        u'HFN',
        u'HFNModified',
        u'HFNforPDCP-SNlength18',
        u'HWLoadIndicator',
        u'IntegrityProtectionAlgorithms',
        u'InterfacesToTrace',
        u'InvokeIndication',
        u'Key-eNodeB-Star',
        u'LAC',
        u'LastVisitedCell-Item',
        u'LastVisitedEUTRANCellInformation',
        u'LastVisitedGERANCellInformation',
        u'LastVisitedUTRANCellInformation',
        u'LHN-ID',
        u'Links-to-log',
        u'LoadIndicator',
        u'LocationReportingInformation',
        u'M1PeriodicReporting',
        u'M1ReportingTrigger',
        u'M1ThresholdEventA2',
        u'M3Configuration',
        u'M3period',
        u'M4Configuration',
        u'M4period',
        u'M5Configuration',
        u'M5period',
        u'M6Configuration',
        u'M6report-interval',
        u'M6delay-threshold',
        u'M7Configuration',
        u'M7period',
        u'ManagementBasedMDTallowed',
        u'Masked-IMEISV',
        u'MDT-Activation',
        u'MDT-Configuration',
        u'MDTPLMNList',
        u'MDT-Location-Info',
        u'Measurement-ID',
        u'MeasurementsToActivate',
        u'MeasurementThresholdA2',
        u'MeNBtoSeNBContainer',
        u'MME-Group-ID',
        u'MME-Code',
        u'MBMS-Service-Area-Identity-List',
        u'MBMS-Service-Area-Identity',
        u'MBSFN-Subframe-Infolist',
        u'MBSFN-Subframe-Info',
        u'MobilityParametersModificationRange',
        u'MobilityParametersInformation',
        u'MultibandInfoList',
        u'BandInfo',
        u'Neighbour-Information',
        u'NextHopChainingCount',
        u'Number-of-Antennaports',
        u'Oneframe',
        u'PA-Values',
        u'PDCP-SN',
        u'PDCP-SNExtended',
        u'PDCP-SNlength18',
        u'PCI',
        u'PLMN-Identity',
        u'Port-Number',
        u'PRACH-Configuration',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'ProSeAuthorized',
        u'ProSeDirectDiscovery',
        u'ProSeDirectCommunication',
        u'ProSeUEtoNetworkRelaying',
        u'QCI',
        u'RadioframeAllocationOffset',
        u'RadioframeAllocationPeriod',
        u'RadioResourceStatus',
        u'ReceiveStatusofULPDCPSDUs',
        u'ReceiveStatusOfULPDCPSDUsExtended',
        u'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'Registration-Request',
        u'RelativeNarrowbandTxPower',
        u'ReplacingCellsList',
        u'ReplacingCellsList-Item',
        u'ReportAmountMDT',
        u'ReportArea',
        u'ReportCharacteristics',
        u'ReportingPeriodicityCSIR',
        u'ReportingPeriodicityRSRPMR',
        u'ReportIntervalMDT',
        u'ResumeID',
        u'RNTP-Threshold',
        u'RRC-Context',
        u'RRCConnReestabIndicator',
        u'RRCConnSetupIndicator',
        u'RSRPMeasurementResult',
        u'RSRPMRList',
        u'S1TNLLoadIndicator',
        u'SCGChangeIndication',
        u'SeNBSecurityKey',
        u'SeNBtoMeNBContainer',
        u'ServedCells',
        u'ServedCell-Information',
        u'SIPTOBearerDeactivationIndication',
        u'ShortMAC-I',
        u'SourceOfUEActivityBehaviourInformation',
        u'SpecialSubframe-Info',
        u'SpecialSubframePatterns',
        u'SubbandCQI',
        u'SRVCCOperationPossible',
        u'SubbandCQICodeword0',
        u'SubbandCQICodeword1',
        u'SubbandCQIList',
        u'SubbandCQIItem',
        u'SubbandSize',
        u'SubscriberProfileIDforRFP',
        u'SubframeAllocation',
        u'SubframeAssignment',
        u'TABasedMDT',
        u'TAC',
        u'TAIBasedMDT',
        u'TAIListforMDT',
        u'TAI-Item',
        u'TAListforMDT',
        u'TargetCellInUTRAN',
        u'TargeteNBtoSource-eNBTransparentContainer',
        u'TDD-Info',
        u'Threshold-RSRP',
        u'Threshold-RSRQ',
        u'TimeToWait',
        u'Time-UE-StayedInCell',
        u'Time-UE-StayedInCell-EnhancedGranularity',
        u'TraceActivation',
        u'TraceCollectionEntityIPAddress',
        u'TraceDepth',
        u'Transmission-Bandwidth',
        u'TransportLayerAddress',
        u'TunnelInformation',
        u'TypeOfError',
        u'UEAggregateMaximumBitRate',
        u'UE-ContextKeptIndicator',
        u'UEID',
        u'UE-HistoryInformation',
        u'UE-HistoryInformationFromTheUE',
        u'UE-S1AP-ID',
        u'UE-X2AP-ID',
        u'UE-X2AP-ID-Extension',
        u'UE-RLF-Report-Container',
        u'UE-RLF-Report-Container-for-extended-bands',
        u'UESecurityCapabilities',
        u'UL-GBR-PRB-usage',
        u'UL-HighInterferenceIndicationInfo',
        u'UL-HighInterferenceIndicationInfo-Item',
        u'UL-HighInterferenceIndication',
        u'UL-InterferenceOverloadIndication',
        u'UL-InterferenceOverloadIndication-Item',
        u'UL-non-GBR-PRB-usage',
        u'UL-Total-PRB-usage',
        u'UsableABSInformation',
        u'UsableABSInformationFDD',
        u'UsableABSInformationTDD',
        u'WidebandCQI',
        u'WidebandCQICodeword1',
        u'X2BenefitValue',
        ]
    _set_ = [
        u'ABSInformationFDD-ExtIEs',
        u'ABSInformationTDD-ExtIEs',
        u'ABS-Status-ExtIEs',
        u'AdditionalSpecialSubframe-Info-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AS-SecurityInformation-ExtIEs',
        u'CellBasedMDT-ExtIEs',
        u'CellReplacingInfo-ExtIEs',
        u'CellType-ExtIEs',
        u'CoMPHypothesisSetItem-ExtIEs',
        u'CoMPInformation-ExtIEs',
        u'CoMPInformationItem-ExtIEs',
        u'CoMPInformationStartTime-ExtIEs',
        u'CompositeAvailableCapacity-ExtIEs',
        u'CompositeAvailableCapacityGroup-ExtIEs',
        u'COUNTvalue-ExtIEs',
        u'COUNTValueExtended-ExtIEs',
        u'COUNTvaluePDCP-SNlength18-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'CSIReportList-ExtIEs',
        u'CSIReportPerCSIProcess-ExtIEs',
        u'CSIReportPerCSIProcessItem-ExtIEs',
        u'DynamicNAICSInformation-ExtIEs',
        u'ECGI-ExtIEs',
        u'EnhancedRNTP-ExtIEs',
        u'EnhancedRNTPStartTime-ExtIEs',
        u'E-RAB-Level-QoS-Parameters-ExtIEs',
        u'E-RAB-ItemIEs',
        u'E-RAB-Item-ExtIEs',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExtendedULInterferenceOverloadInfo-ExtIEs',
        u'FDD-Info-ExtIEs',
        u'ForbiddenTAs-Item-ExtIEs',
        u'ForbiddenLAs-Item-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'GTPtunnelEndpoint-ExtIEs',
        u'GU-Group-ID-ExtIEs',
        u'GUMMEI-ExtIEs',
        u'HandoverRestrictionList-ExtIEs',
        u'HWLoadIndicator-ExtIEs',
        u'LastVisitedEUTRANCellInformation-ExtIEs',
        u'LocationReportingInformation-ExtIEs',
        u'M1PeriodicReporting-ExtIEs',
        u'M1ThresholdEventA2-ExtIEs',
        u'M3Configuration-ExtIEs',
        u'M4Configuration-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MBSFN-Subframe-Info-ExtIEs',
        u'BandInfo-ExtIEs',
        u'Neighbour-Information-ExtIEs',
        u'PRACH-Configuration-ExtIEs',
        u'ProSeAuthorized-ExtIEs',
        u'RadioResourceStatus-ExtIEs',
        u'RelativeNarrowbandTxPower-ExtIEs',
        u'RSRPMeasurementResult-ExtIEs',
        u'RSRPMRList-ExtIEs',
        u'S1TNLLoadIndicator-ExtIEs',
        u'ServedCell-ExtIEs',
        u'ServedCell-Information-ExtIEs',
        u'SpecialSubframe-Info-ExtIEs',
        u'SubbandCQI-ExtIEs',
        u'SubbandCQIItem-ExtIEs',
        u'TABasedMDT-ExtIEs',
        u'TAIBasedMDT-ExtIEs',
        u'TAI-Item-ExtIEs',
        u'TDD-Info-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'Tunnel-Information-ExtIEs',
        u'UEAggregate-MaximumBitrate-ExtIEs',
        u'UESecurityCapabilities-ExtIEs',
        u'UL-HighInterferenceIndicationInfo-Item-ExtIEs',
        u'UsableABSInformationFDD-ExtIEs',
        u'UsableABSInformationTDD-ExtIEs',
        u'WidebandCQI-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'ABSInformationFDD-ExtIEs',
        u'ABSInformationTDD-ExtIEs',
        u'ABS-Status-ExtIEs',
        u'AdditionalSpecialSubframe-Info-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AS-SecurityInformation-ExtIEs',
        u'CellBasedMDT-ExtIEs',
        u'CellReplacingInfo-ExtIEs',
        u'CellType-ExtIEs',
        u'CoMPHypothesisSetItem-ExtIEs',
        u'CoMPInformation-ExtIEs',
        u'CoMPInformationItem-ExtIEs',
        u'CoMPInformationStartTime-ExtIEs',
        u'CompositeAvailableCapacity-ExtIEs',
        u'CompositeAvailableCapacityGroup-ExtIEs',
        u'COUNTvalue-ExtIEs',
        u'COUNTValueExtended-ExtIEs',
        u'COUNTvaluePDCP-SNlength18-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'CSIReportList-ExtIEs',
        u'CSIReportPerCSIProcess-ExtIEs',
        u'CSIReportPerCSIProcessItem-ExtIEs',
        u'DynamicNAICSInformation-ExtIEs',
        u'ECGI-ExtIEs',
        u'EnhancedRNTP-ExtIEs',
        u'EnhancedRNTPStartTime-ExtIEs',
        u'E-RAB-Level-QoS-Parameters-ExtIEs',
        u'E-RAB-ItemIEs',
        u'E-RAB-Item-ExtIEs',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExtendedULInterferenceOverloadInfo-ExtIEs',
        u'FDD-Info-ExtIEs',
        u'ForbiddenTAs-Item-ExtIEs',
        u'ForbiddenLAs-Item-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'GTPtunnelEndpoint-ExtIEs',
        u'GU-Group-ID-ExtIEs',
        u'GUMMEI-ExtIEs',
        u'HandoverRestrictionList-ExtIEs',
        u'HWLoadIndicator-ExtIEs',
        u'LastVisitedEUTRANCellInformation-ExtIEs',
        u'LocationReportingInformation-ExtIEs',
        u'M1PeriodicReporting-ExtIEs',
        u'M1ThresholdEventA2-ExtIEs',
        u'M3Configuration-ExtIEs',
        u'M4Configuration-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MBSFN-Subframe-Info-ExtIEs',
        u'BandInfo-ExtIEs',
        u'Neighbour-Information-ExtIEs',
        u'PRACH-Configuration-ExtIEs',
        u'ProSeAuthorized-ExtIEs',
        u'RadioResourceStatus-ExtIEs',
        u'RelativeNarrowbandTxPower-ExtIEs',
        u'RSRPMeasurementResult-ExtIEs',
        u'RSRPMRList-ExtIEs',
        u'S1TNLLoadIndicator-ExtIEs',
        u'ServedCell-ExtIEs',
        u'ServedCell-Information-ExtIEs',
        u'SpecialSubframe-Info-ExtIEs',
        u'SubbandCQI-ExtIEs',
        u'SubbandCQIItem-ExtIEs',
        u'TABasedMDT-ExtIEs',
        u'TAIBasedMDT-ExtIEs',
        u'TAI-Item-ExtIEs',
        u'TDD-Info-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'Tunnel-Information-ExtIEs',
        u'UEAggregate-MaximumBitrate-ExtIEs',
        u'UESecurityCapabilities-ExtIEs',
        u'UL-HighInterferenceIndicationInfo-Item-ExtIEs',
        u'UsableABSInformationFDD-ExtIEs',
        u'UsableABSInformationTDD-ExtIEs',
        u'WidebandCQI-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< ABSInformation >-----#
    ABSInformation = CHOICE(name=u'ABSInformation', mode=MODE_TYPE)
    _ABSInformation_fdd = SEQ(name=u'fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ABSInformationFDD')))
    _ABSInformation_tdd = SEQ(name=u'tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ABSInformationTDD')))
    _ABSInformation_abs_inactive = NULL(name=u'abs-inactive', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ABSInformation._cont = ASN1Dict([
        (u'fdd', _ABSInformation_fdd),
        (u'tdd', _ABSInformation_tdd),
        (u'abs-inactive', _ABSInformation_abs_inactive),
        ])
    ABSInformation._ext = []
    
    #-----< ABSInformationFDD >-----#
    ABSInformationFDD = SEQ(name=u'ABSInformationFDD', mode=MODE_TYPE)
    _ABSInformationFDD_abs_pattern_info = BIT_STR(name=u'abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationFDD_abs_pattern_info._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _ABSInformationFDD_numberOfCellSpecificAntennaPorts = ENUM(name=u'numberOfCellSpecificAntennaPorts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationFDD_numberOfCellSpecificAntennaPorts._cont = ASN1Dict([(u'one', 0), (u'two', 1), (u'four', 2)])
    _ABSInformationFDD_numberOfCellSpecificAntennaPorts._ext = []
    _ABSInformationFDD_measurement_subset = BIT_STR(name=u'measurement-subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationFDD_measurement_subset._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _ABSInformationFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ABSInformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ABSInformationFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ABSInformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationFDD_iE_Extensions__item__id._const_tab = ____ABSInformationFDD_iE_Extensions__item__id_tab
    ___ABSInformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___ABSInformationFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___ABSInformationFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ABSInformationFDD_iE_Extensions__item__criticality._const_tab = ____ABSInformationFDD_iE_Extensions__item__id_tab
    ___ABSInformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ABSInformationFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ABSInformationFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ABSInformationFDD_iE_Extensions__item__extensionValue._const_tab = ____ABSInformationFDD_iE_Extensions__item__id_tab
    ___ABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ABSInformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ABSInformationFDD_iE_Extensions__item__id),
        (u'criticality', ___ABSInformationFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___ABSInformationFDD_iE_Extensions__item__extensionValue),
        ])
    __ABSInformationFDD_iE_Extensions__item_._ext = None
    _ABSInformationFDD_iE_Extensions._cont = __ABSInformationFDD_iE_Extensions__item_
    _ABSInformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ABSInformationFDD._cont = ASN1Dict([
        (u'abs-pattern-info', _ABSInformationFDD_abs_pattern_info),
        (u'numberOfCellSpecificAntennaPorts', _ABSInformationFDD_numberOfCellSpecificAntennaPorts),
        (u'measurement-subset', _ABSInformationFDD_measurement_subset),
        (u'iE-Extensions', _ABSInformationFDD_iE_Extensions),
        ])
    ABSInformationFDD._ext = []
    
    #-----< ABSInformationFDD-ExtIEs >-----#
    ABSInformationFDD_ExtIEs = CLASS(name=u'ABSInformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ABSInformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ABSInformationTDD >-----#
    ABSInformationTDD = SEQ(name=u'ABSInformationTDD', mode=MODE_TYPE)
    _ABSInformationTDD_abs_pattern_info = BIT_STR(name=u'abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationTDD_abs_pattern_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=[], er=[])
    _ABSInformationTDD_numberOfCellSpecificAntennaPorts = ENUM(name=u'numberOfCellSpecificAntennaPorts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationTDD_numberOfCellSpecificAntennaPorts._cont = ASN1Dict([(u'one', 0), (u'two', 1), (u'four', 2)])
    _ABSInformationTDD_numberOfCellSpecificAntennaPorts._ext = []
    _ABSInformationTDD_measurement_subset = BIT_STR(name=u'measurement-subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationTDD_measurement_subset._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=[], er=[])
    _ABSInformationTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ABSInformationTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ABSInformationTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ABSInformationTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationTDD_iE_Extensions__item__id._const_tab = ____ABSInformationTDD_iE_Extensions__item__id_tab
    ___ABSInformationTDD_iE_Extensions__item__id._const_tab_at = None
    ___ABSInformationTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___ABSInformationTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ABSInformationTDD_iE_Extensions__item__criticality._const_tab = ____ABSInformationTDD_iE_Extensions__item__id_tab
    ___ABSInformationTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ABSInformationTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ABSInformationTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ABSInformationTDD_iE_Extensions__item__extensionValue._const_tab = ____ABSInformationTDD_iE_Extensions__item__id_tab
    ___ABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ABSInformationTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ABSInformationTDD_iE_Extensions__item__id),
        (u'criticality', ___ABSInformationTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___ABSInformationTDD_iE_Extensions__item__extensionValue),
        ])
    __ABSInformationTDD_iE_Extensions__item_._ext = None
    _ABSInformationTDD_iE_Extensions._cont = __ABSInformationTDD_iE_Extensions__item_
    _ABSInformationTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ABSInformationTDD._cont = ASN1Dict([
        (u'abs-pattern-info', _ABSInformationTDD_abs_pattern_info),
        (u'numberOfCellSpecificAntennaPorts', _ABSInformationTDD_numberOfCellSpecificAntennaPorts),
        (u'measurement-subset', _ABSInformationTDD_measurement_subset),
        (u'iE-Extensions', _ABSInformationTDD_iE_Extensions),
        ])
    ABSInformationTDD._ext = []
    
    #-----< ABSInformationTDD-ExtIEs >-----#
    ABSInformationTDD_ExtIEs = CLASS(name=u'ABSInformationTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ABSInformationTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ABS-Status >-----#
    ABS_Status = SEQ(name=u'ABS-Status', mode=MODE_TYPE)
    _ABS_Status_dL_ABS_status = INT(name=u'dL-ABS-status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-ABS-status')))
    _ABS_Status_usableABSInformation = CHOICE(name=u'usableABSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UsableABSInformation')))
    _ABS_Status_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ABS_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ABS_Status_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ABS_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABS_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABS_Status_iE_Extensions__item__id._const_tab = ____ABS_Status_iE_Extensions__item__id_tab
    ___ABS_Status_iE_Extensions__item__id._const_tab_at = None
    ___ABS_Status_iE_Extensions__item__id._const_tab_id = u'id'
    ___ABS_Status_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ABS_Status_iE_Extensions__item__criticality._const_tab = ____ABS_Status_iE_Extensions__item__id_tab
    ___ABS_Status_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ABS_Status_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ABS_Status_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ABS_Status_iE_Extensions__item__extensionValue._const_tab = ____ABS_Status_iE_Extensions__item__id_tab
    ___ABS_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ABS_Status_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ABS_Status_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ABS_Status_iE_Extensions__item__id),
        (u'criticality', ___ABS_Status_iE_Extensions__item__criticality),
        (u'extensionValue', ___ABS_Status_iE_Extensions__item__extensionValue),
        ])
    __ABS_Status_iE_Extensions__item_._ext = None
    _ABS_Status_iE_Extensions._cont = __ABS_Status_iE_Extensions__item_
    _ABS_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ABS_Status._cont = ASN1Dict([
        (u'dL-ABS-status', _ABS_Status_dL_ABS_status),
        (u'usableABSInformation', _ABS_Status_usableABSInformation),
        (u'iE-Extensions', _ABS_Status_iE_Extensions),
        ])
    ABS_Status._ext = []
    
    #-----< ABS-Status-ExtIEs >-----#
    ABS_Status_ExtIEs = CLASS(name=u'ABS-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ABS_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalSpecialSubframe-Info >-----#
    AdditionalSpecialSubframe_Info = SEQ(name=u'AdditionalSpecialSubframe-Info', mode=MODE_TYPE)
    _AdditionalSpecialSubframe_Info_additionalspecialSubframePatterns = ENUM(name=u'additionalspecialSubframePatterns', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframePatterns')))
    _AdditionalSpecialSubframe_Info_cyclicPrefixDL = ENUM(name=u'cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixDL')))
    _AdditionalSpecialSubframe_Info_cyclicPrefixUL = ENUM(name=u'cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixUL')))
    _AdditionalSpecialSubframe_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalSpecialSubframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id._const_tab = ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality._const_tab = ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab = ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalSpecialSubframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id),
        (u'criticality', ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue),
        ])
    __AdditionalSpecialSubframe_Info_iE_Extensions__item_._ext = None
    _AdditionalSpecialSubframe_Info_iE_Extensions._cont = __AdditionalSpecialSubframe_Info_iE_Extensions__item_
    _AdditionalSpecialSubframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalSpecialSubframe_Info._cont = ASN1Dict([
        (u'additionalspecialSubframePatterns', _AdditionalSpecialSubframe_Info_additionalspecialSubframePatterns),
        (u'cyclicPrefixDL', _AdditionalSpecialSubframe_Info_cyclicPrefixDL),
        (u'cyclicPrefixUL', _AdditionalSpecialSubframe_Info_cyclicPrefixUL),
        (u'iE-Extensions', _AdditionalSpecialSubframe_Info_iE_Extensions),
        ])
    AdditionalSpecialSubframe_Info._ext = []
    
    #-----< AdditionalSpecialSubframe-Info-ExtIEs >-----#
    AdditionalSpecialSubframe_Info_ExtIEs = CLASS(name=u'AdditionalSpecialSubframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AdditionalSpecialSubframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalSpecialSubframePatterns >-----#
    AdditionalSpecialSubframePatterns = ENUM(name=u'AdditionalSpecialSubframePatterns', mode=MODE_TYPE)
    AdditionalSpecialSubframePatterns._cont = ASN1Dict([(u'ssp0', 0), (u'ssp1', 1), (u'ssp2', 2), (u'ssp3', 3), (u'ssp4', 4), (u'ssp5', 5), (u'ssp6', 6), (u'ssp7', 7), (u'ssp8', 8), (u'ssp9', 9)])
    AdditionalSpecialSubframePatterns._ext = []
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name=u'AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name=u'AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfMDT >-----#
    AreaScopeOfMDT = CHOICE(name=u'AreaScopeOfMDT', mode=MODE_TYPE)
    _AreaScopeOfMDT_cellBased = SEQ(name=u'cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellBasedMDT')))
    _AreaScopeOfMDT_tABased = SEQ(name=u'tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_pLMNWide = NULL(name=u'pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_tAIBased = SEQ(name=u'tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAIBasedMDT')))
    AreaScopeOfMDT._cont = ASN1Dict([
        (u'cellBased', _AreaScopeOfMDT_cellBased),
        (u'tABased', _AreaScopeOfMDT_tABased),
        (u'pLMNWide', _AreaScopeOfMDT_pLMNWide),
        (u'tAIBased', _AreaScopeOfMDT_tAIBased),
        ])
    AreaScopeOfMDT._ext = [u'tAIBased']
    
    #-----< AS-SecurityInformation >-----#
    AS_SecurityInformation = SEQ(name=u'AS-SecurityInformation', mode=MODE_TYPE)
    _AS_SecurityInformation_key_eNodeB_star = BIT_STR(name=u'key-eNodeB-star', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Key-eNodeB-Star')))
    _AS_SecurityInformation_nextHopChainingCount = INT(name=u'nextHopChainingCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NextHopChainingCount')))
    _AS_SecurityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AS_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AS_SecurityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AS_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AS_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AS_SecurityInformation_iE_Extensions__item__id._const_tab = ____AS_SecurityInformation_iE_Extensions__item__id_tab
    ___AS_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___AS_SecurityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___AS_SecurityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___AS_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____AS_SecurityInformation_iE_Extensions__item__id_tab
    ___AS_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AS_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____AS_SecurityInformation_iE_Extensions__item__id_tab
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AS_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AS_SecurityInformation_iE_Extensions__item__id),
        (u'criticality', ___AS_SecurityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___AS_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __AS_SecurityInformation_iE_Extensions__item_._ext = None
    _AS_SecurityInformation_iE_Extensions._cont = __AS_SecurityInformation_iE_Extensions__item_
    _AS_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AS_SecurityInformation._cont = ASN1Dict([
        (u'key-eNodeB-star', _AS_SecurityInformation_key_eNodeB_star),
        (u'nextHopChainingCount', _AS_SecurityInformation_nextHopChainingCount),
        (u'iE-Extensions', _AS_SecurityInformation_iE_Extensions),
        ])
    AS_SecurityInformation._ext = []
    
    #-----< AS-SecurityInformation-ExtIEs >-----#
    AS_SecurityInformation_ExtIEs = CLASS(name=u'AS-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AS_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BearerType >-----#
    BearerType = ENUM(name=u'BearerType', mode=MODE_TYPE)
    BearerType._cont = ASN1Dict([(u'non-IP', 0)])
    BearerType._ext = []
    
    #-----< BenefitMetric >-----#
    BenefitMetric = INT(name=u'BenefitMetric', mode=MODE_TYPE)
    BenefitMetric._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-101, ub=100)], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name=u'BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000000)], ev=None, er=[])
    
    #-----< BroadcastPLMNs-Item >-----#
    BroadcastPLMNs_Item = SEQ_OF(name=u'BroadcastPLMNs-Item', mode=MODE_TYPE)
    _BroadcastPLMNs_Item__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    BroadcastPLMNs_Item._cont = _BroadcastPLMNs_Item__item_
    BroadcastPLMNs_Item._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< CapacityValue >-----#
    CapacityValue = INT(name=u'CapacityValue', mode=MODE_TYPE)
    CapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name=u'transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transport', _Cause_transport),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'control-processing-overload', 0), (u'hardware-failure', 1), (u'om-intervention', 2), (u'not-enough-user-plane-processing-resources', 3), (u'unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'unspecified', 5), (u'abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'handover-desirable-for-radio-reasons', 0), (u'time-critical-handover', 1), (u'resource-optimisation-handover', 2), (u'reduce-load-in-serving-cell', 3), (u'partial-handover', 4), (u'unknown-new-eNB-UE-X2AP-ID', 5), (u'unknown-old-eNB-UE-X2AP-ID', 6), (u'unknown-pair-of-UE-X2AP-ID', 7), (u'ho-target-not-allowed', 8), (u'tx2relocoverall-expiry', 9), (u'trelocprep-expiry', 10), (u'cell-not-available', 11), (u'no-radio-resources-available-in-target-cell', 12), (u'invalid-MME-GroupID', 13), (u'unknown-MME-Code', 14), (u'encryption-and-or-integrity-protection-algorithms-not-supported', 15), (u'reportCharacteristicsEmpty', 16), (u'noReportPeriodicity', 17), (u'existingMeasurementID', 18), (u'unknown-eNB-Measurement-ID', 19), (u'measurement-temporarily-not-available', 20), (u'unspecified', 21), (u'load-balancing', 22), (u'handover-optimisation', 23), (u'value-out-of-allowed-range', 24), (u'multiple-E-RAB-ID-instances', 25), (u'switch-off-ongoing', 26), (u'not-supported-QCI-value', 27), (u'measurement-not-supported-for-the-object', 28), (u'tDCoverall-expiry', 29), (u'tDCprep-expiry', 30), (u'action-desirable-for-radio-reasons', 31), (u'reduce-load', 32), (u'resource-optimisation', 33), (u'time-critical-action', 34), (u'target-not-allowed', 35), (u'no-radio-resources-available', 36), (u'invalid-QoS-combination', 37), (u'encryption-algorithms-not-aupported', 38), (u'procedure-cancelled', 39), (u'rRM-purpose', 40), (u'improve-user-bit-rate', 41), (u'user-inactivity', 42), (u'radio-connection-with-UE-lost', 43), (u'failure-in-the-radio-interface-procedure', 44), (u'bearer-option-not-supported', 45)])
    CauseRadioNetwork._ext = [u'load-balancing', u'handover-optimisation', u'value-out-of-allowed-range', u'multiple-E-RAB-ID-instances', u'switch-off-ongoing', u'not-supported-QCI-value', u'measurement-not-supported-for-the-object', u'tDCoverall-expiry', u'tDCprep-expiry', u'action-desirable-for-radio-reasons', u'reduce-load', u'resource-optimisation', u'time-critical-action', u'target-not-allowed', u'no-radio-resources-available', u'invalid-QoS-combination', u'encryption-algorithms-not-aupported', u'procedure-cancelled', u'rRM-purpose', u'improve-user-bit-rate', u'user-inactivity', u'radio-connection-with-UE-lost', u'failure-in-the-radio-interface-procedure', u'bearer-option-not-supported']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name=u'CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([(u'transport-resource-unavailable', 0), (u'unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CellBasedMDT >-----#
    CellBasedMDT = SEQ(name=u'CellBasedMDT', mode=MODE_TYPE)
    _CellBasedMDT_cellIdListforMDT = SEQ_OF(name=u'cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellIdListforMDT')))
    _CellBasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__id._const_tab = ____CellBasedMDT_iE_Extensions__item__id_tab
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_iE_Extensions__item__id_tab
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_iE_Extensions__item__id_tab
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBasedMDT_iE_Extensions__item__id),
        (u'criticality', ___CellBasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_iE_Extensions__item_._ext = None
    _CellBasedMDT_iE_Extensions._cont = __CellBasedMDT_iE_Extensions__item_
    _CellBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT._cont = ASN1Dict([
        (u'cellIdListforMDT', _CellBasedMDT_cellIdListforMDT),
        (u'iE-Extensions', _CellBasedMDT_iE_Extensions),
        ])
    CellBasedMDT._ext = []
    
    #-----< CellBasedMDT-ExtIEs >-----#
    CellBasedMDT_ExtIEs = CLASS(name=u'CellBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellCapacityClassValue >-----#
    CellCapacityClassValue = INT(name=u'CellCapacityClassValue', mode=MODE_TYPE)
    CellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< CellDeploymentStatusIndicator >-----#
    CellDeploymentStatusIndicator = ENUM(name=u'CellDeploymentStatusIndicator', mode=MODE_TYPE)
    CellDeploymentStatusIndicator._cont = ASN1Dict([(u'pre-change-notification', 0)])
    CellDeploymentStatusIndicator._ext = []
    
    #-----< CellIdListforMDT >-----#
    CellIdListforMDT = SEQ_OF(name=u'CellIdListforMDT', mode=MODE_TYPE)
    _CellIdListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    CellIdListforMDT._cont = _CellIdListforMDT__item_
    CellIdListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellReplacingInfo >-----#
    CellReplacingInfo = SEQ(name=u'CellReplacingInfo', mode=MODE_TYPE)
    _CellReplacingInfo_replacingCellsList = SEQ_OF(name=u'replacingCellsList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReplacingCellsList')))
    _CellReplacingInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellReplacingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellReplacingInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellReplacingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellReplacingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReplacingInfo_iE_Extensions__item__id._const_tab = ____CellReplacingInfo_iE_Extensions__item__id_tab
    ___CellReplacingInfo_iE_Extensions__item__id._const_tab_at = None
    ___CellReplacingInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellReplacingInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CellReplacingInfo_iE_Extensions__item__criticality._const_tab = ____CellReplacingInfo_iE_Extensions__item__id_tab
    ___CellReplacingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellReplacingInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellReplacingInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CellReplacingInfo_iE_Extensions__item__extensionValue._const_tab = ____CellReplacingInfo_iE_Extensions__item__id_tab
    ___CellReplacingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellReplacingInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellReplacingInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellReplacingInfo_iE_Extensions__item__id),
        (u'criticality', ___CellReplacingInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellReplacingInfo_iE_Extensions__item__extensionValue),
        ])
    __CellReplacingInfo_iE_Extensions__item_._ext = None
    _CellReplacingInfo_iE_Extensions._cont = __CellReplacingInfo_iE_Extensions__item_
    _CellReplacingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellReplacingInfo._cont = ASN1Dict([
        (u'replacingCellsList', _CellReplacingInfo_replacingCellsList),
        (u'iE-Extensions', _CellReplacingInfo_iE_Extensions),
        ])
    CellReplacingInfo._ext = []
    
    #-----< CellReplacingInfo-ExtIEs >-----#
    CellReplacingInfo_ExtIEs = CLASS(name=u'CellReplacingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellReplacingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellReportingIndicator >-----#
    CellReportingIndicator = ENUM(name=u'CellReportingIndicator', mode=MODE_TYPE)
    CellReportingIndicator._cont = ASN1Dict([(u'stop-request', 0)])
    CellReportingIndicator._ext = []
    
    #-----< Cell-Size >-----#
    Cell_Size = ENUM(name=u'Cell-Size', mode=MODE_TYPE)
    Cell_Size._cont = ASN1Dict([(u'verysmall', 0), (u'small', 1), (u'medium', 2), (u'large', 3)])
    Cell_Size._ext = []
    
    #-----< CellType >-----#
    CellType = SEQ(name=u'CellType', mode=MODE_TYPE)
    _CellType_cell_Size = ENUM(name=u'cell-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cell-Size')))
    _CellType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellType_iE_Extensions__item__id),
        (u'criticality', ___CellType_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        (u'cell-Size', _CellType_cell_Size),
        (u'iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name=u'CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPHypothesisSet >-----#
    CoMPHypothesisSet = SEQ_OF(name=u'CoMPHypothesisSet', mode=MODE_TYPE)
    _CoMPHypothesisSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoMPHypothesisSetItem')))
    CoMPHypothesisSet._cont = _CoMPHypothesisSet__item_
    CoMPHypothesisSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CoMPHypothesisSetItem >-----#
    CoMPHypothesisSetItem = SEQ(name=u'CoMPHypothesisSetItem', mode=MODE_TYPE)
    _CoMPHypothesisSetItem_coMPCellID = SEQ(name=u'coMPCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CoMPHypothesisSetItem_coMPHypothesis = BIT_STR(name=u'coMPHypothesis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoMPHypothesisSetItem_coMPHypothesis._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=4400)], ev=[], er=[])
    _CoMPHypothesisSetItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CoMPHypothesisSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CoMPHypothesisSetItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPHypothesisSetItem_iE_Extensions__item__id._const_tab = ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab
    ___CoMPHypothesisSetItem_iE_Extensions__item__id._const_tab_at = None
    ___CoMPHypothesisSetItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality._const_tab = ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue._const_tab = ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CoMPHypothesisSetItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CoMPHypothesisSetItem_iE_Extensions__item__id),
        (u'criticality', ___CoMPHypothesisSetItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue),
        ])
    __CoMPHypothesisSetItem_iE_Extensions__item_._ext = None
    _CoMPHypothesisSetItem_iE_Extensions._cont = __CoMPHypothesisSetItem_iE_Extensions__item_
    _CoMPHypothesisSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CoMPHypothesisSetItem._cont = ASN1Dict([
        (u'coMPCellID', _CoMPHypothesisSetItem_coMPCellID),
        (u'coMPHypothesis', _CoMPHypothesisSetItem_coMPHypothesis),
        (u'iE-Extensions', _CoMPHypothesisSetItem_iE_Extensions),
        ])
    CoMPHypothesisSetItem._ext = []
    
    #-----< CoMPHypothesisSetItem-ExtIEs >-----#
    CoMPHypothesisSetItem_ExtIEs = CLASS(name=u'CoMPHypothesisSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPHypothesisSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPInformation >-----#
    CoMPInformation = SEQ(name=u'CoMPInformation', mode=MODE_TYPE)
    _CoMPInformation_coMPInformationItem = SEQ_OF(name=u'coMPInformationItem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformationItem')))
    _CoMPInformation_coMPInformationStartTime = SEQ_OF(name=u'coMPInformationStartTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformationStartTime')))
    _CoMPInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CoMPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CoMPInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CoMPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPInformation_iE_Extensions__item__id._const_tab = ____CoMPInformation_iE_Extensions__item__id_tab
    ___CoMPInformation_iE_Extensions__item__id._const_tab_at = None
    ___CoMPInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___CoMPInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CoMPInformation_iE_Extensions__item__criticality._const_tab = ____CoMPInformation_iE_Extensions__item__id_tab
    ___CoMPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CoMPInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CoMPInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CoMPInformation_iE_Extensions__item__extensionValue._const_tab = ____CoMPInformation_iE_Extensions__item__id_tab
    ___CoMPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CoMPInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CoMPInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CoMPInformation_iE_Extensions__item__id),
        (u'criticality', ___CoMPInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___CoMPInformation_iE_Extensions__item__extensionValue),
        ])
    __CoMPInformation_iE_Extensions__item_._ext = None
    _CoMPInformation_iE_Extensions._cont = __CoMPInformation_iE_Extensions__item_
    _CoMPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CoMPInformation._cont = ASN1Dict([
        (u'coMPInformationItem', _CoMPInformation_coMPInformationItem),
        (u'coMPInformationStartTime', _CoMPInformation_coMPInformationStartTime),
        (u'iE-Extensions', _CoMPInformation_iE_Extensions),
        ])
    CoMPInformation._ext = []
    
    #-----< CoMPInformation-ExtIEs >-----#
    CoMPInformation_ExtIEs = CLASS(name=u'CoMPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPInformationItem >-----#
    CoMPInformationItem = SEQ_OF(name=u'CoMPInformationItem', mode=MODE_TYPE)
    _CoMPInformationItem__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CoMPInformationItem__item__coMPHypothesisSet = SEQ_OF(name=u'coMPHypothesisSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CoMPHypothesisSet')))
    __CoMPInformationItem__item__benefitMetric = INT(name=u'benefitMetric', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BenefitMetric')))
    __CoMPInformationItem__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CoMPInformationItem__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CoMPInformationItem__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____CoMPInformationItem__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationItem__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationItem__item__iE_Extensions__item__id._const_tab = _____CoMPInformationItem__item__iE_Extensions__item__id_tab
    ____CoMPInformationItem__item__iE_Extensions__item__id._const_tab_at = None
    ____CoMPInformationItem__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CoMPInformationItem__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CoMPInformationItem__item__iE_Extensions__item__criticality._const_tab = _____CoMPInformationItem__item__iE_Extensions__item__id_tab
    ____CoMPInformationItem__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CoMPInformationItem__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue._const_tab = _____CoMPInformationItem__item__iE_Extensions__item__id_tab
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CoMPInformationItem__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CoMPInformationItem__item__iE_Extensions__item__id),
        (u'criticality', ____CoMPInformationItem__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CoMPInformationItem__item__iE_Extensions__item__extensionValue),
        ])
    ___CoMPInformationItem__item__iE_Extensions__item_._ext = None
    __CoMPInformationItem__item__iE_Extensions._cont = ___CoMPInformationItem__item__iE_Extensions__item_
    __CoMPInformationItem__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CoMPInformationItem__item_._cont = ASN1Dict([
        (u'coMPHypothesisSet', __CoMPInformationItem__item__coMPHypothesisSet),
        (u'benefitMetric', __CoMPInformationItem__item__benefitMetric),
        (u'iE-Extensions', __CoMPInformationItem__item__iE_Extensions),
        ])
    _CoMPInformationItem__item_._ext = []
    CoMPInformationItem._cont = _CoMPInformationItem__item_
    CoMPInformationItem._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CoMPInformationItem-ExtIEs >-----#
    CoMPInformationItem_ExtIEs = CLASS(name=u'CoMPInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPInformationStartTime >-----#
    CoMPInformationStartTime = SEQ_OF(name=u'CoMPInformationStartTime', mode=MODE_TYPE)
    _CoMPInformationStartTime__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CoMPInformationStartTime__item__startSFN = INT(name=u'startSFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CoMPInformationStartTime__item__startSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    __CoMPInformationStartTime__item__startSubframeNumber = INT(name=u'startSubframeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CoMPInformationStartTime__item__startSubframeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    __CoMPInformationStartTime__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CoMPInformationStartTime__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CoMPInformationStartTime__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationStartTime__item__iE_Extensions__item__id._const_tab = _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab
    ____CoMPInformationStartTime__item__iE_Extensions__item__id._const_tab_at = None
    ____CoMPInformationStartTime__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality._const_tab = _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue._const_tab = _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CoMPInformationStartTime__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CoMPInformationStartTime__item__iE_Extensions__item__id),
        (u'criticality', ____CoMPInformationStartTime__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue),
        ])
    ___CoMPInformationStartTime__item__iE_Extensions__item_._ext = None
    __CoMPInformationStartTime__item__iE_Extensions._cont = ___CoMPInformationStartTime__item__iE_Extensions__item_
    __CoMPInformationStartTime__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CoMPInformationStartTime__item_._cont = ASN1Dict([
        (u'startSFN', __CoMPInformationStartTime__item__startSFN),
        (u'startSubframeNumber', __CoMPInformationStartTime__item__startSubframeNumber),
        (u'iE-Extensions', __CoMPInformationStartTime__item__iE_Extensions),
        ])
    _CoMPInformationStartTime__item_._ext = []
    CoMPInformationStartTime._cont = _CoMPInformationStartTime__item_
    CoMPInformationStartTime._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    
    #-----< CoMPInformationStartTime-ExtIEs >-----#
    CoMPInformationStartTime_ExtIEs = CLASS(name=u'CoMPInformationStartTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPInformationStartTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacity >-----#
    CompositeAvailableCapacity = SEQ(name=u'CompositeAvailableCapacity', mode=MODE_TYPE)
    _CompositeAvailableCapacity_cellCapacityClassValue = INT(name=u'cellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellCapacityClassValue')), opt=True)
    _CompositeAvailableCapacity_capacityValue = INT(name=u'capacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CapacityValue')))
    _CompositeAvailableCapacity_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacity_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompositeAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompositeAvailableCapacity_iE_Extensions__item__id),
        (u'criticality', ___CompositeAvailableCapacity_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacity_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacity_iE_Extensions._cont = __CompositeAvailableCapacity_iE_Extensions__item_
    _CompositeAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacity._cont = ASN1Dict([
        (u'cellCapacityClassValue', _CompositeAvailableCapacity_cellCapacityClassValue),
        (u'capacityValue', _CompositeAvailableCapacity_capacityValue),
        (u'iE-Extensions', _CompositeAvailableCapacity_iE_Extensions),
        ])
    CompositeAvailableCapacity._ext = []
    
    #-----< CompositeAvailableCapacity-ExtIEs >-----#
    CompositeAvailableCapacity_ExtIEs = CLASS(name=u'CompositeAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacityGroup >-----#
    CompositeAvailableCapacityGroup = SEQ(name=u'CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    _CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity = SEQ(name=u'dL-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity = SEQ(name=u'uL-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacityGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompositeAvailableCapacityGroup_iE_Extensions__item__id),
        (u'criticality', ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacityGroup_iE_Extensions._cont = __CompositeAvailableCapacityGroup_iE_Extensions__item_
    _CompositeAvailableCapacityGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacityGroup._cont = ASN1Dict([
        (u'dL-CompositeAvailableCapacity', _CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity),
        (u'uL-CompositeAvailableCapacity', _CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity),
        (u'iE-Extensions', _CompositeAvailableCapacityGroup_iE_Extensions),
        ])
    CompositeAvailableCapacityGroup._ext = []
    
    #-----< CompositeAvailableCapacityGroup-ExtIEs >-----#
    CompositeAvailableCapacityGroup_ExtIEs = CLASS(name=u'CompositeAvailableCapacityGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacityGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Correlation-ID >-----#
    Correlation_ID = OCT_STR(name=u'Correlation-ID', mode=MODE_TYPE)
    Correlation_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< COUNTvalue >-----#
    COUNTvalue = SEQ(name=u'COUNTvalue', mode=MODE_TYPE)
    _COUNTvalue_pDCP_SN = INT(name=u'pDCP-SN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PDCP-SN')))
    _COUNTvalue_hFN = INT(name=u'hFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HFN')))
    _COUNTvalue_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvalue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvalue_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTvalue_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__id._const_tab = ____COUNTvalue_iE_Extensions__item__id_tab
    ___COUNTvalue_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvalue_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTvalue_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab = ____COUNTvalue_iE_Extensions__item__id_tab
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTvalue_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab = ____COUNTvalue_iE_Extensions__item__id_tab
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTvalue_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTvalue_iE_Extensions__item__id),
        (u'criticality', ___COUNTvalue_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTvalue_iE_Extensions__item__extensionValue),
        ])
    __COUNTvalue_iE_Extensions__item_._ext = None
    _COUNTvalue_iE_Extensions._cont = __COUNTvalue_iE_Extensions__item_
    _COUNTvalue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvalue._cont = ASN1Dict([
        (u'pDCP-SN', _COUNTvalue_pDCP_SN),
        (u'hFN', _COUNTvalue_hFN),
        (u'iE-Extensions', _COUNTvalue_iE_Extensions),
        ])
    COUNTvalue._ext = []
    
    #-----< COUNTvalue-ExtIEs >-----#
    COUNTvalue_ExtIEs = CLASS(name=u'COUNTvalue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    COUNTvalue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTValueExtended >-----#
    COUNTValueExtended = SEQ(name=u'COUNTValueExtended', mode=MODE_TYPE)
    _COUNTValueExtended_pDCP_SNExtended = INT(name=u'pDCP-SNExtended', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PDCP-SNExtended')))
    _COUNTValueExtended_hFNModified = INT(name=u'hFNModified', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HFNModified')))
    _COUNTValueExtended_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueExtended_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueExtended_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTValueExtended_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab = ____COUNTValueExtended_iE_Extensions__item__id_tab
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTValueExtended_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab = ____COUNTValueExtended_iE_Extensions__item__id_tab
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTValueExtended_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueExtended_iE_Extensions__item__id_tab
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTValueExtended_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTValueExtended_iE_Extensions__item__id),
        (u'criticality', ___COUNTValueExtended_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTValueExtended_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueExtended_iE_Extensions__item_._ext = None
    _COUNTValueExtended_iE_Extensions._cont = __COUNTValueExtended_iE_Extensions__item_
    _COUNTValueExtended_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueExtended._cont = ASN1Dict([
        (u'pDCP-SNExtended', _COUNTValueExtended_pDCP_SNExtended),
        (u'hFNModified', _COUNTValueExtended_hFNModified),
        (u'iE-Extensions', _COUNTValueExtended_iE_Extensions),
        ])
    COUNTValueExtended._ext = []
    
    #-----< COUNTValueExtended-ExtIEs >-----#
    COUNTValueExtended_ExtIEs = CLASS(name=u'COUNTValueExtended-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    COUNTValueExtended_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTvaluePDCP-SNlength18 >-----#
    COUNTvaluePDCP_SNlength18 = SEQ(name=u'COUNTvaluePDCP-SNlength18', mode=MODE_TYPE)
    _COUNTvaluePDCP_SNlength18_pDCP_SNlength18 = INT(name=u'pDCP-SNlength18', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18 = INT(name=u'hFNforPDCP-SNlength18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HFNforPDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id),
        (u'criticality', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue),
        ])
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._ext = None
    _COUNTvaluePDCP_SNlength18_iE_Extensions._cont = __COUNTvaluePDCP_SNlength18_iE_Extensions__item_
    _COUNTvaluePDCP_SNlength18_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvaluePDCP_SNlength18._cont = ASN1Dict([
        (u'pDCP-SNlength18', _COUNTvaluePDCP_SNlength18_pDCP_SNlength18),
        (u'hFNforPDCP-SNlength18', _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18),
        (u'iE-Extensions', _COUNTvaluePDCP_SNlength18_iE_Extensions),
        ])
    COUNTvaluePDCP_SNlength18._ext = []
    
    #-----< COUNTvaluePDCP-SNlength18-ExtIEs >-----#
    COUNTvaluePDCP_SNlength18_ExtIEs = CLASS(name=u'COUNTvaluePDCP-SNlength18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    COUNTvaluePDCP_SNlength18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoverageModificationList >-----#
    CoverageModificationList = SEQ_OF(name=u'CoverageModificationList', mode=MODE_TYPE)
    _CoverageModificationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoverageModification-Item')))
    CoverageModificationList._cont = _CoverageModificationList__item_
    CoverageModificationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CoverageModification-Item >-----#
    CoverageModification_Item = SEQ(name=u'CoverageModification-Item', mode=MODE_TYPE)
    _CoverageModification_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CoverageModification_Item_coverageState = INT(name=u'coverageState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoverageModification_Item_coverageState._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _CoverageModification_Item_cellDeploymentStatusIndicator = ENUM(name=u'cellDeploymentStatusIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellDeploymentStatusIndicator')), opt=True)
    _CoverageModification_Item_cellReplacingInfo = SEQ(name=u'cellReplacingInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellReplacingInfo')), opt=True)
    CoverageModification_Item._cont = ASN1Dict([
        (u'eCGI', _CoverageModification_Item_eCGI),
        (u'coverageState', _CoverageModification_Item_coverageState),
        (u'cellDeploymentStatusIndicator', _CoverageModification_Item_cellDeploymentStatusIndicator),
        (u'cellReplacingInfo', _CoverageModification_Item_cellReplacingInfo),
        ])
    CoverageModification_Item._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name=u'typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        (u'criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        (u'iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        (u'iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        (u'typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        (u'iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CRNTI >-----#
    CRNTI = BIT_STR(name=u'CRNTI', mode=MODE_TYPE)
    CRNTI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< CSGMembershipStatus >-----#
    CSGMembershipStatus = ENUM(name=u'CSGMembershipStatus', mode=MODE_TYPE)
    CSGMembershipStatus._cont = ASN1Dict([(u'member', 0), (u'not-member', 1)])
    CSGMembershipStatus._ext = None
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name=u'CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSIReportList >-----#
    CSIReportList = SEQ_OF(name=u'CSIReportList', mode=MODE_TYPE)
    _CSIReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CSIReportList__item__uEID = BIT_STR(name=u'uEID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEID')))
    __CSIReportList__item__cSIReportPerCSIProcess = SEQ_OF(name=u'cSIReportPerCSIProcess', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSIReportPerCSIProcess')))
    __CSIReportList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CSIReportList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CSIReportList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____CSIReportList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportList__item__iE_Extensions__item__id._const_tab = _____CSIReportList__item__iE_Extensions__item__id_tab
    ____CSIReportList__item__iE_Extensions__item__id._const_tab_at = None
    ____CSIReportList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CSIReportList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CSIReportList__item__iE_Extensions__item__criticality._const_tab = _____CSIReportList__item__iE_Extensions__item__id_tab
    ____CSIReportList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CSIReportList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CSIReportList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CSIReportList__item__iE_Extensions__item__extensionValue._const_tab = _____CSIReportList__item__iE_Extensions__item__id_tab
    ____CSIReportList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CSIReportList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CSIReportList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CSIReportList__item__iE_Extensions__item__id),
        (u'criticality', ____CSIReportList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CSIReportList__item__iE_Extensions__item__extensionValue),
        ])
    ___CSIReportList__item__iE_Extensions__item_._ext = None
    __CSIReportList__item__iE_Extensions._cont = ___CSIReportList__item__iE_Extensions__item_
    __CSIReportList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CSIReportList__item_._cont = ASN1Dict([
        (u'uEID', __CSIReportList__item__uEID),
        (u'cSIReportPerCSIProcess', __CSIReportList__item__cSIReportPerCSIProcess),
        (u'iE-Extensions', __CSIReportList__item__iE_Extensions),
        ])
    _CSIReportList__item_._ext = []
    CSIReportList._cont = _CSIReportList__item_
    CSIReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< CSIReportList-ExtIEs >-----#
    CSIReportList_ExtIEs = CLASS(name=u'CSIReportList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSIReportList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSIReportPerCSIProcess >-----#
    CSIReportPerCSIProcess = SEQ_OF(name=u'CSIReportPerCSIProcess', mode=MODE_TYPE)
    _CSIReportPerCSIProcess__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex = INT(name=u'cSIProcessConfigurationIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=[], er=[])
    __CSIReportPerCSIProcess__item__cSIReportPerCSIProcessItem = SEQ_OF(name=u'cSIReportPerCSIProcessItem', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSIReportPerCSIProcessItem')))
    __CSIReportPerCSIProcess__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CSIReportPerCSIProcess__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id._const_tab = _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id._const_tab_at = None
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality._const_tab = _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue._const_tab = _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CSIReportPerCSIProcess__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CSIReportPerCSIProcess__item__iE_Extensions__item__id),
        (u'criticality', ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue),
        ])
    ___CSIReportPerCSIProcess__item__iE_Extensions__item_._ext = None
    __CSIReportPerCSIProcess__item__iE_Extensions._cont = ___CSIReportPerCSIProcess__item__iE_Extensions__item_
    __CSIReportPerCSIProcess__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CSIReportPerCSIProcess__item_._cont = ASN1Dict([
        (u'cSIProcessConfigurationIndex', __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex),
        (u'cSIReportPerCSIProcessItem', __CSIReportPerCSIProcess__item__cSIReportPerCSIProcessItem),
        (u'iE-Extensions', __CSIReportPerCSIProcess__item__iE_Extensions),
        ])
    _CSIReportPerCSIProcess__item_._ext = []
    CSIReportPerCSIProcess._cont = _CSIReportPerCSIProcess__item_
    CSIReportPerCSIProcess._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< CSIReportPerCSIProcess-ExtIEs >-----#
    CSIReportPerCSIProcess_ExtIEs = CLASS(name=u'CSIReportPerCSIProcess-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSIReportPerCSIProcess_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSIReportPerCSIProcessItem >-----#
    CSIReportPerCSIProcessItem = SEQ_OF(name=u'CSIReportPerCSIProcessItem', mode=MODE_TYPE)
    _CSIReportPerCSIProcessItem__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CSIReportPerCSIProcessItem__item__rI = INT(name=u'rI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CSIReportPerCSIProcessItem__item__rI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    __CSIReportPerCSIProcessItem__item__widebandCQI = SEQ(name=u'widebandCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WidebandCQI')))
    __CSIReportPerCSIProcessItem__item__subbandSize = ENUM(name=u'subbandSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandSize')))
    __CSIReportPerCSIProcessItem__item__subbandCQIList = SEQ_OF(name=u'subbandCQIList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQIList')), opt=True)
    __CSIReportPerCSIProcessItem__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id._const_tab = _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id._const_tab_at = None
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality._const_tab = _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue._const_tab = _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id),
        (u'criticality', ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue),
        ])
    ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_._ext = None
    __CSIReportPerCSIProcessItem__item__iE_Extensions._cont = ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_
    __CSIReportPerCSIProcessItem__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CSIReportPerCSIProcessItem__item_._cont = ASN1Dict([
        (u'rI', __CSIReportPerCSIProcessItem__item__rI),
        (u'widebandCQI', __CSIReportPerCSIProcessItem__item__widebandCQI),
        (u'subbandSize', __CSIReportPerCSIProcessItem__item__subbandSize),
        (u'subbandCQIList', __CSIReportPerCSIProcessItem__item__subbandCQIList),
        (u'iE-Extensions', __CSIReportPerCSIProcessItem__item__iE_Extensions),
        ])
    _CSIReportPerCSIProcessItem__item_._ext = []
    CSIReportPerCSIProcessItem._cont = _CSIReportPerCSIProcessItem__item_
    CSIReportPerCSIProcessItem._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< CSIReportPerCSIProcessItem-ExtIEs >-----#
    CSIReportPerCSIProcessItem_ExtIEs = CLASS(name=u'CSIReportPerCSIProcessItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSIReportPerCSIProcessItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CyclicPrefixDL >-----#
    CyclicPrefixDL = ENUM(name=u'CyclicPrefixDL', mode=MODE_TYPE)
    CyclicPrefixDL._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    CyclicPrefixDL._ext = []
    
    #-----< CyclicPrefixUL >-----#
    CyclicPrefixUL = ENUM(name=u'CyclicPrefixUL', mode=MODE_TYPE)
    CyclicPrefixUL._cont = ASN1Dict([(u'normal', 0), (u'extended', 1)])
    CyclicPrefixUL._ext = []
    
    #-----< DeactivationIndication >-----#
    DeactivationIndication = ENUM(name=u'DeactivationIndication', mode=MODE_TYPE)
    DeactivationIndication._cont = ASN1Dict([(u'deactivated', 0)])
    DeactivationIndication._ext = []
    
    #-----< DL-ABS-status >-----#
    DL_ABS_status = INT(name=u'DL-ABS-status', mode=MODE_TYPE)
    DL_ABS_status._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-Forwarding >-----#
    DL_Forwarding = ENUM(name=u'DL-Forwarding', mode=MODE_TYPE)
    DL_Forwarding._cont = ASN1Dict([(u'dL-forwardingProposed', 0)])
    DL_Forwarding._ext = []
    
    #-----< DL-GBR-PRB-usage >-----#
    DL_GBR_PRB_usage = INT(name=u'DL-GBR-PRB-usage', mode=MODE_TYPE)
    DL_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-non-GBR-PRB-usage >-----#
    DL_non_GBR_PRB_usage = INT(name=u'DL-non-GBR-PRB-usage', mode=MODE_TYPE)
    DL_non_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-Total-PRB-usage >-----#
    DL_Total_PRB_usage = INT(name=u'DL-Total-PRB-usage', mode=MODE_TYPE)
    DL_Total_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DynamicDLTransmissionInformation >-----#
    DynamicDLTransmissionInformation = CHOICE(name=u'DynamicDLTransmissionInformation', mode=MODE_TYPE)
    _DynamicDLTransmissionInformation_naics_active = SEQ(name=u'naics-active', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DynamicNAICSInformation')))
    _DynamicDLTransmissionInformation_naics_inactive = NULL(name=u'naics-inactive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DynamicDLTransmissionInformation._cont = ASN1Dict([
        (u'naics-active', _DynamicDLTransmissionInformation_naics_active),
        (u'naics-inactive', _DynamicDLTransmissionInformation_naics_inactive),
        ])
    DynamicDLTransmissionInformation._ext = []
    
    #-----< DynamicNAICSInformation >-----#
    DynamicNAICSInformation = SEQ(name=u'DynamicNAICSInformation', mode=MODE_TYPE)
    _DynamicNAICSInformation_transmissionModes = BIT_STR(name=u'transmissionModes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DynamicNAICSInformation_transmissionModes._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DynamicNAICSInformation_pB_information = INT(name=u'pB-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DynamicNAICSInformation_pB_information._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _DynamicNAICSInformation_pA_list = SEQ_OF(name=u'pA-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DynamicNAICSInformation_pA_list__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PA-Values')))
    _DynamicNAICSInformation_pA_list._cont = __DynamicNAICSInformation_pA_list__item_
    _DynamicNAICSInformation_pA_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _DynamicNAICSInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DynamicNAICSInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DynamicNAICSInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DynamicNAICSInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DynamicNAICSInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicNAICSInformation_iE_Extensions__item__id._const_tab = ____DynamicNAICSInformation_iE_Extensions__item__id_tab
    ___DynamicNAICSInformation_iE_Extensions__item__id._const_tab_at = None
    ___DynamicNAICSInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___DynamicNAICSInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DynamicNAICSInformation_iE_Extensions__item__criticality._const_tab = ____DynamicNAICSInformation_iE_Extensions__item__id_tab
    ___DynamicNAICSInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DynamicNAICSInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue._const_tab = ____DynamicNAICSInformation_iE_Extensions__item__id_tab
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DynamicNAICSInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DynamicNAICSInformation_iE_Extensions__item__id),
        (u'criticality', ___DynamicNAICSInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___DynamicNAICSInformation_iE_Extensions__item__extensionValue),
        ])
    __DynamicNAICSInformation_iE_Extensions__item_._ext = None
    _DynamicNAICSInformation_iE_Extensions._cont = __DynamicNAICSInformation_iE_Extensions__item_
    _DynamicNAICSInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DynamicNAICSInformation._cont = ASN1Dict([
        (u'transmissionModes', _DynamicNAICSInformation_transmissionModes),
        (u'pB-information', _DynamicNAICSInformation_pB_information),
        (u'pA-list', _DynamicNAICSInformation_pA_list),
        (u'iE-Extensions', _DynamicNAICSInformation_iE_Extensions),
        ])
    DynamicNAICSInformation._ext = []
    
    #-----< DynamicNAICSInformation-ExtIEs >-----#
    DynamicNAICSInformation_ExtIEs = CLASS(name=u'DynamicNAICSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DynamicNAICSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EARFCN >-----#
    EARFCN = INT(name=u'EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< EARFCNExtension >-----#
    EARFCNExtension = INT(name=u'EARFCNExtension', mode=MODE_TYPE)
    EARFCNExtension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=[], er=[])
    
    #-----< ECGI >-----#
    ECGI = SEQ(name=u'ECGI', mode=MODE_TYPE)
    _ECGI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _ECGI_eUTRANcellIdentifier = BIT_STR(name=u'eUTRANcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    _ECGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ECGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ECGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ECGI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__id._const_tab = ____ECGI_iE_Extensions__item__id_tab
    ___ECGI_iE_Extensions__item__id._const_tab_at = None
    ___ECGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___ECGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ECGI_iE_Extensions__item__criticality._const_tab = ____ECGI_iE_Extensions__item__id_tab
    ___ECGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ECGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ECGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ECGI_iE_Extensions__item__extensionValue._const_tab = ____ECGI_iE_Extensions__item__id_tab
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ECGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ECGI_iE_Extensions__item__id),
        (u'criticality', ___ECGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___ECGI_iE_Extensions__item__extensionValue),
        ])
    __ECGI_iE_Extensions__item_._ext = None
    _ECGI_iE_Extensions._cont = __ECGI_iE_Extensions__item_
    _ECGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ECGI._cont = ASN1Dict([
        (u'pLMN-Identity', _ECGI_pLMN_Identity),
        (u'eUTRANcellIdentifier', _ECGI_eUTRANcellIdentifier),
        (u'iE-Extensions', _ECGI_iE_Extensions),
        ])
    ECGI._ext = []
    
    #-----< ECGI-ExtIEs >-----#
    ECGI_ExtIEs = CLASS(name=u'ECGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ECGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRNTP >-----#
    EnhancedRNTP = SEQ(name=u'EnhancedRNTP', mode=MODE_TYPE)
    _EnhancedRNTP_enhancedRNTPBitmap = BIT_STR(name=u'enhancedRNTPBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancedRNTP_enhancedRNTPBitmap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=8800)], ev=[], er=[])
    _EnhancedRNTP_rNTP_High_Power_Threshold = ENUM(name=u'rNTP-High-Power-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RNTP-Threshold')))
    _EnhancedRNTP_enhancedRNTPStartTime = SEQ(name=u'enhancedRNTPStartTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EnhancedRNTPStartTime')), opt=True)
    _EnhancedRNTP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRNTP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRNTP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRNTP_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTP_iE_Extensions__item__id._const_tab = ____EnhancedRNTP_iE_Extensions__item__id_tab
    ___EnhancedRNTP_iE_Extensions__item__id._const_tab_at = None
    ___EnhancedRNTP_iE_Extensions__item__id._const_tab_id = u'id'
    ___EnhancedRNTP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EnhancedRNTP_iE_Extensions__item__criticality._const_tab = ____EnhancedRNTP_iE_Extensions__item__id_tab
    ___EnhancedRNTP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRNTP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRNTP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EnhancedRNTP_iE_Extensions__item__extensionValue._const_tab = ____EnhancedRNTP_iE_Extensions__item__id_tab
    ___EnhancedRNTP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRNTP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRNTP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRNTP_iE_Extensions__item__id),
        (u'criticality', ___EnhancedRNTP_iE_Extensions__item__criticality),
        (u'extensionValue', ___EnhancedRNTP_iE_Extensions__item__extensionValue),
        ])
    __EnhancedRNTP_iE_Extensions__item_._ext = None
    _EnhancedRNTP_iE_Extensions._cont = __EnhancedRNTP_iE_Extensions__item_
    _EnhancedRNTP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRNTP._cont = ASN1Dict([
        (u'enhancedRNTPBitmap', _EnhancedRNTP_enhancedRNTPBitmap),
        (u'rNTP-High-Power-Threshold', _EnhancedRNTP_rNTP_High_Power_Threshold),
        (u'enhancedRNTPStartTime', _EnhancedRNTP_enhancedRNTPStartTime),
        (u'iE-Extensions', _EnhancedRNTP_iE_Extensions),
        ])
    EnhancedRNTP._ext = []
    
    #-----< EnhancedRNTP-ExtIEs >-----#
    EnhancedRNTP_ExtIEs = CLASS(name=u'EnhancedRNTP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    EnhancedRNTP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRNTPStartTime >-----#
    EnhancedRNTPStartTime = SEQ(name=u'EnhancedRNTPStartTime', mode=MODE_TYPE)
    _EnhancedRNTPStartTime_startSFN = INT(name=u'startSFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancedRNTPStartTime_startSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    _EnhancedRNTPStartTime_startSubframeNumber = INT(name=u'startSubframeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancedRNTPStartTime_startSubframeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    _EnhancedRNTPStartTime_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRNTPStartTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRNTPStartTime_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTPStartTime_iE_Extensions__item__id._const_tab = ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab
    ___EnhancedRNTPStartTime_iE_Extensions__item__id._const_tab_at = None
    ___EnhancedRNTPStartTime_iE_Extensions__item__id._const_tab_id = u'id'
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality._const_tab = ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue._const_tab = ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRNTPStartTime_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRNTPStartTime_iE_Extensions__item__id),
        (u'criticality', ___EnhancedRNTPStartTime_iE_Extensions__item__criticality),
        (u'extensionValue', ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue),
        ])
    __EnhancedRNTPStartTime_iE_Extensions__item_._ext = None
    _EnhancedRNTPStartTime_iE_Extensions._cont = __EnhancedRNTPStartTime_iE_Extensions__item_
    _EnhancedRNTPStartTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRNTPStartTime._cont = ASN1Dict([
        (u'startSFN', _EnhancedRNTPStartTime_startSFN),
        (u'startSubframeNumber', _EnhancedRNTPStartTime_startSubframeNumber),
        (u'iE-Extensions', _EnhancedRNTPStartTime_iE_Extensions),
        ])
    EnhancedRNTPStartTime._ext = []
    
    #-----< EnhancedRNTPStartTime-ExtIEs >-----#
    EnhancedRNTPStartTime_ExtIEs = CLASS(name=u'EnhancedRNTPStartTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    EnhancedRNTPStartTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name=u'ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macro_eNB_ID = BIT_STR(name=u'macro-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macro_eNB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_home_eNB_ID = BIT_STR(name=u'home-eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_home_eNB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        (u'macro-eNB-ID', _ENB_ID_macro_eNB_ID),
        (u'home-eNB-ID', _ENB_ID_home_eNB_ID),
        ])
    ENB_ID._ext = []
    
    #-----< EncryptionAlgorithms >-----#
    EncryptionAlgorithms = BIT_STR(name=u'EncryptionAlgorithms', mode=MODE_TYPE)
    EncryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EPLMNs >-----#
    EPLMNs = SEQ_OF(name=u'EPLMNs', mode=MODE_TYPE)
    _EPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    EPLMNs._cont = _EPLMNs__item_
    EPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name=u'E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RAB-Level-QoS-Parameters >-----#
    E_RAB_Level_QoS_Parameters = SEQ(name=u'E-RAB-Level-QoS-Parameters', mode=MODE_TYPE)
    _E_RAB_Level_QoS_Parameters_qCI = INT(name=u'qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'QCI')))
    _E_RAB_Level_QoS_Parameters_allocationAndRetentionPriority = SEQ(name=u'allocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AllocationAndRetentionPriority')))
    _E_RAB_Level_QoS_Parameters_gbrQosInformation = SEQ(name=u'gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RAB_Level_QoS_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RAB_Level_QoS_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id._const_tab = ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality._const_tab = ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab = ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RAB_Level_QoS_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id),
        (u'criticality', ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue),
        ])
    __E_RAB_Level_QoS_Parameters_iE_Extensions__item_._ext = None
    _E_RAB_Level_QoS_Parameters_iE_Extensions._cont = __E_RAB_Level_QoS_Parameters_iE_Extensions__item_
    _E_RAB_Level_QoS_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RAB_Level_QoS_Parameters._cont = ASN1Dict([
        (u'qCI', _E_RAB_Level_QoS_Parameters_qCI),
        (u'allocationAndRetentionPriority', _E_RAB_Level_QoS_Parameters_allocationAndRetentionPriority),
        (u'gbrQosInformation', _E_RAB_Level_QoS_Parameters_gbrQosInformation),
        (u'iE-Extensions', _E_RAB_Level_QoS_Parameters_iE_Extensions),
        ])
    E_RAB_Level_QoS_Parameters._ext = []
    
    #-----< E-RAB-Level-QoS-Parameters-ExtIEs >-----#
    E_RAB_Level_QoS_Parameters_ExtIEs = CLASS(name=u'E-RAB-Level-QoS-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RAB_Level_QoS_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RAB-List >-----#
    E_RAB_List = SEQ_OF(name=u'E-RAB-List', mode=MODE_TYPE)
    _E_RAB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RAB_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RAB_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RAB_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Item')))
    ___E_RAB_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', ____E_RAB_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RAB_List__item__id._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__id._const_tab_at = None
    __E_RAB_List__item__id._const_tab_id = u'id'
    __E_RAB_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RAB_List__item__criticality._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RAB_List__item__criticality._const_tab_id = u'criticality'
    __E_RAB_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RAB_List__item__value._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__value._const_tab_at = ('..', u'id')
    __E_RAB_List__item__value._const_tab_id = u'Value'
    _E_RAB_List__item_._cont = ASN1Dict([
        (u'id', __E_RAB_List__item__id),
        (u'criticality', __E_RAB_List__item__criticality),
        (u'value', __E_RAB_List__item__value),
        ])
    _E_RAB_List__item_._ext = None
    E_RAB_List._cont = _E_RAB_List__item_
    E_RAB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RAB-ItemIEs >-----#
    E_RAB_ItemIEs = CLASS(name=u'E-RAB-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RAB_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Item')))
    E_RAB_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _E_RAB_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RAB-Item >-----#
    E_RAB_Item = SEQ(name=u'E-RAB-Item', mode=MODE_TYPE)
    _E_RAB_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RAB_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _E_RAB_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RAB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RAB_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RAB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__id._const_tab = ____E_RAB_Item_iE_Extensions__item__id_tab
    ___E_RAB_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RAB_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RAB_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab = ____E_RAB_Item_iE_Extensions__item__id_tab
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RAB_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RAB_Item_iE_Extensions__item__id_tab
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RAB_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RAB_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RAB_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RAB_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RAB_Item_iE_Extensions__item_._ext = None
    _E_RAB_Item_iE_Extensions._cont = __E_RAB_Item_iE_Extensions__item_
    _E_RAB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RAB_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RAB_Item_e_RAB_ID),
        (u'cause', _E_RAB_Item_cause),
        (u'iE-Extensions', _E_RAB_Item_iE_Extensions),
        ])
    E_RAB_Item._ext = []
    
    #-----< E-RAB-Item-ExtIEs >-----#
    E_RAB_Item_ExtIEs = CLASS(name=u'E-RAB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RAB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-Mode-Info >-----#
    EUTRA_Mode_Info = CHOICE(name=u'EUTRA-Mode-Info', mode=MODE_TYPE)
    _EUTRA_Mode_Info_fDD = SEQ(name=u'fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FDD-Info')))
    _EUTRA_Mode_Info_tDD = SEQ(name=u'tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TDD-Info')))
    EUTRA_Mode_Info._cont = ASN1Dict([
        (u'fDD', _EUTRA_Mode_Info_fDD),
        (u'tDD', _EUTRA_Mode_Info_tDD),
        ])
    EUTRA_Mode_Info._ext = []
    
    #-----< EUTRANCellIdentifier >-----#
    EUTRANCellIdentifier = BIT_STR(name=u'EUTRANCellIdentifier', mode=MODE_TYPE)
    EUTRANCellIdentifier._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EUTRANTraceID >-----#
    EUTRANTraceID = OCT_STR(name=u'EUTRANTraceID', mode=MODE_TYPE)
    EUTRANTraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name=u'EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([(u'change-of-serving-cell', 0)])
    EventType._ext = []
    
    #-----< ExpectedUEBehaviour >-----#
    ExpectedUEBehaviour = SEQ(name=u'ExpectedUEBehaviour', mode=MODE_TYPE)
    _ExpectedUEBehaviour_expectedActivity = SEQ(name=u'expectedActivity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEActivityBehaviour')), opt=True)
    _ExpectedUEBehaviour_expectedHOInterval = ENUM(name=u'expectedHOInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedHOInterval')), opt=True)
    _ExpectedUEBehaviour_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEBehaviour_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEBehaviour_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEBehaviour_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEBehaviour_iE_Extensions._cont = __ExpectedUEBehaviour_iE_Extensions__item_
    _ExpectedUEBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEBehaviour._cont = ASN1Dict([
        (u'expectedActivity', _ExpectedUEBehaviour_expectedActivity),
        (u'expectedHOInterval', _ExpectedUEBehaviour_expectedHOInterval),
        (u'iE-Extensions', _ExpectedUEBehaviour_iE_Extensions),
        ])
    ExpectedUEBehaviour._ext = []
    
    #-----< ExpectedUEBehaviour-ExtIEs >-----#
    ExpectedUEBehaviour_ExtIEs = CLASS(name=u'ExpectedUEBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ExpectedUEBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEActivityBehaviour >-----#
    ExpectedUEActivityBehaviour = SEQ(name=u'ExpectedUEActivityBehaviour', mode=MODE_TYPE)
    _ExpectedUEActivityBehaviour_expectedActivityPeriod = INT(name=u'expectedActivityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedActivityPeriod')), opt=True)
    _ExpectedUEActivityBehaviour_expectedIdlePeriod = INT(name=u'expectedIdlePeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedIdlePeriod')), opt=True)
    _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation = ENUM(name=u'sourceofUEActivityBehaviourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SourceOfUEActivityBehaviourInformation')), opt=True)
    _ExpectedUEActivityBehaviour_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEActivityBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEActivityBehaviour_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEActivityBehaviour_iE_Extensions._cont = __ExpectedUEActivityBehaviour_iE_Extensions__item_
    _ExpectedUEActivityBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEActivityBehaviour._cont = ASN1Dict([
        (u'expectedActivityPeriod', _ExpectedUEActivityBehaviour_expectedActivityPeriod),
        (u'expectedIdlePeriod', _ExpectedUEActivityBehaviour_expectedIdlePeriod),
        (u'sourceofUEActivityBehaviourInformation', _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation),
        (u'iE-Extensions', _ExpectedUEActivityBehaviour_iE_Extensions),
        ])
    ExpectedUEActivityBehaviour._ext = []
    
    #-----< ExpectedUEActivityBehaviour-ExtIEs >-----#
    ExpectedUEActivityBehaviour_ExtIEs = CLASS(name=u'ExpectedUEActivityBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ExpectedUEActivityBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedActivityPeriod >-----#
    ExpectedActivityPeriod = INT(name=u'ExpectedActivityPeriod', mode=MODE_TYPE)
    ExpectedActivityPeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedIdlePeriod >-----#
    ExpectedIdlePeriod = INT(name=u'ExpectedIdlePeriod', mode=MODE_TYPE)
    ExpectedIdlePeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedHOInterval >-----#
    ExpectedHOInterval = ENUM(name=u'ExpectedHOInterval', mode=MODE_TYPE)
    ExpectedHOInterval._cont = ASN1Dict([(u'sec15', 0), (u'sec30', 1), (u'sec60', 2), (u'sec90', 3), (u'sec120', 4), (u'sec180', 5), (u'long-time', 6)])
    ExpectedHOInterval._ext = []
    
    #-----< ExtendedULInterferenceOverloadInfo >-----#
    ExtendedULInterferenceOverloadInfo = SEQ(name=u'ExtendedULInterferenceOverloadInfo', mode=MODE_TYPE)
    _ExtendedULInterferenceOverloadInfo_associatedSubframes = BIT_STR(name=u'associatedSubframes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedULInterferenceOverloadInfo_associatedSubframes._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _ExtendedULInterferenceOverloadInfo_extended_ul_InterferenceOverloadIndication = SEQ_OF(name=u'extended-ul-InterferenceOverloadIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-InterferenceOverloadIndication')))
    _ExtendedULInterferenceOverloadInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id._const_tab = ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality._const_tab = ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue._const_tab = ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id),
        (u'criticality', ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue),
        ])
    __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_._ext = None
    _ExtendedULInterferenceOverloadInfo_iE_Extensions._cont = __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_
    _ExtendedULInterferenceOverloadInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedULInterferenceOverloadInfo._cont = ASN1Dict([
        (u'associatedSubframes', _ExtendedULInterferenceOverloadInfo_associatedSubframes),
        (u'extended-ul-InterferenceOverloadIndication', _ExtendedULInterferenceOverloadInfo_extended_ul_InterferenceOverloadIndication),
        (u'iE-Extensions', _ExtendedULInterferenceOverloadInfo_iE_Extensions),
        ])
    ExtendedULInterferenceOverloadInfo._ext = []
    
    #-----< ExtendedULInterferenceOverloadInfo-ExtIEs >-----#
    ExtendedULInterferenceOverloadInfo_ExtIEs = CLASS(name=u'ExtendedULInterferenceOverloadInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ExtendedULInterferenceOverloadInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FDD-Info >-----#
    FDD_Info = SEQ(name=u'FDD-Info', mode=MODE_TYPE)
    _FDD_Info_uL_EARFCN = INT(name=u'uL-EARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    _FDD_Info_dL_EARFCN = INT(name=u'dL-EARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    _FDD_Info_uL_Transmission_Bandwidth = ENUM(name=u'uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_dL_Transmission_Bandwidth = ENUM(name=u'dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    ____FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 95), (u'criticality', u'reject'), (u'Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___FDD_Info_iE_Extensions__item__id._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___FDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___FDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___FDD_Info_iE_Extensions__item__criticality._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FDD_Info_iE_Extensions__item__id),
        (u'criticality', ___FDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __FDD_Info_iE_Extensions__item_._ext = None
    _FDD_Info_iE_Extensions._cont = __FDD_Info_iE_Extensions__item_
    _FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_Info._cont = ASN1Dict([
        (u'uL-EARFCN', _FDD_Info_uL_EARFCN),
        (u'dL-EARFCN', _FDD_Info_dL_EARFCN),
        (u'uL-Transmission-Bandwidth', _FDD_Info_uL_Transmission_Bandwidth),
        (u'dL-Transmission-Bandwidth', _FDD_Info_dL_Transmission_Bandwidth),
        (u'iE-Extensions', _FDD_Info_iE_Extensions),
        ])
    FDD_Info._ext = []
    
    #-----< FDD-Info-ExtIEs >-----#
    FDD_Info_ExtIEs = CLASS(name=u'FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _FDD_Info_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _FDD_Info_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    FDD_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 95), (u'criticality', u'reject'), (u'Extension', _FDD_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Extension', _FDD_Info_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ForbiddenInterRATs >-----#
    ForbiddenInterRATs = ENUM(name=u'ForbiddenInterRATs', mode=MODE_TYPE)
    ForbiddenInterRATs._cont = ASN1Dict([(u'all', 0), (u'geran', 1), (u'utran', 2), (u'cdma2000', 3), (u'geranandutran', 4), (u'cdma2000andutran', 5)])
    ForbiddenInterRATs._ext = [u'geranandutran', u'cdma2000andutran']
    
    #-----< ForbiddenTAs >-----#
    ForbiddenTAs = SEQ_OF(name=u'ForbiddenTAs', mode=MODE_TYPE)
    _ForbiddenTAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenTAs-Item')))
    ForbiddenTAs._cont = _ForbiddenTAs__item_
    ForbiddenTAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenTAs-Item >-----#
    ForbiddenTAs_Item = SEQ(name=u'ForbiddenTAs-Item', mode=MODE_TYPE)
    _ForbiddenTAs_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _ForbiddenTAs_Item_forbiddenTACs = SEQ_OF(name=u'forbiddenTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenTACs')))
    _ForbiddenTAs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenTAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenTAs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ForbiddenTAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ForbiddenTAs_Item_iE_Extensions__item__id),
        (u'criticality', ___ForbiddenTAs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenTAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenTAs_Item_iE_Extensions._cont = __ForbiddenTAs_Item_iE_Extensions__item_
    _ForbiddenTAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenTAs_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _ForbiddenTAs_Item_pLMN_Identity),
        (u'forbiddenTACs', _ForbiddenTAs_Item_forbiddenTACs),
        (u'iE-Extensions', _ForbiddenTAs_Item_iE_Extensions),
        ])
    ForbiddenTAs_Item._ext = []
    
    #-----< ForbiddenTAs-Item-ExtIEs >-----#
    ForbiddenTAs_Item_ExtIEs = CLASS(name=u'ForbiddenTAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ForbiddenTAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenTACs >-----#
    ForbiddenTACs = SEQ_OF(name=u'ForbiddenTACs', mode=MODE_TYPE)
    _ForbiddenTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    ForbiddenTACs._cont = _ForbiddenTACs__item_
    ForbiddenTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< ForbiddenLAs >-----#
    ForbiddenLAs = SEQ_OF(name=u'ForbiddenLAs', mode=MODE_TYPE)
    _ForbiddenLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenLAs-Item')))
    ForbiddenLAs._cont = _ForbiddenLAs__item_
    ForbiddenLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenLAs-Item >-----#
    ForbiddenLAs_Item = SEQ(name=u'ForbiddenLAs-Item', mode=MODE_TYPE)
    _ForbiddenLAs_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _ForbiddenLAs_Item_forbiddenLACs = SEQ_OF(name=u'forbiddenLACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenLACs')))
    _ForbiddenLAs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenLAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenLAs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ForbiddenLAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ForbiddenLAs_Item_iE_Extensions__item__id),
        (u'criticality', ___ForbiddenLAs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenLAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenLAs_Item_iE_Extensions._cont = __ForbiddenLAs_Item_iE_Extensions__item_
    _ForbiddenLAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenLAs_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _ForbiddenLAs_Item_pLMN_Identity),
        (u'forbiddenLACs', _ForbiddenLAs_Item_forbiddenLACs),
        (u'iE-Extensions', _ForbiddenLAs_Item_iE_Extensions),
        ])
    ForbiddenLAs_Item._ext = []
    
    #-----< ForbiddenLAs-Item-ExtIEs >-----#
    ForbiddenLAs_Item_ExtIEs = CLASS(name=u'ForbiddenLAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ForbiddenLAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenLACs >-----#
    ForbiddenLACs = SEQ_OF(name=u'ForbiddenLACs', mode=MODE_TYPE)
    _ForbiddenLACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LAC')))
    ForbiddenLACs._cont = _ForbiddenLACs__item_
    ForbiddenLACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< Fourframes >-----#
    Fourframes = BIT_STR(name=u'Fourframes', mode=MODE_TYPE)
    Fourframes._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< FreqBandIndicator >-----#
    FreqBandIndicator = INT(name=u'FreqBandIndicator', mode=MODE_TYPE)
    FreqBandIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< FreqBandIndicatorPriority >-----#
    FreqBandIndicatorPriority = ENUM(name=u'FreqBandIndicatorPriority', mode=MODE_TYPE)
    FreqBandIndicatorPriority._cont = ASN1Dict([(u'not-broadcasted', 0), (u'broadcasted', 1)])
    FreqBandIndicatorPriority._ext = []
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name=u'GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name=u'e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name=u'e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name=u'e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name=u'e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GBR_QosInformation_iE_Extensions__item__id),
        (u'criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        (u'e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        (u'e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        (u'e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        (u'e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        (u'iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name=u'GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalENB-ID >-----#
    GlobalENB_ID = SEQ(name=u'GlobalENB-ID', mode=MODE_TYPE)
    _GlobalENB_ID_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _GlobalENB_ID_eNB_ID = CHOICE(name=u'eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ENB-ID')))
    _GlobalENB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GlobalENB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GlobalENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab = ____GlobalENB_ID_iE_Extensions__item__id_tab
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GlobalENB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalENB_ID_iE_Extensions__item__id_tab
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GlobalENB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalENB_ID_iE_Extensions__item__id_tab
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GlobalENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GlobalENB_ID_iE_Extensions__item__id),
        (u'criticality', ___GlobalENB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GlobalENB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalENB_ID_iE_Extensions__item_._ext = None
    _GlobalENB_ID_iE_Extensions._cont = __GlobalENB_ID_iE_Extensions__item_
    _GlobalENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalENB_ID._cont = ASN1Dict([
        (u'pLMN-Identity', _GlobalENB_ID_pLMN_Identity),
        (u'eNB-ID', _GlobalENB_ID_eNB_ID),
        (u'iE-Extensions', _GlobalENB_ID_iE_Extensions),
        ])
    GlobalENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name=u'GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTPtunnelEndpoint >-----#
    GTPtunnelEndpoint = SEQ(name=u'GTPtunnelEndpoint', mode=MODE_TYPE)
    _GTPtunnelEndpoint_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _GTPtunnelEndpoint_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTP-TEI')))
    _GTPtunnelEndpoint_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPtunnelEndpoint_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GTPtunnelEndpoint_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GTPtunnelEndpoint_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GTPtunnelEndpoint_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab_at = None
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab_id = u'id'
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GTPtunnelEndpoint_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GTPtunnelEndpoint_iE_Extensions__item__id),
        (u'criticality', ___GTPtunnelEndpoint_iE_Extensions__item__criticality),
        (u'extensionValue', ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue),
        ])
    __GTPtunnelEndpoint_iE_Extensions__item_._ext = None
    _GTPtunnelEndpoint_iE_Extensions._cont = __GTPtunnelEndpoint_iE_Extensions__item_
    _GTPtunnelEndpoint_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPtunnelEndpoint._cont = ASN1Dict([
        (u'transportLayerAddress', _GTPtunnelEndpoint_transportLayerAddress),
        (u'gTP-TEID', _GTPtunnelEndpoint_gTP_TEID),
        (u'iE-Extensions', _GTPtunnelEndpoint_iE_Extensions),
        ])
    GTPtunnelEndpoint._ext = []
    
    #-----< GTPtunnelEndpoint-ExtIEs >-----#
    GTPtunnelEndpoint_ExtIEs = CLASS(name=u'GTPtunnelEndpoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GTPtunnelEndpoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTP-TEI >-----#
    GTP_TEI = OCT_STR(name=u'GTP-TEI', mode=MODE_TYPE)
    GTP_TEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GUGroupIDList >-----#
    GUGroupIDList = SEQ_OF(name=u'GUGroupIDList', mode=MODE_TYPE)
    _GUGroupIDList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GU-Group-ID')))
    GUGroupIDList._cont = _GUGroupIDList__item_
    GUGroupIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GU-Group-ID >-----#
    GU_Group_ID = SEQ(name=u'GU-Group-ID', mode=MODE_TYPE)
    _GU_Group_ID_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _GU_Group_ID_mME_Group_ID = OCT_STR(name=u'mME-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MME-Group-ID')))
    _GU_Group_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GU_Group_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GU_Group_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GU_Group_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GU_Group_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GU_Group_ID_iE_Extensions__item__id._const_tab = ____GU_Group_ID_iE_Extensions__item__id_tab
    ___GU_Group_ID_iE_Extensions__item__id._const_tab_at = None
    ___GU_Group_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GU_Group_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GU_Group_ID_iE_Extensions__item__criticality._const_tab = ____GU_Group_ID_iE_Extensions__item__id_tab
    ___GU_Group_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GU_Group_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GU_Group_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GU_Group_ID_iE_Extensions__item__extensionValue._const_tab = ____GU_Group_ID_iE_Extensions__item__id_tab
    ___GU_Group_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GU_Group_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GU_Group_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GU_Group_ID_iE_Extensions__item__id),
        (u'criticality', ___GU_Group_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GU_Group_ID_iE_Extensions__item__extensionValue),
        ])
    __GU_Group_ID_iE_Extensions__item_._ext = None
    _GU_Group_ID_iE_Extensions._cont = __GU_Group_ID_iE_Extensions__item_
    _GU_Group_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GU_Group_ID._cont = ASN1Dict([
        (u'pLMN-Identity', _GU_Group_ID_pLMN_Identity),
        (u'mME-Group-ID', _GU_Group_ID_mME_Group_ID),
        (u'iE-Extensions', _GU_Group_ID_iE_Extensions),
        ])
    GU_Group_ID._ext = []
    
    #-----< GU-Group-ID-ExtIEs >-----#
    GU_Group_ID_ExtIEs = CLASS(name=u'GU-Group-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GU_Group_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUMMEI >-----#
    GUMMEI = SEQ(name=u'GUMMEI', mode=MODE_TYPE)
    _GUMMEI_gU_Group_ID = SEQ(name=u'gU-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GU-Group-ID')))
    _GUMMEI_mME_Code = OCT_STR(name=u'mME-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MME-Code')))
    _GUMMEI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GUMMEI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GUMMEI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GUMMEI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__id._const_tab = ____GUMMEI_iE_Extensions__item__id_tab
    ___GUMMEI_iE_Extensions__item__id._const_tab_at = None
    ___GUMMEI_iE_Extensions__item__id._const_tab_id = u'id'
    ___GUMMEI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GUMMEI_iE_Extensions__item__criticality._const_tab = ____GUMMEI_iE_Extensions__item__id_tab
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GUMMEI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab = ____GUMMEI_iE_Extensions__item__id_tab
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GUMMEI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GUMMEI_iE_Extensions__item__id),
        (u'criticality', ___GUMMEI_iE_Extensions__item__criticality),
        (u'extensionValue', ___GUMMEI_iE_Extensions__item__extensionValue),
        ])
    __GUMMEI_iE_Extensions__item_._ext = None
    _GUMMEI_iE_Extensions._cont = __GUMMEI_iE_Extensions__item_
    _GUMMEI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GUMMEI._cont = ASN1Dict([
        (u'gU-Group-ID', _GUMMEI_gU_Group_ID),
        (u'mME-Code', _GUMMEI_mME_Code),
        (u'iE-Extensions', _GUMMEI_iE_Extensions),
        ])
    GUMMEI._ext = []
    
    #-----< GUMMEI-ExtIEs >-----#
    GUMMEI_ExtIEs = CLASS(name=u'GUMMEI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GUMMEI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverReportType >-----#
    HandoverReportType = ENUM(name=u'HandoverReportType', mode=MODE_TYPE)
    HandoverReportType._cont = ASN1Dict([(u'hoTooEarly', 0), (u'hoToWrongCell', 1), (u'interRATpingpong', 2)])
    HandoverReportType._ext = [u'interRATpingpong']
    
    #-----< HandoverRestrictionList >-----#
    HandoverRestrictionList = SEQ(name=u'HandoverRestrictionList', mode=MODE_TYPE)
    _HandoverRestrictionList_servingPLMN = OCT_STR(name=u'servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _HandoverRestrictionList_equivalentPLMNs = SEQ_OF(name=u'equivalentPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EPLMNs')), opt=True)
    _HandoverRestrictionList_forbiddenTAs = SEQ_OF(name=u'forbiddenTAs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenTAs')), opt=True)
    _HandoverRestrictionList_forbiddenLAs = SEQ_OF(name=u'forbiddenLAs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenLAs')), opt=True)
    _HandoverRestrictionList_forbiddenInterRATs = ENUM(name=u'forbiddenInterRATs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenInterRATs')), opt=True)
    _HandoverRestrictionList_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRestrictionList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___HandoverRestrictionList_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverRestrictionList_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverRestrictionList_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverRestrictionList_iE_Extensions__item__id),
        (u'criticality', ___HandoverRestrictionList_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverRestrictionList_iE_Extensions__item__extensionValue),
        ])
    __HandoverRestrictionList_iE_Extensions__item_._ext = None
    _HandoverRestrictionList_iE_Extensions._cont = __HandoverRestrictionList_iE_Extensions__item_
    _HandoverRestrictionList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRestrictionList._cont = ASN1Dict([
        (u'servingPLMN', _HandoverRestrictionList_servingPLMN),
        (u'equivalentPLMNs', _HandoverRestrictionList_equivalentPLMNs),
        (u'forbiddenTAs', _HandoverRestrictionList_forbiddenTAs),
        (u'forbiddenLAs', _HandoverRestrictionList_forbiddenLAs),
        (u'forbiddenInterRATs', _HandoverRestrictionList_forbiddenInterRATs),
        (u'iE-Extensions', _HandoverRestrictionList_iE_Extensions),
        ])
    HandoverRestrictionList._ext = []
    
    #-----< HandoverRestrictionList-ExtIEs >-----#
    HandoverRestrictionList_ExtIEs = CLASS(name=u'HandoverRestrictionList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    HandoverRestrictionList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HFN >-----#
    HFN = INT(name=u'HFN', mode=MODE_TYPE)
    HFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< HFNModified >-----#
    HFNModified = INT(name=u'HFNModified', mode=MODE_TYPE)
    HFNModified._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    
    #-----< HFNforPDCP-SNlength18 >-----#
    HFNforPDCP_SNlength18 = INT(name=u'HFNforPDCP-SNlength18', mode=MODE_TYPE)
    HFNforPDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< HWLoadIndicator >-----#
    HWLoadIndicator = SEQ(name=u'HWLoadIndicator', mode=MODE_TYPE)
    _HWLoadIndicator_dLHWLoadIndicator = ENUM(name=u'dLHWLoadIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _HWLoadIndicator_uLHWLoadIndicator = ENUM(name=u'uLHWLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _HWLoadIndicator_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HWLoadIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___HWLoadIndicator_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____HWLoadIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____HWLoadIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HWLoadIndicator_iE_Extensions__item__id._const_tab = ____HWLoadIndicator_iE_Extensions__item__id_tab
    ___HWLoadIndicator_iE_Extensions__item__id._const_tab_at = None
    ___HWLoadIndicator_iE_Extensions__item__id._const_tab_id = u'id'
    ___HWLoadIndicator_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HWLoadIndicator_iE_Extensions__item__criticality._const_tab = ____HWLoadIndicator_iE_Extensions__item__id_tab
    ___HWLoadIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HWLoadIndicator_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HWLoadIndicator_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HWLoadIndicator_iE_Extensions__item__extensionValue._const_tab = ____HWLoadIndicator_iE_Extensions__item__id_tab
    ___HWLoadIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HWLoadIndicator_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HWLoadIndicator_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HWLoadIndicator_iE_Extensions__item__id),
        (u'criticality', ___HWLoadIndicator_iE_Extensions__item__criticality),
        (u'extensionValue', ___HWLoadIndicator_iE_Extensions__item__extensionValue),
        ])
    __HWLoadIndicator_iE_Extensions__item_._ext = None
    _HWLoadIndicator_iE_Extensions._cont = __HWLoadIndicator_iE_Extensions__item_
    _HWLoadIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HWLoadIndicator._cont = ASN1Dict([
        (u'dLHWLoadIndicator', _HWLoadIndicator_dLHWLoadIndicator),
        (u'uLHWLoadIndicator', _HWLoadIndicator_uLHWLoadIndicator),
        (u'iE-Extensions', _HWLoadIndicator_iE_Extensions),
        ])
    HWLoadIndicator._ext = []
    
    #-----< HWLoadIndicator-ExtIEs >-----#
    HWLoadIndicator_ExtIEs = CLASS(name=u'HWLoadIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    HWLoadIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionAlgorithms >-----#
    IntegrityProtectionAlgorithms = BIT_STR(name=u'IntegrityProtectionAlgorithms', mode=MODE_TYPE)
    IntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name=u'InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< InvokeIndication >-----#
    InvokeIndication = ENUM(name=u'InvokeIndication', mode=MODE_TYPE)
    InvokeIndication._cont = ASN1Dict([(u'abs-information', 0), (u'naics-information-start', 1), (u'naics-information-stop', 2)])
    InvokeIndication._ext = [u'naics-information-start', u'naics-information-stop']
    
    #-----< Key-eNodeB-Star >-----#
    Key_eNodeB_Star = BIT_STR(name=u'Key-eNodeB-Star', mode=MODE_TYPE)
    Key_eNodeB_Star._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LastVisitedCell-Item >-----#
    LastVisitedCell_Item = CHOICE(name=u'LastVisitedCell-Item', mode=MODE_TYPE)
    _LastVisitedCell_Item_e_UTRAN_Cell = SEQ(name=u'e-UTRAN-Cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedEUTRANCellInformation')))
    _LastVisitedCell_Item_uTRAN_Cell = OCT_STR(name=u'uTRAN-Cell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedUTRANCellInformation')))
    _LastVisitedCell_Item_gERAN_Cell = CHOICE(name=u'gERAN-Cell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedGERANCellInformation')))
    LastVisitedCell_Item._cont = ASN1Dict([
        (u'e-UTRAN-Cell', _LastVisitedCell_Item_e_UTRAN_Cell),
        (u'uTRAN-Cell', _LastVisitedCell_Item_uTRAN_Cell),
        (u'gERAN-Cell', _LastVisitedCell_Item_gERAN_Cell),
        ])
    LastVisitedCell_Item._ext = []
    
    #-----< LastVisitedEUTRANCellInformation >-----#
    LastVisitedEUTRANCellInformation = SEQ(name=u'LastVisitedEUTRANCellInformation', mode=MODE_TYPE)
    _LastVisitedEUTRANCellInformation_global_Cell_ID = SEQ(name=u'global-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _LastVisitedEUTRANCellInformation_cellType = SEQ(name=u'cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellType')))
    _LastVisitedEUTRANCellInformation_time_UE_StayedInCell = INT(name=u'time-UE-StayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Time-UE-StayedInCell')))
    _LastVisitedEUTRANCellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 77), (u'criticality', u'ignore'), (u'Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 80), (u'criticality', u'ignore'), (u'Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id),
        (u'criticality', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedEUTRANCellInformation_iE_Extensions._cont = __LastVisitedEUTRANCellInformation_iE_Extensions__item_
    _LastVisitedEUTRANCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedEUTRANCellInformation._cont = ASN1Dict([
        (u'global-Cell-ID', _LastVisitedEUTRANCellInformation_global_Cell_ID),
        (u'cellType', _LastVisitedEUTRANCellInformation_cellType),
        (u'time-UE-StayedInCell', _LastVisitedEUTRANCellInformation_time_UE_StayedInCell),
        (u'iE-Extensions', _LastVisitedEUTRANCellInformation_iE_Extensions),
        ])
    LastVisitedEUTRANCellInformation._ext = []
    
    #-----< LastVisitedEUTRANCellInformation-ExtIEs >-----#
    LastVisitedEUTRANCellInformation_ExtIEs = CLASS(name=u'LastVisitedEUTRANCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    LastVisitedEUTRANCellInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 77), (u'criticality', u'ignore'), (u'Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 80), (u'criticality', u'ignore'), (u'Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LastVisitedGERANCellInformation >-----#
    LastVisitedGERANCellInformation = CHOICE(name=u'LastVisitedGERANCellInformation', mode=MODE_TYPE)
    _LastVisitedGERANCellInformation_undefined = NULL(name=u'undefined', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LastVisitedGERANCellInformation._cont = ASN1Dict([
        (u'undefined', _LastVisitedGERANCellInformation_undefined),
        ])
    LastVisitedGERANCellInformation._ext = []
    
    #-----< LastVisitedUTRANCellInformation >-----#
    LastVisitedUTRANCellInformation = OCT_STR(name=u'LastVisitedUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LHN-ID >-----#
    LHN_ID = OCT_STR(name=u'LHN-ID', mode=MODE_TYPE)
    LHN_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=256)], ev=None, er=[])
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name=u'Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([(u'uplink', 0), (u'downlink', 1), (u'both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< LoadIndicator >-----#
    LoadIndicator = ENUM(name=u'LoadIndicator', mode=MODE_TYPE)
    LoadIndicator._cont = ASN1Dict([(u'lowLoad', 0), (u'mediumLoad', 1), (u'highLoad', 2), (u'overLoad', 3)])
    LoadIndicator._ext = []
    
    #-----< LocationReportingInformation >-----#
    LocationReportingInformation = SEQ(name=u'LocationReportingInformation', mode=MODE_TYPE)
    _LocationReportingInformation_eventType = ENUM(name=u'eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EventType')))
    _LocationReportingInformation_reportArea = ENUM(name=u'reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportArea')))
    _LocationReportingInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationReportingInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____LocationReportingInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingInformation_iE_Extensions__item__id._const_tab = ____LocationReportingInformation_iE_Extensions__item__id_tab
    ___LocationReportingInformation_iE_Extensions__item__id._const_tab_at = None
    ___LocationReportingInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___LocationReportingInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationReportingInformation_iE_Extensions__item__criticality._const_tab = ____LocationReportingInformation_iE_Extensions__item__id_tab
    ___LocationReportingInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationReportingInformation_iE_Extensions__item__extensionValue._const_tab = ____LocationReportingInformation_iE_Extensions__item__id_tab
    ___LocationReportingInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationReportingInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationReportingInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingInformation_iE_Extensions__item__id),
        (u'criticality', ___LocationReportingInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___LocationReportingInformation_iE_Extensions__item__extensionValue),
        ])
    __LocationReportingInformation_iE_Extensions__item_._ext = None
    _LocationReportingInformation_iE_Extensions._cont = __LocationReportingInformation_iE_Extensions__item_
    _LocationReportingInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingInformation._cont = ASN1Dict([
        (u'eventType', _LocationReportingInformation_eventType),
        (u'reportArea', _LocationReportingInformation_reportArea),
        (u'iE-Extensions', _LocationReportingInformation_iE_Extensions),
        ])
    LocationReportingInformation._ext = []
    
    #-----< LocationReportingInformation-ExtIEs >-----#
    LocationReportingInformation_ExtIEs = CLASS(name=u'LocationReportingInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    LocationReportingInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1PeriodicReporting >-----#
    M1PeriodicReporting = SEQ(name=u'M1PeriodicReporting', mode=MODE_TYPE)
    _M1PeriodicReporting_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportIntervalMDT')))
    _M1PeriodicReporting_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportAmountMDT')))
    _M1PeriodicReporting_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1PeriodicReporting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M1PeriodicReporting_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_at = None
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1PeriodicReporting_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1PeriodicReporting_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1PeriodicReporting_iE_Extensions__item__id),
        (u'criticality', ___M1PeriodicReporting_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1PeriodicReporting_iE_Extensions__item__extensionValue),
        ])
    __M1PeriodicReporting_iE_Extensions__item_._ext = None
    _M1PeriodicReporting_iE_Extensions._cont = __M1PeriodicReporting_iE_Extensions__item_
    _M1PeriodicReporting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1PeriodicReporting._cont = ASN1Dict([
        (u'reportInterval', _M1PeriodicReporting_reportInterval),
        (u'reportAmount', _M1PeriodicReporting_reportAmount),
        (u'iE-Extensions', _M1PeriodicReporting_iE_Extensions),
        ])
    M1PeriodicReporting._ext = []
    
    #-----< M1PeriodicReporting-ExtIEs >-----#
    M1PeriodicReporting_ExtIEs = CLASS(name=u'M1PeriodicReporting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M1PeriodicReporting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1ReportingTrigger >-----#
    M1ReportingTrigger = ENUM(name=u'M1ReportingTrigger', mode=MODE_TYPE)
    M1ReportingTrigger._cont = ASN1Dict([(u'periodic', 0), (u'a2eventtriggered', 1), (u'a2eventtriggered-periodic', 2)])
    M1ReportingTrigger._ext = [u'a2eventtriggered-periodic']
    
    #-----< M1ThresholdEventA2 >-----#
    M1ThresholdEventA2 = SEQ(name=u'M1ThresholdEventA2', mode=MODE_TYPE)
    _M1ThresholdEventA2_measurementThreshold = CHOICE(name=u'measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeasurementThresholdA2')))
    _M1ThresholdEventA2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1ThresholdEventA2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M1ThresholdEventA2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_at = None
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1ThresholdEventA2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1ThresholdEventA2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1ThresholdEventA2_iE_Extensions__item__id),
        (u'criticality', ___M1ThresholdEventA2_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1ThresholdEventA2_iE_Extensions__item__extensionValue),
        ])
    __M1ThresholdEventA2_iE_Extensions__item_._ext = None
    _M1ThresholdEventA2_iE_Extensions._cont = __M1ThresholdEventA2_iE_Extensions__item_
    _M1ThresholdEventA2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1ThresholdEventA2._cont = ASN1Dict([
        (u'measurementThreshold', _M1ThresholdEventA2_measurementThreshold),
        (u'iE-Extensions', _M1ThresholdEventA2_iE_Extensions),
        ])
    M1ThresholdEventA2._ext = []
    
    #-----< M1ThresholdEventA2-ExtIEs >-----#
    M1ThresholdEventA2_ExtIEs = CLASS(name=u'M1ThresholdEventA2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M1ThresholdEventA2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3Configuration >-----#
    M3Configuration = SEQ(name=u'M3Configuration', mode=MODE_TYPE)
    _M3Configuration_m3period = ENUM(name=u'm3period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M3period')))
    _M3Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M3Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M3Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M3Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__id._const_tab = ____M3Configuration_iE_Extensions__item__id_tab
    ___M3Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M3Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M3Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M3Configuration_iE_Extensions__item__criticality._const_tab = ____M3Configuration_iE_Extensions__item__id_tab
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M3Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab = ____M3Configuration_iE_Extensions__item__id_tab
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M3Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M3Configuration_iE_Extensions__item__id),
        (u'criticality', ___M3Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M3Configuration_iE_Extensions__item__extensionValue),
        ])
    __M3Configuration_iE_Extensions__item_._ext = None
    _M3Configuration_iE_Extensions._cont = __M3Configuration_iE_Extensions__item_
    _M3Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M3Configuration._cont = ASN1Dict([
        (u'm3period', _M3Configuration_m3period),
        (u'iE-Extensions', _M3Configuration_iE_Extensions),
        ])
    M3Configuration._ext = []
    
    #-----< M3Configuration-ExtIEs >-----#
    M3Configuration_ExtIEs = CLASS(name=u'M3Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M3Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3period >-----#
    M3period = ENUM(name=u'M3period', mode=MODE_TYPE)
    M3period._cont = ASN1Dict([(u'ms100', 0), (u'ms1000', 1), (u'ms10000', 2)])
    M3period._ext = []
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name=u'M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name=u'm4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name=u'm4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M4Configuration_iE_Extensions__item__id),
        (u'criticality', ___M4Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        (u'm4period', _M4Configuration_m4period),
        (u'm4-links-to-log', _M4Configuration_m4_links_to_log),
        (u'iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name=u'M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4period >-----#
    M4period = ENUM(name=u'M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M4period._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name=u'M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name=u'm5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name=u'm5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M5Configuration_iE_Extensions__item__id),
        (u'criticality', ___M5Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        (u'm5period', _M5Configuration_m5period),
        (u'm5-links-to-log', _M5Configuration_m5_links_to_log),
        (u'iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name=u'M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name=u'M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M5period._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name=u'M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_interval = ENUM(name=u'm6report-interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M6report-interval')))
    _M6Configuration_m6delay_threshold = ENUM(name=u'm6delay-threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M6delay-threshold')), opt=True)
    _M6Configuration_m6_links_to_log = ENUM(name=u'm6-links-to-log', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M6Configuration_iE_Extensions__item__id),
        (u'criticality', ___M6Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        (u'm6report-interval', _M6Configuration_m6report_interval),
        (u'm6delay-threshold', _M6Configuration_m6delay_threshold),
        (u'm6-links-to-log', _M6Configuration_m6_links_to_log),
        (u'iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name=u'M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6report-interval >-----#
    M6report_interval = ENUM(name=u'M6report-interval', mode=MODE_TYPE)
    M6report_interval._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3)])
    M6report_interval._ext = []
    
    #-----< M6delay-threshold >-----#
    M6delay_threshold = ENUM(name=u'M6delay-threshold', mode=MODE_TYPE)
    M6delay_threshold._cont = ASN1Dict([(u'ms30', 0), (u'ms40', 1), (u'ms50', 2), (u'ms60', 3), (u'ms70', 4), (u'ms80', 5), (u'ms90', 6), (u'ms100', 7), (u'ms150', 8), (u'ms300', 9), (u'ms500', 10), (u'ms750', 11)])
    M6delay_threshold._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name=u'M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name=u'm7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name=u'm7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M7Configuration_iE_Extensions__item__id),
        (u'criticality', ___M7Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        (u'm7period', _M7Configuration_m7period),
        (u'm7-links-to-log', _M7Configuration_m7_links_to_log),
        (u'iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name=u'M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name=u'M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< ManagementBasedMDTallowed >-----#
    ManagementBasedMDTallowed = ENUM(name=u'ManagementBasedMDTallowed', mode=MODE_TYPE)
    ManagementBasedMDTallowed._cont = ASN1Dict([(u'allowed', 0)])
    ManagementBasedMDTallowed._ext = []
    
    #-----< Masked-IMEISV >-----#
    Masked_IMEISV = BIT_STR(name=u'Masked-IMEISV', mode=MODE_TYPE)
    Masked_IMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name=u'MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([(u'immediate-MDT-only', 0), (u'immediate-MDT-and-Trace', 1)])
    MDT_Activation._ext = []
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Activation = ENUM(name=u'mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MDT-Activation')))
    _MDT_Configuration_areaScopeOfMDT = CHOICE(name=u'areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AreaScopeOfMDT')))
    _MDT_Configuration_measurementsToActivate = BIT_STR(name=u'measurementsToActivate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeasurementsToActivate')))
    _MDT_Configuration_m1reportingTrigger = ENUM(name=u'm1reportingTrigger', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M1ReportingTrigger')))
    _MDT_Configuration_m1thresholdeventA2 = SEQ(name=u'm1thresholdeventA2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M1ThresholdEventA2')), opt=True)
    _MDT_Configuration_m1periodicReporting = SEQ(name=u'm1periodicReporting', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M1PeriodicReporting')), opt=True)
    _MDT_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M3Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M4Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M5Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Location-Info')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M6Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M7Configuration')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'conditional')]), dict([(u'id', 87), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 88), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'conditional')]), dict([(u'id', 162), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        (u'mdt-Activation', _MDT_Configuration_mdt_Activation),
        (u'areaScopeOfMDT', _MDT_Configuration_areaScopeOfMDT),
        (u'measurementsToActivate', _MDT_Configuration_measurementsToActivate),
        (u'm1reportingTrigger', _MDT_Configuration_m1reportingTrigger),
        (u'm1thresholdeventA2', _MDT_Configuration_m1thresholdeventA2),
        (u'm1periodicReporting', _MDT_Configuration_m1periodicReporting),
        (u'iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name=u'MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _MDT_Configuration_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M3Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M4Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M5Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Location-Info')))
    _MDT_Configuration_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _MDT_Configuration_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M6Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M7Configuration')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_1), (u'presence', u'conditional')]), dict([(u'id', 87), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 88), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_5), (u'presence', u'conditional')]), dict([(u'id', 162), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_6), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name=u'MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDT-Location-Info >-----#
    MDT_Location_Info = BIT_STR(name=u'MDT-Location-Info', mode=MODE_TYPE)
    MDT_Location_Info._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< Measurement-ID >-----#
    Measurement_ID = INT(name=u'Measurement-ID', mode=MODE_TYPE)
    Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name=u'MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MeasurementThresholdA2 >-----#
    MeasurementThresholdA2 = CHOICE(name=u'MeasurementThresholdA2', mode=MODE_TYPE)
    _MeasurementThresholdA2_threshold_RSRP = INT(name=u'threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdA2_threshold_RSRQ = INT(name=u'threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Threshold-RSRQ')))
    MeasurementThresholdA2._cont = ASN1Dict([
        (u'threshold-RSRP', _MeasurementThresholdA2_threshold_RSRP),
        (u'threshold-RSRQ', _MeasurementThresholdA2_threshold_RSRQ),
        ])
    MeasurementThresholdA2._ext = []
    
    #-----< MeNBtoSeNBContainer >-----#
    MeNBtoSeNBContainer = OCT_STR(name=u'MeNBtoSeNBContainer', mode=MODE_TYPE)
    
    #-----< MME-Group-ID >-----#
    MME_Group_ID = OCT_STR(name=u'MME-Group-ID', mode=MODE_TYPE)
    MME_Group_ID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MME-Code >-----#
    MME_Code = OCT_STR(name=u'MME-Code', mode=MODE_TYPE)
    MME_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MBMS-Service-Area-Identity-List >-----#
    MBMS_Service_Area_Identity_List = SEQ_OF(name=u'MBMS-Service-Area-Identity-List', mode=MODE_TYPE)
    _MBMS_Service_Area_Identity_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBMS-Service-Area-Identity')))
    MBMS_Service_Area_Identity_List._cont = _MBMS_Service_Area_Identity_List__item_
    MBMS_Service_Area_Identity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBMS-Service-Area-Identity >-----#
    MBMS_Service_Area_Identity = OCT_STR(name=u'MBMS-Service-Area-Identity', mode=MODE_TYPE)
    MBMS_Service_Area_Identity._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MBSFN-Subframe-Infolist >-----#
    MBSFN_Subframe_Infolist = SEQ_OF(name=u'MBSFN-Subframe-Infolist', mode=MODE_TYPE)
    _MBSFN_Subframe_Infolist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBSFN-Subframe-Info')))
    MBSFN_Subframe_Infolist._cont = _MBSFN_Subframe_Infolist__item_
    MBSFN_Subframe_Infolist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MBSFN-Subframe-Info >-----#
    MBSFN_Subframe_Info = SEQ(name=u'MBSFN-Subframe-Info', mode=MODE_TYPE)
    _MBSFN_Subframe_Info_radioframeAllocationPeriod = ENUM(name=u'radioframeAllocationPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioframeAllocationPeriod')))
    _MBSFN_Subframe_Info_radioframeAllocationOffset = INT(name=u'radioframeAllocationOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioframeAllocationOffset')))
    _MBSFN_Subframe_Info_subframeAllocation = CHOICE(name=u'subframeAllocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubframeAllocation')))
    _MBSFN_Subframe_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSFN_Subframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MBSFN_Subframe_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Subframe_Info_iE_Extensions__item__id._const_tab = ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab
    ___MBSFN_Subframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___MBSFN_Subframe_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality._const_tab = ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue._const_tab = ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBSFN_Subframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBSFN_Subframe_Info_iE_Extensions__item__id),
        (u'criticality', ___MBSFN_Subframe_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue),
        ])
    __MBSFN_Subframe_Info_iE_Extensions__item_._ext = None
    _MBSFN_Subframe_Info_iE_Extensions._cont = __MBSFN_Subframe_Info_iE_Extensions__item_
    _MBSFN_Subframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSFN_Subframe_Info._cont = ASN1Dict([
        (u'radioframeAllocationPeriod', _MBSFN_Subframe_Info_radioframeAllocationPeriod),
        (u'radioframeAllocationOffset', _MBSFN_Subframe_Info_radioframeAllocationOffset),
        (u'subframeAllocation', _MBSFN_Subframe_Info_subframeAllocation),
        (u'iE-Extensions', _MBSFN_Subframe_Info_iE_Extensions),
        ])
    MBSFN_Subframe_Info._ext = []
    
    #-----< MBSFN-Subframe-Info-ExtIEs >-----#
    MBSFN_Subframe_Info_ExtIEs = CLASS(name=u'MBSFN-Subframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MBSFN_Subframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MobilityParametersModificationRange >-----#
    MobilityParametersModificationRange = SEQ(name=u'MobilityParametersModificationRange', mode=MODE_TYPE)
    _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit = INT(name=u'handoverTriggerChangeLowerLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit = INT(name=u'handoverTriggerChangeUpperLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    MobilityParametersModificationRange._cont = ASN1Dict([
        (u'handoverTriggerChangeLowerLimit', _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit),
        (u'handoverTriggerChangeUpperLimit', _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit),
        ])
    MobilityParametersModificationRange._ext = []
    
    #-----< MobilityParametersInformation >-----#
    MobilityParametersInformation = SEQ(name=u'MobilityParametersInformation', mode=MODE_TYPE)
    _MobilityParametersInformation_handoverTriggerChange = INT(name=u'handoverTriggerChange', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobilityParametersInformation_handoverTriggerChange._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    MobilityParametersInformation._cont = ASN1Dict([
        (u'handoverTriggerChange', _MobilityParametersInformation_handoverTriggerChange),
        ])
    MobilityParametersInformation._ext = []
    
    #-----< MultibandInfoList >-----#
    MultibandInfoList = SEQ_OF(name=u'MultibandInfoList', mode=MODE_TYPE)
    _MultibandInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BandInfo')))
    MultibandInfoList._cont = _MultibandInfoList__item_
    MultibandInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< BandInfo >-----#
    BandInfo = SEQ(name=u'BandInfo', mode=MODE_TYPE)
    _BandInfo_freqBandIndicator = INT(name=u'freqBandIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FreqBandIndicator')))
    _BandInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BandInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___BandInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BandInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BandInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BandInfo_iE_Extensions__item__id._const_tab = ____BandInfo_iE_Extensions__item__id_tab
    ___BandInfo_iE_Extensions__item__id._const_tab_at = None
    ___BandInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___BandInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___BandInfo_iE_Extensions__item__criticality._const_tab = ____BandInfo_iE_Extensions__item__id_tab
    ___BandInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BandInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BandInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___BandInfo_iE_Extensions__item__extensionValue._const_tab = ____BandInfo_iE_Extensions__item__id_tab
    ___BandInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BandInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BandInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BandInfo_iE_Extensions__item__id),
        (u'criticality', ___BandInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___BandInfo_iE_Extensions__item__extensionValue),
        ])
    __BandInfo_iE_Extensions__item_._ext = None
    _BandInfo_iE_Extensions._cont = __BandInfo_iE_Extensions__item_
    _BandInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BandInfo._cont = ASN1Dict([
        (u'freqBandIndicator', _BandInfo_freqBandIndicator),
        (u'iE-Extensions', _BandInfo_iE_Extensions),
        ])
    BandInfo._ext = []
    
    #-----< BandInfo-ExtIEs >-----#
    BandInfo_ExtIEs = CLASS(name=u'BandInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    BandInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Neighbour-Information >-----#
    Neighbour_Information = SEQ_OF(name=u'Neighbour-Information', mode=MODE_TYPE)
    _Neighbour_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Neighbour_Information__item__eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    __Neighbour_Information__item__pCI = INT(name=u'pCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    __Neighbour_Information__item__eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    __Neighbour_Information__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Neighbour_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____Neighbour_Information__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____Neighbour_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _____Neighbour_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 76), (u'criticality', u'ignore'), (u'Extension', ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Extension', ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ____Neighbour_Information__item__iE_Extensions__item__id._const_tab = _____Neighbour_Information__item__iE_Extensions__item__id_tab
    ____Neighbour_Information__item__iE_Extensions__item__id._const_tab_at = None
    ____Neighbour_Information__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____Neighbour_Information__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Neighbour_Information__item__iE_Extensions__item__criticality._const_tab = _____Neighbour_Information__item__iE_Extensions__item__id_tab
    ____Neighbour_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Neighbour_Information__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue._const_tab = _____Neighbour_Information__item__iE_Extensions__item__id_tab
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Neighbour_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Neighbour_Information__item__iE_Extensions__item__id),
        (u'criticality', ____Neighbour_Information__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____Neighbour_Information__item__iE_Extensions__item__extensionValue),
        ])
    ___Neighbour_Information__item__iE_Extensions__item_._ext = None
    __Neighbour_Information__item__iE_Extensions._cont = ___Neighbour_Information__item__iE_Extensions__item_
    __Neighbour_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Neighbour_Information__item_._cont = ASN1Dict([
        (u'eCGI', __Neighbour_Information__item__eCGI),
        (u'pCI', __Neighbour_Information__item__pCI),
        (u'eARFCN', __Neighbour_Information__item__eARFCN),
        (u'iE-Extensions', __Neighbour_Information__item__iE_Extensions),
        ])
    _Neighbour_Information__item_._ext = []
    Neighbour_Information._cont = _Neighbour_Information__item_
    Neighbour_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< Neighbour-Information-ExtIEs >-----#
    Neighbour_Information_ExtIEs = CLASS(name=u'Neighbour-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _Neighbour_Information_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _Neighbour_Information_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    Neighbour_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 76), (u'criticality', u'ignore'), (u'Extension', _Neighbour_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Extension', _Neighbour_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NextHopChainingCount >-----#
    NextHopChainingCount = INT(name=u'NextHopChainingCount', mode=MODE_TYPE)
    NextHopChainingCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< Number-of-Antennaports >-----#
    Number_of_Antennaports = ENUM(name=u'Number-of-Antennaports', mode=MODE_TYPE)
    Number_of_Antennaports._cont = ASN1Dict([(u'an1', 0), (u'an2', 1), (u'an4', 2)])
    Number_of_Antennaports._ext = []
    
    #-----< Oneframe >-----#
    Oneframe = BIT_STR(name=u'Oneframe', mode=MODE_TYPE)
    Oneframe._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< PA-Values >-----#
    PA_Values = ENUM(name=u'PA-Values', mode=MODE_TYPE)
    PA_Values._cont = ASN1Dict([(u'dB-6', 0), (u'dB-4dot77', 1), (u'dB-3', 2), (u'dB-1dot77', 3), (u'dB0', 4), (u'dB1', 5), (u'dB2', 6), (u'dB3', 7)])
    PA_Values._ext = []
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name=u'PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< PDCP-SNExtended >-----#
    PDCP_SNExtended = INT(name=u'PDCP-SNExtended', mode=MODE_TYPE)
    PDCP_SNExtended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< PDCP-SNlength18 >-----#
    PDCP_SNlength18 = INT(name=u'PDCP-SNlength18', mode=MODE_TYPE)
    PDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< PCI >-----#
    PCI = INT(name=u'PCI', mode=MODE_TYPE)
    PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=[], er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name=u'PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Port-Number >-----#
    Port_Number = OCT_STR(name=u'Port-Number', mode=MODE_TYPE)
    Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PRACH-Configuration >-----#
    PRACH_Configuration = SEQ(name=u'PRACH-Configuration', mode=MODE_TYPE)
    _PRACH_Configuration_rootSequenceIndex = INT(name=u'rootSequenceIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=837)], ev=None, er=[])
    _PRACH_Configuration_zeroCorrelationIndex = INT(name=u'zeroCorrelationIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_zeroCorrelationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _PRACH_Configuration_highSpeedFlag = BOOL(name=u'highSpeedFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_prach_FreqOffset = INT(name=u'prach-FreqOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_prach_FreqOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=94)], ev=None, er=[])
    _PRACH_Configuration_prach_ConfigIndex = INT(name=u'prach-ConfigIndex', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRACH_Configuration_prach_ConfigIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PRACH_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___PRACH_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PRACH_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PRACH_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_Configuration_iE_Extensions__item__id._const_tab = ____PRACH_Configuration_iE_Extensions__item__id_tab
    ___PRACH_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___PRACH_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PRACH_Configuration_iE_Extensions__item__criticality._const_tab = ____PRACH_Configuration_iE_Extensions__item__id_tab
    ___PRACH_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PRACH_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PRACH_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab = ____PRACH_Configuration_iE_Extensions__item__id_tab
    ___PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PRACH_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PRACH_Configuration_iE_Extensions__item__id),
        (u'criticality', ___PRACH_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___PRACH_Configuration_iE_Extensions__item__extensionValue),
        ])
    __PRACH_Configuration_iE_Extensions__item_._ext = None
    _PRACH_Configuration_iE_Extensions._cont = __PRACH_Configuration_iE_Extensions__item_
    _PRACH_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_Configuration._cont = ASN1Dict([
        (u'rootSequenceIndex', _PRACH_Configuration_rootSequenceIndex),
        (u'zeroCorrelationIndex', _PRACH_Configuration_zeroCorrelationIndex),
        (u'highSpeedFlag', _PRACH_Configuration_highSpeedFlag),
        (u'prach-FreqOffset', _PRACH_Configuration_prach_FreqOffset),
        (u'prach-ConfigIndex', _PRACH_Configuration_prach_ConfigIndex),
        (u'iE-Extensions', _PRACH_Configuration_iE_Extensions),
        ])
    PRACH_Configuration._ext = []
    
    #-----< PRACH-Configuration-ExtIEs >-----#
    PRACH_Configuration_ExtIEs = CLASS(name=u'PRACH-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    PRACH_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name=u'PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([(u'spare', 0), (u'highest', 1), (u'lowest', 14), (u'no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< ProSeAuthorized >-----#
    ProSeAuthorized = SEQ(name=u'ProSeAuthorized', mode=MODE_TYPE)
    _ProSeAuthorized_proSeDirectDiscovery = ENUM(name=u'proSeDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ProSeDirectDiscovery')), opt=True)
    _ProSeAuthorized_proSeDirectCommunication = ENUM(name=u'proSeDirectCommunication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ProSeDirectCommunication')), opt=True)
    _ProSeAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProSeAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ProSeAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ProSeAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ____ProSeAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___ProSeAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ProSeAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ProSeAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ProSeAuthorized_iE_Extensions__item__id),
        (u'criticality', ___ProSeAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___ProSeAuthorized_iE_Extensions__item__extensionValue),
        ])
    __ProSeAuthorized_iE_Extensions__item_._ext = None
    _ProSeAuthorized_iE_Extensions._cont = __ProSeAuthorized_iE_Extensions__item_
    _ProSeAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProSeAuthorized._cont = ASN1Dict([
        (u'proSeDirectDiscovery', _ProSeAuthorized_proSeDirectDiscovery),
        (u'proSeDirectCommunication', _ProSeAuthorized_proSeDirectCommunication),
        (u'iE-Extensions', _ProSeAuthorized_iE_Extensions),
        ])
    ProSeAuthorized._ext = []
    
    #-----< ProSeAuthorized-ExtIEs >-----#
    ProSeAuthorized_ExtIEs = CLASS(name=u'ProSeAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ProSeAuthorized_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ProSeAuthorized_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _ProSeAuthorized_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ProSeDirectDiscovery >-----#
    ProSeDirectDiscovery = ENUM(name=u'ProSeDirectDiscovery', mode=MODE_TYPE)
    ProSeDirectDiscovery._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    ProSeDirectDiscovery._ext = []
    
    #-----< ProSeDirectCommunication >-----#
    ProSeDirectCommunication = ENUM(name=u'ProSeDirectCommunication', mode=MODE_TYPE)
    ProSeDirectCommunication._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    ProSeDirectCommunication._ext = []
    
    #-----< ProSeUEtoNetworkRelaying >-----#
    ProSeUEtoNetworkRelaying = ENUM(name=u'ProSeUEtoNetworkRelaying', mode=MODE_TYPE)
    ProSeUEtoNetworkRelaying._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    ProSeUEtoNetworkRelaying._ext = []
    
    #-----< QCI >-----#
    QCI = INT(name=u'QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RadioframeAllocationOffset >-----#
    RadioframeAllocationOffset = INT(name=u'RadioframeAllocationOffset', mode=MODE_TYPE)
    RadioframeAllocationOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< RadioframeAllocationPeriod >-----#
    RadioframeAllocationPeriod = ENUM(name=u'RadioframeAllocationPeriod', mode=MODE_TYPE)
    RadioframeAllocationPeriod._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2), (u'n8', 3), (u'n16', 4), (u'n32', 5)])
    RadioframeAllocationPeriod._ext = []
    
    #-----< RadioResourceStatus >-----#
    RadioResourceStatus = SEQ(name=u'RadioResourceStatus', mode=MODE_TYPE)
    _RadioResourceStatus_dL_GBR_PRB_usage = INT(name=u'dL-GBR-PRB-usage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-GBR-PRB-usage')))
    _RadioResourceStatus_uL_GBR_PRB_usage = INT(name=u'uL-GBR-PRB-usage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-GBR-PRB-usage')))
    _RadioResourceStatus_dL_non_GBR_PRB_usage = INT(name=u'dL-non-GBR-PRB-usage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-non-GBR-PRB-usage')))
    _RadioResourceStatus_uL_non_GBR_PRB_usage = INT(name=u'uL-non-GBR-PRB-usage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-non-GBR-PRB-usage')))
    _RadioResourceStatus_dL_Total_PRB_usage = INT(name=u'dL-Total-PRB-usage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Total-PRB-usage')))
    _RadioResourceStatus_uL_Total_PRB_usage = INT(name=u'uL-Total-PRB-usage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-Total-PRB-usage')))
    _RadioResourceStatus_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RadioResourceStatus_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_id = u'id'
    ___RadioResourceStatus_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RadioResourceStatus_iE_Extensions__item__id),
        (u'criticality', ___RadioResourceStatus_iE_Extensions__item__criticality),
        (u'extensionValue', ___RadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __RadioResourceStatus_iE_Extensions__item_._ext = None
    _RadioResourceStatus_iE_Extensions._cont = __RadioResourceStatus_iE_Extensions__item_
    _RadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioResourceStatus._cont = ASN1Dict([
        (u'dL-GBR-PRB-usage', _RadioResourceStatus_dL_GBR_PRB_usage),
        (u'uL-GBR-PRB-usage', _RadioResourceStatus_uL_GBR_PRB_usage),
        (u'dL-non-GBR-PRB-usage', _RadioResourceStatus_dL_non_GBR_PRB_usage),
        (u'uL-non-GBR-PRB-usage', _RadioResourceStatus_uL_non_GBR_PRB_usage),
        (u'dL-Total-PRB-usage', _RadioResourceStatus_dL_Total_PRB_usage),
        (u'uL-Total-PRB-usage', _RadioResourceStatus_uL_Total_PRB_usage),
        (u'iE-Extensions', _RadioResourceStatus_iE_Extensions),
        ])
    RadioResourceStatus._ext = []
    
    #-----< RadioResourceStatus-ExtIEs >-----#
    RadioResourceStatus_ExtIEs = CLASS(name=u'RadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RadioResourceStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReceiveStatusofULPDCPSDUs >-----#
    ReceiveStatusofULPDCPSDUs = BIT_STR(name=u'ReceiveStatusofULPDCPSDUs', mode=MODE_TYPE)
    ReceiveStatusofULPDCPSDUs._const_sz = ASN1Set(rv=[4096], rr=[], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsExtended >-----#
    ReceiveStatusOfULPDCPSDUsExtended = BIT_STR(name=u'ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsExtended._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = BIT_STR(name=u'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    
    #-----< Registration-Request >-----#
    Registration_Request = ENUM(name=u'Registration-Request', mode=MODE_TYPE)
    Registration_Request._cont = ASN1Dict([(u'start', 0), (u'stop', 1), (u'partial-stop', 2), (u'add', 3)])
    Registration_Request._ext = [u'partial-stop', u'add']
    
    #-----< RelativeNarrowbandTxPower >-----#
    RelativeNarrowbandTxPower = SEQ(name=u'RelativeNarrowbandTxPower', mode=MODE_TYPE)
    _RelativeNarrowbandTxPower_rNTP_PerPRB = BIT_STR(name=u'rNTP-PerPRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_rNTP_PerPRB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=110)], ev=[], er=[])
    _RelativeNarrowbandTxPower_rNTP_Threshold = ENUM(name=u'rNTP-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RNTP-Threshold')))
    _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts = ENUM(name=u'numberOfCellSpecificAntennaPorts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts._cont = ASN1Dict([(u'one', 0), (u'two', 1), (u'four', 2)])
    _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts._ext = []
    _RelativeNarrowbandTxPower_p_B = INT(name=u'p-B', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_p_B._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact = INT(name=u'pDCCH-InterferenceImpact', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=[], er=[])
    _RelativeNarrowbandTxPower_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeNarrowbandTxPower_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EnhancedRNTP')))
    ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'ignore'), (u'Extension', _____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id._const_tab = ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id._const_tab_at = None
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id._const_tab_id = u'id'
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality._const_tab = ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue._const_tab = ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RelativeNarrowbandTxPower_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RelativeNarrowbandTxPower_iE_Extensions__item__id),
        (u'criticality', ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality),
        (u'extensionValue', ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue),
        ])
    __RelativeNarrowbandTxPower_iE_Extensions__item_._ext = None
    _RelativeNarrowbandTxPower_iE_Extensions._cont = __RelativeNarrowbandTxPower_iE_Extensions__item_
    _RelativeNarrowbandTxPower_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeNarrowbandTxPower._cont = ASN1Dict([
        (u'rNTP-PerPRB', _RelativeNarrowbandTxPower_rNTP_PerPRB),
        (u'rNTP-Threshold', _RelativeNarrowbandTxPower_rNTP_Threshold),
        (u'numberOfCellSpecificAntennaPorts', _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts),
        (u'p-B', _RelativeNarrowbandTxPower_p_B),
        (u'pDCCH-InterferenceImpact', _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact),
        (u'iE-Extensions', _RelativeNarrowbandTxPower_iE_Extensions),
        ])
    RelativeNarrowbandTxPower._ext = []
    
    #-----< RelativeNarrowbandTxPower-ExtIEs >-----#
    RelativeNarrowbandTxPower_ExtIEs = CLASS(name=u'RelativeNarrowbandTxPower-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _RelativeNarrowbandTxPower_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EnhancedRNTP')))
    RelativeNarrowbandTxPower_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'ignore'), (u'Extension', _RelativeNarrowbandTxPower_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReplacingCellsList >-----#
    ReplacingCellsList = SEQ_OF(name=u'ReplacingCellsList', mode=MODE_TYPE)
    _ReplacingCellsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReplacingCellsList-Item')))
    ReplacingCellsList._cont = _ReplacingCellsList__item_
    ReplacingCellsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ReplacingCellsList-Item >-----#
    ReplacingCellsList_Item = SEQ(name=u'ReplacingCellsList-Item', mode=MODE_TYPE)
    _ReplacingCellsList_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ReplacingCellsList_Item._cont = ASN1Dict([
        (u'eCGI', _ReplacingCellsList_Item_eCGI),
        ])
    ReplacingCellsList_Item._ext = []
    
    #-----< ReportAmountMDT >-----#
    ReportAmountMDT = ENUM(name=u'ReportAmountMDT', mode=MODE_TYPE)
    ReportAmountMDT._cont = ASN1Dict([(u'r1', 0), (u'r2', 1), (u'r4', 2), (u'r8', 3), (u'r16', 4), (u'r32', 5), (u'r64', 6), (u'rinfinity', 7)])
    ReportAmountMDT._ext = None
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name=u'ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([(u'ecgi', 0)])
    ReportArea._ext = []
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name=u'ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicityCSIR >-----#
    ReportingPeriodicityCSIR = ENUM(name=u'ReportingPeriodicityCSIR', mode=MODE_TYPE)
    ReportingPeriodicityCSIR._cont = ASN1Dict([(u'ms5', 0), (u'ms10', 1), (u'ms20', 2), (u'ms40', 3), (u'ms80', 4)])
    ReportingPeriodicityCSIR._ext = []
    
    #-----< ReportingPeriodicityRSRPMR >-----#
    ReportingPeriodicityRSRPMR = ENUM(name=u'ReportingPeriodicityRSRPMR', mode=MODE_TYPE)
    ReportingPeriodicityRSRPMR._cont = ASN1Dict([(u'one-hundred-20-ms', 0), (u'two-hundred-40-ms', 1), (u'four-hundred-80-ms', 2), (u'six-hundred-40-ms', 3)])
    ReportingPeriodicityRSRPMR._ext = []
    
    #-----< ReportIntervalMDT >-----#
    ReportIntervalMDT = ENUM(name=u'ReportIntervalMDT', mode=MODE_TYPE)
    ReportIntervalMDT._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms480', 2), (u'ms640', 3), (u'ms1024', 4), (u'ms2048', 5), (u'ms5120', 6), (u'ms10240', 7), (u'min1', 8), (u'min6', 9), (u'min12', 10), (u'min30', 11), (u'min60', 12)])
    ReportIntervalMDT._ext = None
    
    #-----< ResumeID >-----#
    ResumeID = CHOICE(name=u'ResumeID', mode=MODE_TYPE)
    _ResumeID_non_truncated = BIT_STR(name=u'non-truncated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResumeID_non_truncated._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _ResumeID_truncated = BIT_STR(name=u'truncated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResumeID_truncated._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    ResumeID._cont = ASN1Dict([
        (u'non-truncated', _ResumeID_non_truncated),
        (u'truncated', _ResumeID_truncated),
        ])
    ResumeID._ext = []
    
    #-----< RNTP-Threshold >-----#
    RNTP_Threshold = ENUM(name=u'RNTP-Threshold', mode=MODE_TYPE)
    RNTP_Threshold._cont = ASN1Dict([(u'minusInfinity', 0), (u'minusEleven', 1), (u'minusTen', 2), (u'minusNine', 3), (u'minusEight', 4), (u'minusSeven', 5), (u'minusSix', 6), (u'minusFive', 7), (u'minusFour', 8), (u'minusThree', 9), (u'minusTwo', 10), (u'minusOne', 11), (u'zero', 12), (u'one', 13), (u'two', 14), (u'three', 15)])
    RNTP_Threshold._ext = []
    
    #-----< RRC-Context >-----#
    RRC_Context = OCT_STR(name=u'RRC-Context', mode=MODE_TYPE)
    
    #-----< RRCConnReestabIndicator >-----#
    RRCConnReestabIndicator = ENUM(name=u'RRCConnReestabIndicator', mode=MODE_TYPE)
    RRCConnReestabIndicator._cont = ASN1Dict([(u'reconfigurationFailure', 0), (u'handoverFailure', 1), (u'otherFailure', 2)])
    RRCConnReestabIndicator._ext = []
    
    #-----< RRCConnSetupIndicator >-----#
    RRCConnSetupIndicator = ENUM(name=u'RRCConnSetupIndicator', mode=MODE_TYPE)
    RRCConnSetupIndicator._cont = ASN1Dict([(u'rrcConnSetup', 0)])
    RRCConnSetupIndicator._ext = []
    
    #-----< RSRPMeasurementResult >-----#
    RSRPMeasurementResult = SEQ_OF(name=u'RSRPMeasurementResult', mode=MODE_TYPE)
    _RSRPMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RSRPMeasurementResult__item__rSRPCellID = SEQ(name=u'rSRPCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    __RSRPMeasurementResult__item__rSRPMeasured = INT(name=u'rSRPMeasured', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RSRPMeasurementResult__item__rSRPMeasured._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=[], er=[])
    __RSRPMeasurementResult__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RSRPMeasurementResult__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____RSRPMeasurementResult__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RSRPMeasurementResult__item__iE_Extensions__item__id._const_tab = _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab
    ____RSRPMeasurementResult__item__iE_Extensions__item__id._const_tab_at = None
    ____RSRPMeasurementResult__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality._const_tab = _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue._const_tab = _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___RSRPMeasurementResult__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____RSRPMeasurementResult__item__iE_Extensions__item__id),
        (u'criticality', ____RSRPMeasurementResult__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue),
        ])
    ___RSRPMeasurementResult__item__iE_Extensions__item_._ext = None
    __RSRPMeasurementResult__item__iE_Extensions._cont = ___RSRPMeasurementResult__item__iE_Extensions__item_
    __RSRPMeasurementResult__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RSRPMeasurementResult__item_._cont = ASN1Dict([
        (u'rSRPCellID', __RSRPMeasurementResult__item__rSRPCellID),
        (u'rSRPMeasured', __RSRPMeasurementResult__item__rSRPMeasured),
        (u'iE-Extensions', __RSRPMeasurementResult__item__iE_Extensions),
        ])
    _RSRPMeasurementResult__item_._ext = []
    RSRPMeasurementResult._cont = _RSRPMeasurementResult__item_
    RSRPMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< RSRPMeasurementResult-ExtIEs >-----#
    RSRPMeasurementResult_ExtIEs = CLASS(name=u'RSRPMeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RSRPMeasurementResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSRPMRList >-----#
    RSRPMRList = SEQ_OF(name=u'RSRPMRList', mode=MODE_TYPE)
    _RSRPMRList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RSRPMRList__item__rSRPMeasurementResult = SEQ_OF(name=u'rSRPMeasurementResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RSRPMeasurementResult')))
    __RSRPMRList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RSRPMRList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____RSRPMRList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____RSRPMRList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______RSRPMRList__item__iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEID')))
    _____RSRPMRList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 147), (u'criticality', u'ignore'), (u'Extension', ______RSRPMRList__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ____RSRPMRList__item__iE_Extensions__item__id._const_tab = _____RSRPMRList__item__iE_Extensions__item__id_tab
    ____RSRPMRList__item__iE_Extensions__item__id._const_tab_at = None
    ____RSRPMRList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____RSRPMRList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RSRPMRList__item__iE_Extensions__item__criticality._const_tab = _____RSRPMRList__item__iE_Extensions__item__id_tab
    ____RSRPMRList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____RSRPMRList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____RSRPMRList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RSRPMRList__item__iE_Extensions__item__extensionValue._const_tab = _____RSRPMRList__item__iE_Extensions__item__id_tab
    ____RSRPMRList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____RSRPMRList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___RSRPMRList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____RSRPMRList__item__iE_Extensions__item__id),
        (u'criticality', ____RSRPMRList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____RSRPMRList__item__iE_Extensions__item__extensionValue),
        ])
    ___RSRPMRList__item__iE_Extensions__item_._ext = None
    __RSRPMRList__item__iE_Extensions._cont = ___RSRPMRList__item__iE_Extensions__item_
    __RSRPMRList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RSRPMRList__item_._cont = ASN1Dict([
        (u'rSRPMeasurementResult', __RSRPMRList__item__rSRPMeasurementResult),
        (u'iE-Extensions', __RSRPMRList__item__iE_Extensions),
        ])
    _RSRPMRList__item_._ext = []
    RSRPMRList._cont = _RSRPMRList__item_
    RSRPMRList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< RSRPMRList-ExtIEs >-----#
    RSRPMRList_ExtIEs = CLASS(name=u'RSRPMRList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _RSRPMRList_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEID')))
    RSRPMRList_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 147), (u'criticality', u'ignore'), (u'Extension', _RSRPMRList_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1TNLLoadIndicator >-----#
    S1TNLLoadIndicator = SEQ(name=u'S1TNLLoadIndicator', mode=MODE_TYPE)
    _S1TNLLoadIndicator_dLS1TNLLoadIndicator = ENUM(name=u'dLS1TNLLoadIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _S1TNLLoadIndicator_uLS1TNLLoadIndicator = ENUM(name=u'uLS1TNLLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _S1TNLLoadIndicator_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __S1TNLLoadIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___S1TNLLoadIndicator_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____S1TNLLoadIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____S1TNLLoadIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S1TNLLoadIndicator_iE_Extensions__item__id._const_tab = ____S1TNLLoadIndicator_iE_Extensions__item__id_tab
    ___S1TNLLoadIndicator_iE_Extensions__item__id._const_tab_at = None
    ___S1TNLLoadIndicator_iE_Extensions__item__id._const_tab_id = u'id'
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality._const_tab = ____S1TNLLoadIndicator_iE_Extensions__item__id_tab
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue._const_tab = ____S1TNLLoadIndicator_iE_Extensions__item__id_tab
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __S1TNLLoadIndicator_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___S1TNLLoadIndicator_iE_Extensions__item__id),
        (u'criticality', ___S1TNLLoadIndicator_iE_Extensions__item__criticality),
        (u'extensionValue', ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue),
        ])
    __S1TNLLoadIndicator_iE_Extensions__item_._ext = None
    _S1TNLLoadIndicator_iE_Extensions._cont = __S1TNLLoadIndicator_iE_Extensions__item_
    _S1TNLLoadIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    S1TNLLoadIndicator._cont = ASN1Dict([
        (u'dLS1TNLLoadIndicator', _S1TNLLoadIndicator_dLS1TNLLoadIndicator),
        (u'uLS1TNLLoadIndicator', _S1TNLLoadIndicator_uLS1TNLLoadIndicator),
        (u'iE-Extensions', _S1TNLLoadIndicator_iE_Extensions),
        ])
    S1TNLLoadIndicator._ext = []
    
    #-----< S1TNLLoadIndicator-ExtIEs >-----#
    S1TNLLoadIndicator_ExtIEs = CLASS(name=u'S1TNLLoadIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    S1TNLLoadIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCGChangeIndication >-----#
    SCGChangeIndication = ENUM(name=u'SCGChangeIndication', mode=MODE_TYPE)
    SCGChangeIndication._cont = ASN1Dict([(u'pDCPCountWrapAround', 0), (u'pSCellChange', 1), (u'other', 2)])
    SCGChangeIndication._ext = []
    
    #-----< SeNBSecurityKey >-----#
    SeNBSecurityKey = BIT_STR(name=u'SeNBSecurityKey', mode=MODE_TYPE)
    SeNBSecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SeNBtoMeNBContainer >-----#
    SeNBtoMeNBContainer = OCT_STR(name=u'SeNBtoMeNBContainer', mode=MODE_TYPE)
    
    #-----< ServedCells >-----#
    ServedCells = SEQ_OF(name=u'ServedCells', mode=MODE_TYPE)
    _ServedCells__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ServedCells__item__servedCellInfo = SEQ(name=u'servedCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ServedCell-Information')))
    __ServedCells__item__neighbour_Info = SEQ_OF(name=u'neighbour-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Neighbour-Information')), opt=True)
    __ServedCells__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___ServedCells__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____ServedCells__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    _____ServedCells__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedCells__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedCells__item__iE_Extensions__item__id._const_tab = _____ServedCells__item__iE_Extensions__item__id_tab
    ____ServedCells__item__iE_Extensions__item__id._const_tab_at = None
    ____ServedCells__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____ServedCells__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ServedCells__item__iE_Extensions__item__criticality._const_tab = _____ServedCells__item__iE_Extensions__item__id_tab
    ____ServedCells__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____ServedCells__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____ServedCells__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ServedCells__item__iE_Extensions__item__extensionValue._const_tab = _____ServedCells__item__iE_Extensions__item__id_tab
    ____ServedCells__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____ServedCells__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___ServedCells__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____ServedCells__item__iE_Extensions__item__id),
        (u'criticality', ____ServedCells__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____ServedCells__item__iE_Extensions__item__extensionValue),
        ])
    ___ServedCells__item__iE_Extensions__item_._ext = None
    __ServedCells__item__iE_Extensions._cont = ___ServedCells__item__iE_Extensions__item_
    __ServedCells__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _ServedCells__item_._cont = ASN1Dict([
        (u'servedCellInfo', __ServedCells__item__servedCellInfo),
        (u'neighbour-Info', __ServedCells__item__neighbour_Info),
        (u'iE-Extensions', __ServedCells__item__iE_Extensions),
        ])
    _ServedCells__item_._ext = []
    ServedCells._cont = _ServedCells__item_
    ServedCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedCell-ExtIEs >-----#
    ServedCell_ExtIEs = CLASS(name=u'ServedCell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedCell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServedCell-Information >-----#
    ServedCell_Information = SEQ(name=u'ServedCell-Information', mode=MODE_TYPE)
    _ServedCell_Information_pCI = INT(name=u'pCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    _ServedCell_Information_cellId = SEQ(name=u'cellId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ServedCell_Information_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _ServedCell_Information_broadcastPLMNs = SEQ_OF(name=u'broadcastPLMNs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BroadcastPLMNs-Item')))
    _ServedCell_Information_eUTRA_Mode_Info = CHOICE(name=u'eUTRA-Mode-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRA-Mode-Info')))
    _ServedCell_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCell_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Number-of-Antennaports')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PRACH-Configuration')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBSFN-Subframe-Infolist')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSG-Id')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBMS-Service-Area-Identity-List')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MultibandInfoList')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FreqBandIndicatorPriority')))
    ____ServedCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 84), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ServedCell_Information_iE_Extensions__item__id._const_tab = ____ServedCell_Information_iE_Extensions__item__id_tab
    ___ServedCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___ServedCell_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedCell_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ServedCell_Information_iE_Extensions__item__criticality._const_tab = ____ServedCell_Information_iE_Extensions__item__id_tab
    ___ServedCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedCell_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedCell_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ServedCell_Information_iE_Extensions__item__extensionValue._const_tab = ____ServedCell_Information_iE_Extensions__item__id_tab
    ___ServedCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedCell_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedCell_Information_iE_Extensions__item__id),
        (u'criticality', ___ServedCell_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedCell_Information_iE_Extensions__item__extensionValue),
        ])
    __ServedCell_Information_iE_Extensions__item_._ext = None
    _ServedCell_Information_iE_Extensions._cont = __ServedCell_Information_iE_Extensions__item_
    _ServedCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCell_Information._cont = ASN1Dict([
        (u'pCI', _ServedCell_Information_pCI),
        (u'cellId', _ServedCell_Information_cellId),
        (u'tAC', _ServedCell_Information_tAC),
        (u'broadcastPLMNs', _ServedCell_Information_broadcastPLMNs),
        (u'eUTRA-Mode-Info', _ServedCell_Information_eUTRA_Mode_Info),
        (u'iE-Extensions', _ServedCell_Information_iE_Extensions),
        ])
    ServedCell_Information._ext = []
    
    #-----< ServedCell-Information-ExtIEs >-----#
    ServedCell_Information_ExtIEs = CLASS(name=u'ServedCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ServedCell_Information_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Number-of-Antennaports')))
    _ServedCell_Information_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PRACH-Configuration')))
    _ServedCell_Information_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBSFN-Subframe-Infolist')))
    _ServedCell_Information_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSG-Id')))
    _ServedCell_Information_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBMS-Service-Area-Identity-List')))
    _ServedCell_Information_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MultibandInfoList')))
    _ServedCell_Information_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FreqBandIndicatorPriority')))
    ServedCell_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 84), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _ServedCell_Information_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SIPTOBearerDeactivationIndication >-----#
    SIPTOBearerDeactivationIndication = ENUM(name=u'SIPTOBearerDeactivationIndication', mode=MODE_TYPE)
    SIPTOBearerDeactivationIndication._cont = ASN1Dict([(u'true', 0)])
    SIPTOBearerDeactivationIndication._ext = []
    
    #-----< ShortMAC-I >-----#
    ShortMAC_I = BIT_STR(name=u'ShortMAC-I', mode=MODE_TYPE)
    ShortMAC_I._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SourceOfUEActivityBehaviourInformation >-----#
    SourceOfUEActivityBehaviourInformation = ENUM(name=u'SourceOfUEActivityBehaviourInformation', mode=MODE_TYPE)
    SourceOfUEActivityBehaviourInformation._cont = ASN1Dict([(u'subscription-information', 0), (u'statistics', 1)])
    SourceOfUEActivityBehaviourInformation._ext = []
    
    #-----< SpecialSubframe-Info >-----#
    SpecialSubframe_Info = SEQ(name=u'SpecialSubframe-Info', mode=MODE_TYPE)
    _SpecialSubframe_Info_specialSubframePatterns = ENUM(name=u'specialSubframePatterns', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SpecialSubframePatterns')))
    _SpecialSubframe_Info_cyclicPrefixDL = ENUM(name=u'cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixDL')))
    _SpecialSubframe_Info_cyclicPrefixUL = ENUM(name=u'cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixUL')))
    _SpecialSubframe_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpecialSubframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SpecialSubframe_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SpecialSubframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SpecialSubframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpecialSubframe_Info_iE_Extensions__item__id._const_tab = ____SpecialSubframe_Info_iE_Extensions__item__id_tab
    ___SpecialSubframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___SpecialSubframe_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___SpecialSubframe_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab = ____SpecialSubframe_Info_iE_Extensions__item__id_tab
    ___SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab = ____SpecialSubframe_Info_iE_Extensions__item__id_tab
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SpecialSubframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SpecialSubframe_Info_iE_Extensions__item__id),
        (u'criticality', ___SpecialSubframe_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___SpecialSubframe_Info_iE_Extensions__item__extensionValue),
        ])
    __SpecialSubframe_Info_iE_Extensions__item_._ext = None
    _SpecialSubframe_Info_iE_Extensions._cont = __SpecialSubframe_Info_iE_Extensions__item_
    _SpecialSubframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpecialSubframe_Info._cont = ASN1Dict([
        (u'specialSubframePatterns', _SpecialSubframe_Info_specialSubframePatterns),
        (u'cyclicPrefixDL', _SpecialSubframe_Info_cyclicPrefixDL),
        (u'cyclicPrefixUL', _SpecialSubframe_Info_cyclicPrefixUL),
        (u'iE-Extensions', _SpecialSubframe_Info_iE_Extensions),
        ])
    SpecialSubframe_Info._ext = []
    
    #-----< SpecialSubframe-Info-ExtIEs >-----#
    SpecialSubframe_Info_ExtIEs = CLASS(name=u'SpecialSubframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SpecialSubframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpecialSubframePatterns >-----#
    SpecialSubframePatterns = ENUM(name=u'SpecialSubframePatterns', mode=MODE_TYPE)
    SpecialSubframePatterns._cont = ASN1Dict([(u'ssp0', 0), (u'ssp1', 1), (u'ssp2', 2), (u'ssp3', 3), (u'ssp4', 4), (u'ssp5', 5), (u'ssp6', 6), (u'ssp7', 7), (u'ssp8', 8)])
    SpecialSubframePatterns._ext = []
    
    #-----< SubbandCQI >-----#
    SubbandCQI = SEQ(name=u'SubbandCQI', mode=MODE_TYPE)
    _SubbandCQI_subbandCQICodeword0 = CHOICE(name=u'subbandCQICodeword0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQICodeword0')))
    _SubbandCQI_subbandCQICodeword1 = CHOICE(name=u'subbandCQICodeword1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQICodeword1')), opt=True)
    _SubbandCQI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SubbandCQI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SubbandCQI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SubbandCQI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQI_iE_Extensions__item__id._const_tab = ____SubbandCQI_iE_Extensions__item__id_tab
    ___SubbandCQI_iE_Extensions__item__id._const_tab_at = None
    ___SubbandCQI_iE_Extensions__item__id._const_tab_id = u'id'
    ___SubbandCQI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SubbandCQI_iE_Extensions__item__criticality._const_tab = ____SubbandCQI_iE_Extensions__item__id_tab
    ___SubbandCQI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SubbandCQI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SubbandCQI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SubbandCQI_iE_Extensions__item__extensionValue._const_tab = ____SubbandCQI_iE_Extensions__item__id_tab
    ___SubbandCQI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SubbandCQI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SubbandCQI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SubbandCQI_iE_Extensions__item__id),
        (u'criticality', ___SubbandCQI_iE_Extensions__item__criticality),
        (u'extensionValue', ___SubbandCQI_iE_Extensions__item__extensionValue),
        ])
    __SubbandCQI_iE_Extensions__item_._ext = None
    _SubbandCQI_iE_Extensions._cont = __SubbandCQI_iE_Extensions__item_
    _SubbandCQI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SubbandCQI._cont = ASN1Dict([
        (u'subbandCQICodeword0', _SubbandCQI_subbandCQICodeword0),
        (u'subbandCQICodeword1', _SubbandCQI_subbandCQICodeword1),
        (u'iE-Extensions', _SubbandCQI_iE_Extensions),
        ])
    SubbandCQI._ext = []
    
    #-----< SRVCCOperationPossible >-----#
    SRVCCOperationPossible = ENUM(name=u'SRVCCOperationPossible', mode=MODE_TYPE)
    SRVCCOperationPossible._cont = ASN1Dict([(u'possible', 0)])
    SRVCCOperationPossible._ext = []
    
    #-----< SubbandCQI-ExtIEs >-----#
    SubbandCQI_ExtIEs = CLASS(name=u'SubbandCQI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SubbandCQI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SubbandCQICodeword0 >-----#
    SubbandCQICodeword0 = CHOICE(name=u'SubbandCQICodeword0', mode=MODE_TYPE)
    _SubbandCQICodeword0_four_bitCQI = INT(name=u'four-bitCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword0_four_bitCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _SubbandCQICodeword0_two_bitSubbandDifferentialCQI = INT(name=u'two-bitSubbandDifferentialCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword0_two_bitSubbandDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    _SubbandCQICodeword0_two_bitDifferentialCQI = INT(name=u'two-bitDifferentialCQI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword0_two_bitDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    SubbandCQICodeword0._cont = ASN1Dict([
        (u'four-bitCQI', _SubbandCQICodeword0_four_bitCQI),
        (u'two-bitSubbandDifferentialCQI', _SubbandCQICodeword0_two_bitSubbandDifferentialCQI),
        (u'two-bitDifferentialCQI', _SubbandCQICodeword0_two_bitDifferentialCQI),
        ])
    SubbandCQICodeword0._ext = []
    
    #-----< SubbandCQICodeword1 >-----#
    SubbandCQICodeword1 = CHOICE(name=u'SubbandCQICodeword1', mode=MODE_TYPE)
    _SubbandCQICodeword1_four_bitCQI = INT(name=u'four-bitCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_four_bitCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _SubbandCQICodeword1_three_bitSpatialDifferentialCQI = INT(name=u'three-bitSpatialDifferentialCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_three_bitSpatialDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    _SubbandCQICodeword1_two_bitSubbandDifferentialCQI = INT(name=u'two-bitSubbandDifferentialCQI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_two_bitSubbandDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    _SubbandCQICodeword1_two_bitDifferentialCQI = INT(name=u'two-bitDifferentialCQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_two_bitDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    SubbandCQICodeword1._cont = ASN1Dict([
        (u'four-bitCQI', _SubbandCQICodeword1_four_bitCQI),
        (u'three-bitSpatialDifferentialCQI', _SubbandCQICodeword1_three_bitSpatialDifferentialCQI),
        (u'two-bitSubbandDifferentialCQI', _SubbandCQICodeword1_two_bitSubbandDifferentialCQI),
        (u'two-bitDifferentialCQI', _SubbandCQICodeword1_two_bitDifferentialCQI),
        ])
    SubbandCQICodeword1._ext = []
    
    #-----< SubbandCQIList >-----#
    SubbandCQIList = SEQ_OF(name=u'SubbandCQIList', mode=MODE_TYPE)
    _SubbandCQIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQIItem')))
    SubbandCQIList._cont = _SubbandCQIList__item_
    SubbandCQIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< SubbandCQIItem >-----#
    SubbandCQIItem = SEQ(name=u'SubbandCQIItem', mode=MODE_TYPE)
    _SubbandCQIItem_subbandCQI = SEQ(name=u'subbandCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQI')))
    _SubbandCQIItem_subbandIndex = INT(name=u'subbandIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQIItem_subbandIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=27)], ev=[], er=[])
    _SubbandCQIItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SubbandCQIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SubbandCQIItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SubbandCQIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQIItem_iE_Extensions__item__id._const_tab = ____SubbandCQIItem_iE_Extensions__item__id_tab
    ___SubbandCQIItem_iE_Extensions__item__id._const_tab_at = None
    ___SubbandCQIItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SubbandCQIItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SubbandCQIItem_iE_Extensions__item__criticality._const_tab = ____SubbandCQIItem_iE_Extensions__item__id_tab
    ___SubbandCQIItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SubbandCQIItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SubbandCQIItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SubbandCQIItem_iE_Extensions__item__extensionValue._const_tab = ____SubbandCQIItem_iE_Extensions__item__id_tab
    ___SubbandCQIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SubbandCQIItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SubbandCQIItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SubbandCQIItem_iE_Extensions__item__id),
        (u'criticality', ___SubbandCQIItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SubbandCQIItem_iE_Extensions__item__extensionValue),
        ])
    __SubbandCQIItem_iE_Extensions__item_._ext = None
    _SubbandCQIItem_iE_Extensions._cont = __SubbandCQIItem_iE_Extensions__item_
    _SubbandCQIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SubbandCQIItem._cont = ASN1Dict([
        (u'subbandCQI', _SubbandCQIItem_subbandCQI),
        (u'subbandIndex', _SubbandCQIItem_subbandIndex),
        (u'iE-Extensions', _SubbandCQIItem_iE_Extensions),
        ])
    SubbandCQIItem._ext = []
    
    #-----< SubbandCQIItem-ExtIEs >-----#
    SubbandCQIItem_ExtIEs = CLASS(name=u'SubbandCQIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SubbandCQIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SubbandSize >-----#
    SubbandSize = ENUM(name=u'SubbandSize', mode=MODE_TYPE)
    SubbandSize._cont = ASN1Dict([(u'size2', 0), (u'size3', 1), (u'size4', 2), (u'size6', 3), (u'size8', 4)])
    SubbandSize._ext = []
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name=u'SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SubframeAllocation >-----#
    SubframeAllocation = CHOICE(name=u'SubframeAllocation', mode=MODE_TYPE)
    _SubframeAllocation_oneframe = BIT_STR(name=u'oneframe', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Oneframe')))
    _SubframeAllocation_fourframes = BIT_STR(name=u'fourframes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Fourframes')))
    SubframeAllocation._cont = ASN1Dict([
        (u'oneframe', _SubframeAllocation_oneframe),
        (u'fourframes', _SubframeAllocation_fourframes),
        ])
    SubframeAllocation._ext = []
    
    #-----< SubframeAssignment >-----#
    SubframeAssignment = ENUM(name=u'SubframeAssignment', mode=MODE_TYPE)
    SubframeAssignment._cont = ASN1Dict([(u'sa0', 0), (u'sa1', 1), (u'sa2', 2), (u'sa3', 3), (u'sa4', 4), (u'sa5', 5), (u'sa6', 6)])
    SubframeAssignment._ext = []
    
    #-----< TABasedMDT >-----#
    TABasedMDT = SEQ(name=u'TABasedMDT', mode=MODE_TYPE)
    _TABasedMDT_tAListforMDT = SEQ_OF(name=u'tAListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAListforMDT')))
    _TABasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TABasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TABasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__id._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TABasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___TABasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TABasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TABasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TABasedMDT_iE_Extensions__item__id),
        (u'criticality', ___TABasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___TABasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TABasedMDT_iE_Extensions__item_._ext = None
    _TABasedMDT_iE_Extensions._cont = __TABasedMDT_iE_Extensions__item_
    _TABasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedMDT._cont = ASN1Dict([
        (u'tAListforMDT', _TABasedMDT_tAListforMDT),
        (u'iE-Extensions', _TABasedMDT_iE_Extensions),
        ])
    TABasedMDT._ext = []
    
    #-----< TABasedMDT-ExtIEs >-----#
    TABasedMDT_ExtIEs = CLASS(name=u'TABasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TABasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name=u'TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TAIBasedMDT >-----#
    TAIBasedMDT = SEQ(name=u'TAIBasedMDT', mode=MODE_TYPE)
    _TAIBasedMDT_tAIListforMDT = SEQ_OF(name=u'tAIListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAIListforMDT')))
    _TAIBasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIBasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIBasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIBasedMDT_iE_Extensions__item__id),
        (u'criticality', ___TAIBasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedMDT_iE_Extensions__item_._ext = None
    _TAIBasedMDT_iE_Extensions._cont = __TAIBasedMDT_iE_Extensions__item_
    _TAIBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedMDT._cont = ASN1Dict([
        (u'tAIListforMDT', _TAIBasedMDT_tAIListforMDT),
        (u'iE-Extensions', _TAIBasedMDT_iE_Extensions),
        ])
    TAIBasedMDT._ext = []
    
    #-----< TAIBasedMDT-ExtIEs >-----#
    TAIBasedMDT_ExtIEs = CLASS(name=u'TAIBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TAIBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforMDT >-----#
    TAIListforMDT = SEQ_OF(name=u'TAIListforMDT', mode=MODE_TYPE)
    _TAIListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAI-Item')))
    TAIListforMDT._cont = _TAIListforMDT__item_
    TAIListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAI-Item >-----#
    TAI_Item = SEQ(name=u'TAI-Item', mode=MODE_TYPE)
    _TAI_Item_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _TAI_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _TAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Item_iE_Extensions__item__id._const_tab = ____TAI_Item_iE_Extensions__item__id_tab
    ___TAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TAI_Item_iE_Extensions__item__criticality._const_tab = ____TAI_Item_iE_Extensions__item__id_tab
    ___TAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TAI_Item_iE_Extensions__item__extensionValue._const_tab = ____TAI_Item_iE_Extensions__item__id_tab
    ___TAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAI_Item_iE_Extensions__item__id),
        (u'criticality', ___TAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAI_Item_iE_Extensions__item__extensionValue),
        ])
    __TAI_Item_iE_Extensions__item_._ext = None
    _TAI_Item_iE_Extensions._cont = __TAI_Item_iE_Extensions__item_
    _TAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI_Item._cont = ASN1Dict([
        (u'tAC', _TAI_Item_tAC),
        (u'pLMN-Identity', _TAI_Item_pLMN_Identity),
        (u'iE-Extensions', _TAI_Item_iE_Extensions),
        ])
    TAI_Item._ext = []
    
    #-----< TAI-Item-ExtIEs >-----#
    TAI_Item_ExtIEs = CLASS(name=u'TAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforMDT >-----#
    TAListforMDT = SEQ_OF(name=u'TAListforMDT', mode=MODE_TYPE)
    _TAListforMDT__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    TAListforMDT._cont = _TAListforMDT__item_
    TAListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TargetCellInUTRAN >-----#
    TargetCellInUTRAN = OCT_STR(name=u'TargetCellInUTRAN', mode=MODE_TYPE)
    
    #-----< TargeteNBtoSource-eNBTransparentContainer >-----#
    TargeteNBtoSource_eNBTransparentContainer = OCT_STR(name=u'TargeteNBtoSource-eNBTransparentContainer', mode=MODE_TYPE)
    
    #-----< TDD-Info >-----#
    TDD_Info = SEQ(name=u'TDD-Info', mode=MODE_TYPE)
    _TDD_Info_eARFCN = INT(name=u'eARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    _TDD_Info_transmission_Bandwidth = ENUM(name=u'transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transmission-Bandwidth')))
    _TDD_Info_subframeAssignment = ENUM(name=u'subframeAssignment', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubframeAssignment')))
    _TDD_Info_specialSubframe_Info = SEQ(name=u'specialSubframe-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SpecialSubframe-Info')))
    _TDD_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TDD_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframe-Info')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    ____TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 97), (u'criticality', u'ignore'), (u'Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_Info_iE_Extensions__item__id._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___TDD_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_Info_iE_Extensions__item__criticality._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_Info_iE_Extensions__item__id),
        (u'criticality', ___TDD_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __TDD_Info_iE_Extensions__item_._ext = None
    _TDD_Info_iE_Extensions._cont = __TDD_Info_iE_Extensions__item_
    _TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_Info._cont = ASN1Dict([
        (u'eARFCN', _TDD_Info_eARFCN),
        (u'transmission-Bandwidth', _TDD_Info_transmission_Bandwidth),
        (u'subframeAssignment', _TDD_Info_subframeAssignment),
        (u'specialSubframe-Info', _TDD_Info_specialSubframe_Info),
        (u'iE-Extensions', _TDD_Info_iE_Extensions),
        ])
    TDD_Info._ext = []
    
    #-----< TDD-Info-ExtIEs >-----#
    TDD_Info_ExtIEs = CLASS(name=u'TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _TDD_Info_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframe-Info')))
    _TDD_Info_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    TDD_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 97), (u'criticality', u'ignore'), (u'Extension', _TDD_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 94), (u'criticality', u'reject'), (u'Extension', _TDD_Info_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Threshold-RSRP >-----#
    Threshold_RSRP = INT(name=u'Threshold-RSRP', mode=MODE_TYPE)
    Threshold_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< Threshold-RSRQ >-----#
    Threshold_RSRQ = INT(name=u'Threshold-RSRQ', mode=MODE_TYPE)
    Threshold_RSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name=u'TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([(u'v1s', 0), (u'v2s', 1), (u'v5s', 2), (u'v10s', 3), (u'v20s', 4), (u'v60s', 5)])
    TimeToWait._ext = []
    
    #-----< Time-UE-StayedInCell >-----#
    Time_UE_StayedInCell = INT(name=u'Time-UE-StayedInCell', mode=MODE_TYPE)
    Time_UE_StayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Time-UE-StayedInCell-EnhancedGranularity >-----#
    Time_UE_StayedInCell_EnhancedGranularity = INT(name=u'Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_TYPE)
    Time_UE_StayedInCell_EnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name=u'TraceActivation', mode=MODE_TYPE)
    _TraceActivation_eUTRANTraceID = OCT_STR(name=u'eUTRANTraceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRANTraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name=u'interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name=u'traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name=u'traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TraceCollectionEntityIPAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Configuration')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 72), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TraceActivation_iE_Extensions__item__id),
        (u'criticality', ___TraceActivation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        (u'eUTRANTraceID', _TraceActivation_eUTRANTraceID),
        (u'interfacesToTrace', _TraceActivation_interfacesToTrace),
        (u'traceDepth', _TraceActivation_traceDepth),
        (u'traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        (u'iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name=u'TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Configuration')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 72), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceCollectionEntityIPAddress >-----#
    TraceCollectionEntityIPAddress = BIT_STR(name=u'TraceCollectionEntityIPAddress', mode=MODE_TYPE)
    TraceCollectionEntityIPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2), (u'minimumWithoutVendorSpecificExtension', 3), (u'mediumWithoutVendorSpecificExtension', 4), (u'maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< Transmission-Bandwidth >-----#
    Transmission_Bandwidth = ENUM(name=u'Transmission-Bandwidth', mode=MODE_TYPE)
    Transmission_Bandwidth._cont = ASN1Dict([(u'bw6', 0), (u'bw15', 1), (u'bw25', 2), (u'bw50', 3), (u'bw75', 4), (u'bw100', 5)])
    Transmission_Bandwidth._ext = []
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TunnelInformation >-----#
    TunnelInformation = SEQ(name=u'TunnelInformation', mode=MODE_TYPE)
    _TunnelInformation_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _TunnelInformation_uDP_Port_Number = OCT_STR(name=u'uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Port-Number')), opt=True)
    _TunnelInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TunnelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TunnelInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TunnelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__id._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__id._const_tab_at = None
    ___TunnelInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TunnelInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TunnelInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TunnelInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TunnelInformation_iE_Extensions__item__id),
        (u'criticality', ___TunnelInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TunnelInformation_iE_Extensions__item__extensionValue),
        ])
    __TunnelInformation_iE_Extensions__item_._ext = None
    _TunnelInformation_iE_Extensions._cont = __TunnelInformation_iE_Extensions__item_
    _TunnelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TunnelInformation._cont = ASN1Dict([
        (u'transportLayerAddress', _TunnelInformation_transportLayerAddress),
        (u'uDP-Port-Number', _TunnelInformation_uDP_Port_Number),
        (u'iE-Extensions', _TunnelInformation_iE_Extensions),
        ])
    TunnelInformation._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name=u'Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< UEAggregateMaximumBitRate >-----#
    UEAggregateMaximumBitRate = SEQ(name=u'UEAggregateMaximumBitRate', mode=MODE_TYPE)
    _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateDownlink = INT(name=u'uEaggregateMaximumBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateUplink = INT(name=u'uEaggregateMaximumBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEAggregateMaximumBitRate_iE_Extensions__item__id),
        (u'criticality', ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __UEAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _UEAggregateMaximumBitRate_iE_Extensions._cont = __UEAggregateMaximumBitRate_iE_Extensions__item_
    _UEAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAggregateMaximumBitRate._cont = ASN1Dict([
        (u'uEaggregateMaximumBitRateDownlink', _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateDownlink),
        (u'uEaggregateMaximumBitRateUplink', _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateUplink),
        (u'iE-Extensions', _UEAggregateMaximumBitRate_iE_Extensions),
        ])
    UEAggregateMaximumBitRate._ext = []
    
    #-----< UEAggregate-MaximumBitrate-ExtIEs >-----#
    UEAggregate_MaximumBitrate_ExtIEs = CLASS(name=u'UEAggregate-MaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UEAggregate_MaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-ContextKeptIndicator >-----#
    UE_ContextKeptIndicator = ENUM(name=u'UE-ContextKeptIndicator', mode=MODE_TYPE)
    UE_ContextKeptIndicator._cont = ASN1Dict([(u'true', 0)])
    UE_ContextKeptIndicator._ext = []
    
    #-----< UEID >-----#
    UEID = BIT_STR(name=u'UEID', mode=MODE_TYPE)
    UEID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UE-HistoryInformation >-----#
    UE_HistoryInformation = SEQ_OF(name=u'UE-HistoryInformation', mode=MODE_TYPE)
    _UE_HistoryInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedCell-Item')))
    UE_HistoryInformation._cont = _UE_HistoryInformation__item_
    UE_HistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UE-HistoryInformationFromTheUE >-----#
    UE_HistoryInformationFromTheUE = OCT_STR(name=u'UE-HistoryInformationFromTheUE', mode=MODE_TYPE)
    
    #-----< UE-S1AP-ID >-----#
    UE_S1AP_ID = INT(name=u'UE-S1AP-ID', mode=MODE_TYPE)
    UE_S1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< UE-X2AP-ID >-----#
    UE_X2AP_ID = INT(name=u'UE-X2AP-ID', mode=MODE_TYPE)
    UE_X2AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< UE-X2AP-ID-Extension >-----#
    UE_X2AP_ID_Extension = INT(name=u'UE-X2AP-ID-Extension', mode=MODE_TYPE)
    UE_X2AP_ID_Extension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< UE-RLF-Report-Container >-----#
    UE_RLF_Report_Container = OCT_STR(name=u'UE-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container-for-extended-bands >-----#
    UE_RLF_Report_Container_for_extended_bands = OCT_STR(name=u'UE-RLF-Report-Container-for-extended-bands', mode=MODE_TYPE)
    
    #-----< UESecurityCapabilities >-----#
    UESecurityCapabilities = SEQ(name=u'UESecurityCapabilities', mode=MODE_TYPE)
    _UESecurityCapabilities_encryptionAlgorithms = BIT_STR(name=u'encryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EncryptionAlgorithms')))
    _UESecurityCapabilities_integrityProtectionAlgorithms = BIT_STR(name=u'integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'IntegrityProtectionAlgorithms')))
    _UESecurityCapabilities_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UESecurityCapabilities_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_id = u'id'
    ___UESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UESecurityCapabilities_iE_Extensions__item__id),
        (u'criticality', ___UESecurityCapabilities_iE_Extensions__item__criticality),
        (u'extensionValue', ___UESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __UESecurityCapabilities_iE_Extensions__item_._ext = None
    _UESecurityCapabilities_iE_Extensions._cont = __UESecurityCapabilities_iE_Extensions__item_
    _UESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESecurityCapabilities._cont = ASN1Dict([
        (u'encryptionAlgorithms', _UESecurityCapabilities_encryptionAlgorithms),
        (u'integrityProtectionAlgorithms', _UESecurityCapabilities_integrityProtectionAlgorithms),
        (u'iE-Extensions', _UESecurityCapabilities_iE_Extensions),
        ])
    UESecurityCapabilities._ext = []
    
    #-----< UESecurityCapabilities-ExtIEs >-----#
    UESecurityCapabilities_ExtIEs = CLASS(name=u'UESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-GBR-PRB-usage >-----#
    UL_GBR_PRB_usage = INT(name=u'UL-GBR-PRB-usage', mode=MODE_TYPE)
    UL_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-HighInterferenceIndicationInfo >-----#
    UL_HighInterferenceIndicationInfo = SEQ_OF(name=u'UL-HighInterferenceIndicationInfo', mode=MODE_TYPE)
    _UL_HighInterferenceIndicationInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UL-HighInterferenceIndicationInfo-Item')))
    UL_HighInterferenceIndicationInfo._cont = _UL_HighInterferenceIndicationInfo__item_
    UL_HighInterferenceIndicationInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-HighInterferenceIndicationInfo-Item >-----#
    UL_HighInterferenceIndicationInfo_Item = SEQ(name=u'UL-HighInterferenceIndicationInfo-Item', mode=MODE_TYPE)
    _UL_HighInterferenceIndicationInfo_Item_target_Cell_ID = SEQ(name=u'target-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _UL_HighInterferenceIndicationInfo_Item_ul_interferenceindication = BIT_STR(name=u'ul-interferenceindication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-HighInterferenceIndication')))
    _UL_HighInterferenceIndicationInfo_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id._const_tab = ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality._const_tab = ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id),
        (u'criticality', ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_._ext = None
    _UL_HighInterferenceIndicationInfo_Item_iE_Extensions._cont = __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_
    _UL_HighInterferenceIndicationInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_HighInterferenceIndicationInfo_Item._cont = ASN1Dict([
        (u'target-Cell-ID', _UL_HighInterferenceIndicationInfo_Item_target_Cell_ID),
        (u'ul-interferenceindication', _UL_HighInterferenceIndicationInfo_Item_ul_interferenceindication),
        (u'iE-Extensions', _UL_HighInterferenceIndicationInfo_Item_iE_Extensions),
        ])
    UL_HighInterferenceIndicationInfo_Item._ext = []
    
    #-----< UL-HighInterferenceIndicationInfo-Item-ExtIEs >-----#
    UL_HighInterferenceIndicationInfo_Item_ExtIEs = CLASS(name=u'UL-HighInterferenceIndicationInfo-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UL_HighInterferenceIndicationInfo_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-HighInterferenceIndication >-----#
    UL_HighInterferenceIndication = BIT_STR(name=u'UL-HighInterferenceIndication', mode=MODE_TYPE)
    UL_HighInterferenceIndication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=110)], ev=[], er=[])
    
    #-----< UL-InterferenceOverloadIndication >-----#
    UL_InterferenceOverloadIndication = SEQ_OF(name=u'UL-InterferenceOverloadIndication', mode=MODE_TYPE)
    _UL_InterferenceOverloadIndication__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UL-InterferenceOverloadIndication-Item')))
    UL_InterferenceOverloadIndication._cont = _UL_InterferenceOverloadIndication__item_
    UL_InterferenceOverloadIndication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=110)], ev=None, er=[])
    
    #-----< UL-InterferenceOverloadIndication-Item >-----#
    UL_InterferenceOverloadIndication_Item = ENUM(name=u'UL-InterferenceOverloadIndication-Item', mode=MODE_TYPE)
    UL_InterferenceOverloadIndication_Item._cont = ASN1Dict([(u'high-interference', 0), (u'medium-interference', 1), (u'low-interference', 2)])
    UL_InterferenceOverloadIndication_Item._ext = []
    
    #-----< UL-non-GBR-PRB-usage >-----#
    UL_non_GBR_PRB_usage = INT(name=u'UL-non-GBR-PRB-usage', mode=MODE_TYPE)
    UL_non_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-Total-PRB-usage >-----#
    UL_Total_PRB_usage = INT(name=u'UL-Total-PRB-usage', mode=MODE_TYPE)
    UL_Total_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UsableABSInformation >-----#
    UsableABSInformation = CHOICE(name=u'UsableABSInformation', mode=MODE_TYPE)
    _UsableABSInformation_fdd = SEQ(name=u'fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UsableABSInformationFDD')))
    _UsableABSInformation_tdd = SEQ(name=u'tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UsableABSInformationTDD')))
    UsableABSInformation._cont = ASN1Dict([
        (u'fdd', _UsableABSInformation_fdd),
        (u'tdd', _UsableABSInformation_tdd),
        ])
    UsableABSInformation._ext = []
    
    #-----< UsableABSInformationFDD >-----#
    UsableABSInformationFDD = SEQ(name=u'UsableABSInformationFDD', mode=MODE_TYPE)
    _UsableABSInformationFDD_usable_abs_pattern_info = BIT_STR(name=u'usable-abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UsableABSInformationFDD_usable_abs_pattern_info._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _UsableABSInformationFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UsableABSInformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UsableABSInformationFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UsableABSInformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationFDD_iE_Extensions__item__id._const_tab = ____UsableABSInformationFDD_iE_Extensions__item__id_tab
    ___UsableABSInformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___UsableABSInformationFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UsableABSInformationFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UsableABSInformationFDD_iE_Extensions__item__criticality._const_tab = ____UsableABSInformationFDD_iE_Extensions__item__id_tab
    ___UsableABSInformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UsableABSInformationFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue._const_tab = ____UsableABSInformationFDD_iE_Extensions__item__id_tab
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UsableABSInformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UsableABSInformationFDD_iE_Extensions__item__id),
        (u'criticality', ___UsableABSInformationFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UsableABSInformationFDD_iE_Extensions__item__extensionValue),
        ])
    __UsableABSInformationFDD_iE_Extensions__item_._ext = None
    _UsableABSInformationFDD_iE_Extensions._cont = __UsableABSInformationFDD_iE_Extensions__item_
    _UsableABSInformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UsableABSInformationFDD._cont = ASN1Dict([
        (u'usable-abs-pattern-info', _UsableABSInformationFDD_usable_abs_pattern_info),
        (u'iE-Extensions', _UsableABSInformationFDD_iE_Extensions),
        ])
    UsableABSInformationFDD._ext = []
    
    #-----< UsableABSInformationFDD-ExtIEs >-----#
    UsableABSInformationFDD_ExtIEs = CLASS(name=u'UsableABSInformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UsableABSInformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UsableABSInformationTDD >-----#
    UsableABSInformationTDD = SEQ(name=u'UsableABSInformationTDD', mode=MODE_TYPE)
    _UsableABSInformationTDD_usaable_abs_pattern_info = BIT_STR(name=u'usaable-abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UsableABSInformationTDD_usaable_abs_pattern_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=[], er=[])
    _UsableABSInformationTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UsableABSInformationTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UsableABSInformationTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UsableABSInformationTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationTDD_iE_Extensions__item__id._const_tab = ____UsableABSInformationTDD_iE_Extensions__item__id_tab
    ___UsableABSInformationTDD_iE_Extensions__item__id._const_tab_at = None
    ___UsableABSInformationTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UsableABSInformationTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UsableABSInformationTDD_iE_Extensions__item__criticality._const_tab = ____UsableABSInformationTDD_iE_Extensions__item__id_tab
    ___UsableABSInformationTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UsableABSInformationTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue._const_tab = ____UsableABSInformationTDD_iE_Extensions__item__id_tab
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UsableABSInformationTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UsableABSInformationTDD_iE_Extensions__item__id),
        (u'criticality', ___UsableABSInformationTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UsableABSInformationTDD_iE_Extensions__item__extensionValue),
        ])
    __UsableABSInformationTDD_iE_Extensions__item_._ext = None
    _UsableABSInformationTDD_iE_Extensions._cont = __UsableABSInformationTDD_iE_Extensions__item_
    _UsableABSInformationTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UsableABSInformationTDD._cont = ASN1Dict([
        (u'usaable-abs-pattern-info', _UsableABSInformationTDD_usaable_abs_pattern_info),
        (u'iE-Extensions', _UsableABSInformationTDD_iE_Extensions),
        ])
    UsableABSInformationTDD._ext = []
    
    #-----< UsableABSInformationTDD-ExtIEs >-----#
    UsableABSInformationTDD_ExtIEs = CLASS(name=u'UsableABSInformationTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UsableABSInformationTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WidebandCQI >-----#
    WidebandCQI = SEQ(name=u'WidebandCQI', mode=MODE_TYPE)
    _WidebandCQI_widebandCQICodeword0 = INT(name=u'widebandCQICodeword0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WidebandCQI_widebandCQICodeword0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _WidebandCQI_widebandCQICodeword1 = CHOICE(name=u'widebandCQICodeword1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WidebandCQICodeword1')), opt=True)
    _WidebandCQI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WidebandCQI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___WidebandCQI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____WidebandCQI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WidebandCQI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WidebandCQI_iE_Extensions__item__id._const_tab = ____WidebandCQI_iE_Extensions__item__id_tab
    ___WidebandCQI_iE_Extensions__item__id._const_tab_at = None
    ___WidebandCQI_iE_Extensions__item__id._const_tab_id = u'id'
    ___WidebandCQI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___WidebandCQI_iE_Extensions__item__criticality._const_tab = ____WidebandCQI_iE_Extensions__item__id_tab
    ___WidebandCQI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WidebandCQI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WidebandCQI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___WidebandCQI_iE_Extensions__item__extensionValue._const_tab = ____WidebandCQI_iE_Extensions__item__id_tab
    ___WidebandCQI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WidebandCQI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WidebandCQI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WidebandCQI_iE_Extensions__item__id),
        (u'criticality', ___WidebandCQI_iE_Extensions__item__criticality),
        (u'extensionValue', ___WidebandCQI_iE_Extensions__item__extensionValue),
        ])
    __WidebandCQI_iE_Extensions__item_._ext = None
    _WidebandCQI_iE_Extensions._cont = __WidebandCQI_iE_Extensions__item_
    _WidebandCQI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WidebandCQI._cont = ASN1Dict([
        (u'widebandCQICodeword0', _WidebandCQI_widebandCQICodeword0),
        (u'widebandCQICodeword1', _WidebandCQI_widebandCQICodeword1),
        (u'iE-Extensions', _WidebandCQI_iE_Extensions),
        ])
    WidebandCQI._ext = []
    
    #-----< WidebandCQI-ExtIEs >-----#
    WidebandCQI_ExtIEs = CLASS(name=u'WidebandCQI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    WidebandCQI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WidebandCQICodeword1 >-----#
    WidebandCQICodeword1 = CHOICE(name=u'WidebandCQICodeword1', mode=MODE_TYPE)
    _WidebandCQICodeword1_four_bitCQI = INT(name=u'four-bitCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WidebandCQICodeword1_four_bitCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _WidebandCQICodeword1_three_bitSpatialDifferentialCQI = INT(name=u'three-bitSpatialDifferentialCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WidebandCQICodeword1_three_bitSpatialDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    WidebandCQICodeword1._cont = ASN1Dict([
        (u'four-bitCQI', _WidebandCQICodeword1_four_bitCQI),
        (u'three-bitSpatialDifferentialCQI', _WidebandCQICodeword1_three_bitSpatialDifferentialCQI),
        ])
    WidebandCQICodeword1._ext = []
    
    #-----< X2BenefitValue >-----#
    X2BenefitValue = INT(name=u'X2BenefitValue', mode=MODE_TYPE)
    X2BenefitValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    _all_ = [
        _ABSInformation_fdd,
        _ABSInformation_tdd,
        _ABSInformation_abs_inactive,
        ABSInformation,
        _ABSInformationFDD_abs_pattern_info,
        _ABSInformationFDD_numberOfCellSpecificAntennaPorts,
        _ABSInformationFDD_measurement_subset,
        ____ABSInformationFDD_iE_Extensions__item__id_tab,
        ___ABSInformationFDD_iE_Extensions__item__id,
        ___ABSInformationFDD_iE_Extensions__item__criticality,
        ___ABSInformationFDD_iE_Extensions__item__extensionValue,
        __ABSInformationFDD_iE_Extensions__item_,
        _ABSInformationFDD_iE_Extensions,
        ABSInformationFDD,
        ABSInformationFDD_ExtIEs,
        _ABSInformationTDD_abs_pattern_info,
        _ABSInformationTDD_numberOfCellSpecificAntennaPorts,
        _ABSInformationTDD_measurement_subset,
        ____ABSInformationTDD_iE_Extensions__item__id_tab,
        ___ABSInformationTDD_iE_Extensions__item__id,
        ___ABSInformationTDD_iE_Extensions__item__criticality,
        ___ABSInformationTDD_iE_Extensions__item__extensionValue,
        __ABSInformationTDD_iE_Extensions__item_,
        _ABSInformationTDD_iE_Extensions,
        ABSInformationTDD,
        ABSInformationTDD_ExtIEs,
        _ABS_Status_dL_ABS_status,
        _ABS_Status_usableABSInformation,
        ____ABS_Status_iE_Extensions__item__id_tab,
        ___ABS_Status_iE_Extensions__item__id,
        ___ABS_Status_iE_Extensions__item__criticality,
        ___ABS_Status_iE_Extensions__item__extensionValue,
        __ABS_Status_iE_Extensions__item_,
        _ABS_Status_iE_Extensions,
        ABS_Status,
        ABS_Status_ExtIEs,
        _AdditionalSpecialSubframe_Info_additionalspecialSubframePatterns,
        _AdditionalSpecialSubframe_Info_cyclicPrefixDL,
        _AdditionalSpecialSubframe_Info_cyclicPrefixUL,
        ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab,
        ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id,
        ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality,
        ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue,
        __AdditionalSpecialSubframe_Info_iE_Extensions__item_,
        _AdditionalSpecialSubframe_Info_iE_Extensions,
        AdditionalSpecialSubframe_Info,
        AdditionalSpecialSubframe_Info_ExtIEs,
        AdditionalSpecialSubframePatterns,
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AreaScopeOfMDT_cellBased,
        _AreaScopeOfMDT_tABased,
        _AreaScopeOfMDT_pLMNWide,
        _AreaScopeOfMDT_tAIBased,
        AreaScopeOfMDT,
        _AS_SecurityInformation_key_eNodeB_star,
        _AS_SecurityInformation_nextHopChainingCount,
        ____AS_SecurityInformation_iE_Extensions__item__id_tab,
        ___AS_SecurityInformation_iE_Extensions__item__id,
        ___AS_SecurityInformation_iE_Extensions__item__criticality,
        ___AS_SecurityInformation_iE_Extensions__item__extensionValue,
        __AS_SecurityInformation_iE_Extensions__item_,
        _AS_SecurityInformation_iE_Extensions,
        AS_SecurityInformation,
        AS_SecurityInformation_ExtIEs,
        BearerType,
        BenefitMetric,
        BitRate,
        _BroadcastPLMNs_Item__item_,
        BroadcastPLMNs_Item,
        CapacityValue,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        _CellBasedMDT_cellIdListforMDT,
        ____CellBasedMDT_iE_Extensions__item__id_tab,
        ___CellBasedMDT_iE_Extensions__item__id,
        ___CellBasedMDT_iE_Extensions__item__criticality,
        ___CellBasedMDT_iE_Extensions__item__extensionValue,
        __CellBasedMDT_iE_Extensions__item_,
        _CellBasedMDT_iE_Extensions,
        CellBasedMDT,
        CellBasedMDT_ExtIEs,
        CellCapacityClassValue,
        CellDeploymentStatusIndicator,
        _CellIdListforMDT__item_,
        CellIdListforMDT,
        _CellReplacingInfo_replacingCellsList,
        ____CellReplacingInfo_iE_Extensions__item__id_tab,
        ___CellReplacingInfo_iE_Extensions__item__id,
        ___CellReplacingInfo_iE_Extensions__item__criticality,
        ___CellReplacingInfo_iE_Extensions__item__extensionValue,
        __CellReplacingInfo_iE_Extensions__item_,
        _CellReplacingInfo_iE_Extensions,
        CellReplacingInfo,
        CellReplacingInfo_ExtIEs,
        CellReportingIndicator,
        Cell_Size,
        _CellType_cell_Size,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ___CellType_iE_Extensions__item__criticality,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        _CoMPHypothesisSet__item_,
        CoMPHypothesisSet,
        _CoMPHypothesisSetItem_coMPCellID,
        _CoMPHypothesisSetItem_coMPHypothesis,
        ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab,
        ___CoMPHypothesisSetItem_iE_Extensions__item__id,
        ___CoMPHypothesisSetItem_iE_Extensions__item__criticality,
        ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue,
        __CoMPHypothesisSetItem_iE_Extensions__item_,
        _CoMPHypothesisSetItem_iE_Extensions,
        CoMPHypothesisSetItem,
        CoMPHypothesisSetItem_ExtIEs,
        _CoMPInformation_coMPInformationItem,
        _CoMPInformation_coMPInformationStartTime,
        ____CoMPInformation_iE_Extensions__item__id_tab,
        ___CoMPInformation_iE_Extensions__item__id,
        ___CoMPInformation_iE_Extensions__item__criticality,
        ___CoMPInformation_iE_Extensions__item__extensionValue,
        __CoMPInformation_iE_Extensions__item_,
        _CoMPInformation_iE_Extensions,
        CoMPInformation,
        CoMPInformation_ExtIEs,
        __CoMPInformationItem__item__coMPHypothesisSet,
        __CoMPInformationItem__item__benefitMetric,
        _____CoMPInformationItem__item__iE_Extensions__item__id_tab,
        ____CoMPInformationItem__item__iE_Extensions__item__id,
        ____CoMPInformationItem__item__iE_Extensions__item__criticality,
        ____CoMPInformationItem__item__iE_Extensions__item__extensionValue,
        ___CoMPInformationItem__item__iE_Extensions__item_,
        __CoMPInformationItem__item__iE_Extensions,
        _CoMPInformationItem__item_,
        CoMPInformationItem,
        CoMPInformationItem_ExtIEs,
        __CoMPInformationStartTime__item__startSFN,
        __CoMPInformationStartTime__item__startSubframeNumber,
        _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab,
        ____CoMPInformationStartTime__item__iE_Extensions__item__id,
        ____CoMPInformationStartTime__item__iE_Extensions__item__criticality,
        ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue,
        ___CoMPInformationStartTime__item__iE_Extensions__item_,
        __CoMPInformationStartTime__item__iE_Extensions,
        _CoMPInformationStartTime__item_,
        CoMPInformationStartTime,
        CoMPInformationStartTime_ExtIEs,
        _CompositeAvailableCapacity_cellCapacityClassValue,
        _CompositeAvailableCapacity_capacityValue,
        ____CompositeAvailableCapacity_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__id,
        ___CompositeAvailableCapacity_iE_Extensions__item__criticality,
        ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacity_iE_Extensions__item_,
        _CompositeAvailableCapacity_iE_Extensions,
        CompositeAvailableCapacity,
        CompositeAvailableCapacity_ExtIEs,
        _CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity,
        _CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__id,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacityGroup_iE_Extensions__item_,
        _CompositeAvailableCapacityGroup_iE_Extensions,
        CompositeAvailableCapacityGroup,
        CompositeAvailableCapacityGroup_ExtIEs,
        Correlation_ID,
        _COUNTvalue_pDCP_SN,
        _COUNTvalue_hFN,
        ____COUNTvalue_iE_Extensions__item__id_tab,
        ___COUNTvalue_iE_Extensions__item__id,
        ___COUNTvalue_iE_Extensions__item__criticality,
        ___COUNTvalue_iE_Extensions__item__extensionValue,
        __COUNTvalue_iE_Extensions__item_,
        _COUNTvalue_iE_Extensions,
        COUNTvalue,
        COUNTvalue_ExtIEs,
        _COUNTValueExtended_pDCP_SNExtended,
        _COUNTValueExtended_hFNModified,
        ____COUNTValueExtended_iE_Extensions__item__id_tab,
        ___COUNTValueExtended_iE_Extensions__item__id,
        ___COUNTValueExtended_iE_Extensions__item__criticality,
        ___COUNTValueExtended_iE_Extensions__item__extensionValue,
        __COUNTValueExtended_iE_Extensions__item_,
        _COUNTValueExtended_iE_Extensions,
        COUNTValueExtended,
        COUNTValueExtended_ExtIEs,
        _COUNTvaluePDCP_SNlength18_pDCP_SNlength18,
        _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue,
        __COUNTvaluePDCP_SNlength18_iE_Extensions__item_,
        _COUNTvaluePDCP_SNlength18_iE_Extensions,
        COUNTvaluePDCP_SNlength18,
        COUNTvaluePDCP_SNlength18_ExtIEs,
        _CoverageModificationList__item_,
        CoverageModificationList,
        _CoverageModification_Item_eCGI,
        _CoverageModification_Item_coverageState,
        _CoverageModification_Item_cellDeploymentStatusIndicator,
        _CoverageModification_Item_cellReplacingInfo,
        CoverageModification_Item,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        CRNTI,
        CSGMembershipStatus,
        CSG_Id,
        __CSIReportList__item__uEID,
        __CSIReportList__item__cSIReportPerCSIProcess,
        _____CSIReportList__item__iE_Extensions__item__id_tab,
        ____CSIReportList__item__iE_Extensions__item__id,
        ____CSIReportList__item__iE_Extensions__item__criticality,
        ____CSIReportList__item__iE_Extensions__item__extensionValue,
        ___CSIReportList__item__iE_Extensions__item_,
        __CSIReportList__item__iE_Extensions,
        _CSIReportList__item_,
        CSIReportList,
        CSIReportList_ExtIEs,
        __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex,
        __CSIReportPerCSIProcess__item__cSIReportPerCSIProcessItem,
        _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab,
        ____CSIReportPerCSIProcess__item__iE_Extensions__item__id,
        ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality,
        ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue,
        ___CSIReportPerCSIProcess__item__iE_Extensions__item_,
        __CSIReportPerCSIProcess__item__iE_Extensions,
        _CSIReportPerCSIProcess__item_,
        CSIReportPerCSIProcess,
        CSIReportPerCSIProcess_ExtIEs,
        __CSIReportPerCSIProcessItem__item__rI,
        __CSIReportPerCSIProcessItem__item__widebandCQI,
        __CSIReportPerCSIProcessItem__item__subbandSize,
        __CSIReportPerCSIProcessItem__item__subbandCQIList,
        _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab,
        ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id,
        ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality,
        ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue,
        ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_,
        __CSIReportPerCSIProcessItem__item__iE_Extensions,
        _CSIReportPerCSIProcessItem__item_,
        CSIReportPerCSIProcessItem,
        CSIReportPerCSIProcessItem_ExtIEs,
        CyclicPrefixDL,
        CyclicPrefixUL,
        DeactivationIndication,
        DL_ABS_status,
        DL_Forwarding,
        DL_GBR_PRB_usage,
        DL_non_GBR_PRB_usage,
        DL_Total_PRB_usage,
        _DynamicDLTransmissionInformation_naics_active,
        _DynamicDLTransmissionInformation_naics_inactive,
        DynamicDLTransmissionInformation,
        _DynamicNAICSInformation_transmissionModes,
        _DynamicNAICSInformation_pB_information,
        __DynamicNAICSInformation_pA_list__item_,
        _DynamicNAICSInformation_pA_list,
        ____DynamicNAICSInformation_iE_Extensions__item__id_tab,
        ___DynamicNAICSInformation_iE_Extensions__item__id,
        ___DynamicNAICSInformation_iE_Extensions__item__criticality,
        ___DynamicNAICSInformation_iE_Extensions__item__extensionValue,
        __DynamicNAICSInformation_iE_Extensions__item_,
        _DynamicNAICSInformation_iE_Extensions,
        DynamicNAICSInformation,
        DynamicNAICSInformation_ExtIEs,
        EARFCN,
        EARFCNExtension,
        _ECGI_pLMN_Identity,
        _ECGI_eUTRANcellIdentifier,
        ____ECGI_iE_Extensions__item__id_tab,
        ___ECGI_iE_Extensions__item__id,
        ___ECGI_iE_Extensions__item__criticality,
        ___ECGI_iE_Extensions__item__extensionValue,
        __ECGI_iE_Extensions__item_,
        _ECGI_iE_Extensions,
        ECGI,
        ECGI_ExtIEs,
        _EnhancedRNTP_enhancedRNTPBitmap,
        _EnhancedRNTP_rNTP_High_Power_Threshold,
        _EnhancedRNTP_enhancedRNTPStartTime,
        ____EnhancedRNTP_iE_Extensions__item__id_tab,
        ___EnhancedRNTP_iE_Extensions__item__id,
        ___EnhancedRNTP_iE_Extensions__item__criticality,
        ___EnhancedRNTP_iE_Extensions__item__extensionValue,
        __EnhancedRNTP_iE_Extensions__item_,
        _EnhancedRNTP_iE_Extensions,
        EnhancedRNTP,
        EnhancedRNTP_ExtIEs,
        _EnhancedRNTPStartTime_startSFN,
        _EnhancedRNTPStartTime_startSubframeNumber,
        ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab,
        ___EnhancedRNTPStartTime_iE_Extensions__item__id,
        ___EnhancedRNTPStartTime_iE_Extensions__item__criticality,
        ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue,
        __EnhancedRNTPStartTime_iE_Extensions__item_,
        _EnhancedRNTPStartTime_iE_Extensions,
        EnhancedRNTPStartTime,
        EnhancedRNTPStartTime_ExtIEs,
        _ENB_ID_macro_eNB_ID,
        _ENB_ID_home_eNB_ID,
        ENB_ID,
        EncryptionAlgorithms,
        _EPLMNs__item_,
        EPLMNs,
        E_RAB_ID,
        _E_RAB_Level_QoS_Parameters_qCI,
        _E_RAB_Level_QoS_Parameters_allocationAndRetentionPriority,
        _E_RAB_Level_QoS_Parameters_gbrQosInformation,
        ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab,
        ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id,
        ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality,
        ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue,
        __E_RAB_Level_QoS_Parameters_iE_Extensions__item_,
        _E_RAB_Level_QoS_Parameters_iE_Extensions,
        E_RAB_Level_QoS_Parameters,
        E_RAB_Level_QoS_Parameters_ExtIEs,
        ___E_RAB_List__item__id_tab,
        ____E_RAB_List__item__id_tab_val_Value_0,
        __E_RAB_List__item__id,
        __E_RAB_List__item__criticality,
        __E_RAB_List__item__value,
        _E_RAB_List__item_,
        E_RAB_List,
        E_RAB_ItemIEs,
        _E_RAB_ItemIEs_val_Value_0,
        _E_RAB_Item_e_RAB_ID,
        _E_RAB_Item_cause,
        ____E_RAB_Item_iE_Extensions__item__id_tab,
        ___E_RAB_Item_iE_Extensions__item__id,
        ___E_RAB_Item_iE_Extensions__item__criticality,
        ___E_RAB_Item_iE_Extensions__item__extensionValue,
        __E_RAB_Item_iE_Extensions__item_,
        _E_RAB_Item_iE_Extensions,
        E_RAB_Item,
        E_RAB_Item_ExtIEs,
        _EUTRA_Mode_Info_fDD,
        _EUTRA_Mode_Info_tDD,
        EUTRA_Mode_Info,
        EUTRANCellIdentifier,
        EUTRANTraceID,
        EventType,
        _ExpectedUEBehaviour_expectedActivity,
        _ExpectedUEBehaviour_expectedHOInterval,
        ____ExpectedUEBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__id,
        ___ExpectedUEBehaviour_iE_Extensions__item__criticality,
        ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEBehaviour_iE_Extensions__item_,
        _ExpectedUEBehaviour_iE_Extensions,
        ExpectedUEBehaviour,
        ExpectedUEBehaviour_ExtIEs,
        _ExpectedUEActivityBehaviour_expectedActivityPeriod,
        _ExpectedUEActivityBehaviour_expectedIdlePeriod,
        _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__id,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEActivityBehaviour_iE_Extensions__item_,
        _ExpectedUEActivityBehaviour_iE_Extensions,
        ExpectedUEActivityBehaviour,
        ExpectedUEActivityBehaviour_ExtIEs,
        ExpectedActivityPeriod,
        ExpectedIdlePeriod,
        ExpectedHOInterval,
        _ExtendedULInterferenceOverloadInfo_associatedSubframes,
        _ExtendedULInterferenceOverloadInfo_extended_ul_InterferenceOverloadIndication,
        ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab,
        ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id,
        ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality,
        ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue,
        __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_,
        _ExtendedULInterferenceOverloadInfo_iE_Extensions,
        ExtendedULInterferenceOverloadInfo,
        ExtendedULInterferenceOverloadInfo_ExtIEs,
        _FDD_Info_uL_EARFCN,
        _FDD_Info_dL_EARFCN,
        _FDD_Info_uL_Transmission_Bandwidth,
        _FDD_Info_dL_Transmission_Bandwidth,
        ____FDD_Info_iE_Extensions__item__id_tab,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___FDD_Info_iE_Extensions__item__id,
        ___FDD_Info_iE_Extensions__item__criticality,
        ___FDD_Info_iE_Extensions__item__extensionValue,
        __FDD_Info_iE_Extensions__item_,
        _FDD_Info_iE_Extensions,
        FDD_Info,
        FDD_Info_ExtIEs,
        _FDD_Info_ExtIEs_val_Extension_0,
        _FDD_Info_ExtIEs_val_Extension_1,
        ForbiddenInterRATs,
        _ForbiddenTAs__item_,
        ForbiddenTAs,
        _ForbiddenTAs_Item_pLMN_Identity,
        _ForbiddenTAs_Item_forbiddenTACs,
        ____ForbiddenTAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__id,
        ___ForbiddenTAs_Item_iE_Extensions__item__criticality,
        ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenTAs_Item_iE_Extensions__item_,
        _ForbiddenTAs_Item_iE_Extensions,
        ForbiddenTAs_Item,
        ForbiddenTAs_Item_ExtIEs,
        _ForbiddenTACs__item_,
        ForbiddenTACs,
        _ForbiddenLAs__item_,
        ForbiddenLAs,
        _ForbiddenLAs_Item_pLMN_Identity,
        _ForbiddenLAs_Item_forbiddenLACs,
        ____ForbiddenLAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__id,
        ___ForbiddenLAs_Item_iE_Extensions__item__criticality,
        ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenLAs_Item_iE_Extensions__item_,
        _ForbiddenLAs_Item_iE_Extensions,
        ForbiddenLAs_Item,
        ForbiddenLAs_Item_ExtIEs,
        _ForbiddenLACs__item_,
        ForbiddenLACs,
        Fourframes,
        FreqBandIndicator,
        FreqBandIndicatorPriority,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GlobalENB_ID_pLMN_Identity,
        _GlobalENB_ID_eNB_ID,
        ____GlobalENB_ID_iE_Extensions__item__id_tab,
        ___GlobalENB_ID_iE_Extensions__item__id,
        ___GlobalENB_ID_iE_Extensions__item__criticality,
        ___GlobalENB_ID_iE_Extensions__item__extensionValue,
        __GlobalENB_ID_iE_Extensions__item_,
        _GlobalENB_ID_iE_Extensions,
        GlobalENB_ID,
        GlobalENB_ID_ExtIEs,
        _GTPtunnelEndpoint_transportLayerAddress,
        _GTPtunnelEndpoint_gTP_TEID,
        ____GTPtunnelEndpoint_iE_Extensions__item__id_tab,
        ___GTPtunnelEndpoint_iE_Extensions__item__id,
        ___GTPtunnelEndpoint_iE_Extensions__item__criticality,
        ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue,
        __GTPtunnelEndpoint_iE_Extensions__item_,
        _GTPtunnelEndpoint_iE_Extensions,
        GTPtunnelEndpoint,
        GTPtunnelEndpoint_ExtIEs,
        GTP_TEI,
        _GUGroupIDList__item_,
        GUGroupIDList,
        _GU_Group_ID_pLMN_Identity,
        _GU_Group_ID_mME_Group_ID,
        ____GU_Group_ID_iE_Extensions__item__id_tab,
        ___GU_Group_ID_iE_Extensions__item__id,
        ___GU_Group_ID_iE_Extensions__item__criticality,
        ___GU_Group_ID_iE_Extensions__item__extensionValue,
        __GU_Group_ID_iE_Extensions__item_,
        _GU_Group_ID_iE_Extensions,
        GU_Group_ID,
        GU_Group_ID_ExtIEs,
        _GUMMEI_gU_Group_ID,
        _GUMMEI_mME_Code,
        ____GUMMEI_iE_Extensions__item__id_tab,
        ___GUMMEI_iE_Extensions__item__id,
        ___GUMMEI_iE_Extensions__item__criticality,
        ___GUMMEI_iE_Extensions__item__extensionValue,
        __GUMMEI_iE_Extensions__item_,
        _GUMMEI_iE_Extensions,
        GUMMEI,
        GUMMEI_ExtIEs,
        HandoverReportType,
        _HandoverRestrictionList_servingPLMN,
        _HandoverRestrictionList_equivalentPLMNs,
        _HandoverRestrictionList_forbiddenTAs,
        _HandoverRestrictionList_forbiddenLAs,
        _HandoverRestrictionList_forbiddenInterRATs,
        ____HandoverRestrictionList_iE_Extensions__item__id_tab,
        ___HandoverRestrictionList_iE_Extensions__item__id,
        ___HandoverRestrictionList_iE_Extensions__item__criticality,
        ___HandoverRestrictionList_iE_Extensions__item__extensionValue,
        __HandoverRestrictionList_iE_Extensions__item_,
        _HandoverRestrictionList_iE_Extensions,
        HandoverRestrictionList,
        HandoverRestrictionList_ExtIEs,
        HFN,
        HFNModified,
        HFNforPDCP_SNlength18,
        _HWLoadIndicator_dLHWLoadIndicator,
        _HWLoadIndicator_uLHWLoadIndicator,
        ____HWLoadIndicator_iE_Extensions__item__id_tab,
        ___HWLoadIndicator_iE_Extensions__item__id,
        ___HWLoadIndicator_iE_Extensions__item__criticality,
        ___HWLoadIndicator_iE_Extensions__item__extensionValue,
        __HWLoadIndicator_iE_Extensions__item_,
        _HWLoadIndicator_iE_Extensions,
        HWLoadIndicator,
        HWLoadIndicator_ExtIEs,
        IntegrityProtectionAlgorithms,
        InterfacesToTrace,
        InvokeIndication,
        Key_eNodeB_Star,
        LAC,
        _LastVisitedCell_Item_e_UTRAN_Cell,
        _LastVisitedCell_Item_uTRAN_Cell,
        _LastVisitedCell_Item_gERAN_Cell,
        LastVisitedCell_Item,
        _LastVisitedEUTRANCellInformation_global_Cell_ID,
        _LastVisitedEUTRANCellInformation_cellType,
        _LastVisitedEUTRANCellInformation_time_UE_StayedInCell,
        ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedEUTRANCellInformation_iE_Extensions__item_,
        _LastVisitedEUTRANCellInformation_iE_Extensions,
        LastVisitedEUTRANCellInformation,
        LastVisitedEUTRANCellInformation_ExtIEs,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1,
        _LastVisitedGERANCellInformation_undefined,
        LastVisitedGERANCellInformation,
        LastVisitedUTRANCellInformation,
        LHN_ID,
        Links_to_log,
        LoadIndicator,
        _LocationReportingInformation_eventType,
        _LocationReportingInformation_reportArea,
        ____LocationReportingInformation_iE_Extensions__item__id_tab,
        ___LocationReportingInformation_iE_Extensions__item__id,
        ___LocationReportingInformation_iE_Extensions__item__criticality,
        ___LocationReportingInformation_iE_Extensions__item__extensionValue,
        __LocationReportingInformation_iE_Extensions__item_,
        _LocationReportingInformation_iE_Extensions,
        LocationReportingInformation,
        LocationReportingInformation_ExtIEs,
        _M1PeriodicReporting_reportInterval,
        _M1PeriodicReporting_reportAmount,
        ____M1PeriodicReporting_iE_Extensions__item__id_tab,
        ___M1PeriodicReporting_iE_Extensions__item__id,
        ___M1PeriodicReporting_iE_Extensions__item__criticality,
        ___M1PeriodicReporting_iE_Extensions__item__extensionValue,
        __M1PeriodicReporting_iE_Extensions__item_,
        _M1PeriodicReporting_iE_Extensions,
        M1PeriodicReporting,
        M1PeriodicReporting_ExtIEs,
        M1ReportingTrigger,
        _M1ThresholdEventA2_measurementThreshold,
        ____M1ThresholdEventA2_iE_Extensions__item__id_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__id,
        ___M1ThresholdEventA2_iE_Extensions__item__criticality,
        ___M1ThresholdEventA2_iE_Extensions__item__extensionValue,
        __M1ThresholdEventA2_iE_Extensions__item_,
        _M1ThresholdEventA2_iE_Extensions,
        M1ThresholdEventA2,
        M1ThresholdEventA2_ExtIEs,
        _M3Configuration_m3period,
        ____M3Configuration_iE_Extensions__item__id_tab,
        ___M3Configuration_iE_Extensions__item__id,
        ___M3Configuration_iE_Extensions__item__criticality,
        ___M3Configuration_iE_Extensions__item__extensionValue,
        __M3Configuration_iE_Extensions__item_,
        _M3Configuration_iE_Extensions,
        M3Configuration,
        M3Configuration_ExtIEs,
        M3period,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        ___M4Configuration_iE_Extensions__item__id,
        ___M4Configuration_iE_Extensions__item__criticality,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        M4period,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        ___M5Configuration_iE_Extensions__item__id,
        ___M5Configuration_iE_Extensions__item__criticality,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        M5period,
        _M6Configuration_m6report_interval,
        _M6Configuration_m6delay_threshold,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        ___M6Configuration_iE_Extensions__item__id,
        ___M6Configuration_iE_Extensions__item__criticality,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        M6report_interval,
        M6delay_threshold,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        ___M7Configuration_iE_Extensions__item__id,
        ___M7Configuration_iE_Extensions__item__criticality,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        M7period,
        ManagementBasedMDTallowed,
        Masked_IMEISV,
        MDT_Activation,
        _MDT_Configuration_mdt_Activation,
        _MDT_Configuration_areaScopeOfMDT,
        _MDT_Configuration_measurementsToActivate,
        _MDT_Configuration_m1reportingTrigger,
        _MDT_Configuration_m1thresholdeventA2,
        _MDT_Configuration_m1periodicReporting,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_2,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_3,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_4,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_5,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_6,
        ___MDT_Configuration_iE_Extensions__item__id,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_ExtIEs_val_Extension_0,
        _MDT_Configuration_ExtIEs_val_Extension_1,
        _MDT_Configuration_ExtIEs_val_Extension_2,
        _MDT_Configuration_ExtIEs_val_Extension_3,
        _MDT_Configuration_ExtIEs_val_Extension_4,
        _MDT_Configuration_ExtIEs_val_Extension_5,
        _MDT_Configuration_ExtIEs_val_Extension_6,
        _MDTPLMNList__item_,
        MDTPLMNList,
        MDT_Location_Info,
        Measurement_ID,
        MeasurementsToActivate,
        _MeasurementThresholdA2_threshold_RSRP,
        _MeasurementThresholdA2_threshold_RSRQ,
        MeasurementThresholdA2,
        MeNBtoSeNBContainer,
        MME_Group_ID,
        MME_Code,
        _MBMS_Service_Area_Identity_List__item_,
        MBMS_Service_Area_Identity_List,
        MBMS_Service_Area_Identity,
        _MBSFN_Subframe_Infolist__item_,
        MBSFN_Subframe_Infolist,
        _MBSFN_Subframe_Info_radioframeAllocationPeriod,
        _MBSFN_Subframe_Info_radioframeAllocationOffset,
        _MBSFN_Subframe_Info_subframeAllocation,
        ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab,
        ___MBSFN_Subframe_Info_iE_Extensions__item__id,
        ___MBSFN_Subframe_Info_iE_Extensions__item__criticality,
        ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue,
        __MBSFN_Subframe_Info_iE_Extensions__item_,
        _MBSFN_Subframe_Info_iE_Extensions,
        MBSFN_Subframe_Info,
        MBSFN_Subframe_Info_ExtIEs,
        _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit,
        _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit,
        MobilityParametersModificationRange,
        _MobilityParametersInformation_handoverTriggerChange,
        MobilityParametersInformation,
        _MultibandInfoList__item_,
        MultibandInfoList,
        _BandInfo_freqBandIndicator,
        ____BandInfo_iE_Extensions__item__id_tab,
        ___BandInfo_iE_Extensions__item__id,
        ___BandInfo_iE_Extensions__item__criticality,
        ___BandInfo_iE_Extensions__item__extensionValue,
        __BandInfo_iE_Extensions__item_,
        _BandInfo_iE_Extensions,
        BandInfo,
        BandInfo_ExtIEs,
        __Neighbour_Information__item__eCGI,
        __Neighbour_Information__item__pCI,
        __Neighbour_Information__item__eARFCN,
        _____Neighbour_Information__item__iE_Extensions__item__id_tab,
        ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____Neighbour_Information__item__iE_Extensions__item__id,
        ____Neighbour_Information__item__iE_Extensions__item__criticality,
        ____Neighbour_Information__item__iE_Extensions__item__extensionValue,
        ___Neighbour_Information__item__iE_Extensions__item_,
        __Neighbour_Information__item__iE_Extensions,
        _Neighbour_Information__item_,
        Neighbour_Information,
        Neighbour_Information_ExtIEs,
        _Neighbour_Information_ExtIEs_val_Extension_0,
        _Neighbour_Information_ExtIEs_val_Extension_1,
        NextHopChainingCount,
        Number_of_Antennaports,
        Oneframe,
        PA_Values,
        PDCP_SN,
        PDCP_SNExtended,
        PDCP_SNlength18,
        PCI,
        PLMN_Identity,
        Port_Number,
        _PRACH_Configuration_rootSequenceIndex,
        _PRACH_Configuration_zeroCorrelationIndex,
        _PRACH_Configuration_highSpeedFlag,
        _PRACH_Configuration_prach_FreqOffset,
        _PRACH_Configuration_prach_ConfigIndex,
        ____PRACH_Configuration_iE_Extensions__item__id_tab,
        ___PRACH_Configuration_iE_Extensions__item__id,
        ___PRACH_Configuration_iE_Extensions__item__criticality,
        ___PRACH_Configuration_iE_Extensions__item__extensionValue,
        __PRACH_Configuration_iE_Extensions__item_,
        _PRACH_Configuration_iE_Extensions,
        PRACH_Configuration,
        PRACH_Configuration_ExtIEs,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        _ProSeAuthorized_proSeDirectDiscovery,
        _ProSeAuthorized_proSeDirectCommunication,
        ____ProSeAuthorized_iE_Extensions__item__id_tab,
        _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0,
        ___ProSeAuthorized_iE_Extensions__item__id,
        ___ProSeAuthorized_iE_Extensions__item__criticality,
        ___ProSeAuthorized_iE_Extensions__item__extensionValue,
        __ProSeAuthorized_iE_Extensions__item_,
        _ProSeAuthorized_iE_Extensions,
        ProSeAuthorized,
        ProSeAuthorized_ExtIEs,
        _ProSeAuthorized_ExtIEs_val_Extension_0,
        ProSeDirectDiscovery,
        ProSeDirectCommunication,
        ProSeUEtoNetworkRelaying,
        QCI,
        RadioframeAllocationOffset,
        RadioframeAllocationPeriod,
        _RadioResourceStatus_dL_GBR_PRB_usage,
        _RadioResourceStatus_uL_GBR_PRB_usage,
        _RadioResourceStatus_dL_non_GBR_PRB_usage,
        _RadioResourceStatus_uL_non_GBR_PRB_usage,
        _RadioResourceStatus_dL_Total_PRB_usage,
        _RadioResourceStatus_uL_Total_PRB_usage,
        ____RadioResourceStatus_iE_Extensions__item__id_tab,
        ___RadioResourceStatus_iE_Extensions__item__id,
        ___RadioResourceStatus_iE_Extensions__item__criticality,
        ___RadioResourceStatus_iE_Extensions__item__extensionValue,
        __RadioResourceStatus_iE_Extensions__item_,
        _RadioResourceStatus_iE_Extensions,
        RadioResourceStatus,
        RadioResourceStatus_ExtIEs,
        ReceiveStatusofULPDCPSDUs,
        ReceiveStatusOfULPDCPSDUsExtended,
        ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        Registration_Request,
        _RelativeNarrowbandTxPower_rNTP_PerPRB,
        _RelativeNarrowbandTxPower_rNTP_Threshold,
        _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts,
        _RelativeNarrowbandTxPower_p_B,
        _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact,
        ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab,
        _____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab_val_Extension_0,
        ___RelativeNarrowbandTxPower_iE_Extensions__item__id,
        ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality,
        ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue,
        __RelativeNarrowbandTxPower_iE_Extensions__item_,
        _RelativeNarrowbandTxPower_iE_Extensions,
        RelativeNarrowbandTxPower,
        RelativeNarrowbandTxPower_ExtIEs,
        _RelativeNarrowbandTxPower_ExtIEs_val_Extension_0,
        _ReplacingCellsList__item_,
        ReplacingCellsList,
        _ReplacingCellsList_Item_eCGI,
        ReplacingCellsList_Item,
        ReportAmountMDT,
        ReportArea,
        ReportCharacteristics,
        ReportingPeriodicityCSIR,
        ReportingPeriodicityRSRPMR,
        ReportIntervalMDT,
        _ResumeID_non_truncated,
        _ResumeID_truncated,
        ResumeID,
        RNTP_Threshold,
        RRC_Context,
        RRCConnReestabIndicator,
        RRCConnSetupIndicator,
        __RSRPMeasurementResult__item__rSRPCellID,
        __RSRPMeasurementResult__item__rSRPMeasured,
        _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab,
        ____RSRPMeasurementResult__item__iE_Extensions__item__id,
        ____RSRPMeasurementResult__item__iE_Extensions__item__criticality,
        ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue,
        ___RSRPMeasurementResult__item__iE_Extensions__item_,
        __RSRPMeasurementResult__item__iE_Extensions,
        _RSRPMeasurementResult__item_,
        RSRPMeasurementResult,
        RSRPMeasurementResult_ExtIEs,
        __RSRPMRList__item__rSRPMeasurementResult,
        _____RSRPMRList__item__iE_Extensions__item__id_tab,
        ______RSRPMRList__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____RSRPMRList__item__iE_Extensions__item__id,
        ____RSRPMRList__item__iE_Extensions__item__criticality,
        ____RSRPMRList__item__iE_Extensions__item__extensionValue,
        ___RSRPMRList__item__iE_Extensions__item_,
        __RSRPMRList__item__iE_Extensions,
        _RSRPMRList__item_,
        RSRPMRList,
        RSRPMRList_ExtIEs,
        _RSRPMRList_ExtIEs_val_Extension_0,
        _S1TNLLoadIndicator_dLS1TNLLoadIndicator,
        _S1TNLLoadIndicator_uLS1TNLLoadIndicator,
        ____S1TNLLoadIndicator_iE_Extensions__item__id_tab,
        ___S1TNLLoadIndicator_iE_Extensions__item__id,
        ___S1TNLLoadIndicator_iE_Extensions__item__criticality,
        ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue,
        __S1TNLLoadIndicator_iE_Extensions__item_,
        _S1TNLLoadIndicator_iE_Extensions,
        S1TNLLoadIndicator,
        S1TNLLoadIndicator_ExtIEs,
        SCGChangeIndication,
        SeNBSecurityKey,
        SeNBtoMeNBContainer,
        __ServedCells__item__servedCellInfo,
        __ServedCells__item__neighbour_Info,
        _____ServedCells__item__iE_Extensions__item__id_tab,
        ____ServedCells__item__iE_Extensions__item__id,
        ____ServedCells__item__iE_Extensions__item__criticality,
        ____ServedCells__item__iE_Extensions__item__extensionValue,
        ___ServedCells__item__iE_Extensions__item_,
        __ServedCells__item__iE_Extensions,
        _ServedCells__item_,
        ServedCells,
        ServedCell_ExtIEs,
        _ServedCell_Information_pCI,
        _ServedCell_Information_cellId,
        _ServedCell_Information_tAC,
        _ServedCell_Information_broadcastPLMNs,
        _ServedCell_Information_eUTRA_Mode_Info,
        ____ServedCell_Information_iE_Extensions__item__id_tab,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_6,
        ___ServedCell_Information_iE_Extensions__item__id,
        ___ServedCell_Information_iE_Extensions__item__criticality,
        ___ServedCell_Information_iE_Extensions__item__extensionValue,
        __ServedCell_Information_iE_Extensions__item_,
        _ServedCell_Information_iE_Extensions,
        ServedCell_Information,
        ServedCell_Information_ExtIEs,
        _ServedCell_Information_ExtIEs_val_Extension_0,
        _ServedCell_Information_ExtIEs_val_Extension_1,
        _ServedCell_Information_ExtIEs_val_Extension_2,
        _ServedCell_Information_ExtIEs_val_Extension_3,
        _ServedCell_Information_ExtIEs_val_Extension_4,
        _ServedCell_Information_ExtIEs_val_Extension_5,
        _ServedCell_Information_ExtIEs_val_Extension_6,
        SIPTOBearerDeactivationIndication,
        ShortMAC_I,
        SourceOfUEActivityBehaviourInformation,
        _SpecialSubframe_Info_specialSubframePatterns,
        _SpecialSubframe_Info_cyclicPrefixDL,
        _SpecialSubframe_Info_cyclicPrefixUL,
        ____SpecialSubframe_Info_iE_Extensions__item__id_tab,
        ___SpecialSubframe_Info_iE_Extensions__item__id,
        ___SpecialSubframe_Info_iE_Extensions__item__criticality,
        ___SpecialSubframe_Info_iE_Extensions__item__extensionValue,
        __SpecialSubframe_Info_iE_Extensions__item_,
        _SpecialSubframe_Info_iE_Extensions,
        SpecialSubframe_Info,
        SpecialSubframe_Info_ExtIEs,
        SpecialSubframePatterns,
        _SubbandCQI_subbandCQICodeword0,
        _SubbandCQI_subbandCQICodeword1,
        ____SubbandCQI_iE_Extensions__item__id_tab,
        ___SubbandCQI_iE_Extensions__item__id,
        ___SubbandCQI_iE_Extensions__item__criticality,
        ___SubbandCQI_iE_Extensions__item__extensionValue,
        __SubbandCQI_iE_Extensions__item_,
        _SubbandCQI_iE_Extensions,
        SubbandCQI,
        SRVCCOperationPossible,
        SubbandCQI_ExtIEs,
        _SubbandCQICodeword0_four_bitCQI,
        _SubbandCQICodeword0_two_bitSubbandDifferentialCQI,
        _SubbandCQICodeword0_two_bitDifferentialCQI,
        SubbandCQICodeword0,
        _SubbandCQICodeword1_four_bitCQI,
        _SubbandCQICodeword1_three_bitSpatialDifferentialCQI,
        _SubbandCQICodeword1_two_bitSubbandDifferentialCQI,
        _SubbandCQICodeword1_two_bitDifferentialCQI,
        SubbandCQICodeword1,
        _SubbandCQIList__item_,
        SubbandCQIList,
        _SubbandCQIItem_subbandCQI,
        _SubbandCQIItem_subbandIndex,
        ____SubbandCQIItem_iE_Extensions__item__id_tab,
        ___SubbandCQIItem_iE_Extensions__item__id,
        ___SubbandCQIItem_iE_Extensions__item__criticality,
        ___SubbandCQIItem_iE_Extensions__item__extensionValue,
        __SubbandCQIItem_iE_Extensions__item_,
        _SubbandCQIItem_iE_Extensions,
        SubbandCQIItem,
        SubbandCQIItem_ExtIEs,
        SubbandSize,
        SubscriberProfileIDforRFP,
        _SubframeAllocation_oneframe,
        _SubframeAllocation_fourframes,
        SubframeAllocation,
        SubframeAssignment,
        _TABasedMDT_tAListforMDT,
        ____TABasedMDT_iE_Extensions__item__id_tab,
        ___TABasedMDT_iE_Extensions__item__id,
        ___TABasedMDT_iE_Extensions__item__criticality,
        ___TABasedMDT_iE_Extensions__item__extensionValue,
        __TABasedMDT_iE_Extensions__item_,
        _TABasedMDT_iE_Extensions,
        TABasedMDT,
        TABasedMDT_ExtIEs,
        TAC,
        _TAIBasedMDT_tAIListforMDT,
        ____TAIBasedMDT_iE_Extensions__item__id_tab,
        ___TAIBasedMDT_iE_Extensions__item__id,
        ___TAIBasedMDT_iE_Extensions__item__criticality,
        ___TAIBasedMDT_iE_Extensions__item__extensionValue,
        __TAIBasedMDT_iE_Extensions__item_,
        _TAIBasedMDT_iE_Extensions,
        TAIBasedMDT,
        TAIBasedMDT_ExtIEs,
        _TAIListforMDT__item_,
        TAIListforMDT,
        _TAI_Item_tAC,
        _TAI_Item_pLMN_Identity,
        ____TAI_Item_iE_Extensions__item__id_tab,
        ___TAI_Item_iE_Extensions__item__id,
        ___TAI_Item_iE_Extensions__item__criticality,
        ___TAI_Item_iE_Extensions__item__extensionValue,
        __TAI_Item_iE_Extensions__item_,
        _TAI_Item_iE_Extensions,
        TAI_Item,
        TAI_Item_ExtIEs,
        _TAListforMDT__item_,
        TAListforMDT,
        TargetCellInUTRAN,
        TargeteNBtoSource_eNBTransparentContainer,
        _TDD_Info_eARFCN,
        _TDD_Info_transmission_Bandwidth,
        _TDD_Info_subframeAssignment,
        _TDD_Info_specialSubframe_Info,
        ____TDD_Info_iE_Extensions__item__id_tab,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___TDD_Info_iE_Extensions__item__id,
        ___TDD_Info_iE_Extensions__item__criticality,
        ___TDD_Info_iE_Extensions__item__extensionValue,
        __TDD_Info_iE_Extensions__item_,
        _TDD_Info_iE_Extensions,
        TDD_Info,
        TDD_Info_ExtIEs,
        _TDD_Info_ExtIEs_val_Extension_0,
        _TDD_Info_ExtIEs_val_Extension_1,
        Threshold_RSRP,
        Threshold_RSRQ,
        TimeToWait,
        Time_UE_StayedInCell,
        Time_UE_StayedInCell_EnhancedGranularity,
        _TraceActivation_eUTRANTraceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        TraceCollectionEntityIPAddress,
        TraceDepth,
        Transmission_Bandwidth,
        TransportLayerAddress,
        _TunnelInformation_transportLayerAddress,
        _TunnelInformation_uDP_Port_Number,
        ____TunnelInformation_iE_Extensions__item__id_tab,
        ___TunnelInformation_iE_Extensions__item__id,
        ___TunnelInformation_iE_Extensions__item__criticality,
        ___TunnelInformation_iE_Extensions__item__extensionValue,
        __TunnelInformation_iE_Extensions__item_,
        _TunnelInformation_iE_Extensions,
        TunnelInformation,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateDownlink,
        _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateUplink,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__id,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __UEAggregateMaximumBitRate_iE_Extensions__item_,
        _UEAggregateMaximumBitRate_iE_Extensions,
        UEAggregateMaximumBitRate,
        UEAggregate_MaximumBitrate_ExtIEs,
        UE_ContextKeptIndicator,
        UEID,
        _UE_HistoryInformation__item_,
        UE_HistoryInformation,
        UE_HistoryInformationFromTheUE,
        UE_S1AP_ID,
        UE_X2AP_ID,
        UE_X2AP_ID_Extension,
        UE_RLF_Report_Container,
        UE_RLF_Report_Container_for_extended_bands,
        _UESecurityCapabilities_encryptionAlgorithms,
        _UESecurityCapabilities_integrityProtectionAlgorithms,
        ____UESecurityCapabilities_iE_Extensions__item__id_tab,
        ___UESecurityCapabilities_iE_Extensions__item__id,
        ___UESecurityCapabilities_iE_Extensions__item__criticality,
        ___UESecurityCapabilities_iE_Extensions__item__extensionValue,
        __UESecurityCapabilities_iE_Extensions__item_,
        _UESecurityCapabilities_iE_Extensions,
        UESecurityCapabilities,
        UESecurityCapabilities_ExtIEs,
        UL_GBR_PRB_usage,
        _UL_HighInterferenceIndicationInfo__item_,
        UL_HighInterferenceIndicationInfo,
        _UL_HighInterferenceIndicationInfo_Item_target_Cell_ID,
        _UL_HighInterferenceIndicationInfo_Item_ul_interferenceindication,
        ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab,
        ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id,
        ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality,
        ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue,
        __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_,
        _UL_HighInterferenceIndicationInfo_Item_iE_Extensions,
        UL_HighInterferenceIndicationInfo_Item,
        UL_HighInterferenceIndicationInfo_Item_ExtIEs,
        UL_HighInterferenceIndication,
        _UL_InterferenceOverloadIndication__item_,
        UL_InterferenceOverloadIndication,
        UL_InterferenceOverloadIndication_Item,
        UL_non_GBR_PRB_usage,
        UL_Total_PRB_usage,
        _UsableABSInformation_fdd,
        _UsableABSInformation_tdd,
        UsableABSInformation,
        _UsableABSInformationFDD_usable_abs_pattern_info,
        ____UsableABSInformationFDD_iE_Extensions__item__id_tab,
        ___UsableABSInformationFDD_iE_Extensions__item__id,
        ___UsableABSInformationFDD_iE_Extensions__item__criticality,
        ___UsableABSInformationFDD_iE_Extensions__item__extensionValue,
        __UsableABSInformationFDD_iE_Extensions__item_,
        _UsableABSInformationFDD_iE_Extensions,
        UsableABSInformationFDD,
        UsableABSInformationFDD_ExtIEs,
        _UsableABSInformationTDD_usaable_abs_pattern_info,
        ____UsableABSInformationTDD_iE_Extensions__item__id_tab,
        ___UsableABSInformationTDD_iE_Extensions__item__id,
        ___UsableABSInformationTDD_iE_Extensions__item__criticality,
        ___UsableABSInformationTDD_iE_Extensions__item__extensionValue,
        __UsableABSInformationTDD_iE_Extensions__item_,
        _UsableABSInformationTDD_iE_Extensions,
        UsableABSInformationTDD,
        UsableABSInformationTDD_ExtIEs,
        _WidebandCQI_widebandCQICodeword0,
        _WidebandCQI_widebandCQICodeword1,
        ____WidebandCQI_iE_Extensions__item__id_tab,
        ___WidebandCQI_iE_Extensions__item__id,
        ___WidebandCQI_iE_Extensions__item__criticality,
        ___WidebandCQI_iE_Extensions__item__extensionValue,
        __WidebandCQI_iE_Extensions__item_,
        _WidebandCQI_iE_Extensions,
        WidebandCQI,
        WidebandCQI_ExtIEs,
        _WidebandCQICodeword1_four_bitCQI,
        _WidebandCQICodeword1_three_bitSpatialDifferentialCQI,
        WidebandCQICodeword1,
        X2BenefitValue,
    ]

class X2AP_PDU_Contents:

    _name_  = u'X2AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 1]
    
    _obj_ = [
        u'HandoverRequest',
        u'HandoverRequest-IEs',
        u'UE-ContextInformation',
        u'UE-ContextInformation-ExtIEs',
        u'E-RABs-ToBeSetup-List',
        u'E-RABs-ToBeSetup-ItemIEs',
        u'E-RABs-ToBeSetup-Item',
        u'E-RABs-ToBeSetup-ItemExtIEs',
        u'MobilityInformation',
        u'UE-ContextReferenceAtSeNB',
        u'UE-ContextReferenceAtSeNB-ItemExtIEs',
        u'HandoverRequestAcknowledge',
        u'HandoverRequestAcknowledge-IEs',
        u'E-RABs-Admitted-List',
        u'E-RABs-Admitted-ItemIEs',
        u'E-RABs-Admitted-Item',
        u'E-RABs-Admitted-Item-ExtIEs',
        u'HandoverPreparationFailure',
        u'HandoverPreparationFailure-IEs',
        u'HandoverReport',
        u'HandoverReport-IEs',
        u'SNStatusTransfer',
        u'SNStatusTransfer-IEs',
        u'E-RABs-SubjectToStatusTransfer-List',
        u'E-RABs-SubjectToStatusTransfer-ItemIEs',
        u'E-RABs-SubjectToStatusTransfer-Item',
        u'E-RABs-SubjectToStatusTransfer-ItemExtIEs',
        u'UEContextRelease',
        u'UEContextRelease-IEs',
        u'HandoverCancel',
        u'HandoverCancel-IEs',
        u'ErrorIndication',
        u'ErrorIndication-IEs',
        u'ResetRequest',
        u'ResetRequest-IEs',
        u'ResetResponse',
        u'ResetResponse-IEs',
        u'X2SetupRequest',
        u'X2SetupRequest-IEs',
        u'X2SetupResponse',
        u'X2SetupResponse-IEs',
        u'X2SetupFailure',
        u'X2SetupFailure-IEs',
        u'LoadInformation',
        u'LoadInformation-IEs',
        u'CellInformation-List',
        u'CellInformation-ItemIEs',
        u'CellInformation-Item',
        u'CellInformation-Item-ExtIEs',
        u'ENBConfigurationUpdate',
        u'ENBConfigurationUpdate-IEs',
        u'ServedCellsToModify',
        u'ServedCellsToModify-Item',
        u'ServedCellsToModify-Item-ExtIEs',
        u'Old-ECGIs',
        u'ENBConfigurationUpdateAcknowledge',
        u'ENBConfigurationUpdateAcknowledge-IEs',
        u'ENBConfigurationUpdateFailure',
        u'ENBConfigurationUpdateFailure-IEs',
        u'ResourceStatusRequest',
        u'ResourceStatusRequest-IEs',
        u'CellToReport-List',
        u'CellToReport-ItemIEs',
        u'CellToReport-Item',
        u'CellToReport-Item-ExtIEs',
        u'ReportingPeriodicity',
        u'PartialSuccessIndicator',
        u'ResourceStatusResponse',
        u'ResourceStatusResponse-IEs',
        u'MeasurementInitiationResult-List',
        u'MeasurementInitiationResult-ItemIEs',
        u'MeasurementInitiationResult-Item',
        u'MeasurementInitiationResult-Item-ExtIEs',
        u'MeasurementFailureCause-List',
        u'MeasurementFailureCause-ItemIEs',
        u'MeasurementFailureCause-Item',
        u'MeasurementFailureCause-Item-ExtIEs',
        u'ResourceStatusFailure',
        u'ResourceStatusFailure-IEs',
        u'CompleteFailureCauseInformation-List',
        u'CompleteFailureCauseInformation-ItemIEs',
        u'CompleteFailureCauseInformation-Item',
        u'CompleteFailureCauseInformation-Item-ExtIEs',
        u'ResourceStatusUpdate',
        u'ResourceStatusUpdate-IEs',
        u'CellMeasurementResult-List',
        u'CellMeasurementResult-ItemIEs',
        u'CellMeasurementResult-Item',
        u'CellMeasurementResult-Item-ExtIEs',
        u'PrivateMessage',
        u'PrivateMessage-IEs',
        u'MobilityChangeRequest',
        u'MobilityChangeRequest-IEs',
        u'MobilityChangeAcknowledge',
        u'MobilityChangeAcknowledge-IEs',
        u'MobilityChangeFailure',
        u'MobilityChangeFailure-IEs',
        u'RLFIndication',
        u'RLFIndication-IEs',
        u'CellActivationRequest',
        u'CellActivationRequest-IEs',
        u'ServedCellsToActivate',
        u'ServedCellsToActivate-Item',
        u'ServedCellsToActivate-Item-ExtIEs',
        u'CellActivationResponse',
        u'CellActivationResponse-IEs',
        u'ActivatedCellList',
        u'ActivatedCellList-Item',
        u'ActivatedCellList-Item-ExtIEs',
        u'CellActivationFailure',
        u'CellActivationFailure-IEs',
        u'X2Release',
        u'X2Release-IEs',
        u'X2APMessageTransfer',
        u'X2APMessageTransfer-IEs',
        u'RNL-Header',
        u'RNL-Header-Item-ExtIEs',
        u'X2AP-Message',
        u'SeNBAdditionRequest',
        u'SeNBAdditionRequest-IEs',
        u'E-RABs-ToBeAdded-List',
        u'E-RABs-ToBeAdded-ItemIEs',
        u'E-RABs-ToBeAdded-Item',
        u'E-RABs-ToBeAdded-Item-SCG-Bearer',
        u'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs',
        u'E-RABs-ToBeAdded-Item-Split-Bearer',
        u'E-RABs-ToBeAdded-Item-Split-BearerExtIEs',
        u'SeNBAdditionRequestAcknowledge',
        u'SeNBAdditionRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ToBeAdded-List',
        u'E-RABs-Admitted-ToBeAdded-ItemIEs',
        u'E-RABs-Admitted-ToBeAdded-Item',
        u'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer',
        u'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer',
        u'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs',
        u'SeNBAdditionRequestReject',
        u'SeNBAdditionRequestReject-IEs',
        u'SeNBReconfigurationComplete',
        u'SeNBReconfigurationComplete-IEs',
        u'ResponseInformationSeNBReconfComp',
        u'ResponseInformationSeNBReconfComp-SuccessItem',
        u'ResponseInformationSeNBReconfComp-SuccessItemExtIEs',
        u'ResponseInformationSeNBReconfComp-RejectByMeNBItem',
        u'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs',
        u'SeNBModificationRequest',
        u'SeNBModificationRequest-IEs',
        u'UE-ContextInformationSeNBModReq',
        u'UE-ContextInformationSeNBModReqExtIEs',
        u'E-RABs-ToBeAdded-List-ModReq',
        u'E-RABs-ToBeAdded-ModReqItemIEs',
        u'E-RABs-ToBeAdded-ModReqItem',
        u'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer',
        u'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeAdded-ModReqItem-Split-Bearer',
        u'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs',
        u'E-RABs-ToBeModified-List-ModReq',
        u'E-RABs-ToBeModified-ModReqItemIEs',
        u'E-RABs-ToBeModified-ModReqItem',
        u'E-RABs-ToBeModified-ModReqItem-SCG-Bearer',
        u'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeModified-ModReqItem-Split-Bearer',
        u'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs',
        u'E-RABs-ToBeReleased-List-ModReq',
        u'E-RABs-ToBeReleased-ModReqItemIEs',
        u'E-RABs-ToBeReleased-ModReqItem',
        u'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer',
        u'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-ModReqItem-Split-Bearer',
        u'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs',
        u'SeNBModificationRequestAcknowledge',
        u'SeNBModificationRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckList',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckList',
        u'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckList',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        u'E-RABs-Admitted-ToReleased-ModAckItem',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs',
        u'SeNBModificationRequestReject',
        u'SeNBModificationRequestReject-IEs',
        u'SeNBModificationRequired',
        u'SeNBModificationRequired-IEs',
        u'E-RABs-ToBeReleased-ModReqd',
        u'E-RABs-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-ToBeReleased-ModReqdItem',
        u'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        u'SeNBModificationConfirm',
        u'SeNBModificationConfirm-IEs',
        u'SeNBModificationRefuse',
        u'SeNBModificationRefuse-IEs',
        u'SeNBReleaseRequest',
        u'SeNBReleaseRequest-IEs',
        u'E-RABs-ToBeReleased-List-RelReq',
        u'E-RABs-ToBeReleased-RelReqItemIEs',
        u'E-RABs-ToBeReleased-RelReqItem',
        u'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer',
        u'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-RelReqItem-Split-Bearer',
        u'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs',
        u'SeNBReleaseRequired',
        u'SeNBReleaseRequired-IEs',
        u'SeNBReleaseConfirm',
        u'SeNBReleaseConfirm-IEs',
        u'E-RABs-ToBeReleased-List-RelConf',
        u'E-RABs-ToBeReleased-RelConfItemIEs',
        u'E-RABs-ToBeReleased-RelConfItem',
        u'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer',
        u'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-RelConfItem-Split-Bearer',
        u'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs',
        u'SeNBCounterCheckRequest',
        u'SeNBCounterCheckRequest-IEs',
        u'E-RABs-SubjectToCounterCheck-List',
        u'E-RABs-SubjectToCounterCheckItemIEs',
        u'E-RABs-SubjectToCounterCheckItem',
        u'E-RABs-SubjectToCounterCheckItemExtIEs',
        u'X2RemovalRequest',
        u'X2RemovalRequest-IEs',
        u'X2RemovalResponse',
        u'X2RemovalResponse-IEs',
        u'X2RemovalFailure',
        u'X2RemovalFailure-IEs',
        u'RetrieveUEContextRequest',
        u'RetrieveUEContextRequest-IEs',
        u'RetrieveUEContextResponse',
        u'RetrieveUEContextResponse-IEs',
        u'UE-ContextInformationRetrieve',
        u'UE-ContextInformationRetrieve-ExtIEs',
        u'E-RABs-ToBeSetup-ListRetrieve',
        u'E-RABs-ToBeSetupRetrieve-ItemIEs',
        u'E-RABs-ToBeSetupRetrieve-Item',
        u'E-RABs-ToBeSetupRetrieve-ItemExtIEs',
        u'RetrieveUEContextFailure',
        u'RetrieveUEContextFailure-IEs',
        ]
    _type_ = [
        u'HandoverRequest',
        u'UE-ContextInformation',
        u'E-RABs-ToBeSetup-List',
        u'E-RABs-ToBeSetup-Item',
        u'MobilityInformation',
        u'UE-ContextReferenceAtSeNB',
        u'HandoverRequestAcknowledge',
        u'E-RABs-Admitted-List',
        u'E-RABs-Admitted-Item',
        u'HandoverPreparationFailure',
        u'HandoverReport',
        u'SNStatusTransfer',
        u'E-RABs-SubjectToStatusTransfer-List',
        u'E-RABs-SubjectToStatusTransfer-Item',
        u'UEContextRelease',
        u'HandoverCancel',
        u'ErrorIndication',
        u'ResetRequest',
        u'ResetResponse',
        u'X2SetupRequest',
        u'X2SetupResponse',
        u'X2SetupFailure',
        u'LoadInformation',
        u'CellInformation-List',
        u'CellInformation-Item',
        u'ENBConfigurationUpdate',
        u'ServedCellsToModify',
        u'ServedCellsToModify-Item',
        u'Old-ECGIs',
        u'ENBConfigurationUpdateAcknowledge',
        u'ENBConfigurationUpdateFailure',
        u'ResourceStatusRequest',
        u'CellToReport-List',
        u'CellToReport-Item',
        u'ReportingPeriodicity',
        u'PartialSuccessIndicator',
        u'ResourceStatusResponse',
        u'MeasurementInitiationResult-List',
        u'MeasurementInitiationResult-Item',
        u'MeasurementFailureCause-List',
        u'MeasurementFailureCause-Item',
        u'ResourceStatusFailure',
        u'CompleteFailureCauseInformation-List',
        u'CompleteFailureCauseInformation-Item',
        u'ResourceStatusUpdate',
        u'CellMeasurementResult-List',
        u'CellMeasurementResult-Item',
        u'PrivateMessage',
        u'MobilityChangeRequest',
        u'MobilityChangeAcknowledge',
        u'MobilityChangeFailure',
        u'RLFIndication',
        u'CellActivationRequest',
        u'ServedCellsToActivate',
        u'ServedCellsToActivate-Item',
        u'CellActivationResponse',
        u'ActivatedCellList',
        u'ActivatedCellList-Item',
        u'CellActivationFailure',
        u'X2Release',
        u'X2APMessageTransfer',
        u'RNL-Header',
        u'X2AP-Message',
        u'SeNBAdditionRequest',
        u'E-RABs-ToBeAdded-List',
        u'E-RABs-ToBeAdded-Item',
        u'E-RABs-ToBeAdded-Item-SCG-Bearer',
        u'E-RABs-ToBeAdded-Item-Split-Bearer',
        u'SeNBAdditionRequestAcknowledge',
        u'E-RABs-Admitted-ToBeAdded-List',
        u'E-RABs-Admitted-ToBeAdded-Item',
        u'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer',
        u'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer',
        u'SeNBAdditionRequestReject',
        u'SeNBReconfigurationComplete',
        u'ResponseInformationSeNBReconfComp',
        u'ResponseInformationSeNBReconfComp-SuccessItem',
        u'ResponseInformationSeNBReconfComp-RejectByMeNBItem',
        u'SeNBModificationRequest',
        u'UE-ContextInformationSeNBModReq',
        u'E-RABs-ToBeAdded-List-ModReq',
        u'E-RABs-ToBeAdded-ModReqItem',
        u'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer',
        u'E-RABs-ToBeAdded-ModReqItem-Split-Bearer',
        u'E-RABs-ToBeModified-List-ModReq',
        u'E-RABs-ToBeModified-ModReqItem',
        u'E-RABs-ToBeModified-ModReqItem-SCG-Bearer',
        u'E-RABs-ToBeModified-ModReqItem-Split-Bearer',
        u'E-RABs-ToBeReleased-List-ModReq',
        u'E-RABs-ToBeReleased-ModReqItem',
        u'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer',
        u'E-RABs-ToBeReleased-ModReqItem-Split-Bearer',
        u'SeNBModificationRequestAcknowledge',
        u'E-RABs-Admitted-ToBeAdded-ModAckList',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer',
        u'E-RABs-Admitted-ToBeModified-ModAckList',
        u'E-RABs-Admitted-ToBeModified-ModAckItem',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer',
        u'E-RABs-Admitted-ToBeReleased-ModAckList',
        u'E-RABs-Admitted-ToReleased-ModAckItem',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer',
        u'SeNBModificationRequestReject',
        u'SeNBModificationRequired',
        u'E-RABs-ToBeReleased-ModReqd',
        u'E-RABs-ToBeReleased-ModReqdItem',
        u'SeNBModificationConfirm',
        u'SeNBModificationRefuse',
        u'SeNBReleaseRequest',
        u'E-RABs-ToBeReleased-List-RelReq',
        u'E-RABs-ToBeReleased-RelReqItem',
        u'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer',
        u'E-RABs-ToBeReleased-RelReqItem-Split-Bearer',
        u'SeNBReleaseRequired',
        u'SeNBReleaseConfirm',
        u'E-RABs-ToBeReleased-List-RelConf',
        u'E-RABs-ToBeReleased-RelConfItem',
        u'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer',
        u'E-RABs-ToBeReleased-RelConfItem-Split-Bearer',
        u'SeNBCounterCheckRequest',
        u'E-RABs-SubjectToCounterCheck-List',
        u'E-RABs-SubjectToCounterCheckItem',
        u'X2RemovalRequest',
        u'X2RemovalResponse',
        u'X2RemovalFailure',
        u'RetrieveUEContextRequest',
        u'RetrieveUEContextResponse',
        u'UE-ContextInformationRetrieve',
        u'E-RABs-ToBeSetup-ListRetrieve',
        u'E-RABs-ToBeSetupRetrieve-Item',
        u'RetrieveUEContextFailure',
        ]
    _set_ = [
        u'HandoverRequest-IEs',
        u'UE-ContextInformation-ExtIEs',
        u'E-RABs-ToBeSetup-ItemIEs',
        u'E-RABs-ToBeSetup-ItemExtIEs',
        u'UE-ContextReferenceAtSeNB-ItemExtIEs',
        u'HandoverRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ItemIEs',
        u'E-RABs-Admitted-Item-ExtIEs',
        u'HandoverPreparationFailure-IEs',
        u'HandoverReport-IEs',
        u'SNStatusTransfer-IEs',
        u'E-RABs-SubjectToStatusTransfer-ItemIEs',
        u'E-RABs-SubjectToStatusTransfer-ItemExtIEs',
        u'UEContextRelease-IEs',
        u'HandoverCancel-IEs',
        u'ErrorIndication-IEs',
        u'ResetRequest-IEs',
        u'ResetResponse-IEs',
        u'X2SetupRequest-IEs',
        u'X2SetupResponse-IEs',
        u'X2SetupFailure-IEs',
        u'LoadInformation-IEs',
        u'CellInformation-ItemIEs',
        u'CellInformation-Item-ExtIEs',
        u'ENBConfigurationUpdate-IEs',
        u'ServedCellsToModify-Item-ExtIEs',
        u'ENBConfigurationUpdateAcknowledge-IEs',
        u'ENBConfigurationUpdateFailure-IEs',
        u'ResourceStatusRequest-IEs',
        u'CellToReport-ItemIEs',
        u'CellToReport-Item-ExtIEs',
        u'ResourceStatusResponse-IEs',
        u'MeasurementInitiationResult-ItemIEs',
        u'MeasurementInitiationResult-Item-ExtIEs',
        u'MeasurementFailureCause-ItemIEs',
        u'MeasurementFailureCause-Item-ExtIEs',
        u'ResourceStatusFailure-IEs',
        u'CompleteFailureCauseInformation-ItemIEs',
        u'CompleteFailureCauseInformation-Item-ExtIEs',
        u'ResourceStatusUpdate-IEs',
        u'CellMeasurementResult-ItemIEs',
        u'CellMeasurementResult-Item-ExtIEs',
        u'PrivateMessage-IEs',
        u'MobilityChangeRequest-IEs',
        u'MobilityChangeAcknowledge-IEs',
        u'MobilityChangeFailure-IEs',
        u'RLFIndication-IEs',
        u'CellActivationRequest-IEs',
        u'ServedCellsToActivate-Item-ExtIEs',
        u'CellActivationResponse-IEs',
        u'ActivatedCellList-Item-ExtIEs',
        u'CellActivationFailure-IEs',
        u'X2Release-IEs',
        u'X2APMessageTransfer-IEs',
        u'RNL-Header-Item-ExtIEs',
        u'SeNBAdditionRequest-IEs',
        u'E-RABs-ToBeAdded-ItemIEs',
        u'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs',
        u'E-RABs-ToBeAdded-Item-Split-BearerExtIEs',
        u'SeNBAdditionRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ToBeAdded-ItemIEs',
        u'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs',
        u'SeNBAdditionRequestReject-IEs',
        u'SeNBReconfigurationComplete-IEs',
        u'ResponseInformationSeNBReconfComp-SuccessItemExtIEs',
        u'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs',
        u'SeNBModificationRequest-IEs',
        u'UE-ContextInformationSeNBModReqExtIEs',
        u'E-RABs-ToBeAdded-ModReqItemIEs',
        u'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs',
        u'E-RABs-ToBeModified-ModReqItemIEs',
        u'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs',
        u'E-RABs-ToBeReleased-ModReqItemIEs',
        u'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs',
        u'SeNBModificationRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs',
        u'SeNBModificationRequestReject-IEs',
        u'SeNBModificationRequired-IEs',
        u'E-RABs-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        u'SeNBModificationConfirm-IEs',
        u'SeNBModificationRefuse-IEs',
        u'SeNBReleaseRequest-IEs',
        u'E-RABs-ToBeReleased-RelReqItemIEs',
        u'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs',
        u'SeNBReleaseRequired-IEs',
        u'SeNBReleaseConfirm-IEs',
        u'E-RABs-ToBeReleased-RelConfItemIEs',
        u'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs',
        u'SeNBCounterCheckRequest-IEs',
        u'E-RABs-SubjectToCounterCheckItemIEs',
        u'E-RABs-SubjectToCounterCheckItemExtIEs',
        u'X2RemovalRequest-IEs',
        u'X2RemovalResponse-IEs',
        u'X2RemovalFailure-IEs',
        u'RetrieveUEContextRequest-IEs',
        u'RetrieveUEContextResponse-IEs',
        u'UE-ContextInformationRetrieve-ExtIEs',
        u'E-RABs-ToBeSetupRetrieve-ItemIEs',
        u'E-RABs-ToBeSetupRetrieve-ItemExtIEs',
        u'RetrieveUEContextFailure-IEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'HandoverRequest-IEs',
        u'UE-ContextInformation-ExtIEs',
        u'E-RABs-ToBeSetup-ItemIEs',
        u'E-RABs-ToBeSetup-ItemExtIEs',
        u'UE-ContextReferenceAtSeNB-ItemExtIEs',
        u'HandoverRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ItemIEs',
        u'E-RABs-Admitted-Item-ExtIEs',
        u'HandoverPreparationFailure-IEs',
        u'HandoverReport-IEs',
        u'SNStatusTransfer-IEs',
        u'E-RABs-SubjectToStatusTransfer-ItemIEs',
        u'E-RABs-SubjectToStatusTransfer-ItemExtIEs',
        u'UEContextRelease-IEs',
        u'HandoverCancel-IEs',
        u'ErrorIndication-IEs',
        u'ResetRequest-IEs',
        u'ResetResponse-IEs',
        u'X2SetupRequest-IEs',
        u'X2SetupResponse-IEs',
        u'X2SetupFailure-IEs',
        u'LoadInformation-IEs',
        u'CellInformation-ItemIEs',
        u'CellInformation-Item-ExtIEs',
        u'ENBConfigurationUpdate-IEs',
        u'ServedCellsToModify-Item-ExtIEs',
        u'ENBConfigurationUpdateAcknowledge-IEs',
        u'ENBConfigurationUpdateFailure-IEs',
        u'ResourceStatusRequest-IEs',
        u'CellToReport-ItemIEs',
        u'CellToReport-Item-ExtIEs',
        u'ResourceStatusResponse-IEs',
        u'MeasurementInitiationResult-ItemIEs',
        u'MeasurementInitiationResult-Item-ExtIEs',
        u'MeasurementFailureCause-ItemIEs',
        u'MeasurementFailureCause-Item-ExtIEs',
        u'ResourceStatusFailure-IEs',
        u'CompleteFailureCauseInformation-ItemIEs',
        u'CompleteFailureCauseInformation-Item-ExtIEs',
        u'ResourceStatusUpdate-IEs',
        u'CellMeasurementResult-ItemIEs',
        u'CellMeasurementResult-Item-ExtIEs',
        u'PrivateMessage-IEs',
        u'MobilityChangeRequest-IEs',
        u'MobilityChangeAcknowledge-IEs',
        u'MobilityChangeFailure-IEs',
        u'RLFIndication-IEs',
        u'CellActivationRequest-IEs',
        u'ServedCellsToActivate-Item-ExtIEs',
        u'CellActivationResponse-IEs',
        u'ActivatedCellList-Item-ExtIEs',
        u'CellActivationFailure-IEs',
        u'X2Release-IEs',
        u'X2APMessageTransfer-IEs',
        u'RNL-Header-Item-ExtIEs',
        u'SeNBAdditionRequest-IEs',
        u'E-RABs-ToBeAdded-ItemIEs',
        u'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs',
        u'E-RABs-ToBeAdded-Item-Split-BearerExtIEs',
        u'SeNBAdditionRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ToBeAdded-ItemIEs',
        u'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs',
        u'SeNBAdditionRequestReject-IEs',
        u'SeNBReconfigurationComplete-IEs',
        u'ResponseInformationSeNBReconfComp-SuccessItemExtIEs',
        u'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs',
        u'SeNBModificationRequest-IEs',
        u'UE-ContextInformationSeNBModReqExtIEs',
        u'E-RABs-ToBeAdded-ModReqItemIEs',
        u'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs',
        u'E-RABs-ToBeModified-ModReqItemIEs',
        u'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs',
        u'E-RABs-ToBeReleased-ModReqItemIEs',
        u'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs',
        u'SeNBModificationRequestAcknowledge-IEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs',
        u'SeNBModificationRequestReject-IEs',
        u'SeNBModificationRequired-IEs',
        u'E-RABs-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        u'SeNBModificationConfirm-IEs',
        u'SeNBModificationRefuse-IEs',
        u'SeNBReleaseRequest-IEs',
        u'E-RABs-ToBeReleased-RelReqItemIEs',
        u'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs',
        u'SeNBReleaseRequired-IEs',
        u'SeNBReleaseConfirm-IEs',
        u'E-RABs-ToBeReleased-RelConfItemIEs',
        u'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs',
        u'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs',
        u'SeNBCounterCheckRequest-IEs',
        u'E-RABs-SubjectToCounterCheckItemIEs',
        u'E-RABs-SubjectToCounterCheckItemExtIEs',
        u'X2RemovalRequest-IEs',
        u'X2RemovalResponse-IEs',
        u'X2RemovalFailure-IEs',
        u'RetrieveUEContextRequest-IEs',
        u'RetrieveUEContextResponse-IEs',
        u'UE-ContextInformationRetrieve-ExtIEs',
        u'E-RABs-ToBeSetupRetrieve-ItemIEs',
        u'E-RABs-ToBeSetupRetrieve-ItemExtIEs',
        u'RetrieveUEContextFailure-IEs',
        ]
    _param_ = [
        ]
    
    #-----< HandoverRequest >-----#
    HandoverRequest = SEQ(name=u'HandoverRequest', mode=MODE_TYPE)
    _HandoverRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtSeNB')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____HandoverRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequest_protocolIEs__item__id._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequest_protocolIEs__item__criticality._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequest_protocolIEs__item__value._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequest_protocolIEs__item__id),
        (u'criticality', ___HandoverRequest_protocolIEs__item__criticality),
        (u'value', ___HandoverRequest_protocolIEs__item__value),
        ])
    __HandoverRequest_protocolIEs__item_._ext = None
    _HandoverRequest_protocolIEs._cont = __HandoverRequest_protocolIEs__item_
    _HandoverRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequest._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequest_protocolIEs),
        ])
    HandoverRequest._ext = []
    
    #-----< HandoverRequest-IEs >-----#
    HandoverRequest_IEs = CLASS(name=u'HandoverRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverRequest_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverRequest_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverRequest_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _HandoverRequest_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformation')))
    _HandoverRequest_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformation')))
    _HandoverRequest_IEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _HandoverRequest_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _HandoverRequest_IEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _HandoverRequest_IEs_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _HandoverRequest_IEs_val_Value_10 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _HandoverRequest_IEs_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _HandoverRequest_IEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _HandoverRequest_IEs_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _HandoverRequest_IEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtSeNB')))
    _HandoverRequest_IEs_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    HandoverRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'reject'), (u'Value', _HandoverRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _HandoverRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _HandoverRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _HandoverRequest_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _HandoverRequest_IEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _HandoverRequest_IEs_val_Value_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformation >-----#
    UE_ContextInformation = SEQ(name=u'UE-ContextInformation', mode=MODE_TYPE)
    _UE_ContextInformation_mME_UE_S1AP_ID = INT(name=u'mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-S1AP-ID')))
    _UE_ContextInformation_uESecurityCapabilities = SEQ(name=u'uESecurityCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _UE_ContextInformation_aS_SecurityInformation = SEQ(name=u'aS-SecurityInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AS-SecurityInformation')))
    _UE_ContextInformation_uEaggregateMaximumBitRate = SEQ(name=u'uEaggregateMaximumBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _UE_ContextInformation_subscriberProfileIDforRFP = INT(name=u'subscriberProfileIDforRFP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')), opt=True)
    _UE_ContextInformation_e_RABs_ToBeSetup_List = SEQ_OF(name=u'e-RABs-ToBeSetup-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-List')))
    _UE_ContextInformation_rRC_Context = OCT_STR(name=u'rRC-Context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRC-Context')))
    _UE_ContextInformation_handoverRestrictionList = SEQ(name=u'handoverRestrictionList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')), opt=True)
    _UE_ContextInformation_locationReportingInformation = SEQ(name=u'locationReportingInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LocationReportingInformation')), opt=True)
    _UE_ContextInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_ContextInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    ____UE_ContextInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 74), (u'criticality', u'ignore'), (u'Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 89), (u'criticality', u'ignore'), (u'Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UE_ContextInformation_iE_Extensions__item__id._const_tab = ____UE_ContextInformation_iE_Extensions__item__id_tab
    ___UE_ContextInformation_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_ContextInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_ContextInformation_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformation_iE_Extensions__item__id_tab
    ___UE_ContextInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_ContextInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_ContextInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_ContextInformation_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformation_iE_Extensions__item__id_tab
    ___UE_ContextInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_ContextInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_ContextInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_ContextInformation_iE_Extensions__item__id),
        (u'criticality', ___UE_ContextInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_ContextInformation_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformation_iE_Extensions__item_._ext = None
    _UE_ContextInformation_iE_Extensions._cont = __UE_ContextInformation_iE_Extensions__item_
    _UE_ContextInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformation._cont = ASN1Dict([
        (u'mME-UE-S1AP-ID', _UE_ContextInformation_mME_UE_S1AP_ID),
        (u'uESecurityCapabilities', _UE_ContextInformation_uESecurityCapabilities),
        (u'aS-SecurityInformation', _UE_ContextInformation_aS_SecurityInformation),
        (u'uEaggregateMaximumBitRate', _UE_ContextInformation_uEaggregateMaximumBitRate),
        (u'subscriberProfileIDforRFP', _UE_ContextInformation_subscriberProfileIDforRFP),
        (u'e-RABs-ToBeSetup-List', _UE_ContextInformation_e_RABs_ToBeSetup_List),
        (u'rRC-Context', _UE_ContextInformation_rRC_Context),
        (u'handoverRestrictionList', _UE_ContextInformation_handoverRestrictionList),
        (u'locationReportingInformation', _UE_ContextInformation_locationReportingInformation),
        (u'iE-Extensions', _UE_ContextInformation_iE_Extensions),
        ])
    UE_ContextInformation._ext = []
    
    #-----< UE-ContextInformation-ExtIEs >-----#
    UE_ContextInformation_ExtIEs = CLASS(name=u'UE-ContextInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _UE_ContextInformation_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')))
    _UE_ContextInformation_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    UE_ContextInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 74), (u'criticality', u'ignore'), (u'Extension', _UE_ContextInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 89), (u'criticality', u'ignore'), (u'Extension', _UE_ContextInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetup-List >-----#
    E_RABs_ToBeSetup_List = SEQ_OF(name=u'E-RABs-ToBeSetup-List', mode=MODE_TYPE)
    _E_RABs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeSetup_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-Item')))
    ___E_RABs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeSetup_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeSetup_List__item__id._const_tab = ___E_RABs_ToBeSetup_List__item__id_tab
    __E_RABs_ToBeSetup_List__item__id._const_tab_at = None
    __E_RABs_ToBeSetup_List__item__id._const_tab_id = u'id'
    __E_RABs_ToBeSetup_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeSetup_List__item__criticality._const_tab = ___E_RABs_ToBeSetup_List__item__id_tab
    __E_RABs_ToBeSetup_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeSetup_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeSetup_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeSetup_List__item__value._const_tab = ___E_RABs_ToBeSetup_List__item__id_tab
    __E_RABs_ToBeSetup_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeSetup_List__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeSetup_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeSetup_List__item__id),
        (u'criticality', __E_RABs_ToBeSetup_List__item__criticality),
        (u'value', __E_RABs_ToBeSetup_List__item__value),
        ])
    _E_RABs_ToBeSetup_List__item_._ext = None
    E_RABs_ToBeSetup_List._cont = _E_RABs_ToBeSetup_List__item_
    E_RABs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeSetup-ItemIEs >-----#
    E_RABs_ToBeSetup_ItemIEs = CLASS(name=u'E-RABs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-Item')))
    E_RABs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeSetup_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetup-Item >-----#
    E_RABs_ToBeSetup_Item = SEQ(name=u'E-RABs-ToBeSetup-Item', mode=MODE_TYPE)
    _E_RABs_ToBeSetup_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeSetup_Item_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeSetup_Item_dL_Forwarding = ENUM(name=u'dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeSetup_Item_uL_GTPtunnelEndpoint = SEQ(name=u'uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeSetup_Item_iE_Extensions._cont = __E_RABs_ToBeSetup_Item_iE_Extensions__item_
    _E_RABs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeSetup_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeSetup_Item_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeSetup_Item_e_RAB_Level_QoS_Parameters),
        (u'dL-Forwarding', _E_RABs_ToBeSetup_Item_dL_Forwarding),
        (u'uL-GTPtunnelEndpoint', _E_RABs_ToBeSetup_Item_uL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeSetup_Item_iE_Extensions),
        ])
    E_RABs_ToBeSetup_Item._ext = []
    
    #-----< E-RABs-ToBeSetup-ItemExtIEs >-----#
    E_RABs_ToBeSetup_ItemExtIEs = CLASS(name=u'E-RABs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    E_RABs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name=u'MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< UE-ContextReferenceAtSeNB >-----#
    UE_ContextReferenceAtSeNB = SEQ(name=u'UE-ContextReferenceAtSeNB', mode=MODE_TYPE)
    _UE_ContextReferenceAtSeNB_source_GlobalSeNB_ID = SEQ(name=u'source-GlobalSeNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID = INT(name=u'seNB-UE-X2AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID_Extension = INT(name=u'seNB-UE-X2AP-ID-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _UE_ContextReferenceAtSeNB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextReferenceAtSeNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id._const_tab = ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality._const_tab = ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_ContextReferenceAtSeNB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id),
        (u'criticality', ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextReferenceAtSeNB_iE_Extensions__item_._ext = None
    _UE_ContextReferenceAtSeNB_iE_Extensions._cont = __UE_ContextReferenceAtSeNB_iE_Extensions__item_
    _UE_ContextReferenceAtSeNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextReferenceAtSeNB._cont = ASN1Dict([
        (u'source-GlobalSeNB-ID', _UE_ContextReferenceAtSeNB_source_GlobalSeNB_ID),
        (u'seNB-UE-X2AP-ID', _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID),
        (u'seNB-UE-X2AP-ID-Extension', _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID_Extension),
        (u'iE-Extensions', _UE_ContextReferenceAtSeNB_iE_Extensions),
        ])
    UE_ContextReferenceAtSeNB._ext = []
    
    #-----< UE-ContextReferenceAtSeNB-ItemExtIEs >-----#
    UE_ContextReferenceAtSeNB_ItemExtIEs = CLASS(name=u'UE-ContextReferenceAtSeNB-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextReferenceAtSeNB_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledge >-----#
    HandoverRequestAcknowledge = SEQ(name=u'HandoverRequestAcknowledge', mode=MODE_TYPE)
    _HandoverRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-List')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargeteNBtoSource-eNBTransparentContainer')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___HandoverRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___HandoverRequestAcknowledge_protocolIEs__item__value),
        ])
    __HandoverRequestAcknowledge_protocolIEs__item_._ext = None
    _HandoverRequestAcknowledge_protocolIEs._cont = __HandoverRequestAcknowledge_protocolIEs__item_
    _HandoverRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequestAcknowledge_protocolIEs),
        ])
    HandoverRequestAcknowledge._ext = []
    
    #-----< HandoverRequestAcknowledge-IEs >-----#
    HandoverRequestAcknowledge_IEs = CLASS(name=u'HandoverRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverRequestAcknowledge_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverRequestAcknowledge_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-List')))
    _HandoverRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _HandoverRequestAcknowledge_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargeteNBtoSource-eNBTransparentContainer')))
    _HandoverRequestAcknowledge_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _HandoverRequestAcknowledge_IEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _HandoverRequestAcknowledge_IEs_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverRequestAcknowledge_IEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverRequestAcknowledge_IEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    HandoverRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _HandoverRequestAcknowledge_IEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-List >-----#
    E_RABs_Admitted_List = SEQ_OF(name=u'E-RABs-Admitted-List', mode=MODE_TYPE)
    _E_RABs_Admitted_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-Item')))
    ___E_RABs_Admitted_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_List__item__id._const_tab = ___E_RABs_Admitted_List__item__id_tab
    __E_RABs_Admitted_List__item__id._const_tab_at = None
    __E_RABs_Admitted_List__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_List__item__criticality._const_tab = ___E_RABs_Admitted_List__item__id_tab
    __E_RABs_Admitted_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_List__item__value._const_tab = ___E_RABs_Admitted_List__item__id_tab
    __E_RABs_Admitted_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_List__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_List__item__id),
        (u'criticality', __E_RABs_Admitted_List__item__criticality),
        (u'value', __E_RABs_Admitted_List__item__value),
        ])
    _E_RABs_Admitted_List__item_._ext = None
    E_RABs_Admitted_List._cont = _E_RABs_Admitted_List__item_
    E_RABs_Admitted_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ItemIEs >-----#
    E_RABs_Admitted_ItemIEs = CLASS(name=u'E-RABs-Admitted-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-Item')))
    E_RABs_Admitted_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-Item >-----#
    E_RABs_Admitted_Item = SEQ(name=u'E-RABs-Admitted-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_Item_uL_GTP_TunnelEndpoint = SEQ(name=u'uL-GTP-TunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_Item_dL_GTP_TunnelEndpoint = SEQ(name=u'dL-GTP-TunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_Item_iE_Extensions._cont = __E_RABs_Admitted_Item_iE_Extensions__item_
    _E_RABs_Admitted_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_Item_e_RAB_ID),
        (u'uL-GTP-TunnelEndpoint', _E_RABs_Admitted_Item_uL_GTP_TunnelEndpoint),
        (u'dL-GTP-TunnelEndpoint', _E_RABs_Admitted_Item_dL_GTP_TunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_Item_iE_Extensions),
        ])
    E_RABs_Admitted_Item._ext = []
    
    #-----< E-RABs-Admitted-Item-ExtIEs >-----#
    E_RABs_Admitted_Item_ExtIEs = CLASS(name=u'E-RABs-Admitted-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationFailure >-----#
    HandoverPreparationFailure = SEQ(name=u'HandoverPreparationFailure', mode=MODE_TYPE)
    _HandoverPreparationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverPreparationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverPreparationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverPreparationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverPreparationFailure_protocolIEs__item__id),
        (u'criticality', ___HandoverPreparationFailure_protocolIEs__item__criticality),
        (u'value', ___HandoverPreparationFailure_protocolIEs__item__value),
        ])
    __HandoverPreparationFailure_protocolIEs__item_._ext = None
    _HandoverPreparationFailure_protocolIEs._cont = __HandoverPreparationFailure_protocolIEs__item_
    _HandoverPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverPreparationFailure._cont = ASN1Dict([
        (u'protocolIEs', _HandoverPreparationFailure_protocolIEs),
        ])
    HandoverPreparationFailure._ext = []
    
    #-----< HandoverPreparationFailure-IEs >-----#
    HandoverPreparationFailure_IEs = CLASS(name=u'HandoverPreparationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverPreparationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverPreparationFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverPreparationFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _HandoverPreparationFailure_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    HandoverPreparationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailure_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailure_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverReport >-----#
    HandoverReport = SEQ(name=u'HandoverReport', mode=MODE_TYPE)
    _HandoverReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____HandoverReport_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverReportType')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargetCellInUTRAN')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    ____HandoverReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 81), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverReport_protocolIEs__item__id._const_tab = ____HandoverReport_protocolIEs__item__id_tab
    ___HandoverReport_protocolIEs__item__id._const_tab_at = None
    ___HandoverReport_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverReport_protocolIEs__item__criticality._const_tab = ____HandoverReport_protocolIEs__item__id_tab
    ___HandoverReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverReport_protocolIEs__item__value._const_tab = ____HandoverReport_protocolIEs__item__id_tab
    ___HandoverReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverReport_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverReport_protocolIEs__item__id),
        (u'criticality', ___HandoverReport_protocolIEs__item__criticality),
        (u'value', ___HandoverReport_protocolIEs__item__value),
        ])
    __HandoverReport_protocolIEs__item_._ext = None
    _HandoverReport_protocolIEs._cont = __HandoverReport_protocolIEs__item_
    _HandoverReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverReport._cont = ASN1Dict([
        (u'protocolIEs', _HandoverReport_protocolIEs),
        ])
    HandoverReport._ext = []
    
    #-----< HandoverReport-IEs >-----#
    HandoverReport_IEs = CLASS(name=u'HandoverReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverReport_IEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverReportType')))
    _HandoverReport_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverReport_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverReport_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverReport_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverReport_IEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargetCellInUTRAN')))
    _HandoverReport_IEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _HandoverReport_IEs_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _HandoverReport_IEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _HandoverReport_IEs_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    HandoverReport_IEs._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 81), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _HandoverReport_IEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SNStatusTransfer >-----#
    SNStatusTransfer = SEQ(name=u'SNStatusTransfer', mode=MODE_TYPE)
    _SNStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SNStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SNStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SNStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-List')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SNStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SNStatusTransfer_protocolIEs__item__id._const_tab = ____SNStatusTransfer_protocolIEs__item__id_tab
    ___SNStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___SNStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___SNStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SNStatusTransfer_protocolIEs__item__criticality._const_tab = ____SNStatusTransfer_protocolIEs__item__id_tab
    ___SNStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SNStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SNStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SNStatusTransfer_protocolIEs__item__value._const_tab = ____SNStatusTransfer_protocolIEs__item__id_tab
    ___SNStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SNStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __SNStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SNStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___SNStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___SNStatusTransfer_protocolIEs__item__value),
        ])
    __SNStatusTransfer_protocolIEs__item_._ext = None
    _SNStatusTransfer_protocolIEs._cont = __SNStatusTransfer_protocolIEs__item_
    _SNStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SNStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _SNStatusTransfer_protocolIEs),
        ])
    SNStatusTransfer._ext = []
    
    #-----< SNStatusTransfer-IEs >-----#
    SNStatusTransfer_IEs = CLASS(name=u'SNStatusTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SNStatusTransfer_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SNStatusTransfer_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SNStatusTransfer_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-List')))
    _SNStatusTransfer_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SNStatusTransfer_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SNStatusTransfer_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _SNStatusTransfer_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _SNStatusTransfer_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _SNStatusTransfer_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _SNStatusTransfer_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _SNStatusTransfer_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToStatusTransfer-List >-----#
    E_RABs_SubjectToStatusTransfer_List = SEQ_OF(name=u'E-RABs-SubjectToStatusTransfer-List', mode=MODE_TYPE)
    _E_RABs_SubjectToStatusTransfer_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_SubjectToStatusTransfer_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_SubjectToStatusTransfer_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_SubjectToStatusTransfer_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-Item')))
    ___E_RABs_SubjectToStatusTransfer_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', ____E_RABs_SubjectToStatusTransfer_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_SubjectToStatusTransfer_List__item__id._const_tab = ___E_RABs_SubjectToStatusTransfer_List__item__id_tab
    __E_RABs_SubjectToStatusTransfer_List__item__id._const_tab_at = None
    __E_RABs_SubjectToStatusTransfer_List__item__id._const_tab_id = u'id'
    __E_RABs_SubjectToStatusTransfer_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_SubjectToStatusTransfer_List__item__criticality._const_tab = ___E_RABs_SubjectToStatusTransfer_List__item__id_tab
    __E_RABs_SubjectToStatusTransfer_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_SubjectToStatusTransfer_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_SubjectToStatusTransfer_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_SubjectToStatusTransfer_List__item__value._const_tab = ___E_RABs_SubjectToStatusTransfer_List__item__id_tab
    __E_RABs_SubjectToStatusTransfer_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_SubjectToStatusTransfer_List__item__value._const_tab_id = u'Value'
    _E_RABs_SubjectToStatusTransfer_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_SubjectToStatusTransfer_List__item__id),
        (u'criticality', __E_RABs_SubjectToStatusTransfer_List__item__criticality),
        (u'value', __E_RABs_SubjectToStatusTransfer_List__item__value),
        ])
    _E_RABs_SubjectToStatusTransfer_List__item_._ext = None
    E_RABs_SubjectToStatusTransfer_List._cont = _E_RABs_SubjectToStatusTransfer_List__item_
    E_RABs_SubjectToStatusTransfer_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-SubjectToStatusTransfer-ItemIEs >-----#
    E_RABs_SubjectToStatusTransfer_ItemIEs = CLASS(name=u'E-RABs-SubjectToStatusTransfer-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_SubjectToStatusTransfer_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-Item')))
    E_RABs_SubjectToStatusTransfer_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _E_RABs_SubjectToStatusTransfer_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-SubjectToStatusTransfer-Item >-----#
    E_RABs_SubjectToStatusTransfer_Item = SEQ(name=u'E-RABs-SubjectToStatusTransfer-Item', mode=MODE_TYPE)
    _E_RABs_SubjectToStatusTransfer_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs = BIT_STR(name=u'receiveStatusofULPDCPSDUs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusofULPDCPSDUs')), opt=True)
    _E_RABs_SubjectToStatusTransfer_Item_uL_COUNTvalue = SEQ(name=u'uL-COUNTvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvalue')))
    _E_RABs_SubjectToStatusTransfer_Item_dL_COUNTvalue = SEQ(name=u'dL-COUNTvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvalue')))
    _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 150), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 151), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 152), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab = ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_._ext = None
    _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions._cont = __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_
    _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_SubjectToStatusTransfer_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_SubjectToStatusTransfer_Item_e_RAB_ID),
        (u'receiveStatusofULPDCPSDUs', _E_RABs_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs),
        (u'uL-COUNTvalue', _E_RABs_SubjectToStatusTransfer_Item_uL_COUNTvalue),
        (u'dL-COUNTvalue', _E_RABs_SubjectToStatusTransfer_Item_dL_COUNTvalue),
        (u'iE-Extensions', _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions),
        ])
    E_RABs_SubjectToStatusTransfer_Item._ext = []
    
    #-----< E-RABs-SubjectToStatusTransfer-ItemExtIEs >-----#
    E_RABs_SubjectToStatusTransfer_ItemExtIEs = CLASS(name=u'E-RABs-SubjectToStatusTransfer-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    E_RABs_SubjectToStatusTransfer_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 92), (u'criticality', u'ignore'), (u'Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'ignore'), (u'Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 150), (u'criticality', u'ignore'), (u'Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 151), (u'criticality', u'ignore'), (u'Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 152), (u'criticality', u'ignore'), (u'Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextRelease >-----#
    UEContextRelease = SEQ(name=u'UEContextRelease', mode=MODE_TYPE)
    _UEContextRelease_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __UEContextRelease_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___UEContextRelease_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____UEContextRelease_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SIPTOBearerDeactivationIndication')))
    ____UEContextRelease_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'ignore'), (u'Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextRelease_protocolIEs__item__id._const_tab = ____UEContextRelease_protocolIEs__item__id_tab
    ___UEContextRelease_protocolIEs__item__id._const_tab_at = None
    ___UEContextRelease_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextRelease_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextRelease_protocolIEs__item__criticality._const_tab = ____UEContextRelease_protocolIEs__item__id_tab
    ___UEContextRelease_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextRelease_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextRelease_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextRelease_protocolIEs__item__value._const_tab = ____UEContextRelease_protocolIEs__item__id_tab
    ___UEContextRelease_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextRelease_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextRelease_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextRelease_protocolIEs__item__id),
        (u'criticality', ___UEContextRelease_protocolIEs__item__criticality),
        (u'value', ___UEContextRelease_protocolIEs__item__value),
        ])
    __UEContextRelease_protocolIEs__item_._ext = None
    _UEContextRelease_protocolIEs._cont = __UEContextRelease_protocolIEs__item_
    _UEContextRelease_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextRelease._cont = ASN1Dict([
        (u'protocolIEs', _UEContextRelease_protocolIEs),
        ])
    UEContextRelease._ext = []
    
    #-----< UEContextRelease-IEs >-----#
    UEContextRelease_IEs = CLASS(name=u'UEContextRelease-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _UEContextRelease_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UEContextRelease_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UEContextRelease_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _UEContextRelease_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _UEContextRelease_IEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SIPTOBearerDeactivationIndication')))
    UEContextRelease_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _UEContextRelease_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _UEContextRelease_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _UEContextRelease_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _UEContextRelease_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'ignore'), (u'Value', _UEContextRelease_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancel >-----#
    HandoverCancel = SEQ(name=u'HandoverCancel', mode=MODE_TYPE)
    _HandoverCancel_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancel_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____HandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____HandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverCancel_protocolIEs__item__id._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancel_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCancel_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCancel_protocolIEs__item__criticality._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCancel_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCancel_protocolIEs__item__value._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCancel_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCancel_protocolIEs__item__id),
        (u'criticality', ___HandoverCancel_protocolIEs__item__criticality),
        (u'value', ___HandoverCancel_protocolIEs__item__value),
        ])
    __HandoverCancel_protocolIEs__item_._ext = None
    _HandoverCancel_protocolIEs._cont = __HandoverCancel_protocolIEs__item_
    _HandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancel._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCancel_protocolIEs),
        ])
    HandoverCancel._ext = []
    
    #-----< HandoverCancel-IEs >-----#
    HandoverCancel_IEs = CLASS(name=u'HandoverCancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverCancel_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverCancel_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverCancel_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverCancel_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverCancel_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    HandoverCancel_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'reject'), (u'Value', _HandoverCancel_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _HandoverCancel_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _HandoverCancel_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'reject'), (u'Value', _HandoverCancel_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _HandoverCancel_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name=u'ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _ErrorIndication_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _ErrorIndication_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndication_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _ErrorIndication_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetRequest >-----#
    ResetRequest = SEQ(name=u'ResetRequest', mode=MODE_TYPE)
    _ResetRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResetRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResetRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ResetRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    ____ResetRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ResetRequest_protocolIEs__item__id._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__id._const_tab_at = None
    ___ResetRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ResetRequest_protocolIEs__item__criticality._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ResetRequest_protocolIEs__item__value._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetRequest_protocolIEs__item__id),
        (u'criticality', ___ResetRequest_protocolIEs__item__criticality),
        (u'value', ___ResetRequest_protocolIEs__item__value),
        ])
    __ResetRequest_protocolIEs__item_._ext = None
    _ResetRequest_protocolIEs._cont = __ResetRequest_protocolIEs__item_
    _ResetRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetRequest._cont = ASN1Dict([
        (u'protocolIEs', _ResetRequest_protocolIEs),
        ])
    ResetRequest._ext = []
    
    #-----< ResetRequest-IEs >-----#
    ResetRequest_IEs = CLASS(name=u'ResetRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResetRequest_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    ResetRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _ResetRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse >-----#
    ResetResponse = SEQ(name=u'ResetResponse', mode=MODE_TYPE)
    _ResetResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResetResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResetResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ResetResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____ResetResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolIEs__item__id._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__id._const_tab_at = None
    ___ResetResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResponse_protocolIEs__item__criticality._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ResetResponse_protocolIEs__item__value._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetResponse_protocolIEs__item__id),
        (u'criticality', ___ResetResponse_protocolIEs__item__criticality),
        (u'value', ___ResetResponse_protocolIEs__item__value),
        ])
    __ResetResponse_protocolIEs__item_._ext = None
    _ResetResponse_protocolIEs._cont = __ResetResponse_protocolIEs__item_
    _ResetResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResponse._cont = ASN1Dict([
        (u'protocolIEs', _ResetResponse_protocolIEs),
        ])
    ResetResponse._ext = []
    
    #-----< ResetResponse-IEs >-----#
    ResetResponse_IEs = CLASS(name=u'ResetResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResetResponse_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ResetResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _ResetResponse_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2SetupRequest >-----#
    X2SetupRequest = SEQ(name=u'X2SetupRequest', mode=MODE_TYPE)
    _X2SetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2SetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    ____X2SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'reject'), (u'Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2SetupRequest_protocolIEs__item__id._const_tab = ____X2SetupRequest_protocolIEs__item__id_tab
    ___X2SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___X2SetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___X2SetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2SetupRequest_protocolIEs__item__criticality._const_tab = ____X2SetupRequest_protocolIEs__item__id_tab
    ___X2SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2SetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2SetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2SetupRequest_protocolIEs__item__value._const_tab = ____X2SetupRequest_protocolIEs__item__id_tab
    ___X2SetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2SetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __X2SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2SetupRequest_protocolIEs__item__id),
        (u'criticality', ___X2SetupRequest_protocolIEs__item__criticality),
        (u'value', ___X2SetupRequest_protocolIEs__item__value),
        ])
    __X2SetupRequest_protocolIEs__item_._ext = None
    _X2SetupRequest_protocolIEs._cont = __X2SetupRequest_protocolIEs__item_
    _X2SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2SetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _X2SetupRequest_protocolIEs),
        ])
    X2SetupRequest._ext = []
    
    #-----< X2SetupRequest-IEs >-----#
    X2SetupRequest_IEs = CLASS(name=u'X2SetupRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2SetupRequest_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2SetupRequest_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _X2SetupRequest_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _X2SetupRequest_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    X2SetupRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _X2SetupRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'reject'), (u'Value', _X2SetupRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _X2SetupRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _X2SetupRequest_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2SetupResponse >-----#
    X2SetupResponse = SEQ(name=u'X2SetupResponse', mode=MODE_TYPE)
    _X2SetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2SetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    ____X2SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'reject'), (u'Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2SetupResponse_protocolIEs__item__id._const_tab = ____X2SetupResponse_protocolIEs__item__id_tab
    ___X2SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___X2SetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___X2SetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2SetupResponse_protocolIEs__item__criticality._const_tab = ____X2SetupResponse_protocolIEs__item__id_tab
    ___X2SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2SetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2SetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2SetupResponse_protocolIEs__item__value._const_tab = ____X2SetupResponse_protocolIEs__item__id_tab
    ___X2SetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2SetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __X2SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2SetupResponse_protocolIEs__item__id),
        (u'criticality', ___X2SetupResponse_protocolIEs__item__criticality),
        (u'value', ___X2SetupResponse_protocolIEs__item__value),
        ])
    __X2SetupResponse_protocolIEs__item_._ext = None
    _X2SetupResponse_protocolIEs._cont = __X2SetupResponse_protocolIEs__item_
    _X2SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2SetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _X2SetupResponse_protocolIEs),
        ])
    X2SetupResponse._ext = []
    
    #-----< X2SetupResponse-IEs >-----#
    X2SetupResponse_IEs = CLASS(name=u'X2SetupResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2SetupResponse_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2SetupResponse_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _X2SetupResponse_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _X2SetupResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _X2SetupResponse_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    X2SetupResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _X2SetupResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'reject'), (u'Value', _X2SetupResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _X2SetupResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _X2SetupResponse_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _X2SetupResponse_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2SetupFailure >-----#
    X2SetupFailure = SEQ(name=u'X2SetupFailure', mode=MODE_TYPE)
    _X2SetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2SetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____X2SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2SetupFailure_protocolIEs__item__id._const_tab = ____X2SetupFailure_protocolIEs__item__id_tab
    ___X2SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___X2SetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___X2SetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2SetupFailure_protocolIEs__item__criticality._const_tab = ____X2SetupFailure_protocolIEs__item__id_tab
    ___X2SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2SetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2SetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2SetupFailure_protocolIEs__item__value._const_tab = ____X2SetupFailure_protocolIEs__item__id_tab
    ___X2SetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2SetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __X2SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2SetupFailure_protocolIEs__item__id),
        (u'criticality', ___X2SetupFailure_protocolIEs__item__criticality),
        (u'value', ___X2SetupFailure_protocolIEs__item__value),
        ])
    __X2SetupFailure_protocolIEs__item_._ext = None
    _X2SetupFailure_protocolIEs._cont = __X2SetupFailure_protocolIEs__item_
    _X2SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2SetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _X2SetupFailure_protocolIEs),
        ])
    X2SetupFailure._ext = []
    
    #-----< X2SetupFailure-IEs >-----#
    X2SetupFailure_IEs = CLASS(name=u'X2SetupFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2SetupFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _X2SetupFailure_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _X2SetupFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    X2SetupFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _X2SetupFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _X2SetupFailure_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _X2SetupFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoadInformation >-----#
    LoadInformation = SEQ(name=u'LoadInformation', mode=MODE_TYPE)
    _LoadInformation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __LoadInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___LoadInformation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____LoadInformation_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____LoadInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-List')))
    ____LoadInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _____LoadInformation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LoadInformation_protocolIEs__item__id._const_tab = ____LoadInformation_protocolIEs__item__id_tab
    ___LoadInformation_protocolIEs__item__id._const_tab_at = None
    ___LoadInformation_protocolIEs__item__id._const_tab_id = u'id'
    ___LoadInformation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___LoadInformation_protocolIEs__item__criticality._const_tab = ____LoadInformation_protocolIEs__item__id_tab
    ___LoadInformation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LoadInformation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LoadInformation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___LoadInformation_protocolIEs__item__value._const_tab = ____LoadInformation_protocolIEs__item__id_tab
    ___LoadInformation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LoadInformation_protocolIEs__item__value._const_tab_id = u'Value'
    __LoadInformation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LoadInformation_protocolIEs__item__id),
        (u'criticality', ___LoadInformation_protocolIEs__item__criticality),
        (u'value', ___LoadInformation_protocolIEs__item__value),
        ])
    __LoadInformation_protocolIEs__item_._ext = None
    _LoadInformation_protocolIEs._cont = __LoadInformation_protocolIEs__item_
    _LoadInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LoadInformation._cont = ASN1Dict([
        (u'protocolIEs', _LoadInformation_protocolIEs),
        ])
    LoadInformation._ext = []
    
    #-----< LoadInformation-IEs >-----#
    LoadInformation_IEs = CLASS(name=u'LoadInformation-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _LoadInformation_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-List')))
    LoadInformation_IEs._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _LoadInformation_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellInformation-List >-----#
    CellInformation_List = SEQ_OF(name=u'CellInformation-List', mode=MODE_TYPE)
    _CellInformation_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellInformation_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___CellInformation_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellInformation_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-Item')))
    ___CellInformation_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', ____CellInformation_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CellInformation_List__item__id._const_tab = ___CellInformation_List__item__id_tab
    __CellInformation_List__item__id._const_tab_at = None
    __CellInformation_List__item__id._const_tab_id = u'id'
    __CellInformation_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __CellInformation_List__item__criticality._const_tab = ___CellInformation_List__item__id_tab
    __CellInformation_List__item__criticality._const_tab_at = ('..', u'id')
    __CellInformation_List__item__criticality._const_tab_id = u'criticality'
    __CellInformation_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __CellInformation_List__item__value._const_tab = ___CellInformation_List__item__id_tab
    __CellInformation_List__item__value._const_tab_at = ('..', u'id')
    __CellInformation_List__item__value._const_tab_id = u'Value'
    _CellInformation_List__item_._cont = ASN1Dict([
        (u'id', __CellInformation_List__item__id),
        (u'criticality', __CellInformation_List__item__criticality),
        (u'value', __CellInformation_List__item__value),
        ])
    _CellInformation_List__item_._ext = None
    CellInformation_List._cont = _CellInformation_List__item_
    CellInformation_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellInformation-ItemIEs >-----#
    CellInformation_ItemIEs = CLASS(name=u'CellInformation-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellInformation_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-Item')))
    CellInformation_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _CellInformation_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellInformation-Item >-----#
    CellInformation_Item = SEQ(name=u'CellInformation-Item', mode=MODE_TYPE)
    _CellInformation_Item_cell_ID = SEQ(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellInformation_Item_ul_InterferenceOverloadIndication = SEQ_OF(name=u'ul-InterferenceOverloadIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-InterferenceOverloadIndication')), opt=True)
    _CellInformation_Item_ul_HighInterferenceIndicationInfo = SEQ_OF(name=u'ul-HighInterferenceIndicationInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-HighInterferenceIndicationInfo')), opt=True)
    _CellInformation_Item_relativeNarrowbandTxPower = SEQ(name=u'relativeNarrowbandTxPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RelativeNarrowbandTxPower')), opt=True)
    _CellInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABSInformation')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InvokeIndication')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubframeAssignment')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedULInterferenceOverloadInfo')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformation')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_5 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DynamicDLTransmissionInformation')))
    ____CellInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 62), (u'criticality', u'ignore'), (u'Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 99), (u'criticality', u'ignore'), (u'Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellInformation_Item_iE_Extensions__item__id._const_tab = ____CellInformation_Item_iE_Extensions__item__id_tab
    ___CellInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CellInformation_Item_iE_Extensions__item__criticality._const_tab = ____CellInformation_Item_iE_Extensions__item__id_tab
    ___CellInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CellInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____CellInformation_Item_iE_Extensions__item__id_tab
    ___CellInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___CellInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __CellInformation_Item_iE_Extensions__item_._ext = None
    _CellInformation_Item_iE_Extensions._cont = __CellInformation_Item_iE_Extensions__item_
    _CellInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellInformation_Item._cont = ASN1Dict([
        (u'cell-ID', _CellInformation_Item_cell_ID),
        (u'ul-InterferenceOverloadIndication', _CellInformation_Item_ul_InterferenceOverloadIndication),
        (u'ul-HighInterferenceIndicationInfo', _CellInformation_Item_ul_HighInterferenceIndicationInfo),
        (u'relativeNarrowbandTxPower', _CellInformation_Item_relativeNarrowbandTxPower),
        (u'iE-Extensions', _CellInformation_Item_iE_Extensions),
        ])
    CellInformation_Item._ext = []
    
    #-----< CellInformation-Item-ExtIEs >-----#
    CellInformation_Item_ExtIEs = CLASS(name=u'CellInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _CellInformation_Item_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABSInformation')))
    _CellInformation_Item_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InvokeIndication')))
    _CellInformation_Item_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubframeAssignment')))
    _CellInformation_Item_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedULInterferenceOverloadInfo')))
    _CellInformation_Item_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformation')))
    _CellInformation_Item_ExtIEs_val_Extension_5 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DynamicDLTransmissionInformation')))
    CellInformation_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Extension', _CellInformation_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 62), (u'criticality', u'ignore'), (u'Extension', _CellInformation_Item_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 99), (u'criticality', u'ignore'), (u'Extension', _CellInformation_Item_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _CellInformation_Item_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _CellInformation_Item_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Extension', _CellInformation_Item_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdate >-----#
    ENBConfigurationUpdate = SEQ(name=u'ENBConfigurationUpdate', mode=MODE_TYPE)
    _ENBConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToModify')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'Old-ECGIs')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoverageModificationList')))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 143), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationUpdate_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdate_protocolIEs__item_._ext = None
    _ENBConfigurationUpdate_protocolIEs._cont = __ENBConfigurationUpdate_protocolIEs__item_
    _ENBConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationUpdate_protocolIEs),
        ])
    ENBConfigurationUpdate._ext = []
    
    #-----< ENBConfigurationUpdate-IEs >-----#
    ENBConfigurationUpdate_IEs = CLASS(name=u'ENBConfigurationUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENBConfigurationUpdate_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _ENBConfigurationUpdate_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToModify')))
    _ENBConfigurationUpdate_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'Old-ECGIs')))
    _ENBConfigurationUpdate_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _ENBConfigurationUpdate_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _ENBConfigurationUpdate_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoverageModificationList')))
    ENBConfigurationUpdate_IEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdate_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdate_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdate_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdate_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdate_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 143), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdate_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedCellsToModify >-----#
    ServedCellsToModify = SEQ_OF(name=u'ServedCellsToModify', mode=MODE_TYPE)
    _ServedCellsToModify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToModify-Item')))
    ServedCellsToModify._cont = _ServedCellsToModify__item_
    ServedCellsToModify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedCellsToModify-Item >-----#
    ServedCellsToModify_Item = SEQ(name=u'ServedCellsToModify-Item', mode=MODE_TYPE)
    _ServedCellsToModify_Item_old_ecgi = SEQ(name=u'old-ecgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ServedCellsToModify_Item_servedCellInfo = SEQ(name=u'servedCellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ServedCell-Information')))
    _ServedCellsToModify_Item_neighbour_Info = SEQ_OF(name=u'neighbour-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Neighbour-Information')), opt=True)
    _ServedCellsToModify_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCellsToModify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCellsToModify_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedCellsToModify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DeactivationIndication')))
    ____ServedCellsToModify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'ignore'), (u'Extension', _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ServedCellsToModify_Item_iE_Extensions__item__id._const_tab = ____ServedCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedCellsToModify_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedCellsToModify_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality._const_tab = ____ServedCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedCellsToModify_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedCellsToModify_Item_iE_Extensions__item__id),
        (u'criticality', ___ServedCellsToModify_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedCellsToModify_Item_iE_Extensions__item_._ext = None
    _ServedCellsToModify_Item_iE_Extensions._cont = __ServedCellsToModify_Item_iE_Extensions__item_
    _ServedCellsToModify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCellsToModify_Item._cont = ASN1Dict([
        (u'old-ecgi', _ServedCellsToModify_Item_old_ecgi),
        (u'servedCellInfo', _ServedCellsToModify_Item_servedCellInfo),
        (u'neighbour-Info', _ServedCellsToModify_Item_neighbour_Info),
        (u'iE-Extensions', _ServedCellsToModify_Item_iE_Extensions),
        ])
    ServedCellsToModify_Item._ext = []
    
    #-----< ServedCellsToModify-Item-ExtIEs >-----#
    ServedCellsToModify_Item_ExtIEs = CLASS(name=u'ServedCellsToModify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ServedCellsToModify_Item_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DeactivationIndication')))
    ServedCellsToModify_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'ignore'), (u'Extension', _ServedCellsToModify_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Old-ECGIs >-----#
    Old_ECGIs = SEQ_OF(name=u'Old-ECGIs', mode=MODE_TYPE)
    _Old_ECGIs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    Old_ECGIs._cont = _Old_ECGIs__item_
    Old_ECGIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ENBConfigurationUpdateAcknowledge >-----#
    ENBConfigurationUpdateAcknowledge = SEQ(name=u'ENBConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _ENBConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateAcknowledge_protocolIEs._cont = __ENBConfigurationUpdateAcknowledge_protocolIEs__item_
    _ENBConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationUpdateAcknowledge_protocolIEs),
        ])
    ENBConfigurationUpdateAcknowledge._ext = []
    
    #-----< ENBConfigurationUpdateAcknowledge-IEs >-----#
    ENBConfigurationUpdateAcknowledge_IEs = CLASS(name=u'ENBConfigurationUpdateAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateAcknowledge_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateAcknowledge_IEs._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateAcknowledge_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdateFailure >-----#
    ENBConfigurationUpdateFailure = SEQ(name=u'ENBConfigurationUpdateFailure', mode=MODE_TYPE)
    _ENBConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateFailure_protocolIEs._cont = __ENBConfigurationUpdateFailure_protocolIEs__item_
    _ENBConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationUpdateFailure_protocolIEs),
        ])
    ENBConfigurationUpdateFailure._ext = []
    
    #-----< ENBConfigurationUpdateFailure-IEs >-----#
    ENBConfigurationUpdateFailure_IEs = CLASS(name=u'ENBConfigurationUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENBConfigurationUpdateFailure_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _ENBConfigurationUpdateFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateFailure_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusRequest >-----#
    ResourceStatusRequest = SEQ(name=u'ResourceStatusRequest', mode=MODE_TYPE)
    _ResourceStatusRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Registration-Request')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-List')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ReportingPeriodicity')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PartialSuccessIndicator')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityRSRPMR')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityCSIR')))
    ____ResourceStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusRequest_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusRequest_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusRequest_protocolIEs__item__value),
        ])
    __ResourceStatusRequest_protocolIEs__item_._ext = None
    _ResourceStatusRequest_protocolIEs._cont = __ResourceStatusRequest_protocolIEs__item_
    _ResourceStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusRequest._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusRequest_protocolIEs),
        ])
    ResourceStatusRequest._ext = []
    
    #-----< ResourceStatusRequest-IEs >-----#
    ResourceStatusRequest_IEs = CLASS(name=u'ResourceStatusRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Registration-Request')))
    _ResourceStatusRequest_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics')))
    _ResourceStatusRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-List')))
    _ResourceStatusRequest_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ReportingPeriodicity')))
    _ResourceStatusRequest_IEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PartialSuccessIndicator')))
    _ResourceStatusRequest_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityRSRPMR')))
    _ResourceStatusRequest_IEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityCSIR')))
    ResourceStatusRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _ResourceStatusRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequest_IEs_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _ResourceStatusRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 38), (u'criticality', u'reject'), (u'Value', _ResourceStatusRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequest_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequest_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequest_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _ResourceStatusRequest_IEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellToReport-List >-----#
    CellToReport_List = SEQ_OF(name=u'CellToReport-List', mode=MODE_TYPE)
    _CellToReport_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellToReport_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___CellToReport_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellToReport_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-Item')))
    ___CellToReport_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', ____CellToReport_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CellToReport_List__item__id._const_tab = ___CellToReport_List__item__id_tab
    __CellToReport_List__item__id._const_tab_at = None
    __CellToReport_List__item__id._const_tab_id = u'id'
    __CellToReport_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __CellToReport_List__item__criticality._const_tab = ___CellToReport_List__item__id_tab
    __CellToReport_List__item__criticality._const_tab_at = ('..', u'id')
    __CellToReport_List__item__criticality._const_tab_id = u'criticality'
    __CellToReport_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __CellToReport_List__item__value._const_tab = ___CellToReport_List__item__id_tab
    __CellToReport_List__item__value._const_tab_at = ('..', u'id')
    __CellToReport_List__item__value._const_tab_id = u'Value'
    _CellToReport_List__item_._cont = ASN1Dict([
        (u'id', __CellToReport_List__item__id),
        (u'criticality', __CellToReport_List__item__criticality),
        (u'value', __CellToReport_List__item__value),
        ])
    _CellToReport_List__item_._ext = None
    CellToReport_List._cont = _CellToReport_List__item_
    CellToReport_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellToReport-ItemIEs >-----#
    CellToReport_ItemIEs = CLASS(name=u'CellToReport-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellToReport_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-Item')))
    CellToReport_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _CellToReport_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellToReport-Item >-----#
    CellToReport_Item = SEQ(name=u'CellToReport-Item', mode=MODE_TYPE)
    _CellToReport_Item_cell_ID = SEQ(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellToReport_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellToReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellToReport_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellToReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_Item_iE_Extensions__item__id._const_tab = ____CellToReport_Item_iE_Extensions__item__id_tab
    ___CellToReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellToReport_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellToReport_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CellToReport_Item_iE_Extensions__item__criticality._const_tab = ____CellToReport_Item_iE_Extensions__item__id_tab
    ___CellToReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellToReport_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellToReport_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CellToReport_Item_iE_Extensions__item__extensionValue._const_tab = ____CellToReport_Item_iE_Extensions__item__id_tab
    ___CellToReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellToReport_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellToReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellToReport_Item_iE_Extensions__item__id),
        (u'criticality', ___CellToReport_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellToReport_Item_iE_Extensions__item__extensionValue),
        ])
    __CellToReport_Item_iE_Extensions__item_._ext = None
    _CellToReport_Item_iE_Extensions._cont = __CellToReport_Item_iE_Extensions__item_
    _CellToReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellToReport_Item._cont = ASN1Dict([
        (u'cell-ID', _CellToReport_Item_cell_ID),
        (u'iE-Extensions', _CellToReport_Item_iE_Extensions),
        ])
    CellToReport_Item._ext = []
    
    #-----< CellToReport-Item-ExtIEs >-----#
    CellToReport_Item_ExtIEs = CLASS(name=u'CellToReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellToReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name=u'ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([(u'one-thousand-ms', 0), (u'two-thousand-ms', 1), (u'five-thousand-ms', 2), (u'ten-thousand-ms', 3)])
    ReportingPeriodicity._ext = []
    
    #-----< PartialSuccessIndicator >-----#
    PartialSuccessIndicator = ENUM(name=u'PartialSuccessIndicator', mode=MODE_TYPE)
    PartialSuccessIndicator._cont = ASN1Dict([(u'partial-success-allowed', 0)])
    PartialSuccessIndicator._ext = []
    
    #-----< ResourceStatusResponse >-----#
    ResourceStatusResponse = SEQ(name=u'ResourceStatusResponse', mode=MODE_TYPE)
    _ResourceStatusResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-List')))
    ____ResourceStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusResponse_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusResponse_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusResponse_protocolIEs__item__value),
        ])
    __ResourceStatusResponse_protocolIEs__item_._ext = None
    _ResourceStatusResponse_protocolIEs._cont = __ResourceStatusResponse_protocolIEs__item_
    _ResourceStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusResponse._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusResponse_protocolIEs),
        ])
    ResourceStatusResponse._ext = []
    
    #-----< ResourceStatusResponse-IEs >-----#
    ResourceStatusResponse_IEs = CLASS(name=u'ResourceStatusResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusResponse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusResponse_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ResourceStatusResponse_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-List')))
    ResourceStatusResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _ResourceStatusResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _ResourceStatusResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _ResourceStatusResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _ResourceStatusResponse_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementInitiationResult-List >-----#
    MeasurementInitiationResult_List = SEQ_OF(name=u'MeasurementInitiationResult-List', mode=MODE_TYPE)
    _MeasurementInitiationResult_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __MeasurementInitiationResult_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___MeasurementInitiationResult_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____MeasurementInitiationResult_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-Item')))
    ___MeasurementInitiationResult_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', ____MeasurementInitiationResult_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementInitiationResult_List__item__id._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__id._const_tab_at = None
    __MeasurementInitiationResult_List__item__id._const_tab_id = u'id'
    __MeasurementInitiationResult_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __MeasurementInitiationResult_List__item__criticality._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__criticality._const_tab_at = ('..', u'id')
    __MeasurementInitiationResult_List__item__criticality._const_tab_id = u'criticality'
    __MeasurementInitiationResult_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __MeasurementInitiationResult_List__item__value._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__value._const_tab_at = ('..', u'id')
    __MeasurementInitiationResult_List__item__value._const_tab_id = u'Value'
    _MeasurementInitiationResult_List__item_._cont = ASN1Dict([
        (u'id', __MeasurementInitiationResult_List__item__id),
        (u'criticality', __MeasurementInitiationResult_List__item__criticality),
        (u'value', __MeasurementInitiationResult_List__item__value),
        ])
    _MeasurementInitiationResult_List__item_._ext = None
    MeasurementInitiationResult_List._cont = _MeasurementInitiationResult_List__item_
    MeasurementInitiationResult_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MeasurementInitiationResult-ItemIEs >-----#
    MeasurementInitiationResult_ItemIEs = CLASS(name=u'MeasurementInitiationResult-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MeasurementInitiationResult_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-Item')))
    MeasurementInitiationResult_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _MeasurementInitiationResult_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementInitiationResult-Item >-----#
    MeasurementInitiationResult_Item = SEQ(name=u'MeasurementInitiationResult-Item', mode=MODE_TYPE)
    _MeasurementInitiationResult_Item_cell_ID = SEQ(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MeasurementInitiationResult_Item_measurementFailureCause_List = SEQ_OF(name=u'measurementFailureCause-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-List')), opt=True)
    _MeasurementInitiationResult_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementInitiationResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementInitiationResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementInitiationResult_Item_iE_Extensions__item__id),
        (u'criticality', ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementInitiationResult_Item_iE_Extensions__item_._ext = None
    _MeasurementInitiationResult_Item_iE_Extensions._cont = __MeasurementInitiationResult_Item_iE_Extensions__item_
    _MeasurementInitiationResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementInitiationResult_Item._cont = ASN1Dict([
        (u'cell-ID', _MeasurementInitiationResult_Item_cell_ID),
        (u'measurementFailureCause-List', _MeasurementInitiationResult_Item_measurementFailureCause_List),
        (u'iE-Extensions', _MeasurementInitiationResult_Item_iE_Extensions),
        ])
    MeasurementInitiationResult_Item._ext = []
    
    #-----< MeasurementInitiationResult-Item-ExtIEs >-----#
    MeasurementInitiationResult_Item_ExtIEs = CLASS(name=u'MeasurementInitiationResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MeasurementInitiationResult_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailureCause-List >-----#
    MeasurementFailureCause_List = SEQ_OF(name=u'MeasurementFailureCause-List', mode=MODE_TYPE)
    _MeasurementFailureCause_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __MeasurementFailureCause_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___MeasurementFailureCause_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____MeasurementFailureCause_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-Item')))
    ___MeasurementFailureCause_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', ____MeasurementFailureCause_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementFailureCause_List__item__id._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__id._const_tab_at = None
    __MeasurementFailureCause_List__item__id._const_tab_id = u'id'
    __MeasurementFailureCause_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __MeasurementFailureCause_List__item__criticality._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__criticality._const_tab_at = ('..', u'id')
    __MeasurementFailureCause_List__item__criticality._const_tab_id = u'criticality'
    __MeasurementFailureCause_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __MeasurementFailureCause_List__item__value._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__value._const_tab_at = ('..', u'id')
    __MeasurementFailureCause_List__item__value._const_tab_id = u'Value'
    _MeasurementFailureCause_List__item_._cont = ASN1Dict([
        (u'id', __MeasurementFailureCause_List__item__id),
        (u'criticality', __MeasurementFailureCause_List__item__criticality),
        (u'value', __MeasurementFailureCause_List__item__value),
        ])
    _MeasurementFailureCause_List__item_._ext = None
    MeasurementFailureCause_List._cont = _MeasurementFailureCause_List__item_
    MeasurementFailureCause_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MeasurementFailureCause-ItemIEs >-----#
    MeasurementFailureCause_ItemIEs = CLASS(name=u'MeasurementFailureCause-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MeasurementFailureCause_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-Item')))
    MeasurementFailureCause_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _MeasurementFailureCause_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementFailureCause-Item >-----#
    MeasurementFailureCause_Item = SEQ(name=u'MeasurementFailureCause-Item', mode=MODE_TYPE)
    _MeasurementFailureCause_Item_measurementFailedReportCharacteristics = BIT_STR(name=u'measurementFailedReportCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics')))
    _MeasurementFailureCause_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _MeasurementFailureCause_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementFailureCause_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementFailureCause_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementFailureCause_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementFailureCause_Item_iE_Extensions__item__id),
        (u'criticality', ___MeasurementFailureCause_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementFailureCause_Item_iE_Extensions__item_._ext = None
    _MeasurementFailureCause_Item_iE_Extensions._cont = __MeasurementFailureCause_Item_iE_Extensions__item_
    _MeasurementFailureCause_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementFailureCause_Item._cont = ASN1Dict([
        (u'measurementFailedReportCharacteristics', _MeasurementFailureCause_Item_measurementFailedReportCharacteristics),
        (u'cause', _MeasurementFailureCause_Item_cause),
        (u'iE-Extensions', _MeasurementFailureCause_Item_iE_Extensions),
        ])
    MeasurementFailureCause_Item._ext = []
    
    #-----< MeasurementFailureCause-Item-ExtIEs >-----#
    MeasurementFailureCause_Item_ExtIEs = CLASS(name=u'MeasurementFailureCause-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MeasurementFailureCause_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusFailure >-----#
    ResourceStatusFailure = SEQ(name=u'ResourceStatusFailure', mode=MODE_TYPE)
    _ResourceStatusFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-List')))
    ____ResourceStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusFailure_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusFailure_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusFailure_protocolIEs__item__value),
        ])
    __ResourceStatusFailure_protocolIEs__item_._ext = None
    _ResourceStatusFailure_protocolIEs._cont = __ResourceStatusFailure_protocolIEs__item_
    _ResourceStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusFailure._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusFailure_protocolIEs),
        ])
    ResourceStatusFailure._ext = []
    
    #-----< ResourceStatusFailure-IEs >-----#
    ResourceStatusFailure_IEs = CLASS(name=u'ResourceStatusFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusFailure_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusFailure_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ResourceStatusFailure_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ResourceStatusFailure_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-List')))
    ResourceStatusFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _ResourceStatusFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _ResourceStatusFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _ResourceStatusFailure_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _ResourceStatusFailure_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _ResourceStatusFailure_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CompleteFailureCauseInformation-List >-----#
    CompleteFailureCauseInformation_List = SEQ_OF(name=u'CompleteFailureCauseInformation-List', mode=MODE_TYPE)
    _CompleteFailureCauseInformation_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CompleteFailureCauseInformation_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___CompleteFailureCauseInformation_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-Item')))
    ___CompleteFailureCauseInformation_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CompleteFailureCauseInformation_List__item__id._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__id._const_tab_at = None
    __CompleteFailureCauseInformation_List__item__id._const_tab_id = u'id'
    __CompleteFailureCauseInformation_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __CompleteFailureCauseInformation_List__item__criticality._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__criticality._const_tab_at = ('..', u'id')
    __CompleteFailureCauseInformation_List__item__criticality._const_tab_id = u'criticality'
    __CompleteFailureCauseInformation_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __CompleteFailureCauseInformation_List__item__value._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__value._const_tab_at = ('..', u'id')
    __CompleteFailureCauseInformation_List__item__value._const_tab_id = u'Value'
    _CompleteFailureCauseInformation_List__item_._cont = ASN1Dict([
        (u'id', __CompleteFailureCauseInformation_List__item__id),
        (u'criticality', __CompleteFailureCauseInformation_List__item__criticality),
        (u'value', __CompleteFailureCauseInformation_List__item__value),
        ])
    _CompleteFailureCauseInformation_List__item_._ext = None
    CompleteFailureCauseInformation_List._cont = _CompleteFailureCauseInformation_List__item_
    CompleteFailureCauseInformation_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-ItemIEs >-----#
    CompleteFailureCauseInformation_ItemIEs = CLASS(name=u'CompleteFailureCauseInformation-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CompleteFailureCauseInformation_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-Item')))
    CompleteFailureCauseInformation_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _CompleteFailureCauseInformation_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-Item >-----#
    CompleteFailureCauseInformation_Item = SEQ(name=u'CompleteFailureCauseInformation-Item', mode=MODE_TYPE)
    _CompleteFailureCauseInformation_Item_cell_ID = SEQ(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CompleteFailureCauseInformation_Item_measurementFailureCause_List = SEQ_OF(name=u'measurementFailureCause-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-List')))
    _CompleteFailureCauseInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_._ext = None
    _CompleteFailureCauseInformation_Item_iE_Extensions._cont = __CompleteFailureCauseInformation_Item_iE_Extensions__item_
    _CompleteFailureCauseInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompleteFailureCauseInformation_Item._cont = ASN1Dict([
        (u'cell-ID', _CompleteFailureCauseInformation_Item_cell_ID),
        (u'measurementFailureCause-List', _CompleteFailureCauseInformation_Item_measurementFailureCause_List),
        (u'iE-Extensions', _CompleteFailureCauseInformation_Item_iE_Extensions),
        ])
    CompleteFailureCauseInformation_Item._ext = []
    
    #-----< CompleteFailureCauseInformation-Item-ExtIEs >-----#
    CompleteFailureCauseInformation_Item_ExtIEs = CLASS(name=u'CompleteFailureCauseInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CompleteFailureCauseInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusUpdate >-----#
    ResourceStatusUpdate = SEQ(name=u'ResourceStatusUpdate', mode=MODE_TYPE)
    _ResourceStatusUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-List')))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___ResourceStatusUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResourceStatusUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __ResourceStatusUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResourceStatusUpdate_protocolIEs__item__id),
        (u'criticality', ___ResourceStatusUpdate_protocolIEs__item__criticality),
        (u'value', ___ResourceStatusUpdate_protocolIEs__item__value),
        ])
    __ResourceStatusUpdate_protocolIEs__item_._ext = None
    _ResourceStatusUpdate_protocolIEs._cont = __ResourceStatusUpdate_protocolIEs__item_
    _ResourceStatusUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusUpdate._cont = ASN1Dict([
        (u'protocolIEs', _ResourceStatusUpdate_protocolIEs),
        ])
    ResourceStatusUpdate._ext = []
    
    #-----< ResourceStatusUpdate-IEs >-----#
    ResourceStatusUpdate_IEs = CLASS(name=u'ResourceStatusUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusUpdate_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusUpdate_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusUpdate_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-List')))
    ResourceStatusUpdate_IEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _ResourceStatusUpdate_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _ResourceStatusUpdate_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _ResourceStatusUpdate_IEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellMeasurementResult-List >-----#
    CellMeasurementResult_List = SEQ_OF(name=u'CellMeasurementResult-List', mode=MODE_TYPE)
    _CellMeasurementResult_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellMeasurementResult_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___CellMeasurementResult_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellMeasurementResult_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-Item')))
    ___CellMeasurementResult_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', ____CellMeasurementResult_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CellMeasurementResult_List__item__id._const_tab = ___CellMeasurementResult_List__item__id_tab
    __CellMeasurementResult_List__item__id._const_tab_at = None
    __CellMeasurementResult_List__item__id._const_tab_id = u'id'
    __CellMeasurementResult_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __CellMeasurementResult_List__item__criticality._const_tab = ___CellMeasurementResult_List__item__id_tab
    __CellMeasurementResult_List__item__criticality._const_tab_at = ('..', u'id')
    __CellMeasurementResult_List__item__criticality._const_tab_id = u'criticality'
    __CellMeasurementResult_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __CellMeasurementResult_List__item__value._const_tab = ___CellMeasurementResult_List__item__id_tab
    __CellMeasurementResult_List__item__value._const_tab_at = ('..', u'id')
    __CellMeasurementResult_List__item__value._const_tab_id = u'Value'
    _CellMeasurementResult_List__item_._cont = ASN1Dict([
        (u'id', __CellMeasurementResult_List__item__id),
        (u'criticality', __CellMeasurementResult_List__item__criticality),
        (u'value', __CellMeasurementResult_List__item__value),
        ])
    _CellMeasurementResult_List__item_._ext = None
    CellMeasurementResult_List._cont = _CellMeasurementResult_List__item_
    CellMeasurementResult_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellMeasurementResult-ItemIEs >-----#
    CellMeasurementResult_ItemIEs = CLASS(name=u'CellMeasurementResult-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellMeasurementResult_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-Item')))
    CellMeasurementResult_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _CellMeasurementResult_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellMeasurementResult-Item >-----#
    CellMeasurementResult_Item = SEQ(name=u'CellMeasurementResult-Item', mode=MODE_TYPE)
    _CellMeasurementResult_Item_cell_ID = SEQ(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellMeasurementResult_Item_hWLoadIndicator = SEQ(name=u'hWLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HWLoadIndicator')), opt=True)
    _CellMeasurementResult_Item_s1TNLLoadIndicator = SEQ(name=u's1TNLLoadIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'S1TNLLoadIndicator')), opt=True)
    _CellMeasurementResult_Item_radioResourceStatus = SEQ(name=u'radioResourceStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioResourceStatus')), opt=True)
    _CellMeasurementResult_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellMeasurementResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellMeasurementResult_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellMeasurementResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacityGroup')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABS-Status')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RSRPMRList')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSIReportList')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CellReportingIndicator')))
    ____CellMeasurementResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 42), (u'criticality', u'ignore'), (u'Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 170), (u'criticality', u'ignore'), (u'Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellMeasurementResult_Item_iE_Extensions__item__id._const_tab = ____CellMeasurementResult_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellMeasurementResult_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality._const_tab = ____CellMeasurementResult_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab = ____CellMeasurementResult_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellMeasurementResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellMeasurementResult_Item_iE_Extensions__item__id),
        (u'criticality', ___CellMeasurementResult_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue),
        ])
    __CellMeasurementResult_Item_iE_Extensions__item_._ext = None
    _CellMeasurementResult_Item_iE_Extensions._cont = __CellMeasurementResult_Item_iE_Extensions__item_
    _CellMeasurementResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellMeasurementResult_Item._cont = ASN1Dict([
        (u'cell-ID', _CellMeasurementResult_Item_cell_ID),
        (u'hWLoadIndicator', _CellMeasurementResult_Item_hWLoadIndicator),
        (u's1TNLLoadIndicator', _CellMeasurementResult_Item_s1TNLLoadIndicator),
        (u'radioResourceStatus', _CellMeasurementResult_Item_radioResourceStatus),
        (u'iE-Extensions', _CellMeasurementResult_Item_iE_Extensions),
        ])
    CellMeasurementResult_Item._ext = []
    
    #-----< CellMeasurementResult-Item-ExtIEs >-----#
    CellMeasurementResult_Item_ExtIEs = CLASS(name=u'CellMeasurementResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacityGroup')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABS-Status')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RSRPMRList')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSIReportList')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CellReportingIndicator')))
    CellMeasurementResult_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 42), (u'criticality', u'ignore'), (u'Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 170), (u'criticality', u'ignore'), (u'Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_X2AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PRIVATE-IES'), [u'criticality']))
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PRIVATE-IES'), [u'Value']))
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name=u'PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MobilityChangeRequest >-----#
    MobilityChangeRequest = SEQ(name=u'MobilityChangeRequest', mode=MODE_TYPE)
    _MobilityChangeRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __MobilityChangeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___MobilityChangeRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____MobilityChangeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    ____MobilityChangeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 45), (u'criticality', u'reject'), (u'Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MobilityChangeRequest_protocolIEs__item__id._const_tab = ____MobilityChangeRequest_protocolIEs__item__id_tab
    ___MobilityChangeRequest_protocolIEs__item__id._const_tab_at = None
    ___MobilityChangeRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___MobilityChangeRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___MobilityChangeRequest_protocolIEs__item__criticality._const_tab = ____MobilityChangeRequest_protocolIEs__item__id_tab
    ___MobilityChangeRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MobilityChangeRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MobilityChangeRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___MobilityChangeRequest_protocolIEs__item__value._const_tab = ____MobilityChangeRequest_protocolIEs__item__id_tab
    ___MobilityChangeRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MobilityChangeRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __MobilityChangeRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MobilityChangeRequest_protocolIEs__item__id),
        (u'criticality', ___MobilityChangeRequest_protocolIEs__item__criticality),
        (u'value', ___MobilityChangeRequest_protocolIEs__item__value),
        ])
    __MobilityChangeRequest_protocolIEs__item_._ext = None
    _MobilityChangeRequest_protocolIEs._cont = __MobilityChangeRequest_protocolIEs__item_
    _MobilityChangeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MobilityChangeRequest._cont = ASN1Dict([
        (u'protocolIEs', _MobilityChangeRequest_protocolIEs),
        ])
    MobilityChangeRequest._ext = []
    
    #-----< MobilityChangeRequest-IEs >-----#
    MobilityChangeRequest_IEs = CLASS(name=u'MobilityChangeRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MobilityChangeRequest_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeRequest_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeRequest_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _MobilityChangeRequest_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _MobilityChangeRequest_IEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    MobilityChangeRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _MobilityChangeRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _MobilityChangeRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _MobilityChangeRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 45), (u'criticality', u'reject'), (u'Value', _MobilityChangeRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'reject'), (u'Value', _MobilityChangeRequest_IEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MobilityChangeAcknowledge >-----#
    MobilityChangeAcknowledge = SEQ(name=u'MobilityChangeAcknowledge', mode=MODE_TYPE)
    _MobilityChangeAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __MobilityChangeAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___MobilityChangeAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____MobilityChangeAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____MobilityChangeAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MobilityChangeAcknowledge_protocolIEs__item__id._const_tab = ____MobilityChangeAcknowledge_protocolIEs__item__id_tab
    ___MobilityChangeAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___MobilityChangeAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality._const_tab = ____MobilityChangeAcknowledge_protocolIEs__item__id_tab
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MobilityChangeAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___MobilityChangeAcknowledge_protocolIEs__item__value._const_tab = ____MobilityChangeAcknowledge_protocolIEs__item__id_tab
    ___MobilityChangeAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MobilityChangeAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __MobilityChangeAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MobilityChangeAcknowledge_protocolIEs__item__id),
        (u'criticality', ___MobilityChangeAcknowledge_protocolIEs__item__criticality),
        (u'value', ___MobilityChangeAcknowledge_protocolIEs__item__value),
        ])
    __MobilityChangeAcknowledge_protocolIEs__item_._ext = None
    _MobilityChangeAcknowledge_protocolIEs._cont = __MobilityChangeAcknowledge_protocolIEs__item_
    _MobilityChangeAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MobilityChangeAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _MobilityChangeAcknowledge_protocolIEs),
        ])
    MobilityChangeAcknowledge._ext = []
    
    #-----< MobilityChangeAcknowledge-IEs >-----#
    MobilityChangeAcknowledge_IEs = CLASS(name=u'MobilityChangeAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MobilityChangeAcknowledge_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeAcknowledge_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeAcknowledge_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    MobilityChangeAcknowledge_IEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'reject'), (u'Value', _MobilityChangeAcknowledge_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'reject'), (u'Value', _MobilityChangeAcknowledge_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _MobilityChangeAcknowledge_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MobilityChangeFailure >-----#
    MobilityChangeFailure = SEQ(name=u'MobilityChangeFailure', mode=MODE_TYPE)
    _MobilityChangeFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __MobilityChangeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___MobilityChangeFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____MobilityChangeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersModificationRange')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____MobilityChangeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MobilityChangeFailure_protocolIEs__item__id._const_tab = ____MobilityChangeFailure_protocolIEs__item__id_tab
    ___MobilityChangeFailure_protocolIEs__item__id._const_tab_at = None
    ___MobilityChangeFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MobilityChangeFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___MobilityChangeFailure_protocolIEs__item__criticality._const_tab = ____MobilityChangeFailure_protocolIEs__item__id_tab
    ___MobilityChangeFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MobilityChangeFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MobilityChangeFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___MobilityChangeFailure_protocolIEs__item__value._const_tab = ____MobilityChangeFailure_protocolIEs__item__id_tab
    ___MobilityChangeFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MobilityChangeFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MobilityChangeFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MobilityChangeFailure_protocolIEs__item__id),
        (u'criticality', ___MobilityChangeFailure_protocolIEs__item__criticality),
        (u'value', ___MobilityChangeFailure_protocolIEs__item__value),
        ])
    __MobilityChangeFailure_protocolIEs__item_._ext = None
    _MobilityChangeFailure_protocolIEs._cont = __MobilityChangeFailure_protocolIEs__item_
    _MobilityChangeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MobilityChangeFailure._cont = ASN1Dict([
        (u'protocolIEs', _MobilityChangeFailure_protocolIEs),
        ])
    MobilityChangeFailure._ext = []
    
    #-----< MobilityChangeFailure-IEs >-----#
    MobilityChangeFailure_IEs = CLASS(name=u'MobilityChangeFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MobilityChangeFailure_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeFailure_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _MobilityChangeFailure_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersModificationRange')))
    _MobilityChangeFailure_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    MobilityChangeFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _MobilityChangeFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _MobilityChangeFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _MobilityChangeFailure_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _MobilityChangeFailure_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _MobilityChangeFailure_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RLFIndication >-----#
    RLFIndication = SEQ(name=u'RLFIndication', mode=MODE_TYPE)
    _RLFIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RLFIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RLFIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____RLFIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnSetupIndicator')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnReestabIndicator')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    ____RLFIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RLFIndication_protocolIEs__item__id._const_tab = ____RLFIndication_protocolIEs__item__id_tab
    ___RLFIndication_protocolIEs__item__id._const_tab_at = None
    ___RLFIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___RLFIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___RLFIndication_protocolIEs__item__criticality._const_tab = ____RLFIndication_protocolIEs__item__id_tab
    ___RLFIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RLFIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RLFIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___RLFIndication_protocolIEs__item__value._const_tab = ____RLFIndication_protocolIEs__item__id_tab
    ___RLFIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RLFIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __RLFIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RLFIndication_protocolIEs__item__id),
        (u'criticality', ___RLFIndication_protocolIEs__item__criticality),
        (u'value', ___RLFIndication_protocolIEs__item__value),
        ])
    __RLFIndication_protocolIEs__item_._ext = None
    _RLFIndication_protocolIEs._cont = __RLFIndication_protocolIEs__item_
    _RLFIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RLFIndication._cont = ASN1Dict([
        (u'protocolIEs', _RLFIndication_protocolIEs),
        ])
    RLFIndication._ext = []
    
    #-----< RLFIndication-IEs >-----#
    RLFIndication_IEs = CLASS(name=u'RLFIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RLFIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    _RLFIndication_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _RLFIndication_IEs_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _RLFIndication_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _RLFIndication_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _RLFIndication_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnSetupIndicator')))
    _RLFIndication_IEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnReestabIndicator')))
    _RLFIndication_IEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    RLFIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _RLFIndication_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _RLFIndication_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellActivationRequest >-----#
    CellActivationRequest = SEQ(name=u'CellActivationRequest', mode=MODE_TYPE)
    _CellActivationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellActivationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____CellActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellActivationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToActivate')))
    ____CellActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'reject'), (u'Value', _____CellActivationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CellActivationRequest_protocolIEs__item__id._const_tab = ____CellActivationRequest_protocolIEs__item__id_tab
    ___CellActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___CellActivationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___CellActivationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___CellActivationRequest_protocolIEs__item__criticality._const_tab = ____CellActivationRequest_protocolIEs__item__id_tab
    ___CellActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CellActivationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CellActivationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___CellActivationRequest_protocolIEs__item__value._const_tab = ____CellActivationRequest_protocolIEs__item__id_tab
    ___CellActivationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CellActivationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __CellActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CellActivationRequest_protocolIEs__item__id),
        (u'criticality', ___CellActivationRequest_protocolIEs__item__criticality),
        (u'value', ___CellActivationRequest_protocolIEs__item__value),
        ])
    __CellActivationRequest_protocolIEs__item_._ext = None
    _CellActivationRequest_protocolIEs._cont = __CellActivationRequest_protocolIEs__item_
    _CellActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellActivationRequest._cont = ASN1Dict([
        (u'protocolIEs', _CellActivationRequest_protocolIEs),
        ])
    CellActivationRequest._ext = []
    
    #-----< CellActivationRequest-IEs >-----#
    CellActivationRequest_IEs = CLASS(name=u'CellActivationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellActivationRequest_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToActivate')))
    CellActivationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'reject'), (u'Value', _CellActivationRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ServedCellsToActivate >-----#
    ServedCellsToActivate = SEQ_OF(name=u'ServedCellsToActivate', mode=MODE_TYPE)
    _ServedCellsToActivate__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToActivate-Item')))
    ServedCellsToActivate._cont = _ServedCellsToActivate__item_
    ServedCellsToActivate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedCellsToActivate-Item >-----#
    ServedCellsToActivate_Item = SEQ(name=u'ServedCellsToActivate-Item', mode=MODE_TYPE)
    _ServedCellsToActivate_Item_ecgi = SEQ(name=u'ecgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ServedCellsToActivate_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCellsToActivate_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCellsToActivate_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellsToActivate_Item_iE_Extensions__item__id._const_tab = ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab
    ___ServedCellsToActivate_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedCellsToActivate_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality._const_tab = ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedCellsToActivate_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedCellsToActivate_Item_iE_Extensions__item__id),
        (u'criticality', ___ServedCellsToActivate_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedCellsToActivate_Item_iE_Extensions__item_._ext = None
    _ServedCellsToActivate_Item_iE_Extensions._cont = __ServedCellsToActivate_Item_iE_Extensions__item_
    _ServedCellsToActivate_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCellsToActivate_Item._cont = ASN1Dict([
        (u'ecgi', _ServedCellsToActivate_Item_ecgi),
        (u'iE-Extensions', _ServedCellsToActivate_Item_iE_Extensions),
        ])
    ServedCellsToActivate_Item._ext = []
    
    #-----< ServedCellsToActivate-Item-ExtIEs >-----#
    ServedCellsToActivate_Item_ExtIEs = CLASS(name=u'ServedCellsToActivate-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedCellsToActivate_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellActivationResponse >-----#
    CellActivationResponse = SEQ(name=u'CellActivationResponse', mode=MODE_TYPE)
    _CellActivationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellActivationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____CellActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedCellList')))
    _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____CellActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellActivationResponse_protocolIEs__item__id._const_tab = ____CellActivationResponse_protocolIEs__item__id_tab
    ___CellActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___CellActivationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___CellActivationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___CellActivationResponse_protocolIEs__item__criticality._const_tab = ____CellActivationResponse_protocolIEs__item__id_tab
    ___CellActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CellActivationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CellActivationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___CellActivationResponse_protocolIEs__item__value._const_tab = ____CellActivationResponse_protocolIEs__item__id_tab
    ___CellActivationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CellActivationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __CellActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CellActivationResponse_protocolIEs__item__id),
        (u'criticality', ___CellActivationResponse_protocolIEs__item__criticality),
        (u'value', ___CellActivationResponse_protocolIEs__item__value),
        ])
    __CellActivationResponse_protocolIEs__item_._ext = None
    _CellActivationResponse_protocolIEs._cont = __CellActivationResponse_protocolIEs__item_
    _CellActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellActivationResponse._cont = ASN1Dict([
        (u'protocolIEs', _CellActivationResponse_protocolIEs),
        ])
    CellActivationResponse._ext = []
    
    #-----< CellActivationResponse-IEs >-----#
    CellActivationResponse_IEs = CLASS(name=u'CellActivationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellActivationResponse_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedCellList')))
    _CellActivationResponse_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    CellActivationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _CellActivationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _CellActivationResponse_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ActivatedCellList >-----#
    ActivatedCellList = SEQ_OF(name=u'ActivatedCellList', mode=MODE_TYPE)
    _ActivatedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedCellList-Item')))
    ActivatedCellList._cont = _ActivatedCellList__item_
    ActivatedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ActivatedCellList-Item >-----#
    ActivatedCellList_Item = SEQ(name=u'ActivatedCellList-Item', mode=MODE_TYPE)
    _ActivatedCellList_Item_ecgi = SEQ(name=u'ecgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ActivatedCellList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActivatedCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ActivatedCellList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ActivatedCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedCellList_Item_iE_Extensions__item__id._const_tab = ____ActivatedCellList_Item_iE_Extensions__item__id_tab
    ___ActivatedCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___ActivatedCellList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ActivatedCellList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ActivatedCellList_Item_iE_Extensions__item__criticality._const_tab = ____ActivatedCellList_Item_iE_Extensions__item__id_tab
    ___ActivatedCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ActivatedCellList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____ActivatedCellList_Item_iE_Extensions__item__id_tab
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ActivatedCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ActivatedCellList_Item_iE_Extensions__item__id),
        (u'criticality', ___ActivatedCellList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ActivatedCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __ActivatedCellList_Item_iE_Extensions__item_._ext = None
    _ActivatedCellList_Item_iE_Extensions._cont = __ActivatedCellList_Item_iE_Extensions__item_
    _ActivatedCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActivatedCellList_Item._cont = ASN1Dict([
        (u'ecgi', _ActivatedCellList_Item_ecgi),
        (u'iE-Extensions', _ActivatedCellList_Item_iE_Extensions),
        ])
    ActivatedCellList_Item._ext = []
    
    #-----< ActivatedCellList-Item-ExtIEs >-----#
    ActivatedCellList_Item_ExtIEs = CLASS(name=u'ActivatedCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ActivatedCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellActivationFailure >-----#
    CellActivationFailure = SEQ(name=u'CellActivationFailure', mode=MODE_TYPE)
    _CellActivationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellActivationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____CellActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____CellActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellActivationFailure_protocolIEs__item__id._const_tab = ____CellActivationFailure_protocolIEs__item__id_tab
    ___CellActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___CellActivationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___CellActivationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___CellActivationFailure_protocolIEs__item__criticality._const_tab = ____CellActivationFailure_protocolIEs__item__id_tab
    ___CellActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CellActivationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CellActivationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___CellActivationFailure_protocolIEs__item__value._const_tab = ____CellActivationFailure_protocolIEs__item__id_tab
    ___CellActivationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CellActivationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __CellActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CellActivationFailure_protocolIEs__item__id),
        (u'criticality', ___CellActivationFailure_protocolIEs__item__criticality),
        (u'value', ___CellActivationFailure_protocolIEs__item__value),
        ])
    __CellActivationFailure_protocolIEs__item_._ext = None
    _CellActivationFailure_protocolIEs._cont = __CellActivationFailure_protocolIEs__item_
    _CellActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellActivationFailure._cont = ASN1Dict([
        (u'protocolIEs', _CellActivationFailure_protocolIEs),
        ])
    CellActivationFailure._ext = []
    
    #-----< CellActivationFailure-IEs >-----#
    CellActivationFailure_IEs = CLASS(name=u'CellActivationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellActivationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _CellActivationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    CellActivationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _CellActivationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _CellActivationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2Release >-----#
    X2Release = SEQ(name=u'X2Release', mode=MODE_TYPE)
    _X2Release_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2Release_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2Release_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2Release_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2Release_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    ____X2Release_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____X2Release_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___X2Release_protocolIEs__item__id._const_tab = ____X2Release_protocolIEs__item__id_tab
    ___X2Release_protocolIEs__item__id._const_tab_at = None
    ___X2Release_protocolIEs__item__id._const_tab_id = u'id'
    ___X2Release_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2Release_protocolIEs__item__criticality._const_tab = ____X2Release_protocolIEs__item__id_tab
    ___X2Release_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2Release_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2Release_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2Release_protocolIEs__item__value._const_tab = ____X2Release_protocolIEs__item__id_tab
    ___X2Release_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2Release_protocolIEs__item__value._const_tab_id = u'Value'
    __X2Release_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2Release_protocolIEs__item__id),
        (u'criticality', ___X2Release_protocolIEs__item__criticality),
        (u'value', ___X2Release_protocolIEs__item__value),
        ])
    __X2Release_protocolIEs__item_._ext = None
    _X2Release_protocolIEs._cont = __X2Release_protocolIEs__item_
    _X2Release_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2Release._cont = ASN1Dict([
        (u'protocolIEs', _X2Release_protocolIEs),
        ])
    X2Release._ext = []
    
    #-----< X2Release-IEs >-----#
    X2Release_IEs = CLASS(name=u'X2Release-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2Release_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    X2Release_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _X2Release_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< X2APMessageTransfer >-----#
    X2APMessageTransfer = SEQ(name=u'X2APMessageTransfer', mode=MODE_TYPE)
    _X2APMessageTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2APMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2APMessageTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2APMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RNL-Header')))
    _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2AP-Message')))
    ____X2APMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2APMessageTransfer_protocolIEs__item__id._const_tab = ____X2APMessageTransfer_protocolIEs__item__id_tab
    ___X2APMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___X2APMessageTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___X2APMessageTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2APMessageTransfer_protocolIEs__item__criticality._const_tab = ____X2APMessageTransfer_protocolIEs__item__id_tab
    ___X2APMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2APMessageTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2APMessageTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2APMessageTransfer_protocolIEs__item__value._const_tab = ____X2APMessageTransfer_protocolIEs__item__id_tab
    ___X2APMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2APMessageTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __X2APMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2APMessageTransfer_protocolIEs__item__id),
        (u'criticality', ___X2APMessageTransfer_protocolIEs__item__criticality),
        (u'value', ___X2APMessageTransfer_protocolIEs__item__value),
        ])
    __X2APMessageTransfer_protocolIEs__item_._ext = None
    _X2APMessageTransfer_protocolIEs._cont = __X2APMessageTransfer_protocolIEs__item_
    _X2APMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2APMessageTransfer._cont = ASN1Dict([
        (u'protocolIEs', _X2APMessageTransfer_protocolIEs),
        ])
    X2APMessageTransfer._ext = []
    
    #-----< X2APMessageTransfer-IEs >-----#
    X2APMessageTransfer_IEs = CLASS(name=u'X2APMessageTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2APMessageTransfer_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RNL-Header')))
    _X2APMessageTransfer_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2AP-Message')))
    X2APMessageTransfer_IEs._val = ASN1Set(rv=[dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _X2APMessageTransfer_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _X2APMessageTransfer_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RNL-Header >-----#
    RNL_Header = SEQ(name=u'RNL-Header', mode=MODE_TYPE)
    _RNL_Header_source_GlobalENB_ID = SEQ(name=u'source-GlobalENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _RNL_Header_target_GlobalENB_ID = SEQ(name=u'target-GlobalENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')), opt=True)
    _RNL_Header_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNL_Header_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RNL_Header_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RNL_Header_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RNL_Header_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNL_Header_iE_Extensions__item__id._const_tab = ____RNL_Header_iE_Extensions__item__id_tab
    ___RNL_Header_iE_Extensions__item__id._const_tab_at = None
    ___RNL_Header_iE_Extensions__item__id._const_tab_id = u'id'
    ___RNL_Header_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RNL_Header_iE_Extensions__item__criticality._const_tab = ____RNL_Header_iE_Extensions__item__id_tab
    ___RNL_Header_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RNL_Header_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RNL_Header_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RNL_Header_iE_Extensions__item__extensionValue._const_tab = ____RNL_Header_iE_Extensions__item__id_tab
    ___RNL_Header_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RNL_Header_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RNL_Header_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RNL_Header_iE_Extensions__item__id),
        (u'criticality', ___RNL_Header_iE_Extensions__item__criticality),
        (u'extensionValue', ___RNL_Header_iE_Extensions__item__extensionValue),
        ])
    __RNL_Header_iE_Extensions__item_._ext = None
    _RNL_Header_iE_Extensions._cont = __RNL_Header_iE_Extensions__item_
    _RNL_Header_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNL_Header._cont = ASN1Dict([
        (u'source-GlobalENB-ID', _RNL_Header_source_GlobalENB_ID),
        (u'target-GlobalENB-ID', _RNL_Header_target_GlobalENB_ID),
        (u'iE-Extensions', _RNL_Header_iE_Extensions),
        ])
    RNL_Header._ext = []
    
    #-----< RNL-Header-Item-ExtIEs >-----#
    RNL_Header_Item_ExtIEs = CLASS(name=u'RNL-Header-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RNL_Header_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< X2AP-Message >-----#
    X2AP_Message = OCT_STR(name=u'X2AP-Message', mode=MODE_TYPE)
    
    #-----< SeNBAdditionRequest >-----#
    SeNBAdditionRequest = SEQ(name=u'SeNBAdditionRequest', mode=MODE_TYPE)
    _SeNBAdditionRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBAdditionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBAdditionRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBAdditionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBSecurityKey')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-List')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBAdditionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 113), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 114), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 115), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBAdditionRequest_protocolIEs__item__id._const_tab = ____SeNBAdditionRequest_protocolIEs__item__id_tab
    ___SeNBAdditionRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBAdditionRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBAdditionRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBAdditionRequest_protocolIEs__item__criticality._const_tab = ____SeNBAdditionRequest_protocolIEs__item__id_tab
    ___SeNBAdditionRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBAdditionRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBAdditionRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBAdditionRequest_protocolIEs__item__value._const_tab = ____SeNBAdditionRequest_protocolIEs__item__id_tab
    ___SeNBAdditionRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBAdditionRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBAdditionRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBAdditionRequest_protocolIEs__item__id),
        (u'criticality', ___SeNBAdditionRequest_protocolIEs__item__criticality),
        (u'value', ___SeNBAdditionRequest_protocolIEs__item__value),
        ])
    __SeNBAdditionRequest_protocolIEs__item_._ext = None
    _SeNBAdditionRequest_protocolIEs._cont = __SeNBAdditionRequest_protocolIEs__item_
    _SeNBAdditionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBAdditionRequest._cont = ASN1Dict([
        (u'protocolIEs', _SeNBAdditionRequest_protocolIEs),
        ])
    SeNBAdditionRequest._ext = []
    
    #-----< SeNBAdditionRequest-IEs >-----#
    SeNBAdditionRequest_IEs = CLASS(name=u'SeNBAdditionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBAdditionRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequest_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _SeNBAdditionRequest_IEs_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBSecurityKey')))
    _SeNBAdditionRequest_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _SeNBAdditionRequest_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _SeNBAdditionRequest_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-List')))
    _SeNBAdditionRequest_IEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBAdditionRequest_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _SeNBAdditionRequest_IEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequest_IEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequest_IEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _SeNBAdditionRequest_IEs_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBAdditionRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 113), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 114), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 115), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequest_IEs_val_Value_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-List >-----#
    E_RABs_ToBeAdded_List = SEQ_OF(name=u'E-RABs-ToBeAdded-List', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeAdded_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeAdded_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item')))
    ___E_RABs_ToBeAdded_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 118), (u'criticality', u'reject'), (u'Value', ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_List__item__id._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_List__item__id._const_tab_id = u'id'
    __E_RABs_ToBeAdded_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeAdded_List__item__criticality._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeAdded_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeAdded_List__item__value._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeAdded_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeAdded_List__item__id),
        (u'criticality', __E_RABs_ToBeAdded_List__item__criticality),
        (u'value', __E_RABs_ToBeAdded_List__item__value),
        ])
    _E_RABs_ToBeAdded_List__item_._ext = None
    E_RABs_ToBeAdded_List._cont = _E_RABs_ToBeAdded_List__item_
    E_RABs_ToBeAdded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-ItemIEs >-----#
    E_RABs_ToBeAdded_ItemIEs = CLASS(name=u'E-RABs-ToBeAdded-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_ItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item')))
    E_RABs_ToBeAdded_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 118), (u'criticality', u'reject'), (u'Value', _E_RABs_ToBeAdded_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-Item >-----#
    E_RABs_ToBeAdded_Item = CHOICE(name=u'E-RABs-ToBeAdded-Item', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item-SCG-Bearer')))
    _E_RABs_ToBeAdded_Item_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item-Split-Bearer')))
    E_RABs_ToBeAdded_Item._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_ToBeAdded_Item_sCG_Bearer),
        (u'split-Bearer', _E_RABs_ToBeAdded_Item_split_Bearer),
        ])
    E_RABs_ToBeAdded_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-Item-SCG-Bearer >-----#
    E_RABs_ToBeAdded_Item_SCG_Bearer = SEQ(name=u'E-RABs-ToBeAdded-Item-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_Item_SCG_Bearer_dL_Forwarding = ENUM(name=u'dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeAdded_Item_SCG_Bearer_s1_UL_GTPtunnelEndpoint = SEQ(name=u's1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_Item_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_Level_QoS_Parameters),
        (u'dL-Forwarding', _E_RABs_ToBeAdded_Item_SCG_Bearer_dL_Forwarding),
        (u's1-UL-GTPtunnelEndpoint', _E_RABs_ToBeAdded_Item_SCG_Bearer_s1_UL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_Item_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-Item-SCG-BearerExtIEs >-----#
    E_RABs_ToBeAdded_Item_SCG_BearerExtIEs = CLASS(name=u'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    E_RABs_ToBeAdded_Item_SCG_BearerExtIEs._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-Item-Split-Bearer >-----#
    E_RABs_ToBeAdded_Item_Split_Bearer = SEQ(name=u'E-RABs-ToBeAdded-Item-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_Item_Split_Bearer_meNB_GTPtunnelEndpoint = SEQ(name=u'meNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_Item_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_Level_QoS_Parameters),
        (u'meNB-GTPtunnelEndpoint', _E_RABs_ToBeAdded_Item_Split_Bearer_meNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_Item_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-Item-Split-BearerExtIEs >-----#
    E_RABs_ToBeAdded_Item_Split_BearerExtIEs = CLASS(name=u'E-RABs-ToBeAdded-Item-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeAdded_Item_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBAdditionRequestAcknowledge >-----#
    SeNBAdditionRequestAcknowledge = SEQ(name=u'SeNBAdditionRequestAcknowledge', mode=MODE_TYPE)
    _SeNBAdditionRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBAdditionRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TunnelInformation')))
    ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 168), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 163), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab = ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab = ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBAdditionRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value),
        ])
    __SeNBAdditionRequestAcknowledge_protocolIEs__item_._ext = None
    _SeNBAdditionRequestAcknowledge_protocolIEs._cont = __SeNBAdditionRequestAcknowledge_protocolIEs__item_
    _SeNBAdditionRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBAdditionRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _SeNBAdditionRequestAcknowledge_protocolIEs),
        ])
    SeNBAdditionRequestAcknowledge._ext = []
    
    #-----< SeNBAdditionRequestAcknowledge-IEs >-----#
    SeNBAdditionRequestAcknowledge_IEs = CLASS(name=u'SeNBAdditionRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TunnelInformation')))
    SeNBAdditionRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 168), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 163), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-List >-----#
    E_RABs_Admitted_ToBeAdded_List = SEQ_OF(name=u'E-RABs-Admitted-ToBeAdded-List', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeAdded_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeAdded_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item')))
    ___E_RABs_Admitted_ToBeAdded_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeAdded_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeAdded_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeAdded_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeAdded_List__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeAdded_List__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeAdded_List__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_List__item_._ext = None
    E_RABs_Admitted_ToBeAdded_List._cont = _E_RABs_Admitted_ToBeAdded_List__item_
    E_RABs_Admitted_ToBeAdded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_ItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item')))
    E_RABs_Admitted_ToBeAdded_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 121), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-Item >-----#
    E_RABs_Admitted_ToBeAdded_Item = CHOICE(name=u'E-RABs-Admitted-ToBeAdded-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer')))
    _E_RABs_Admitted_ToBeAdded_Item_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer')))
    E_RABs_Admitted_ToBeAdded_Item._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_Admitted_ToBeAdded_Item_sCG_Bearer),
        (u'split-Bearer', _E_RABs_Admitted_ToBeAdded_Item_split_Bearer),
        ])
    E_RABs_Admitted_ToBeAdded_Item._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_s1_DL_GTPtunnelEndpoint = SEQ(name=u's1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name=u'dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name=u'uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_e_RAB_ID),
        (u's1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_s1_DL_GTPtunnelEndpoint),
        (u'dL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        (u'uL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-Split-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_Item_Split_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_seNB_GTPtunnelEndpoint = SEQ(name=u'seNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_Item_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_e_RAB_ID),
        (u'seNB-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_seNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_Item_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBAdditionRequestReject >-----#
    SeNBAdditionRequestReject = SEQ(name=u'SeNBAdditionRequestReject', mode=MODE_TYPE)
    _SeNBAdditionRequestReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBAdditionRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBAdditionRequestReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBAdditionRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBAdditionRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBAdditionRequestReject_protocolIEs__item__id._const_tab = ____SeNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SeNBAdditionRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SeNBAdditionRequestReject_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality._const_tab = ____SeNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBAdditionRequestReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBAdditionRequestReject_protocolIEs__item__value._const_tab = ____SeNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SeNBAdditionRequestReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBAdditionRequestReject_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBAdditionRequestReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBAdditionRequestReject_protocolIEs__item__id),
        (u'criticality', ___SeNBAdditionRequestReject_protocolIEs__item__criticality),
        (u'value', ___SeNBAdditionRequestReject_protocolIEs__item__value),
        ])
    __SeNBAdditionRequestReject_protocolIEs__item_._ext = None
    _SeNBAdditionRequestReject_protocolIEs._cont = __SeNBAdditionRequestReject_protocolIEs__item_
    _SeNBAdditionRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBAdditionRequestReject._cont = ASN1Dict([
        (u'protocolIEs', _SeNBAdditionRequestReject_protocolIEs),
        ])
    SeNBAdditionRequestReject._ext = []
    
    #-----< SeNBAdditionRequestReject-IEs >-----#
    SeNBAdditionRequestReject_IEs = CLASS(name=u'SeNBAdditionRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBAdditionRequestReject_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestReject_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestReject_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBAdditionRequestReject_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBAdditionRequestReject_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequestReject_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBAdditionRequestReject_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestReject_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestReject_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestReject_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBAdditionRequestReject_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestReject_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBAdditionRequestReject_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBReconfigurationComplete >-----#
    SeNBReconfigurationComplete = SEQ(name=u'SeNBReconfigurationComplete', mode=MODE_TYPE)
    _SeNBReconfigurationComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReconfigurationComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReconfigurationComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBReconfigurationComplete_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReconfigurationComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 123), (u'criticality', u'ignore'), (u'Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBReconfigurationComplete_protocolIEs__item__id._const_tab = ____SeNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SeNBReconfigurationComplete_protocolIEs__item__id._const_tab_at = None
    ___SeNBReconfigurationComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality._const_tab = ____SeNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBReconfigurationComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBReconfigurationComplete_protocolIEs__item__value._const_tab = ____SeNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SeNBReconfigurationComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBReconfigurationComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBReconfigurationComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBReconfigurationComplete_protocolIEs__item__id),
        (u'criticality', ___SeNBReconfigurationComplete_protocolIEs__item__criticality),
        (u'value', ___SeNBReconfigurationComplete_protocolIEs__item__value),
        ])
    __SeNBReconfigurationComplete_protocolIEs__item_._ext = None
    _SeNBReconfigurationComplete_protocolIEs._cont = __SeNBReconfigurationComplete_protocolIEs__item_
    _SeNBReconfigurationComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReconfigurationComplete._cont = ASN1Dict([
        (u'protocolIEs', _SeNBReconfigurationComplete_protocolIEs),
        ])
    SeNBReconfigurationComplete._ext = []
    
    #-----< SeNBReconfigurationComplete-IEs >-----#
    SeNBReconfigurationComplete_IEs = CLASS(name=u'SeNBReconfigurationComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReconfigurationComplete_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReconfigurationComplete_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReconfigurationComplete_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp')))
    _SeNBReconfigurationComplete_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReconfigurationComplete_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReconfigurationComplete_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBReconfigurationComplete_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBReconfigurationComplete_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 123), (u'criticality', u'ignore'), (u'Value', _SeNBReconfigurationComplete_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBReconfigurationComplete_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBReconfigurationComplete_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResponseInformationSeNBReconfComp >-----#
    ResponseInformationSeNBReconfComp = CHOICE(name=u'ResponseInformationSeNBReconfComp', mode=MODE_TYPE)
    _ResponseInformationSeNBReconfComp_success = SEQ(name=u'success', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp-SuccessItem')))
    _ResponseInformationSeNBReconfComp_reject_by_MeNB = SEQ(name=u'reject-by-MeNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp-RejectByMeNBItem')))
    ResponseInformationSeNBReconfComp._cont = ASN1Dict([
        (u'success', _ResponseInformationSeNBReconfComp_success),
        (u'reject-by-MeNB', _ResponseInformationSeNBReconfComp_reject_by_MeNB),
        ])
    ResponseInformationSeNBReconfComp._ext = []
    
    #-----< ResponseInformationSeNBReconfComp-SuccessItem >-----#
    ResponseInformationSeNBReconfComp_SuccessItem = SEQ(name=u'ResponseInformationSeNBReconfComp-SuccessItem', mode=MODE_TYPE)
    _ResponseInformationSeNBReconfComp_SuccessItem_meNBtoSeNBContainer = OCT_STR(name=u'meNBtoSeNBContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')), opt=True)
    _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab = ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab_at = None
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab = ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab = ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id),
        (u'criticality', ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue),
        ])
    __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_._ext = None
    _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions._cont = __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_
    _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseInformationSeNBReconfComp_SuccessItem._cont = ASN1Dict([
        (u'meNBtoSeNBContainer', _ResponseInformationSeNBReconfComp_SuccessItem_meNBtoSeNBContainer),
        (u'iE-Extensions', _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions),
        ])
    ResponseInformationSeNBReconfComp_SuccessItem._ext = []
    
    #-----< ResponseInformationSeNBReconfComp-SuccessItemExtIEs >-----#
    ResponseInformationSeNBReconfComp_SuccessItemExtIEs = CLASS(name=u'ResponseInformationSeNBReconfComp-SuccessItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ResponseInformationSeNBReconfComp_SuccessItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseInformationSeNBReconfComp-RejectByMeNBItem >-----#
    ResponseInformationSeNBReconfComp_RejectByMeNBItem = SEQ(name=u'ResponseInformationSeNBReconfComp-RejectByMeNBItem', mode=MODE_TYPE)
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_meNBtoSeNBContainer = OCT_STR(name=u'meNBtoSeNBContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')), opt=True)
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab = ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab_at = None
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab = ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab = ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id),
        (u'criticality', ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue),
        ])
    __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_._ext = None
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions._cont = __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseInformationSeNBReconfComp_RejectByMeNBItem._cont = ASN1Dict([
        (u'cause', _ResponseInformationSeNBReconfComp_RejectByMeNBItem_cause),
        (u'meNBtoSeNBContainer', _ResponseInformationSeNBReconfComp_RejectByMeNBItem_meNBtoSeNBContainer),
        (u'iE-Extensions', _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions),
        ])
    ResponseInformationSeNBReconfComp_RejectByMeNBItem._ext = []
    
    #-----< ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs >-----#
    ResponseInformationSeNBReconfComp_RejectByMeNBItemExtIEs = CLASS(name=u'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ResponseInformationSeNBReconfComp_RejectByMeNBItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequest >-----#
    SeNBModificationRequest = SEQ(name=u'SeNBModificationRequest', mode=MODE_TYPE)
    _SeNBModificationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationSeNBModReq')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequest_protocolIEs__item__id._const_tab = ____SeNBModificationRequest_protocolIEs__item__id_tab
    ___SeNBModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBModificationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBModificationRequest_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequest_protocolIEs__item__id_tab
    ___SeNBModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBModificationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBModificationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBModificationRequest_protocolIEs__item__value._const_tab = ____SeNBModificationRequest_protocolIEs__item__id_tab
    ___SeNBModificationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBModificationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBModificationRequest_protocolIEs__item__id),
        (u'criticality', ___SeNBModificationRequest_protocolIEs__item__criticality),
        (u'value', ___SeNBModificationRequest_protocolIEs__item__value),
        ])
    __SeNBModificationRequest_protocolIEs__item_._ext = None
    _SeNBModificationRequest_protocolIEs._cont = __SeNBModificationRequest_protocolIEs__item_
    _SeNBModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequest._cont = ASN1Dict([
        (u'protocolIEs', _SeNBModificationRequest_protocolIEs),
        ])
    SeNBModificationRequest._ext = []
    
    #-----< SeNBModificationRequest-IEs >-----#
    SeNBModificationRequest_IEs = CLASS(name=u'SeNBModificationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequest_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _SeNBModificationRequest_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _SeNBModificationRequest_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationSeNBModReq')))
    _SeNBModificationRequest_IEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBModificationRequest_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _SeNBModificationRequest_IEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequest_IEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequest_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequest_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequest_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequest_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequest_IEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformationSeNBModReq >-----#
    UE_ContextInformationSeNBModReq = SEQ(name=u'UE-ContextInformationSeNBModReq', mode=MODE_TYPE)
    _UE_ContextInformationSeNBModReq_uE_SecurityCapabilities = SEQ(name=u'uE-SecurityCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')), opt=True)
    _UE_ContextInformationSeNBModReq_seNB_SecurityKey = BIT_STR(name=u'seNB-SecurityKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SeNBSecurityKey')), opt=True)
    _UE_ContextInformationSeNBModReq_seNBUEAggregateMaximumBitRate = SEQ(name=u'seNBUEAggregateMaximumBitRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')), opt=True)
    _UE_ContextInformationSeNBModReq_e_RABs_ToBeAdded = SEQ_OF(name=u'e-RABs-ToBeAdded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-List-ModReq')), opt=True)
    _UE_ContextInformationSeNBModReq_e_RABs_ToBeModified = SEQ_OF(name=u'e-RABs-ToBeModified', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-List-ModReq')), opt=True)
    _UE_ContextInformationSeNBModReq_e_RABs_ToBeReleased = SEQ_OF(name=u'e-RABs-ToBeReleased', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-ModReq')), opt=True)
    _UE_ContextInformationSeNBModReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformationSeNBModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id._const_tab = ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_ContextInformationSeNBModReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id),
        (u'criticality', ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformationSeNBModReq_iE_Extensions__item_._ext = None
    _UE_ContextInformationSeNBModReq_iE_Extensions._cont = __UE_ContextInformationSeNBModReq_iE_Extensions__item_
    _UE_ContextInformationSeNBModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformationSeNBModReq._cont = ASN1Dict([
        (u'uE-SecurityCapabilities', _UE_ContextInformationSeNBModReq_uE_SecurityCapabilities),
        (u'seNB-SecurityKey', _UE_ContextInformationSeNBModReq_seNB_SecurityKey),
        (u'seNBUEAggregateMaximumBitRate', _UE_ContextInformationSeNBModReq_seNBUEAggregateMaximumBitRate),
        (u'e-RABs-ToBeAdded', _UE_ContextInformationSeNBModReq_e_RABs_ToBeAdded),
        (u'e-RABs-ToBeModified', _UE_ContextInformationSeNBModReq_e_RABs_ToBeModified),
        (u'e-RABs-ToBeReleased', _UE_ContextInformationSeNBModReq_e_RABs_ToBeReleased),
        (u'iE-Extensions', _UE_ContextInformationSeNBModReq_iE_Extensions),
        ])
    UE_ContextInformationSeNBModReq._ext = []
    
    #-----< UE-ContextInformationSeNBModReqExtIEs >-----#
    UE_ContextInformationSeNBModReqExtIEs = CLASS(name=u'UE-ContextInformationSeNBModReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextInformationSeNBModReqExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-List-ModReq >-----#
    E_RABs_ToBeAdded_List_ModReq = SEQ_OF(name=u'E-RABs-ToBeAdded-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeAdded_List_ModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeAdded_List_ModReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem')))
    ___E_RABs_ToBeAdded_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 125), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeAdded_List_ModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeAdded_List_ModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeAdded_List_ModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeAdded_List_ModReq__item__id),
        (u'criticality', __E_RABs_ToBeAdded_List_ModReq__item__criticality),
        (u'value', __E_RABs_ToBeAdded_List_ModReq__item__value),
        ])
    _E_RABs_ToBeAdded_List_ModReq__item_._ext = None
    E_RABs_ToBeAdded_List_ModReq._cont = _E_RABs_ToBeAdded_List_ModReq__item_
    E_RABs_ToBeAdded_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItemIEs >-----#
    E_RABs_ToBeAdded_ModReqItemIEs = CLASS(name=u'E-RABs-ToBeAdded-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem')))
    E_RABs_ToBeAdded_ModReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 125), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItem >-----#
    E_RABs_ToBeAdded_ModReqItem = CHOICE(name=u'E-RABs-ToBeAdded-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer')))
    _E_RABs_ToBeAdded_ModReqItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem-Split-Bearer')))
    E_RABs_ToBeAdded_ModReqItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_ToBeAdded_ModReqItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_ToBeAdded_ModReqItem_split_Bearer),
        ])
    E_RABs_ToBeAdded_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItem-SCG-Bearer >-----#
    E_RABs_ToBeAdded_ModReqItem_SCG_Bearer = SEQ(name=u'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_dL_Forwarding = ENUM(name=u'dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint = SEQ(name=u's1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_ModReqItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters),
        (u'dL-Forwarding', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_dL_Forwarding),
        (u's1-UL-GTPtunnelEndpoint', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_ModReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItem-Split-Bearer >-----#
    E_RABs_ToBeAdded_ModReqItem_Split_Bearer = SEQ(name=u'E-RABs-ToBeAdded-ModReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint = SEQ(name=u'meNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_ModReqItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters),
        (u'meNB-GTPtunnelEndpoint', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_ModReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-List-ModReq >-----#
    E_RABs_ToBeModified_List_ModReq = SEQ_OF(name=u'E-RABs-ToBeModified-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeModified_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeModified_List_ModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeModified_List_ModReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem')))
    ___E_RABs_ToBeModified_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 126), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeModified_List_ModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeModified_List_ModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeModified_List_ModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeModified_List_ModReq__item__id),
        (u'criticality', __E_RABs_ToBeModified_List_ModReq__item__criticality),
        (u'value', __E_RABs_ToBeModified_List_ModReq__item__value),
        ])
    _E_RABs_ToBeModified_List_ModReq__item_._ext = None
    E_RABs_ToBeModified_List_ModReq._cont = _E_RABs_ToBeModified_List_ModReq__item_
    E_RABs_ToBeModified_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItemIEs >-----#
    E_RABs_ToBeModified_ModReqItemIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem')))
    E_RABs_ToBeModified_ModReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 126), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItem >-----#
    E_RABs_ToBeModified_ModReqItem = CHOICE(name=u'E-RABs-ToBeModified-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem-SCG-Bearer')))
    _E_RABs_ToBeModified_ModReqItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem-Split-Bearer')))
    E_RABs_ToBeModified_ModReqItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_ToBeModified_ModReqItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_ToBeModified_ModReqItem_split_Bearer),
        ])
    E_RABs_ToBeModified_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItem-SCG-Bearer >-----#
    E_RABs_ToBeModified_ModReqItem_SCG_Bearer = SEQ(name=u'E-RABs-ToBeModified-ModReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint = SEQ(name=u's1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_ModReqItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters),
        (u's1-UL-GTPtunnelEndpoint', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeModified_ModReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeModified_ModReqItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_ModReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItem-Split-Bearer >-----#
    E_RABs_ToBeModified_ModReqItem_Split_Bearer = SEQ(name=u'E-RABs-ToBeModified-ModReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint = SEQ(name=u'meNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_ModReqItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters),
        (u'meNB-GTPtunnelEndpoint', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeModified_ModReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeModified_ModReqItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_ModReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-ModReq >-----#
    E_RABs_ToBeReleased_List_ModReq = SEQ_OF(name=u'E-RABs-ToBeReleased-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_List_ModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_List_ModReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem')))
    ___E_RABs_ToBeReleased_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_List_ModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_List_ModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_List_ModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_List_ModReq__item__id),
        (u'criticality', __E_RABs_ToBeReleased_List_ModReq__item__criticality),
        (u'value', __E_RABs_ToBeReleased_List_ModReq__item__value),
        ])
    _E_RABs_ToBeReleased_List_ModReq__item_._ext = None
    E_RABs_ToBeReleased_List_ModReq._cont = _E_RABs_ToBeReleased_List_ModReq__item_
    E_RABs_ToBeReleased_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItemIEs >-----#
    E_RABs_ToBeReleased_ModReqItemIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem')))
    E_RABs_ToBeReleased_ModReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItem >-----#
    E_RABs_ToBeReleased_ModReqItem = CHOICE(name=u'E-RABs-ToBeReleased-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer')))
    _E_RABs_ToBeReleased_ModReqItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem-Split-Bearer')))
    E_RABs_ToBeReleased_ModReqItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_ToBeReleased_ModReqItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_ToBeReleased_ModReqItem_split_Bearer),
        ])
    E_RABs_ToBeReleased_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItem-SCG-Bearer >-----#
    E_RABs_ToBeReleased_ModReqItem_SCG_Bearer = SEQ(name=u'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_uL_GTPtunnelEndpoint = SEQ(name=u'uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_e_RAB_ID),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_dL_GTPtunnelEndpoint),
        (u'uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_uL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeReleased_ModReqItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItem-Split-Bearer >-----#
    E_RABs_ToBeReleased_ModReqItem_Split_Bearer = SEQ(name=u'E-RABs-ToBeReleased-ModReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_e_RAB_ID),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeReleased_ModReqItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequestAcknowledge >-----#
    SeNBModificationRequestAcknowledge = SEQ(name=u'SeNBModificationRequestAcknowledge', mode=MODE_TYPE)
    _SeNBModificationRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckList')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckList')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckList')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab = ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab = ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBModificationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBModificationRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___SeNBModificationRequestAcknowledge_protocolIEs__item__value),
        ])
    __SeNBModificationRequestAcknowledge_protocolIEs__item_._ext = None
    _SeNBModificationRequestAcknowledge_protocolIEs._cont = __SeNBModificationRequestAcknowledge_protocolIEs__item_
    _SeNBModificationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _SeNBModificationRequestAcknowledge_protocolIEs),
        ])
    SeNBModificationRequestAcknowledge._ext = []
    
    #-----< SeNBModificationRequestAcknowledge-IEs >-----#
    SeNBModificationRequestAcknowledge_IEs = CLASS(name=u'SeNBModificationRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckList')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckList')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckList')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckList >-----#
    E_RABs_Admitted_ToBeAdded_ModAckList = SEQ_OF(name=u'E-RABs-Admitted-ToBeAdded-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem')))
    ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeAdded_ModAckList__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeAdded_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeAdded_ModAckList._cont = _E_RABs_Admitted_ToBeAdded_ModAckList__item_
    E_RABs_Admitted_ToBeAdded_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem')))
    E_RABs_Admitted_ToBeAdded_ModAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem = CHOICE(name=u'E-RABs-Admitted-ToBeAdded-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer')))
    E_RABs_Admitted_ToBeAdded_ModAckItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_Admitted_ToBeAdded_ModAckItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_Admitted_ToBeAdded_ModAckItem_split_Bearer),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint = SEQ(name=u's1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name=u'dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name=u'uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_e_RAB_ID),
        (u's1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint),
        (u'dL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        (u'uL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint = SEQ(name=u'seNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_e_RAB_ID),
        (u'seNB-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckList >-----#
    E_RABs_Admitted_ToBeModified_ModAckList = SEQ_OF(name=u'E-RABs-Admitted-ToBeModified-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem')))
    ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeModified_ModAckList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeModified_ModAckList__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeModified_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeModified_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeModified_ModAckList._cont = _E_RABs_Admitted_ToBeModified_ModAckList__item_
    E_RABs_Admitted_ToBeModified_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeModified-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem')))
    E_RABs_Admitted_ToBeModified_ModAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem = CHOICE(name=u'E-RABs-Admitted-ToBeModified-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer')))
    E_RABs_Admitted_ToBeModified_ModAckItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_Admitted_ToBeModified_ModAckItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_Admitted_ToBeModified_ModAckItem_split_Bearer),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint = SEQ(name=u's1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_e_RAB_ID),
        (u's1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint = SEQ(name=u'seNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_e_RAB_ID),
        (u'seNB-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckList >-----#
    E_RABs_Admitted_ToBeReleased_ModAckList = SEQ_OF(name=u'E-RABs-Admitted-ToBeReleased-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToReleased-ModAckItem')))
    ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeReleased_ModAckList__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeReleased_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeReleased_ModAckList._cont = _E_RABs_Admitted_ToBeReleased_ModAckList__item_
    E_RABs_Admitted_ToBeReleased_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToReleased-ModAckItem')))
    E_RABs_Admitted_ToBeReleased_ModAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToReleased-ModAckItem >-----#
    E_RABs_Admitted_ToReleased_ModAckItem = CHOICE(name=u'E-RABs-Admitted-ToReleased-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToReleased_ModAckItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer')))
    _E_RABs_Admitted_ToReleased_ModAckItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer')))
    E_RABs_Admitted_ToReleased_ModAckItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_Admitted_ToReleased_ModAckItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_Admitted_ToReleased_ModAckItem_split_Bearer),
        ])
    E_RABs_Admitted_ToReleased_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_e_RAB_ID),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer = SEQ(name=u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_e_RAB_ID),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequestReject >-----#
    SeNBModificationRequestReject = SEQ(name=u'SeNBModificationRequestReject', mode=MODE_TYPE)
    _SeNBModificationRequestReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequestReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBModificationRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequestReject_protocolIEs__item__id._const_tab = ____SeNBModificationRequestReject_protocolIEs__item__id_tab
    ___SeNBModificationRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequestReject_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBModificationRequestReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBModificationRequestReject_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequestReject_protocolIEs__item__id_tab
    ___SeNBModificationRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBModificationRequestReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBModificationRequestReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBModificationRequestReject_protocolIEs__item__value._const_tab = ____SeNBModificationRequestReject_protocolIEs__item__id_tab
    ___SeNBModificationRequestReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBModificationRequestReject_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBModificationRequestReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBModificationRequestReject_protocolIEs__item__id),
        (u'criticality', ___SeNBModificationRequestReject_protocolIEs__item__criticality),
        (u'value', ___SeNBModificationRequestReject_protocolIEs__item__value),
        ])
    __SeNBModificationRequestReject_protocolIEs__item_._ext = None
    _SeNBModificationRequestReject_protocolIEs._cont = __SeNBModificationRequestReject_protocolIEs__item_
    _SeNBModificationRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequestReject._cont = ASN1Dict([
        (u'protocolIEs', _SeNBModificationRequestReject_protocolIEs),
        ])
    SeNBModificationRequestReject._ext = []
    
    #-----< SeNBModificationRequestReject-IEs >-----#
    SeNBModificationRequestReject_IEs = CLASS(name=u'SeNBModificationRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequestReject_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestReject_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestReject_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRequestReject_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationRequestReject_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequestReject_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequestReject_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestReject_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestReject_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestReject_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestReject_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestReject_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequestReject_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequired >-----#
    SeNBModificationRequired = SEQ(name=u'SeNBModificationRequired', mode=MODE_TYPE)
    _SeNBModificationRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqd')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequired_protocolIEs__item__id._const_tab = ____SeNBModificationRequired_protocolIEs__item__id_tab
    ___SeNBModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBModificationRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBModificationRequired_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequired_protocolIEs__item__id_tab
    ___SeNBModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBModificationRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBModificationRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBModificationRequired_protocolIEs__item__value._const_tab = ____SeNBModificationRequired_protocolIEs__item__id_tab
    ___SeNBModificationRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBModificationRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBModificationRequired_protocolIEs__item__id),
        (u'criticality', ___SeNBModificationRequired_protocolIEs__item__criticality),
        (u'value', ___SeNBModificationRequired_protocolIEs__item__value),
        ])
    __SeNBModificationRequired_protocolIEs__item_._ext = None
    _SeNBModificationRequired_protocolIEs._cont = __SeNBModificationRequired_protocolIEs__item_
    _SeNBModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequired._cont = ASN1Dict([
        (u'protocolIEs', _SeNBModificationRequired_protocolIEs),
        ])
    SeNBModificationRequired._ext = []
    
    #-----< SeNBModificationRequired-IEs >-----#
    SeNBModificationRequired_IEs = CLASS(name=u'SeNBModificationRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequired_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequired_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequired_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRequired_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _SeNBModificationRequired_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqd')))
    _SeNBModificationRequired_IEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _SeNBModificationRequired_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequired_IEs_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequired_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequired_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequired_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequired_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequired_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequired_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRequired_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequired_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBModificationRequired_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqd >-----#
    E_RABs_ToBeReleased_ModReqd = SEQ_OF(name=u'E-RABs-ToBeReleased-ModReqd', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_ModReqd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_ModReqd__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_ModReqd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdItem')))
    ___E_RABs_ToBeReleased_ModReqd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_ModReqd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_ModReqd__item__id._const_tab = ___E_RABs_ToBeReleased_ModReqd__item__id_tab
    __E_RABs_ToBeReleased_ModReqd__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_ModReqd__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_ModReqd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_ModReqd__item__criticality._const_tab = ___E_RABs_ToBeReleased_ModReqd__item__id_tab
    __E_RABs_ToBeReleased_ModReqd__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_ModReqd__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_ModReqd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_ModReqd__item__value._const_tab = ___E_RABs_ToBeReleased_ModReqd__item__id_tab
    __E_RABs_ToBeReleased_ModReqd__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_ModReqd__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_ModReqd__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_ModReqd__item__id),
        (u'criticality', __E_RABs_ToBeReleased_ModReqd__item__criticality),
        (u'value', __E_RABs_ToBeReleased_ModReqd__item__value),
        ])
    _E_RABs_ToBeReleased_ModReqd__item_._ext = None
    E_RABs_ToBeReleased_ModReqd._cont = _E_RABs_ToBeReleased_ModReqd__item_
    E_RABs_ToBeReleased_ModReqd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdItemIEs >-----#
    E_RABs_ToBeReleased_ModReqdItemIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqdItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdItem')))
    E_RABs_ToBeReleased_ModReqdItemIEs._val = ASN1Set(rv=[dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdItem >-----#
    E_RABs_ToBeReleased_ModReqdItem = SEQ(name=u'E-RABs-ToBeReleased-ModReqdItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqdItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqdItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID),
        (u'cause', _E_RABs_ToBeReleased_ModReqdItem_cause),
        (u'iE-Extensions', _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqdItem._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqdItemExtIEs >-----#
    E_RABs_ToBeReleased_ModReqdItemExtIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqdItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqdItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationConfirm >-----#
    SeNBModificationConfirm = SEQ(name=u'SeNBModificationConfirm', mode=MODE_TYPE)
    _SeNBModificationConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationConfirm_protocolIEs__item__id._const_tab = ____SeNBModificationConfirm_protocolIEs__item__id_tab
    ___SeNBModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBModificationConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBModificationConfirm_protocolIEs__item__criticality._const_tab = ____SeNBModificationConfirm_protocolIEs__item__id_tab
    ___SeNBModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBModificationConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBModificationConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBModificationConfirm_protocolIEs__item__value._const_tab = ____SeNBModificationConfirm_protocolIEs__item__id_tab
    ___SeNBModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBModificationConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBModificationConfirm_protocolIEs__item__id),
        (u'criticality', ___SeNBModificationConfirm_protocolIEs__item__criticality),
        (u'value', ___SeNBModificationConfirm_protocolIEs__item__value),
        ])
    __SeNBModificationConfirm_protocolIEs__item_._ext = None
    _SeNBModificationConfirm_protocolIEs._cont = __SeNBModificationConfirm_protocolIEs__item_
    _SeNBModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationConfirm._cont = ASN1Dict([
        (u'protocolIEs', _SeNBModificationConfirm_protocolIEs),
        ])
    SeNBModificationConfirm._ext = []
    
    #-----< SeNBModificationConfirm-IEs >-----#
    SeNBModificationConfirm_IEs = CLASS(name=u'SeNBModificationConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationConfirm_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationConfirm_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationConfirm_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBModificationConfirm_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationConfirm_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationConfirm_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationConfirm_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _SeNBModificationConfirm_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _SeNBModificationConfirm_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _SeNBModificationConfirm_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBModificationConfirm_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _SeNBModificationConfirm_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _SeNBModificationConfirm_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRefuse >-----#
    SeNBModificationRefuse = SEQ(name=u'SeNBModificationRefuse', mode=MODE_TYPE)
    _SeNBModificationRefuse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRefuse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRefuse_protocolIEs__item__id._const_tab = ____SeNBModificationRefuse_protocolIEs__item__id_tab
    ___SeNBModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRefuse_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBModificationRefuse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBModificationRefuse_protocolIEs__item__criticality._const_tab = ____SeNBModificationRefuse_protocolIEs__item__id_tab
    ___SeNBModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBModificationRefuse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBModificationRefuse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBModificationRefuse_protocolIEs__item__value._const_tab = ____SeNBModificationRefuse_protocolIEs__item__id_tab
    ___SeNBModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBModificationRefuse_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBModificationRefuse_protocolIEs__item__id),
        (u'criticality', ___SeNBModificationRefuse_protocolIEs__item__criticality),
        (u'value', ___SeNBModificationRefuse_protocolIEs__item__value),
        ])
    __SeNBModificationRefuse_protocolIEs__item_._ext = None
    _SeNBModificationRefuse_protocolIEs._cont = __SeNBModificationRefuse_protocolIEs__item_
    _SeNBModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRefuse._cont = ASN1Dict([
        (u'protocolIEs', _SeNBModificationRefuse_protocolIEs),
        ])
    SeNBModificationRefuse._ext = []
    
    #-----< SeNBModificationRefuse-IEs >-----#
    SeNBModificationRefuse_IEs = CLASS(name=u'SeNBModificationRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRefuse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRefuse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRefuse_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRefuse_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBModificationRefuse_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationRefuse_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRefuse_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRefuse_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _SeNBModificationRefuse_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBReleaseRequest >-----#
    SeNBReleaseRequest = SEQ(name=u'SeNBReleaseRequest', mode=MODE_TYPE)
    _SeNBReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelReq')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBReleaseRequest_protocolIEs__item__id._const_tab = ____SeNBReleaseRequest_protocolIEs__item__id_tab
    ___SeNBReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBReleaseRequest_protocolIEs__item__criticality._const_tab = ____SeNBReleaseRequest_protocolIEs__item__id_tab
    ___SeNBReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBReleaseRequest_protocolIEs__item__value._const_tab = ____SeNBReleaseRequest_protocolIEs__item__id_tab
    ___SeNBReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___SeNBReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___SeNBReleaseRequest_protocolIEs__item__value),
        ])
    __SeNBReleaseRequest_protocolIEs__item_._ext = None
    _SeNBReleaseRequest_protocolIEs._cont = __SeNBReleaseRequest_protocolIEs__item_
    _SeNBReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _SeNBReleaseRequest_protocolIEs),
        ])
    SeNBReleaseRequest._ext = []
    
    #-----< SeNBReleaseRequest-IEs >-----#
    SeNBReleaseRequest_IEs = CLASS(name=u'SeNBReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReleaseRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequest_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBReleaseRequest_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelReq')))
    _SeNBReleaseRequest_IEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _SeNBReleaseRequest_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseRequest_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReleaseRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequest_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-RelReq >-----#
    E_RABs_ToBeReleased_List_RelReq = SEQ_OF(name=u'E-RABs-ToBeReleased-List-RelReq', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_RelReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_List_RelReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_List_RelReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem')))
    ___E_RABs_ToBeReleased_List_RelReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 138), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_List_RelReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_List_RelReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_List_RelReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_List_RelReq__item__id),
        (u'criticality', __E_RABs_ToBeReleased_List_RelReq__item__criticality),
        (u'value', __E_RABs_ToBeReleased_List_RelReq__item__value),
        ])
    _E_RABs_ToBeReleased_List_RelReq__item_._ext = None
    E_RABs_ToBeReleased_List_RelReq._cont = _E_RABs_ToBeReleased_List_RelReq__item_
    E_RABs_ToBeReleased_List_RelReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItemIEs >-----#
    E_RABs_ToBeReleased_RelReqItemIEs = CLASS(name=u'E-RABs-ToBeReleased-RelReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem')))
    E_RABs_ToBeReleased_RelReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 138), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItem >-----#
    E_RABs_ToBeReleased_RelReqItem = CHOICE(name=u'E-RABs-ToBeReleased-RelReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer')))
    _E_RABs_ToBeReleased_RelReqItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem-Split-Bearer')))
    E_RABs_ToBeReleased_RelReqItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_ToBeReleased_RelReqItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_ToBeReleased_RelReqItem_split_Bearer),
        ])
    E_RABs_ToBeReleased_RelReqItem._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItem-SCG-Bearer >-----#
    E_RABs_ToBeReleased_RelReqItem_SCG_Bearer = SEQ(name=u'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_uL_GTPtunnelEndpoint = SEQ(name=u'uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelReqItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_e_RAB_ID),
        (u'uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_uL_GTPtunnelEndpoint),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelReqItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItem-Split-Bearer >-----#
    E_RABs_ToBeReleased_RelReqItem_Split_Bearer = SEQ(name=u'E-RABs-ToBeReleased-RelReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelReqItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_e_RAB_ID),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelReqItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBReleaseRequired >-----#
    SeNBReleaseRequired = SEQ(name=u'SeNBReleaseRequired', mode=MODE_TYPE)
    _SeNBReleaseRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReleaseRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReleaseRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBReleaseRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReleaseRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBReleaseRequired_protocolIEs__item__id._const_tab = ____SeNBReleaseRequired_protocolIEs__item__id_tab
    ___SeNBReleaseRequired_protocolIEs__item__id._const_tab_at = None
    ___SeNBReleaseRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBReleaseRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBReleaseRequired_protocolIEs__item__criticality._const_tab = ____SeNBReleaseRequired_protocolIEs__item__id_tab
    ___SeNBReleaseRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBReleaseRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBReleaseRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBReleaseRequired_protocolIEs__item__value._const_tab = ____SeNBReleaseRequired_protocolIEs__item__id_tab
    ___SeNBReleaseRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBReleaseRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBReleaseRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBReleaseRequired_protocolIEs__item__id),
        (u'criticality', ___SeNBReleaseRequired_protocolIEs__item__criticality),
        (u'value', ___SeNBReleaseRequired_protocolIEs__item__value),
        ])
    __SeNBReleaseRequired_protocolIEs__item_._ext = None
    _SeNBReleaseRequired_protocolIEs._cont = __SeNBReleaseRequired_protocolIEs__item_
    _SeNBReleaseRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReleaseRequired._cont = ASN1Dict([
        (u'protocolIEs', _SeNBReleaseRequired_protocolIEs),
        ])
    SeNBReleaseRequired._ext = []
    
    #-----< SeNBReleaseRequired-IEs >-----#
    SeNBReleaseRequired_IEs = CLASS(name=u'SeNBReleaseRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReleaseRequired_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequired_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequired_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBReleaseRequired_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseRequired_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReleaseRequired_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequired_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequired_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseRequired_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequired_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _SeNBReleaseRequired_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBReleaseConfirm >-----#
    SeNBReleaseConfirm = SEQ(name=u'SeNBReleaseConfirm', mode=MODE_TYPE)
    _SeNBReleaseConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReleaseConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReleaseConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBReleaseConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelConf')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReleaseConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 139), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBReleaseConfirm_protocolIEs__item__id._const_tab = ____SeNBReleaseConfirm_protocolIEs__item__id_tab
    ___SeNBReleaseConfirm_protocolIEs__item__id._const_tab_at = None
    ___SeNBReleaseConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBReleaseConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBReleaseConfirm_protocolIEs__item__criticality._const_tab = ____SeNBReleaseConfirm_protocolIEs__item__id_tab
    ___SeNBReleaseConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBReleaseConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBReleaseConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBReleaseConfirm_protocolIEs__item__value._const_tab = ____SeNBReleaseConfirm_protocolIEs__item__id_tab
    ___SeNBReleaseConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBReleaseConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBReleaseConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBReleaseConfirm_protocolIEs__item__id),
        (u'criticality', ___SeNBReleaseConfirm_protocolIEs__item__criticality),
        (u'value', ___SeNBReleaseConfirm_protocolIEs__item__value),
        ])
    __SeNBReleaseConfirm_protocolIEs__item_._ext = None
    _SeNBReleaseConfirm_protocolIEs._cont = __SeNBReleaseConfirm_protocolIEs__item_
    _SeNBReleaseConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReleaseConfirm._cont = ASN1Dict([
        (u'protocolIEs', _SeNBReleaseConfirm_protocolIEs),
        ])
    SeNBReleaseConfirm._ext = []
    
    #-----< SeNBReleaseConfirm-IEs >-----#
    SeNBReleaseConfirm_IEs = CLASS(name=u'SeNBReleaseConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReleaseConfirm_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseConfirm_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseConfirm_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelConf')))
    _SeNBReleaseConfirm_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBReleaseConfirm_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseConfirm_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReleaseConfirm_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseConfirm_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseConfirm_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 139), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseConfirm_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseConfirm_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseConfirm_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _SeNBReleaseConfirm_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-RelConf >-----#
    E_RABs_ToBeReleased_List_RelConf = SEQ_OF(name=u'E-RABs-ToBeReleased-List-RelConf', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_RelConf__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_List_RelConf__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_List_RelConf__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem')))
    ___E_RABs_ToBeReleased_List_RelConf__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 140), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_List_RelConf__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_List_RelConf__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_List_RelConf__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_List_RelConf__item__id),
        (u'criticality', __E_RABs_ToBeReleased_List_RelConf__item__criticality),
        (u'value', __E_RABs_ToBeReleased_List_RelConf__item__value),
        ])
    _E_RABs_ToBeReleased_List_RelConf__item_._ext = None
    E_RABs_ToBeReleased_List_RelConf._cont = _E_RABs_ToBeReleased_List_RelConf__item_
    E_RABs_ToBeReleased_List_RelConf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItemIEs >-----#
    E_RABs_ToBeReleased_RelConfItemIEs = CLASS(name=u'E-RABs-ToBeReleased-RelConfItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem')))
    E_RABs_ToBeReleased_RelConfItemIEs._val = ASN1Set(rv=[dict([(u'id', 140), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItem >-----#
    E_RABs_ToBeReleased_RelConfItem = CHOICE(name=u'E-RABs-ToBeReleased-RelConfItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_sCG_Bearer = SEQ(name=u'sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer')))
    _E_RABs_ToBeReleased_RelConfItem_split_Bearer = SEQ(name=u'split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem-Split-Bearer')))
    E_RABs_ToBeReleased_RelConfItem._cont = ASN1Dict([
        (u'sCG-Bearer', _E_RABs_ToBeReleased_RelConfItem_sCG_Bearer),
        (u'split-Bearer', _E_RABs_ToBeReleased_RelConfItem_split_Bearer),
        ])
    E_RABs_ToBeReleased_RelConfItem._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItem-SCG-Bearer >-----#
    E_RABs_ToBeReleased_RelConfItem_SCG_Bearer = SEQ(name=u'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_uL_GTPtunnelEndpoint = SEQ(name=u'uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelConfItem_SCG_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_e_RAB_ID),
        (u'uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_uL_GTPtunnelEndpoint),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelConfItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelConfItem_SCG_BearerExtIEs = CLASS(name=u'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelConfItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItem-Split-Bearer >-----#
    E_RABs_ToBeReleased_RelConfItem_Split_Bearer = SEQ(name=u'E-RABs-ToBeReleased-RelConfItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelConfItem_Split_Bearer._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_e_RAB_ID),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelConfItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelConfItem_Split_BearerExtIEs = CLASS(name=u'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelConfItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBCounterCheckRequest >-----#
    SeNBCounterCheckRequest = SEQ(name=u'SeNBCounterCheckRequest', mode=MODE_TYPE)
    _SeNBCounterCheckRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBCounterCheckRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBCounterCheckRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____SeNBCounterCheckRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheck-List')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBCounterCheckRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SeNBCounterCheckRequest_protocolIEs__item__id._const_tab = ____SeNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SeNBCounterCheckRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBCounterCheckRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality._const_tab = ____SeNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SeNBCounterCheckRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___SeNBCounterCheckRequest_protocolIEs__item__value._const_tab = ____SeNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SeNBCounterCheckRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SeNBCounterCheckRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __SeNBCounterCheckRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SeNBCounterCheckRequest_protocolIEs__item__id),
        (u'criticality', ___SeNBCounterCheckRequest_protocolIEs__item__criticality),
        (u'value', ___SeNBCounterCheckRequest_protocolIEs__item__value),
        ])
    __SeNBCounterCheckRequest_protocolIEs__item_._ext = None
    _SeNBCounterCheckRequest_protocolIEs._cont = __SeNBCounterCheckRequest_protocolIEs__item_
    _SeNBCounterCheckRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBCounterCheckRequest._cont = ASN1Dict([
        (u'protocolIEs', _SeNBCounterCheckRequest_protocolIEs),
        ])
    SeNBCounterCheckRequest._ext = []
    
    #-----< SeNBCounterCheckRequest-IEs >-----#
    SeNBCounterCheckRequest_IEs = CLASS(name=u'SeNBCounterCheckRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBCounterCheckRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBCounterCheckRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBCounterCheckRequest_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheck-List')))
    _SeNBCounterCheckRequest_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBCounterCheckRequest_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBCounterCheckRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Value', _SeNBCounterCheckRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Value', _SeNBCounterCheckRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _SeNBCounterCheckRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _SeNBCounterCheckRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _SeNBCounterCheckRequest_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToCounterCheck-List >-----#
    E_RABs_SubjectToCounterCheck_List = SEQ_OF(name=u'E-RABs-SubjectToCounterCheck-List', mode=MODE_TYPE)
    _E_RABs_SubjectToCounterCheck_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_SubjectToCounterCheck_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_SubjectToCounterCheck_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_SubjectToCounterCheck_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheckItem')))
    ___E_RABs_SubjectToCounterCheck_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 142), (u'criticality', u'ignore'), (u'Value', ____E_RABs_SubjectToCounterCheck_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_SubjectToCounterCheck_List__item__id._const_tab = ___E_RABs_SubjectToCounterCheck_List__item__id_tab
    __E_RABs_SubjectToCounterCheck_List__item__id._const_tab_at = None
    __E_RABs_SubjectToCounterCheck_List__item__id._const_tab_id = u'id'
    __E_RABs_SubjectToCounterCheck_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_SubjectToCounterCheck_List__item__criticality._const_tab = ___E_RABs_SubjectToCounterCheck_List__item__id_tab
    __E_RABs_SubjectToCounterCheck_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_SubjectToCounterCheck_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_SubjectToCounterCheck_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_SubjectToCounterCheck_List__item__value._const_tab = ___E_RABs_SubjectToCounterCheck_List__item__id_tab
    __E_RABs_SubjectToCounterCheck_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_SubjectToCounterCheck_List__item__value._const_tab_id = u'Value'
    _E_RABs_SubjectToCounterCheck_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_SubjectToCounterCheck_List__item__id),
        (u'criticality', __E_RABs_SubjectToCounterCheck_List__item__criticality),
        (u'value', __E_RABs_SubjectToCounterCheck_List__item__value),
        ])
    _E_RABs_SubjectToCounterCheck_List__item_._ext = None
    E_RABs_SubjectToCounterCheck_List._cont = _E_RABs_SubjectToCounterCheck_List__item_
    E_RABs_SubjectToCounterCheck_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-SubjectToCounterCheckItemIEs >-----#
    E_RABs_SubjectToCounterCheckItemIEs = CLASS(name=u'E-RABs-SubjectToCounterCheckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_SubjectToCounterCheckItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheckItem')))
    E_RABs_SubjectToCounterCheckItemIEs._val = ASN1Set(rv=[dict([(u'id', 142), (u'criticality', u'ignore'), (u'Value', _E_RABs_SubjectToCounterCheckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToCounterCheckItem >-----#
    E_RABs_SubjectToCounterCheckItem = SEQ(name=u'E-RABs-SubjectToCounterCheckItem', mode=MODE_TYPE)
    _E_RABs_SubjectToCounterCheckItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_SubjectToCounterCheckItem_uL_Count = INT(name=u'uL-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABs_SubjectToCounterCheckItem_uL_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _E_RABs_SubjectToCounterCheckItem_dL_Count = INT(name=u'dL-Count', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABs_SubjectToCounterCheckItem_dL_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _E_RABs_SubjectToCounterCheckItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id._const_tab = ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_._ext = None
    _E_RABs_SubjectToCounterCheckItem_iE_Extensions._cont = __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_
    _E_RABs_SubjectToCounterCheckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_SubjectToCounterCheckItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_SubjectToCounterCheckItem_e_RAB_ID),
        (u'uL-Count', _E_RABs_SubjectToCounterCheckItem_uL_Count),
        (u'dL-Count', _E_RABs_SubjectToCounterCheckItem_dL_Count),
        (u'iE-Extensions', _E_RABs_SubjectToCounterCheckItem_iE_Extensions),
        ])
    E_RABs_SubjectToCounterCheckItem._ext = []
    
    #-----< E-RABs-SubjectToCounterCheckItemExtIEs >-----#
    E_RABs_SubjectToCounterCheckItemExtIEs = CLASS(name=u'E-RABs-SubjectToCounterCheckItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_SubjectToCounterCheckItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< X2RemovalRequest >-----#
    X2RemovalRequest = SEQ(name=u'X2RemovalRequest', mode=MODE_TYPE)
    _X2RemovalRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2RemovalRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2RemovalRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2RemovalRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'X2BenefitValue')))
    ____X2RemovalRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 169), (u'criticality', u'reject'), (u'Value', _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2RemovalRequest_protocolIEs__item__id._const_tab = ____X2RemovalRequest_protocolIEs__item__id_tab
    ___X2RemovalRequest_protocolIEs__item__id._const_tab_at = None
    ___X2RemovalRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___X2RemovalRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2RemovalRequest_protocolIEs__item__criticality._const_tab = ____X2RemovalRequest_protocolIEs__item__id_tab
    ___X2RemovalRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2RemovalRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2RemovalRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2RemovalRequest_protocolIEs__item__value._const_tab = ____X2RemovalRequest_protocolIEs__item__id_tab
    ___X2RemovalRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2RemovalRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __X2RemovalRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2RemovalRequest_protocolIEs__item__id),
        (u'criticality', ___X2RemovalRequest_protocolIEs__item__criticality),
        (u'value', ___X2RemovalRequest_protocolIEs__item__value),
        ])
    __X2RemovalRequest_protocolIEs__item_._ext = None
    _X2RemovalRequest_protocolIEs._cont = __X2RemovalRequest_protocolIEs__item_
    _X2RemovalRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2RemovalRequest._cont = ASN1Dict([
        (u'protocolIEs', _X2RemovalRequest_protocolIEs),
        ])
    X2RemovalRequest._ext = []
    
    #-----< X2RemovalRequest-IEs >-----#
    X2RemovalRequest_IEs = CLASS(name=u'X2RemovalRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2RemovalRequest_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2RemovalRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'X2BenefitValue')))
    X2RemovalRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _X2RemovalRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 169), (u'criticality', u'reject'), (u'Value', _X2RemovalRequest_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2RemovalResponse >-----#
    X2RemovalResponse = SEQ(name=u'X2RemovalResponse', mode=MODE_TYPE)
    _X2RemovalResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2RemovalResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2RemovalResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2RemovalResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____X2RemovalResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2RemovalResponse_protocolIEs__item__id._const_tab = ____X2RemovalResponse_protocolIEs__item__id_tab
    ___X2RemovalResponse_protocolIEs__item__id._const_tab_at = None
    ___X2RemovalResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___X2RemovalResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2RemovalResponse_protocolIEs__item__criticality._const_tab = ____X2RemovalResponse_protocolIEs__item__id_tab
    ___X2RemovalResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2RemovalResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2RemovalResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2RemovalResponse_protocolIEs__item__value._const_tab = ____X2RemovalResponse_protocolIEs__item__id_tab
    ___X2RemovalResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2RemovalResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __X2RemovalResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2RemovalResponse_protocolIEs__item__id),
        (u'criticality', ___X2RemovalResponse_protocolIEs__item__criticality),
        (u'value', ___X2RemovalResponse_protocolIEs__item__value),
        ])
    __X2RemovalResponse_protocolIEs__item_._ext = None
    _X2RemovalResponse_protocolIEs._cont = __X2RemovalResponse_protocolIEs__item_
    _X2RemovalResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2RemovalResponse._cont = ASN1Dict([
        (u'protocolIEs', _X2RemovalResponse_protocolIEs),
        ])
    X2RemovalResponse._ext = []
    
    #-----< X2RemovalResponse-IEs >-----#
    X2RemovalResponse_IEs = CLASS(name=u'X2RemovalResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2RemovalResponse_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2RemovalResponse_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    X2RemovalResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _X2RemovalResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _X2RemovalResponse_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2RemovalFailure >-----#
    X2RemovalFailure = SEQ(name=u'X2RemovalFailure', mode=MODE_TYPE)
    _X2RemovalFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2RemovalFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2RemovalFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____X2RemovalFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____X2RemovalFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2RemovalFailure_protocolIEs__item__id._const_tab = ____X2RemovalFailure_protocolIEs__item__id_tab
    ___X2RemovalFailure_protocolIEs__item__id._const_tab_at = None
    ___X2RemovalFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___X2RemovalFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___X2RemovalFailure_protocolIEs__item__criticality._const_tab = ____X2RemovalFailure_protocolIEs__item__id_tab
    ___X2RemovalFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___X2RemovalFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___X2RemovalFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___X2RemovalFailure_protocolIEs__item__value._const_tab = ____X2RemovalFailure_protocolIEs__item__id_tab
    ___X2RemovalFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___X2RemovalFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __X2RemovalFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___X2RemovalFailure_protocolIEs__item__id),
        (u'criticality', ___X2RemovalFailure_protocolIEs__item__criticality),
        (u'value', ___X2RemovalFailure_protocolIEs__item__value),
        ])
    __X2RemovalFailure_protocolIEs__item_._ext = None
    _X2RemovalFailure_protocolIEs._cont = __X2RemovalFailure_protocolIEs__item_
    _X2RemovalFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2RemovalFailure._cont = ASN1Dict([
        (u'protocolIEs', _X2RemovalFailure_protocolIEs),
        ])
    X2RemovalFailure._ext = []
    
    #-----< X2RemovalFailure-IEs >-----#
    X2RemovalFailure_IEs = CLASS(name=u'X2RemovalFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2RemovalFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _X2RemovalFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    X2RemovalFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _X2RemovalFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _X2RemovalFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEContextRequest >-----#
    RetrieveUEContextRequest = SEQ(name=u'RetrieveUEContextRequest', mode=MODE_TYPE)
    _RetrieveUEContextRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEContextRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEContextRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____RetrieveUEContextRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ResumeID')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    ____RetrieveUEContextRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 51), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 175), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RetrieveUEContextRequest_protocolIEs__item__id._const_tab = ____RetrieveUEContextRequest_protocolIEs__item__id_tab
    ___RetrieveUEContextRequest_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEContextRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RetrieveUEContextRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___RetrieveUEContextRequest_protocolIEs__item__criticality._const_tab = ____RetrieveUEContextRequest_protocolIEs__item__id_tab
    ___RetrieveUEContextRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RetrieveUEContextRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RetrieveUEContextRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___RetrieveUEContextRequest_protocolIEs__item__value._const_tab = ____RetrieveUEContextRequest_protocolIEs__item__id_tab
    ___RetrieveUEContextRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RetrieveUEContextRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RetrieveUEContextRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RetrieveUEContextRequest_protocolIEs__item__id),
        (u'criticality', ___RetrieveUEContextRequest_protocolIEs__item__criticality),
        (u'value', ___RetrieveUEContextRequest_protocolIEs__item__value),
        ])
    __RetrieveUEContextRequest_protocolIEs__item_._ext = None
    _RetrieveUEContextRequest_protocolIEs._cont = __RetrieveUEContextRequest_protocolIEs__item_
    _RetrieveUEContextRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEContextRequest._cont = ASN1Dict([
        (u'protocolIEs', _RetrieveUEContextRequest_protocolIEs),
        ])
    RetrieveUEContextRequest._ext = []
    
    #-----< RetrieveUEContextRequest-IEs >-----#
    RetrieveUEContextRequest_IEs = CLASS(name=u'RetrieveUEContextRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RetrieveUEContextRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextRequest_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ResumeID')))
    _RetrieveUEContextRequest_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _RetrieveUEContextRequest_IEs_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    RetrieveUEContextRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 158), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextRequest_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 51), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 175), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextRequest_IEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEContextResponse >-----#
    RetrieveUEContextResponse = SEQ(name=u'RetrieveUEContextResponse', mode=MODE_TYPE)
    _RetrieveUEContextResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEContextResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEContextResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____RetrieveUEContextResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationRetrieve')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_8 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____RetrieveUEContextResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 173), (u'criticality', u'reject'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RetrieveUEContextResponse_protocolIEs__item__id._const_tab = ____RetrieveUEContextResponse_protocolIEs__item__id_tab
    ___RetrieveUEContextResponse_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEContextResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___RetrieveUEContextResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___RetrieveUEContextResponse_protocolIEs__item__criticality._const_tab = ____RetrieveUEContextResponse_protocolIEs__item__id_tab
    ___RetrieveUEContextResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RetrieveUEContextResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RetrieveUEContextResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___RetrieveUEContextResponse_protocolIEs__item__value._const_tab = ____RetrieveUEContextResponse_protocolIEs__item__id_tab
    ___RetrieveUEContextResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RetrieveUEContextResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __RetrieveUEContextResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RetrieveUEContextResponse_protocolIEs__item__id),
        (u'criticality', ___RetrieveUEContextResponse_protocolIEs__item__criticality),
        (u'value', ___RetrieveUEContextResponse_protocolIEs__item__value),
        ])
    __RetrieveUEContextResponse_protocolIEs__item_._ext = None
    _RetrieveUEContextResponse_protocolIEs._cont = __RetrieveUEContextResponse_protocolIEs__item_
    _RetrieveUEContextResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEContextResponse._cont = ASN1Dict([
        (u'protocolIEs', _RetrieveUEContextResponse_protocolIEs),
        ])
    RetrieveUEContextResponse._ext = []
    
    #-----< RetrieveUEContextResponse-IEs >-----#
    RetrieveUEContextResponse_IEs = CLASS(name=u'RetrieveUEContextResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RetrieveUEContextResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextResponse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextResponse_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextResponse_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextResponse_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _RetrieveUEContextResponse_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationRetrieve')))
    _RetrieveUEContextResponse_IEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _RetrieveUEContextResponse_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _RetrieveUEContextResponse_IEs_val_Value_8 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _RetrieveUEContextResponse_IEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _RetrieveUEContextResponse_IEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _RetrieveUEContextResponse_IEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    RetrieveUEContextResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 173), (u'criticality', u'reject'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextResponse_IEs_val_Value_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformationRetrieve >-----#
    UE_ContextInformationRetrieve = SEQ(name=u'UE-ContextInformationRetrieve', mode=MODE_TYPE)
    _UE_ContextInformationRetrieve_mME_UE_S1AP_ID = INT(name=u'mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-S1AP-ID')))
    _UE_ContextInformationRetrieve_uESecurityCapabilities = SEQ(name=u'uESecurityCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _UE_ContextInformationRetrieve_aS_SecurityInformation = SEQ(name=u'aS-SecurityInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AS-SecurityInformation')))
    _UE_ContextInformationRetrieve_uEaggregateMaximumBitRate = SEQ(name=u'uEaggregateMaximumBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _UE_ContextInformationRetrieve_subscriberProfileIDforRFP = INT(name=u'subscriberProfileIDforRFP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')), opt=True)
    _UE_ContextInformationRetrieve_e_RABs_ToBeSetup_ListRetrieve = SEQ_OF(name=u'e-RABs-ToBeSetup-ListRetrieve', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-ListRetrieve')))
    _UE_ContextInformationRetrieve_rRC_Context = OCT_STR(name=u'rRC-Context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRC-Context')))
    _UE_ContextInformationRetrieve_handoverRestrictionList = SEQ(name=u'handoverRestrictionList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')), opt=True)
    _UE_ContextInformationRetrieve_locationReportingInformation = SEQ(name=u'locationReportingInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LocationReportingInformation')), opt=True)
    _UE_ContextInformationRetrieve_managBasedMDTallowed = ENUM(name=u'managBasedMDTallowed', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')), opt=True)
    _UE_ContextInformationRetrieve_managBasedMDTPLMNList = SEQ_OF(name=u'managBasedMDTPLMNList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')), opt=True)
    _UE_ContextInformationRetrieve_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformationRetrieve_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id._const_tab = ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_ContextInformationRetrieve_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_ContextInformationRetrieve_iE_Extensions__item__id),
        (u'criticality', ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformationRetrieve_iE_Extensions__item_._ext = None
    _UE_ContextInformationRetrieve_iE_Extensions._cont = __UE_ContextInformationRetrieve_iE_Extensions__item_
    _UE_ContextInformationRetrieve_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformationRetrieve._cont = ASN1Dict([
        (u'mME-UE-S1AP-ID', _UE_ContextInformationRetrieve_mME_UE_S1AP_ID),
        (u'uESecurityCapabilities', _UE_ContextInformationRetrieve_uESecurityCapabilities),
        (u'aS-SecurityInformation', _UE_ContextInformationRetrieve_aS_SecurityInformation),
        (u'uEaggregateMaximumBitRate', _UE_ContextInformationRetrieve_uEaggregateMaximumBitRate),
        (u'subscriberProfileIDforRFP', _UE_ContextInformationRetrieve_subscriberProfileIDforRFP),
        (u'e-RABs-ToBeSetup-ListRetrieve', _UE_ContextInformationRetrieve_e_RABs_ToBeSetup_ListRetrieve),
        (u'rRC-Context', _UE_ContextInformationRetrieve_rRC_Context),
        (u'handoverRestrictionList', _UE_ContextInformationRetrieve_handoverRestrictionList),
        (u'locationReportingInformation', _UE_ContextInformationRetrieve_locationReportingInformation),
        (u'managBasedMDTallowed', _UE_ContextInformationRetrieve_managBasedMDTallowed),
        (u'managBasedMDTPLMNList', _UE_ContextInformationRetrieve_managBasedMDTPLMNList),
        (u'iE-Extensions', _UE_ContextInformationRetrieve_iE_Extensions),
        ])
    UE_ContextInformationRetrieve._ext = []
    
    #-----< UE-ContextInformationRetrieve-ExtIEs >-----#
    UE_ContextInformationRetrieve_ExtIEs = CLASS(name=u'UE-ContextInformationRetrieve-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextInformationRetrieve_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetup-ListRetrieve >-----#
    E_RABs_ToBeSetup_ListRetrieve = SEQ_OF(name=u'E-RABs-ToBeSetup-ListRetrieve', mode=MODE_TYPE)
    _E_RABs_ToBeSetup_ListRetrieve__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeSetup_ListRetrieve__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeSetup_ListRetrieve__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetupRetrieve-Item')))
    ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeSetup_ListRetrieve__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeSetup_ListRetrieve__item__id._const_tab = ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab
    __E_RABs_ToBeSetup_ListRetrieve__item__id._const_tab_at = None
    __E_RABs_ToBeSetup_ListRetrieve__item__id._const_tab_id = u'id'
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality._const_tab = ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeSetup_ListRetrieve__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeSetup_ListRetrieve__item__value._const_tab = ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab
    __E_RABs_ToBeSetup_ListRetrieve__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeSetup_ListRetrieve__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeSetup_ListRetrieve__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeSetup_ListRetrieve__item__id),
        (u'criticality', __E_RABs_ToBeSetup_ListRetrieve__item__criticality),
        (u'value', __E_RABs_ToBeSetup_ListRetrieve__item__value),
        ])
    _E_RABs_ToBeSetup_ListRetrieve__item_._ext = None
    E_RABs_ToBeSetup_ListRetrieve._cont = _E_RABs_ToBeSetup_ListRetrieve__item_
    E_RABs_ToBeSetup_ListRetrieve._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeSetupRetrieve-ItemIEs >-----#
    E_RABs_ToBeSetupRetrieve_ItemIEs = CLASS(name=u'E-RABs-ToBeSetupRetrieve-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeSetupRetrieve_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetupRetrieve-Item')))
    E_RABs_ToBeSetupRetrieve_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeSetupRetrieve_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetupRetrieve-Item >-----#
    E_RABs_ToBeSetupRetrieve_Item = SEQ(name=u'E-RABs-ToBeSetupRetrieve-Item', mode=MODE_TYPE)
    _E_RABs_ToBeSetupRetrieve_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeSetupRetrieve_Item_e_RAB_Level_QoS_Parameters = SEQ(name=u'e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeSetupRetrieve_Item_bearerType = ENUM(name=u'bearerType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BearerType')), opt=True)
    _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions._cont = __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_
    _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeSetupRetrieve_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeSetupRetrieve_Item_e_RAB_ID),
        (u'e-RAB-Level-QoS-Parameters', _E_RABs_ToBeSetupRetrieve_Item_e_RAB_Level_QoS_Parameters),
        (u'bearerType', _E_RABs_ToBeSetupRetrieve_Item_bearerType),
        (u'iE-Extensions', _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions),
        ])
    E_RABs_ToBeSetupRetrieve_Item._ext = []
    
    #-----< E-RABs-ToBeSetupRetrieve-ItemExtIEs >-----#
    E_RABs_ToBeSetupRetrieve_ItemExtIEs = CLASS(name=u'E-RABs-ToBeSetupRetrieve-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeSetupRetrieve_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEContextFailure >-----#
    RetrieveUEContextFailure = SEQ(name=u'RetrieveUEContextFailure', mode=MODE_TYPE)
    _RetrieveUEContextFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEContextFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEContextFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'id']))
    ____RetrieveUEContextFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____RetrieveUEContextFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RetrieveUEContextFailure_protocolIEs__item__id._const_tab = ____RetrieveUEContextFailure_protocolIEs__item__id_tab
    ___RetrieveUEContextFailure_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEContextFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___RetrieveUEContextFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'criticality']))
    ___RetrieveUEContextFailure_protocolIEs__item__criticality._const_tab = ____RetrieveUEContextFailure_protocolIEs__item__id_tab
    ___RetrieveUEContextFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RetrieveUEContextFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RetrieveUEContextFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), [u'Value']))
    ___RetrieveUEContextFailure_protocolIEs__item__value._const_tab = ____RetrieveUEContextFailure_protocolIEs__item__id_tab
    ___RetrieveUEContextFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RetrieveUEContextFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __RetrieveUEContextFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RetrieveUEContextFailure_protocolIEs__item__id),
        (u'criticality', ___RetrieveUEContextFailure_protocolIEs__item__criticality),
        (u'value', ___RetrieveUEContextFailure_protocolIEs__item__value),
        ])
    __RetrieveUEContextFailure_protocolIEs__item_._ext = None
    _RetrieveUEContextFailure_protocolIEs._cont = __RetrieveUEContextFailure_protocolIEs__item_
    _RetrieveUEContextFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEContextFailure._cont = ASN1Dict([
        (u'protocolIEs', _RetrieveUEContextFailure_protocolIEs),
        ])
    RetrieveUEContextFailure._ext = []
    
    #-----< RetrieveUEContextFailure-IEs >-----#
    RetrieveUEContextFailure_IEs = CLASS(name=u'RetrieveUEContextFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RetrieveUEContextFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextFailure_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextFailure_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _RetrieveUEContextFailure_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    RetrieveUEContextFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextFailure_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextFailure_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _RetrieveUEContextFailure_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____HandoverRequest_protocolIEs__item__id_tab,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15,
        ___HandoverRequest_protocolIEs__item__id,
        ___HandoverRequest_protocolIEs__item__criticality,
        ___HandoverRequest_protocolIEs__item__value,
        __HandoverRequest_protocolIEs__item_,
        _HandoverRequest_protocolIEs,
        HandoverRequest,
        HandoverRequest_IEs,
        _HandoverRequest_IEs_val_Value_0,
        _HandoverRequest_IEs_val_Value_1,
        _HandoverRequest_IEs_val_Value_2,
        _HandoverRequest_IEs_val_Value_3,
        _HandoverRequest_IEs_val_Value_4,
        _HandoverRequest_IEs_val_Value_5,
        _HandoverRequest_IEs_val_Value_6,
        _HandoverRequest_IEs_val_Value_7,
        _HandoverRequest_IEs_val_Value_8,
        _HandoverRequest_IEs_val_Value_9,
        _HandoverRequest_IEs_val_Value_10,
        _HandoverRequest_IEs_val_Value_11,
        _HandoverRequest_IEs_val_Value_12,
        _HandoverRequest_IEs_val_Value_13,
        _HandoverRequest_IEs_val_Value_14,
        _HandoverRequest_IEs_val_Value_15,
        _UE_ContextInformation_mME_UE_S1AP_ID,
        _UE_ContextInformation_uESecurityCapabilities,
        _UE_ContextInformation_aS_SecurityInformation,
        _UE_ContextInformation_uEaggregateMaximumBitRate,
        _UE_ContextInformation_subscriberProfileIDforRFP,
        _UE_ContextInformation_e_RABs_ToBeSetup_List,
        _UE_ContextInformation_rRC_Context,
        _UE_ContextInformation_handoverRestrictionList,
        _UE_ContextInformation_locationReportingInformation,
        ____UE_ContextInformation_iE_Extensions__item__id_tab,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___UE_ContextInformation_iE_Extensions__item__id,
        ___UE_ContextInformation_iE_Extensions__item__criticality,
        ___UE_ContextInformation_iE_Extensions__item__extensionValue,
        __UE_ContextInformation_iE_Extensions__item_,
        _UE_ContextInformation_iE_Extensions,
        UE_ContextInformation,
        UE_ContextInformation_ExtIEs,
        _UE_ContextInformation_ExtIEs_val_Extension_0,
        _UE_ContextInformation_ExtIEs_val_Extension_1,
        ___E_RABs_ToBeSetup_List__item__id_tab,
        ____E_RABs_ToBeSetup_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeSetup_List__item__id,
        __E_RABs_ToBeSetup_List__item__criticality,
        __E_RABs_ToBeSetup_List__item__value,
        _E_RABs_ToBeSetup_List__item_,
        E_RABs_ToBeSetup_List,
        E_RABs_ToBeSetup_ItemIEs,
        _E_RABs_ToBeSetup_ItemIEs_val_Value_0,
        _E_RABs_ToBeSetup_Item_e_RAB_ID,
        _E_RABs_ToBeSetup_Item_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeSetup_Item_dL_Forwarding,
        _E_RABs_ToBeSetup_Item_uL_GTPtunnelEndpoint,
        ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id,
        ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeSetup_Item_iE_Extensions__item_,
        _E_RABs_ToBeSetup_Item_iE_Extensions,
        E_RABs_ToBeSetup_Item,
        E_RABs_ToBeSetup_ItemExtIEs,
        _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_0,
        MobilityInformation,
        _UE_ContextReferenceAtSeNB_source_GlobalSeNB_ID,
        _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID,
        _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID_Extension,
        ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab,
        ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id,
        ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality,
        ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue,
        __UE_ContextReferenceAtSeNB_iE_Extensions__item_,
        _UE_ContextReferenceAtSeNB_iE_Extensions,
        UE_ContextReferenceAtSeNB,
        UE_ContextReferenceAtSeNB_ItemExtIEs,
        ____HandoverRequestAcknowledge_protocolIEs__item__id_tab,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        ___HandoverRequestAcknowledge_protocolIEs__item__id,
        ___HandoverRequestAcknowledge_protocolIEs__item__criticality,
        ___HandoverRequestAcknowledge_protocolIEs__item__value,
        __HandoverRequestAcknowledge_protocolIEs__item_,
        _HandoverRequestAcknowledge_protocolIEs,
        HandoverRequestAcknowledge,
        HandoverRequestAcknowledge_IEs,
        _HandoverRequestAcknowledge_IEs_val_Value_0,
        _HandoverRequestAcknowledge_IEs_val_Value_1,
        _HandoverRequestAcknowledge_IEs_val_Value_2,
        _HandoverRequestAcknowledge_IEs_val_Value_3,
        _HandoverRequestAcknowledge_IEs_val_Value_4,
        _HandoverRequestAcknowledge_IEs_val_Value_5,
        _HandoverRequestAcknowledge_IEs_val_Value_6,
        _HandoverRequestAcknowledge_IEs_val_Value_7,
        _HandoverRequestAcknowledge_IEs_val_Value_8,
        _HandoverRequestAcknowledge_IEs_val_Value_9,
        ___E_RABs_Admitted_List__item__id_tab,
        ____E_RABs_Admitted_List__item__id_tab_val_Value_0,
        __E_RABs_Admitted_List__item__id,
        __E_RABs_Admitted_List__item__criticality,
        __E_RABs_Admitted_List__item__value,
        _E_RABs_Admitted_List__item_,
        E_RABs_Admitted_List,
        E_RABs_Admitted_ItemIEs,
        _E_RABs_Admitted_ItemIEs_val_Value_0,
        _E_RABs_Admitted_Item_e_RAB_ID,
        _E_RABs_Admitted_Item_uL_GTP_TunnelEndpoint,
        _E_RABs_Admitted_Item_dL_GTP_TunnelEndpoint,
        ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_Item_iE_Extensions__item__id,
        ___E_RABs_Admitted_Item_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_Item_iE_Extensions__item_,
        _E_RABs_Admitted_Item_iE_Extensions,
        E_RABs_Admitted_Item,
        E_RABs_Admitted_Item_ExtIEs,
        ____HandoverPreparationFailure_protocolIEs__item__id_tab,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverPreparationFailure_protocolIEs__item__id,
        ___HandoverPreparationFailure_protocolIEs__item__criticality,
        ___HandoverPreparationFailure_protocolIEs__item__value,
        __HandoverPreparationFailure_protocolIEs__item_,
        _HandoverPreparationFailure_protocolIEs,
        HandoverPreparationFailure,
        HandoverPreparationFailure_IEs,
        _HandoverPreparationFailure_IEs_val_Value_0,
        _HandoverPreparationFailure_IEs_val_Value_1,
        _HandoverPreparationFailure_IEs_val_Value_2,
        _HandoverPreparationFailure_IEs_val_Value_3,
        ____HandoverReport_protocolIEs__item__id_tab,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_9,
        ___HandoverReport_protocolIEs__item__id,
        ___HandoverReport_protocolIEs__item__criticality,
        ___HandoverReport_protocolIEs__item__value,
        __HandoverReport_protocolIEs__item_,
        _HandoverReport_protocolIEs,
        HandoverReport,
        HandoverReport_IEs,
        _HandoverReport_IEs_val_Value_0,
        _HandoverReport_IEs_val_Value_1,
        _HandoverReport_IEs_val_Value_2,
        _HandoverReport_IEs_val_Value_3,
        _HandoverReport_IEs_val_Value_4,
        _HandoverReport_IEs_val_Value_5,
        _HandoverReport_IEs_val_Value_6,
        _HandoverReport_IEs_val_Value_7,
        _HandoverReport_IEs_val_Value_8,
        _HandoverReport_IEs_val_Value_9,
        ____SNStatusTransfer_protocolIEs__item__id_tab,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_4,
        ___SNStatusTransfer_protocolIEs__item__id,
        ___SNStatusTransfer_protocolIEs__item__criticality,
        ___SNStatusTransfer_protocolIEs__item__value,
        __SNStatusTransfer_protocolIEs__item_,
        _SNStatusTransfer_protocolIEs,
        SNStatusTransfer,
        SNStatusTransfer_IEs,
        _SNStatusTransfer_IEs_val_Value_0,
        _SNStatusTransfer_IEs_val_Value_1,
        _SNStatusTransfer_IEs_val_Value_2,
        _SNStatusTransfer_IEs_val_Value_3,
        _SNStatusTransfer_IEs_val_Value_4,
        ___E_RABs_SubjectToStatusTransfer_List__item__id_tab,
        ____E_RABs_SubjectToStatusTransfer_List__item__id_tab_val_Value_0,
        __E_RABs_SubjectToStatusTransfer_List__item__id,
        __E_RABs_SubjectToStatusTransfer_List__item__criticality,
        __E_RABs_SubjectToStatusTransfer_List__item__value,
        _E_RABs_SubjectToStatusTransfer_List__item_,
        E_RABs_SubjectToStatusTransfer_List,
        E_RABs_SubjectToStatusTransfer_ItemIEs,
        _E_RABs_SubjectToStatusTransfer_ItemIEs_val_Value_0,
        _E_RABs_SubjectToStatusTransfer_Item_e_RAB_ID,
        _E_RABs_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs,
        _E_RABs_SubjectToStatusTransfer_Item_uL_COUNTvalue,
        _E_RABs_SubjectToStatusTransfer_Item_dL_COUNTvalue,
        ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id,
        ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality,
        ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue,
        __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_,
        _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions,
        E_RABs_SubjectToStatusTransfer_Item,
        E_RABs_SubjectToStatusTransfer_ItemExtIEs,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5,
        ____UEContextRelease_protocolIEs__item__id_tab,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextRelease_protocolIEs__item__id,
        ___UEContextRelease_protocolIEs__item__criticality,
        ___UEContextRelease_protocolIEs__item__value,
        __UEContextRelease_protocolIEs__item_,
        _UEContextRelease_protocolIEs,
        UEContextRelease,
        UEContextRelease_IEs,
        _UEContextRelease_IEs_val_Value_0,
        _UEContextRelease_IEs_val_Value_1,
        _UEContextRelease_IEs_val_Value_2,
        _UEContextRelease_IEs_val_Value_3,
        _UEContextRelease_IEs_val_Value_4,
        ____HandoverCancel_protocolIEs__item__id_tab,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_4,
        ___HandoverCancel_protocolIEs__item__id,
        ___HandoverCancel_protocolIEs__item__criticality,
        ___HandoverCancel_protocolIEs__item__value,
        __HandoverCancel_protocolIEs__item_,
        _HandoverCancel_protocolIEs,
        HandoverCancel,
        HandoverCancel_IEs,
        _HandoverCancel_IEs_val_Value_0,
        _HandoverCancel_IEs_val_Value_1,
        _HandoverCancel_IEs_val_Value_2,
        _HandoverCancel_IEs_val_Value_3,
        _HandoverCancel_IEs_val_Value_4,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        _ErrorIndication_IEs_val_Value_2,
        _ErrorIndication_IEs_val_Value_3,
        _ErrorIndication_IEs_val_Value_4,
        _ErrorIndication_IEs_val_Value_5,
        ____ResetRequest_protocolIEs__item__id_tab,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_0,
        ___ResetRequest_protocolIEs__item__id,
        ___ResetRequest_protocolIEs__item__criticality,
        ___ResetRequest_protocolIEs__item__value,
        __ResetRequest_protocolIEs__item_,
        _ResetRequest_protocolIEs,
        ResetRequest,
        ResetRequest_IEs,
        _ResetRequest_IEs_val_Value_0,
        ____ResetResponse_protocolIEs__item__id_tab,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_0,
        ___ResetResponse_protocolIEs__item__id,
        ___ResetResponse_protocolIEs__item__criticality,
        ___ResetResponse_protocolIEs__item__value,
        __ResetResponse_protocolIEs__item_,
        _ResetResponse_protocolIEs,
        ResetResponse,
        ResetResponse_IEs,
        _ResetResponse_IEs_val_Value_0,
        ____X2SetupRequest_protocolIEs__item__id_tab,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___X2SetupRequest_protocolIEs__item__id,
        ___X2SetupRequest_protocolIEs__item__criticality,
        ___X2SetupRequest_protocolIEs__item__value,
        __X2SetupRequest_protocolIEs__item_,
        _X2SetupRequest_protocolIEs,
        X2SetupRequest,
        X2SetupRequest_IEs,
        _X2SetupRequest_IEs_val_Value_0,
        _X2SetupRequest_IEs_val_Value_1,
        _X2SetupRequest_IEs_val_Value_2,
        _X2SetupRequest_IEs_val_Value_3,
        ____X2SetupResponse_protocolIEs__item__id_tab,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___X2SetupResponse_protocolIEs__item__id,
        ___X2SetupResponse_protocolIEs__item__criticality,
        ___X2SetupResponse_protocolIEs__item__value,
        __X2SetupResponse_protocolIEs__item_,
        _X2SetupResponse_protocolIEs,
        X2SetupResponse,
        X2SetupResponse_IEs,
        _X2SetupResponse_IEs_val_Value_0,
        _X2SetupResponse_IEs_val_Value_1,
        _X2SetupResponse_IEs_val_Value_2,
        _X2SetupResponse_IEs_val_Value_3,
        _X2SetupResponse_IEs_val_Value_4,
        ____X2SetupFailure_protocolIEs__item__id_tab,
        _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___X2SetupFailure_protocolIEs__item__id,
        ___X2SetupFailure_protocolIEs__item__criticality,
        ___X2SetupFailure_protocolIEs__item__value,
        __X2SetupFailure_protocolIEs__item_,
        _X2SetupFailure_protocolIEs,
        X2SetupFailure,
        X2SetupFailure_IEs,
        _X2SetupFailure_IEs_val_Value_0,
        _X2SetupFailure_IEs_val_Value_1,
        _X2SetupFailure_IEs_val_Value_2,
        ____LoadInformation_protocolIEs__item__id_tab,
        _____LoadInformation_protocolIEs__item__id_tab_val_Value_0,
        ___LoadInformation_protocolIEs__item__id,
        ___LoadInformation_protocolIEs__item__criticality,
        ___LoadInformation_protocolIEs__item__value,
        __LoadInformation_protocolIEs__item_,
        _LoadInformation_protocolIEs,
        LoadInformation,
        LoadInformation_IEs,
        _LoadInformation_IEs_val_Value_0,
        ___CellInformation_List__item__id_tab,
        ____CellInformation_List__item__id_tab_val_Value_0,
        __CellInformation_List__item__id,
        __CellInformation_List__item__criticality,
        __CellInformation_List__item__value,
        _CellInformation_List__item_,
        CellInformation_List,
        CellInformation_ItemIEs,
        _CellInformation_ItemIEs_val_Value_0,
        _CellInformation_Item_cell_ID,
        _CellInformation_Item_ul_InterferenceOverloadIndication,
        _CellInformation_Item_ul_HighInterferenceIndicationInfo,
        _CellInformation_Item_relativeNarrowbandTxPower,
        ____CellInformation_Item_iE_Extensions__item__id_tab,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___CellInformation_Item_iE_Extensions__item__id,
        ___CellInformation_Item_iE_Extensions__item__criticality,
        ___CellInformation_Item_iE_Extensions__item__extensionValue,
        __CellInformation_Item_iE_Extensions__item_,
        _CellInformation_Item_iE_Extensions,
        CellInformation_Item,
        CellInformation_Item_ExtIEs,
        _CellInformation_Item_ExtIEs_val_Extension_0,
        _CellInformation_Item_ExtIEs_val_Extension_1,
        _CellInformation_Item_ExtIEs_val_Extension_2,
        _CellInformation_Item_ExtIEs_val_Extension_3,
        _CellInformation_Item_ExtIEs_val_Extension_4,
        _CellInformation_Item_ExtIEs_val_Extension_5,
        ____ENBConfigurationUpdate_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___ENBConfigurationUpdate_protocolIEs__item__id,
        ___ENBConfigurationUpdate_protocolIEs__item__criticality,
        ___ENBConfigurationUpdate_protocolIEs__item__value,
        __ENBConfigurationUpdate_protocolIEs__item_,
        _ENBConfigurationUpdate_protocolIEs,
        ENBConfigurationUpdate,
        ENBConfigurationUpdate_IEs,
        _ENBConfigurationUpdate_IEs_val_Value_0,
        _ENBConfigurationUpdate_IEs_val_Value_1,
        _ENBConfigurationUpdate_IEs_val_Value_2,
        _ENBConfigurationUpdate_IEs_val_Value_3,
        _ENBConfigurationUpdate_IEs_val_Value_4,
        _ENBConfigurationUpdate_IEs_val_Value_5,
        _ServedCellsToModify__item_,
        ServedCellsToModify,
        _ServedCellsToModify_Item_old_ecgi,
        _ServedCellsToModify_Item_servedCellInfo,
        _ServedCellsToModify_Item_neighbour_Info,
        ____ServedCellsToModify_Item_iE_Extensions__item__id_tab,
        _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___ServedCellsToModify_Item_iE_Extensions__item__id,
        ___ServedCellsToModify_Item_iE_Extensions__item__criticality,
        ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue,
        __ServedCellsToModify_Item_iE_Extensions__item_,
        _ServedCellsToModify_Item_iE_Extensions,
        ServedCellsToModify_Item,
        ServedCellsToModify_Item_ExtIEs,
        _ServedCellsToModify_Item_ExtIEs_val_Extension_0,
        _Old_ECGIs__item_,
        Old_ECGIs,
        ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __ENBConfigurationUpdateAcknowledge_protocolIEs__item_,
        _ENBConfigurationUpdateAcknowledge_protocolIEs,
        ENBConfigurationUpdateAcknowledge,
        ENBConfigurationUpdateAcknowledge_IEs,
        _ENBConfigurationUpdateAcknowledge_IEs_val_Value_0,
        ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__id,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__value,
        __ENBConfigurationUpdateFailure_protocolIEs__item_,
        _ENBConfigurationUpdateFailure_protocolIEs,
        ENBConfigurationUpdateFailure,
        ENBConfigurationUpdateFailure_IEs,
        _ENBConfigurationUpdateFailure_IEs_val_Value_0,
        _ENBConfigurationUpdateFailure_IEs_val_Value_1,
        _ENBConfigurationUpdateFailure_IEs_val_Value_2,
        ____ResourceStatusRequest_protocolIEs__item__id_tab,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_8,
        ___ResourceStatusRequest_protocolIEs__item__id,
        ___ResourceStatusRequest_protocolIEs__item__criticality,
        ___ResourceStatusRequest_protocolIEs__item__value,
        __ResourceStatusRequest_protocolIEs__item_,
        _ResourceStatusRequest_protocolIEs,
        ResourceStatusRequest,
        ResourceStatusRequest_IEs,
        _ResourceStatusRequest_IEs_val_Value_0,
        _ResourceStatusRequest_IEs_val_Value_1,
        _ResourceStatusRequest_IEs_val_Value_2,
        _ResourceStatusRequest_IEs_val_Value_3,
        _ResourceStatusRequest_IEs_val_Value_4,
        _ResourceStatusRequest_IEs_val_Value_5,
        _ResourceStatusRequest_IEs_val_Value_6,
        _ResourceStatusRequest_IEs_val_Value_7,
        _ResourceStatusRequest_IEs_val_Value_8,
        ___CellToReport_List__item__id_tab,
        ____CellToReport_List__item__id_tab_val_Value_0,
        __CellToReport_List__item__id,
        __CellToReport_List__item__criticality,
        __CellToReport_List__item__value,
        _CellToReport_List__item_,
        CellToReport_List,
        CellToReport_ItemIEs,
        _CellToReport_ItemIEs_val_Value_0,
        _CellToReport_Item_cell_ID,
        ____CellToReport_Item_iE_Extensions__item__id_tab,
        ___CellToReport_Item_iE_Extensions__item__id,
        ___CellToReport_Item_iE_Extensions__item__criticality,
        ___CellToReport_Item_iE_Extensions__item__extensionValue,
        __CellToReport_Item_iE_Extensions__item_,
        _CellToReport_Item_iE_Extensions,
        CellToReport_Item,
        CellToReport_Item_ExtIEs,
        ReportingPeriodicity,
        PartialSuccessIndicator,
        ____ResourceStatusResponse_protocolIEs__item__id_tab,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ResourceStatusResponse_protocolIEs__item__id,
        ___ResourceStatusResponse_protocolIEs__item__criticality,
        ___ResourceStatusResponse_protocolIEs__item__value,
        __ResourceStatusResponse_protocolIEs__item_,
        _ResourceStatusResponse_protocolIEs,
        ResourceStatusResponse,
        ResourceStatusResponse_IEs,
        _ResourceStatusResponse_IEs_val_Value_0,
        _ResourceStatusResponse_IEs_val_Value_1,
        _ResourceStatusResponse_IEs_val_Value_2,
        _ResourceStatusResponse_IEs_val_Value_3,
        ___MeasurementInitiationResult_List__item__id_tab,
        ____MeasurementInitiationResult_List__item__id_tab_val_Value_0,
        __MeasurementInitiationResult_List__item__id,
        __MeasurementInitiationResult_List__item__criticality,
        __MeasurementInitiationResult_List__item__value,
        _MeasurementInitiationResult_List__item_,
        MeasurementInitiationResult_List,
        MeasurementInitiationResult_ItemIEs,
        _MeasurementInitiationResult_ItemIEs_val_Value_0,
        _MeasurementInitiationResult_Item_cell_ID,
        _MeasurementInitiationResult_Item_measurementFailureCause_List,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__id,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue,
        __MeasurementInitiationResult_Item_iE_Extensions__item_,
        _MeasurementInitiationResult_Item_iE_Extensions,
        MeasurementInitiationResult_Item,
        MeasurementInitiationResult_Item_ExtIEs,
        ___MeasurementFailureCause_List__item__id_tab,
        ____MeasurementFailureCause_List__item__id_tab_val_Value_0,
        __MeasurementFailureCause_List__item__id,
        __MeasurementFailureCause_List__item__criticality,
        __MeasurementFailureCause_List__item__value,
        _MeasurementFailureCause_List__item_,
        MeasurementFailureCause_List,
        MeasurementFailureCause_ItemIEs,
        _MeasurementFailureCause_ItemIEs_val_Value_0,
        _MeasurementFailureCause_Item_measurementFailedReportCharacteristics,
        _MeasurementFailureCause_Item_cause,
        ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__id,
        ___MeasurementFailureCause_Item_iE_Extensions__item__criticality,
        ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue,
        __MeasurementFailureCause_Item_iE_Extensions__item_,
        _MeasurementFailureCause_Item_iE_Extensions,
        MeasurementFailureCause_Item,
        MeasurementFailureCause_Item_ExtIEs,
        ____ResourceStatusFailure_protocolIEs__item__id_tab,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ResourceStatusFailure_protocolIEs__item__id,
        ___ResourceStatusFailure_protocolIEs__item__criticality,
        ___ResourceStatusFailure_protocolIEs__item__value,
        __ResourceStatusFailure_protocolIEs__item_,
        _ResourceStatusFailure_protocolIEs,
        ResourceStatusFailure,
        ResourceStatusFailure_IEs,
        _ResourceStatusFailure_IEs_val_Value_0,
        _ResourceStatusFailure_IEs_val_Value_1,
        _ResourceStatusFailure_IEs_val_Value_2,
        _ResourceStatusFailure_IEs_val_Value_3,
        _ResourceStatusFailure_IEs_val_Value_4,
        ___CompleteFailureCauseInformation_List__item__id_tab,
        ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0,
        __CompleteFailureCauseInformation_List__item__id,
        __CompleteFailureCauseInformation_List__item__criticality,
        __CompleteFailureCauseInformation_List__item__value,
        _CompleteFailureCauseInformation_List__item_,
        CompleteFailureCauseInformation_List,
        CompleteFailureCauseInformation_ItemIEs,
        _CompleteFailureCauseInformation_ItemIEs_val_Value_0,
        _CompleteFailureCauseInformation_Item_cell_ID,
        _CompleteFailureCauseInformation_Item_measurementFailureCause_List,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue,
        __CompleteFailureCauseInformation_Item_iE_Extensions__item_,
        _CompleteFailureCauseInformation_Item_iE_Extensions,
        CompleteFailureCauseInformation_Item,
        CompleteFailureCauseInformation_Item_ExtIEs,
        ____ResourceStatusUpdate_protocolIEs__item__id_tab,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2,
        ___ResourceStatusUpdate_protocolIEs__item__id,
        ___ResourceStatusUpdate_protocolIEs__item__criticality,
        ___ResourceStatusUpdate_protocolIEs__item__value,
        __ResourceStatusUpdate_protocolIEs__item_,
        _ResourceStatusUpdate_protocolIEs,
        ResourceStatusUpdate,
        ResourceStatusUpdate_IEs,
        _ResourceStatusUpdate_IEs_val_Value_0,
        _ResourceStatusUpdate_IEs_val_Value_1,
        _ResourceStatusUpdate_IEs_val_Value_2,
        ___CellMeasurementResult_List__item__id_tab,
        ____CellMeasurementResult_List__item__id_tab_val_Value_0,
        __CellMeasurementResult_List__item__id,
        __CellMeasurementResult_List__item__criticality,
        __CellMeasurementResult_List__item__value,
        _CellMeasurementResult_List__item_,
        CellMeasurementResult_List,
        CellMeasurementResult_ItemIEs,
        _CellMeasurementResult_ItemIEs_val_Value_0,
        _CellMeasurementResult_Item_cell_ID,
        _CellMeasurementResult_Item_hWLoadIndicator,
        _CellMeasurementResult_Item_s1TNLLoadIndicator,
        _CellMeasurementResult_Item_radioResourceStatus,
        ____CellMeasurementResult_Item_iE_Extensions__item__id_tab,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_4,
        ___CellMeasurementResult_Item_iE_Extensions__item__id,
        ___CellMeasurementResult_Item_iE_Extensions__item__criticality,
        ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue,
        __CellMeasurementResult_Item_iE_Extensions__item_,
        _CellMeasurementResult_Item_iE_Extensions,
        CellMeasurementResult_Item,
        CellMeasurementResult_Item_ExtIEs,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_0,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_1,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_2,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_3,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_4,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ___PrivateMessage_privateIEs__item__criticality,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____MobilityChangeRequest_protocolIEs__item__id_tab,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_4,
        ___MobilityChangeRequest_protocolIEs__item__id,
        ___MobilityChangeRequest_protocolIEs__item__criticality,
        ___MobilityChangeRequest_protocolIEs__item__value,
        __MobilityChangeRequest_protocolIEs__item_,
        _MobilityChangeRequest_protocolIEs,
        MobilityChangeRequest,
        MobilityChangeRequest_IEs,
        _MobilityChangeRequest_IEs_val_Value_0,
        _MobilityChangeRequest_IEs_val_Value_1,
        _MobilityChangeRequest_IEs_val_Value_2,
        _MobilityChangeRequest_IEs_val_Value_3,
        _MobilityChangeRequest_IEs_val_Value_4,
        ____MobilityChangeAcknowledge_protocolIEs__item__id_tab,
        _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___MobilityChangeAcknowledge_protocolIEs__item__id,
        ___MobilityChangeAcknowledge_protocolIEs__item__criticality,
        ___MobilityChangeAcknowledge_protocolIEs__item__value,
        __MobilityChangeAcknowledge_protocolIEs__item_,
        _MobilityChangeAcknowledge_protocolIEs,
        MobilityChangeAcknowledge,
        MobilityChangeAcknowledge_IEs,
        _MobilityChangeAcknowledge_IEs_val_Value_0,
        _MobilityChangeAcknowledge_IEs_val_Value_1,
        _MobilityChangeAcknowledge_IEs_val_Value_2,
        ____MobilityChangeFailure_protocolIEs__item__id_tab,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_3,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_4,
        ___MobilityChangeFailure_protocolIEs__item__id,
        ___MobilityChangeFailure_protocolIEs__item__criticality,
        ___MobilityChangeFailure_protocolIEs__item__value,
        __MobilityChangeFailure_protocolIEs__item_,
        _MobilityChangeFailure_protocolIEs,
        MobilityChangeFailure,
        MobilityChangeFailure_IEs,
        _MobilityChangeFailure_IEs_val_Value_0,
        _MobilityChangeFailure_IEs_val_Value_1,
        _MobilityChangeFailure_IEs_val_Value_2,
        _MobilityChangeFailure_IEs_val_Value_3,
        _MobilityChangeFailure_IEs_val_Value_4,
        ____RLFIndication_protocolIEs__item__id_tab,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_1,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_2,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_3,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_4,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_5,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_6,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_7,
        ___RLFIndication_protocolIEs__item__id,
        ___RLFIndication_protocolIEs__item__criticality,
        ___RLFIndication_protocolIEs__item__value,
        __RLFIndication_protocolIEs__item_,
        _RLFIndication_protocolIEs,
        RLFIndication,
        RLFIndication_IEs,
        _RLFIndication_IEs_val_Value_0,
        _RLFIndication_IEs_val_Value_1,
        _RLFIndication_IEs_val_Value_2,
        _RLFIndication_IEs_val_Value_3,
        _RLFIndication_IEs_val_Value_4,
        _RLFIndication_IEs_val_Value_5,
        _RLFIndication_IEs_val_Value_6,
        _RLFIndication_IEs_val_Value_7,
        ____CellActivationRequest_protocolIEs__item__id_tab,
        _____CellActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___CellActivationRequest_protocolIEs__item__id,
        ___CellActivationRequest_protocolIEs__item__criticality,
        ___CellActivationRequest_protocolIEs__item__value,
        __CellActivationRequest_protocolIEs__item_,
        _CellActivationRequest_protocolIEs,
        CellActivationRequest,
        CellActivationRequest_IEs,
        _CellActivationRequest_IEs_val_Value_0,
        _ServedCellsToActivate__item_,
        ServedCellsToActivate,
        _ServedCellsToActivate_Item_ecgi,
        ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab,
        ___ServedCellsToActivate_Item_iE_Extensions__item__id,
        ___ServedCellsToActivate_Item_iE_Extensions__item__criticality,
        ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue,
        __ServedCellsToActivate_Item_iE_Extensions__item_,
        _ServedCellsToActivate_Item_iE_Extensions,
        ServedCellsToActivate_Item,
        ServedCellsToActivate_Item_ExtIEs,
        ____CellActivationResponse_protocolIEs__item__id_tab,
        _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___CellActivationResponse_protocolIEs__item__id,
        ___CellActivationResponse_protocolIEs__item__criticality,
        ___CellActivationResponse_protocolIEs__item__value,
        __CellActivationResponse_protocolIEs__item_,
        _CellActivationResponse_protocolIEs,
        CellActivationResponse,
        CellActivationResponse_IEs,
        _CellActivationResponse_IEs_val_Value_0,
        _CellActivationResponse_IEs_val_Value_1,
        _ActivatedCellList__item_,
        ActivatedCellList,
        _ActivatedCellList_Item_ecgi,
        ____ActivatedCellList_Item_iE_Extensions__item__id_tab,
        ___ActivatedCellList_Item_iE_Extensions__item__id,
        ___ActivatedCellList_Item_iE_Extensions__item__criticality,
        ___ActivatedCellList_Item_iE_Extensions__item__extensionValue,
        __ActivatedCellList_Item_iE_Extensions__item_,
        _ActivatedCellList_Item_iE_Extensions,
        ActivatedCellList_Item,
        ActivatedCellList_Item_ExtIEs,
        ____CellActivationFailure_protocolIEs__item__id_tab,
        _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___CellActivationFailure_protocolIEs__item__id,
        ___CellActivationFailure_protocolIEs__item__criticality,
        ___CellActivationFailure_protocolIEs__item__value,
        __CellActivationFailure_protocolIEs__item_,
        _CellActivationFailure_protocolIEs,
        CellActivationFailure,
        CellActivationFailure_IEs,
        _CellActivationFailure_IEs_val_Value_0,
        _CellActivationFailure_IEs_val_Value_1,
        ____X2Release_protocolIEs__item__id_tab,
        _____X2Release_protocolIEs__item__id_tab_val_Value_0,
        ___X2Release_protocolIEs__item__id,
        ___X2Release_protocolIEs__item__criticality,
        ___X2Release_protocolIEs__item__value,
        __X2Release_protocolIEs__item_,
        _X2Release_protocolIEs,
        X2Release,
        X2Release_IEs,
        _X2Release_IEs_val_Value_0,
        ____X2APMessageTransfer_protocolIEs__item__id_tab,
        _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___X2APMessageTransfer_protocolIEs__item__id,
        ___X2APMessageTransfer_protocolIEs__item__criticality,
        ___X2APMessageTransfer_protocolIEs__item__value,
        __X2APMessageTransfer_protocolIEs__item_,
        _X2APMessageTransfer_protocolIEs,
        X2APMessageTransfer,
        X2APMessageTransfer_IEs,
        _X2APMessageTransfer_IEs_val_Value_0,
        _X2APMessageTransfer_IEs_val_Value_1,
        _RNL_Header_source_GlobalENB_ID,
        _RNL_Header_target_GlobalENB_ID,
        ____RNL_Header_iE_Extensions__item__id_tab,
        ___RNL_Header_iE_Extensions__item__id,
        ___RNL_Header_iE_Extensions__item__criticality,
        ___RNL_Header_iE_Extensions__item__extensionValue,
        __RNL_Header_iE_Extensions__item_,
        _RNL_Header_iE_Extensions,
        RNL_Header,
        RNL_Header_Item_ExtIEs,
        X2AP_Message,
        ____SeNBAdditionRequest_protocolIEs__item__id_tab,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11,
        ___SeNBAdditionRequest_protocolIEs__item__id,
        ___SeNBAdditionRequest_protocolIEs__item__criticality,
        ___SeNBAdditionRequest_protocolIEs__item__value,
        __SeNBAdditionRequest_protocolIEs__item_,
        _SeNBAdditionRequest_protocolIEs,
        SeNBAdditionRequest,
        SeNBAdditionRequest_IEs,
        _SeNBAdditionRequest_IEs_val_Value_0,
        _SeNBAdditionRequest_IEs_val_Value_1,
        _SeNBAdditionRequest_IEs_val_Value_2,
        _SeNBAdditionRequest_IEs_val_Value_3,
        _SeNBAdditionRequest_IEs_val_Value_4,
        _SeNBAdditionRequest_IEs_val_Value_5,
        _SeNBAdditionRequest_IEs_val_Value_6,
        _SeNBAdditionRequest_IEs_val_Value_7,
        _SeNBAdditionRequest_IEs_val_Value_8,
        _SeNBAdditionRequest_IEs_val_Value_9,
        _SeNBAdditionRequest_IEs_val_Value_10,
        _SeNBAdditionRequest_IEs_val_Value_11,
        ___E_RABs_ToBeAdded_List__item__id_tab,
        ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_List__item__id,
        __E_RABs_ToBeAdded_List__item__criticality,
        __E_RABs_ToBeAdded_List__item__value,
        _E_RABs_ToBeAdded_List__item_,
        E_RABs_ToBeAdded_List,
        E_RABs_ToBeAdded_ItemIEs,
        _E_RABs_ToBeAdded_ItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_Item_sCG_Bearer,
        _E_RABs_ToBeAdded_Item_split_Bearer,
        E_RABs_ToBeAdded_Item,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_dL_Forwarding,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_Item_SCG_Bearer,
        E_RABs_ToBeAdded_Item_SCG_BearerExtIEs,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_Item_Split_Bearer_meNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_Item_Split_Bearer,
        E_RABs_ToBeAdded_Item_Split_BearerExtIEs,
        ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id,
        ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality,
        ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value,
        __SeNBAdditionRequestAcknowledge_protocolIEs__item_,
        _SeNBAdditionRequestAcknowledge_protocolIEs,
        SeNBAdditionRequestAcknowledge,
        SeNBAdditionRequestAcknowledge_IEs,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_0,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_1,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_2,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_3,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_4,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_5,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_6,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_7,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_8,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_9,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_10,
        ___E_RABs_Admitted_ToBeAdded_List__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_List__item__id,
        __E_RABs_Admitted_ToBeAdded_List__item__criticality,
        __E_RABs_Admitted_ToBeAdded_List__item__value,
        _E_RABs_Admitted_ToBeAdded_List__item_,
        E_RABs_Admitted_ToBeAdded_List,
        E_RABs_Admitted_ToBeAdded_ItemIEs,
        _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_Item_sCG_Bearer,
        _E_RABs_Admitted_ToBeAdded_Item_split_Bearer,
        E_RABs_Admitted_ToBeAdded_Item,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer,
        E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_seNB_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_Item_Split_Bearer,
        E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs,
        ____SeNBAdditionRequestReject_protocolIEs__item__id_tab,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBAdditionRequestReject_protocolIEs__item__id,
        ___SeNBAdditionRequestReject_protocolIEs__item__criticality,
        ___SeNBAdditionRequestReject_protocolIEs__item__value,
        __SeNBAdditionRequestReject_protocolIEs__item_,
        _SeNBAdditionRequestReject_protocolIEs,
        SeNBAdditionRequestReject,
        SeNBAdditionRequestReject_IEs,
        _SeNBAdditionRequestReject_IEs_val_Value_0,
        _SeNBAdditionRequestReject_IEs_val_Value_1,
        _SeNBAdditionRequestReject_IEs_val_Value_2,
        _SeNBAdditionRequestReject_IEs_val_Value_3,
        _SeNBAdditionRequestReject_IEs_val_Value_4,
        _SeNBAdditionRequestReject_IEs_val_Value_5,
        ____SeNBReconfigurationComplete_protocolIEs__item__id_tab,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_4,
        ___SeNBReconfigurationComplete_protocolIEs__item__id,
        ___SeNBReconfigurationComplete_protocolIEs__item__criticality,
        ___SeNBReconfigurationComplete_protocolIEs__item__value,
        __SeNBReconfigurationComplete_protocolIEs__item_,
        _SeNBReconfigurationComplete_protocolIEs,
        SeNBReconfigurationComplete,
        SeNBReconfigurationComplete_IEs,
        _SeNBReconfigurationComplete_IEs_val_Value_0,
        _SeNBReconfigurationComplete_IEs_val_Value_1,
        _SeNBReconfigurationComplete_IEs_val_Value_2,
        _SeNBReconfigurationComplete_IEs_val_Value_3,
        _SeNBReconfigurationComplete_IEs_val_Value_4,
        _ResponseInformationSeNBReconfComp_success,
        _ResponseInformationSeNBReconfComp_reject_by_MeNB,
        ResponseInformationSeNBReconfComp,
        _ResponseInformationSeNBReconfComp_SuccessItem_meNBtoSeNBContainer,
        ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab,
        ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id,
        ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality,
        ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue,
        __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_,
        _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions,
        ResponseInformationSeNBReconfComp_SuccessItem,
        ResponseInformationSeNBReconfComp_SuccessItemExtIEs,
        _ResponseInformationSeNBReconfComp_RejectByMeNBItem_cause,
        _ResponseInformationSeNBReconfComp_RejectByMeNBItem_meNBtoSeNBContainer,
        ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab,
        ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id,
        ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality,
        ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue,
        __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_,
        _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions,
        ResponseInformationSeNBReconfComp_RejectByMeNBItem,
        ResponseInformationSeNBReconfComp_RejectByMeNBItemExtIEs,
        ____SeNBModificationRequest_protocolIEs__item__id_tab,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        ___SeNBModificationRequest_protocolIEs__item__id,
        ___SeNBModificationRequest_protocolIEs__item__criticality,
        ___SeNBModificationRequest_protocolIEs__item__value,
        __SeNBModificationRequest_protocolIEs__item_,
        _SeNBModificationRequest_protocolIEs,
        SeNBModificationRequest,
        SeNBModificationRequest_IEs,
        _SeNBModificationRequest_IEs_val_Value_0,
        _SeNBModificationRequest_IEs_val_Value_1,
        _SeNBModificationRequest_IEs_val_Value_2,
        _SeNBModificationRequest_IEs_val_Value_3,
        _SeNBModificationRequest_IEs_val_Value_4,
        _SeNBModificationRequest_IEs_val_Value_5,
        _SeNBModificationRequest_IEs_val_Value_6,
        _SeNBModificationRequest_IEs_val_Value_7,
        _SeNBModificationRequest_IEs_val_Value_8,
        _SeNBModificationRequest_IEs_val_Value_9,
        _UE_ContextInformationSeNBModReq_uE_SecurityCapabilities,
        _UE_ContextInformationSeNBModReq_seNB_SecurityKey,
        _UE_ContextInformationSeNBModReq_seNBUEAggregateMaximumBitRate,
        _UE_ContextInformationSeNBModReq_e_RABs_ToBeAdded,
        _UE_ContextInformationSeNBModReq_e_RABs_ToBeModified,
        _UE_ContextInformationSeNBModReq_e_RABs_ToBeReleased,
        ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab,
        ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id,
        ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality,
        ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue,
        __UE_ContextInformationSeNBModReq_iE_Extensions__item_,
        _UE_ContextInformationSeNBModReq_iE_Extensions,
        UE_ContextInformationSeNBModReq,
        UE_ContextInformationSeNBModReqExtIEs,
        ___E_RABs_ToBeAdded_List_ModReq__item__id_tab,
        ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_List_ModReq__item__id,
        __E_RABs_ToBeAdded_List_ModReq__item__criticality,
        __E_RABs_ToBeAdded_List_ModReq__item__value,
        _E_RABs_ToBeAdded_List_ModReq__item_,
        E_RABs_ToBeAdded_List_ModReq,
        E_RABs_ToBeAdded_ModReqItemIEs,
        _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_ModReqItem_sCG_Bearer,
        _E_RABs_ToBeAdded_ModReqItem_split_Bearer,
        E_RABs_ToBeAdded_ModReqItem,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_dL_Forwarding,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_ModReqItem_SCG_Bearer,
        E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_ModReqItem_Split_Bearer,
        E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs,
        ___E_RABs_ToBeModified_List_ModReq__item__id_tab,
        ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeModified_List_ModReq__item__id,
        __E_RABs_ToBeModified_List_ModReq__item__criticality,
        __E_RABs_ToBeModified_List_ModReq__item__value,
        _E_RABs_ToBeModified_List_ModReq__item_,
        E_RABs_ToBeModified_List_ModReq,
        E_RABs_ToBeModified_ModReqItemIEs,
        _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeModified_ModReqItem_sCG_Bearer,
        _E_RABs_ToBeModified_ModReqItem_split_Bearer,
        E_RABs_ToBeModified_ModReqItem,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeModified_ModReqItem_SCG_Bearer,
        E_RABs_ToBeModified_ModReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeModified_ModReqItem_Split_Bearer,
        E_RABs_ToBeModified_ModReqItem_Split_BearerExtIEs,
        ___E_RABs_ToBeReleased_List_ModReq__item__id_tab,
        ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_ModReq__item__id,
        __E_RABs_ToBeReleased_List_ModReq__item__criticality,
        __E_RABs_ToBeReleased_List_ModReq__item__value,
        _E_RABs_ToBeReleased_List_ModReq__item_,
        E_RABs_ToBeReleased_List_ModReq,
        E_RABs_ToBeReleased_ModReqItemIEs,
        _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_ModReqItem_sCG_Bearer,
        _E_RABs_ToBeReleased_ModReqItem_split_Bearer,
        E_RABs_ToBeReleased_ModReqItem,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_dL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_uL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_ModReqItem_SCG_Bearer,
        E_RABs_ToBeReleased_ModReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_ModReqItem_Split_Bearer,
        E_RABs_ToBeReleased_ModReqItem_Split_BearerExtIEs,
        ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        ___SeNBModificationRequestAcknowledge_protocolIEs__item__id,
        ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality,
        ___SeNBModificationRequestAcknowledge_protocolIEs__item__value,
        __SeNBModificationRequestAcknowledge_protocolIEs__item_,
        _SeNBModificationRequestAcknowledge_protocolIEs,
        SeNBModificationRequestAcknowledge,
        SeNBModificationRequestAcknowledge_IEs,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_0,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_1,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_2,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_3,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_4,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_5,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_6,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_7,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_8,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_9,
        ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__id,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__value,
        _E_RABs_Admitted_ToBeAdded_ModAckList__item_,
        E_RABs_Admitted_ToBeAdded_ModAckList,
        E_RABs_Admitted_ToBeAdded_ModAckItemIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_sCG_Bearer,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_split_Bearer,
        E_RABs_Admitted_ToBeAdded_ModAckItem,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer,
        E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer,
        E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs,
        ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__id,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__value,
        _E_RABs_Admitted_ToBeModified_ModAckList__item_,
        E_RABs_Admitted_ToBeModified_ModAckList,
        E_RABs_Admitted_ToBeModified_ModAckItemIEs,
        _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeModified_ModAckItem_sCG_Bearer,
        _E_RABs_Admitted_ToBeModified_ModAckItem_split_Bearer,
        E_RABs_Admitted_ToBeModified_ModAckItem,
        _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer,
        E_RABs_Admitted_ToBeModified_ModAckItem_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer,
        E_RABs_Admitted_ToBeModified_ModAckItem_Split_BearerExtIEs,
        ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__id,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__value,
        _E_RABs_Admitted_ToBeReleased_ModAckList__item_,
        E_RABs_Admitted_ToBeReleased_ModAckList,
        E_RABs_Admitted_ToBeReleased_ModAckItemIEs,
        _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToReleased_ModAckItem_sCG_Bearer,
        _E_RABs_Admitted_ToReleased_ModAckItem_split_Bearer,
        E_RABs_Admitted_ToReleased_ModAckItem,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_e_RAB_ID,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer,
        E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_e_RAB_ID,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer,
        E_RABs_Admitted_ToBeReleased_ModAckItem_Split_BearerExtIEs,
        ____SeNBModificationRequestReject_protocolIEs__item__id_tab,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBModificationRequestReject_protocolIEs__item__id,
        ___SeNBModificationRequestReject_protocolIEs__item__criticality,
        ___SeNBModificationRequestReject_protocolIEs__item__value,
        __SeNBModificationRequestReject_protocolIEs__item_,
        _SeNBModificationRequestReject_protocolIEs,
        SeNBModificationRequestReject,
        SeNBModificationRequestReject_IEs,
        _SeNBModificationRequestReject_IEs_val_Value_0,
        _SeNBModificationRequestReject_IEs_val_Value_1,
        _SeNBModificationRequestReject_IEs_val_Value_2,
        _SeNBModificationRequestReject_IEs_val_Value_3,
        _SeNBModificationRequestReject_IEs_val_Value_4,
        _SeNBModificationRequestReject_IEs_val_Value_5,
        ____SeNBModificationRequired_protocolIEs__item__id_tab,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_7,
        ___SeNBModificationRequired_protocolIEs__item__id,
        ___SeNBModificationRequired_protocolIEs__item__criticality,
        ___SeNBModificationRequired_protocolIEs__item__value,
        __SeNBModificationRequired_protocolIEs__item_,
        _SeNBModificationRequired_protocolIEs,
        SeNBModificationRequired,
        SeNBModificationRequired_IEs,
        _SeNBModificationRequired_IEs_val_Value_0,
        _SeNBModificationRequired_IEs_val_Value_1,
        _SeNBModificationRequired_IEs_val_Value_2,
        _SeNBModificationRequired_IEs_val_Value_3,
        _SeNBModificationRequired_IEs_val_Value_4,
        _SeNBModificationRequired_IEs_val_Value_5,
        _SeNBModificationRequired_IEs_val_Value_6,
        _SeNBModificationRequired_IEs_val_Value_7,
        ___E_RABs_ToBeReleased_ModReqd__item__id_tab,
        ____E_RABs_ToBeReleased_ModReqd__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_ModReqd__item__id,
        __E_RABs_ToBeReleased_ModReqd__item__criticality,
        __E_RABs_ToBeReleased_ModReqd__item__value,
        _E_RABs_ToBeReleased_ModReqd__item_,
        E_RABs_ToBeReleased_ModReqd,
        E_RABs_ToBeReleased_ModReqdItemIEs,
        _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqdItem_cause,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions,
        E_RABs_ToBeReleased_ModReqdItem,
        E_RABs_ToBeReleased_ModReqdItemExtIEs,
        ____SeNBModificationConfirm_protocolIEs__item__id_tab,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBModificationConfirm_protocolIEs__item__id,
        ___SeNBModificationConfirm_protocolIEs__item__criticality,
        ___SeNBModificationConfirm_protocolIEs__item__value,
        __SeNBModificationConfirm_protocolIEs__item_,
        _SeNBModificationConfirm_protocolIEs,
        SeNBModificationConfirm,
        SeNBModificationConfirm_IEs,
        _SeNBModificationConfirm_IEs_val_Value_0,
        _SeNBModificationConfirm_IEs_val_Value_1,
        _SeNBModificationConfirm_IEs_val_Value_2,
        _SeNBModificationConfirm_IEs_val_Value_3,
        _SeNBModificationConfirm_IEs_val_Value_4,
        _SeNBModificationConfirm_IEs_val_Value_5,
        ____SeNBModificationRefuse_protocolIEs__item__id_tab,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_6,
        ___SeNBModificationRefuse_protocolIEs__item__id,
        ___SeNBModificationRefuse_protocolIEs__item__criticality,
        ___SeNBModificationRefuse_protocolIEs__item__value,
        __SeNBModificationRefuse_protocolIEs__item_,
        _SeNBModificationRefuse_protocolIEs,
        SeNBModificationRefuse,
        SeNBModificationRefuse_IEs,
        _SeNBModificationRefuse_IEs_val_Value_0,
        _SeNBModificationRefuse_IEs_val_Value_1,
        _SeNBModificationRefuse_IEs_val_Value_2,
        _SeNBModificationRefuse_IEs_val_Value_3,
        _SeNBModificationRefuse_IEs_val_Value_4,
        _SeNBModificationRefuse_IEs_val_Value_5,
        _SeNBModificationRefuse_IEs_val_Value_6,
        ____SeNBReleaseRequest_protocolIEs__item__id_tab,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6,
        ___SeNBReleaseRequest_protocolIEs__item__id,
        ___SeNBReleaseRequest_protocolIEs__item__criticality,
        ___SeNBReleaseRequest_protocolIEs__item__value,
        __SeNBReleaseRequest_protocolIEs__item_,
        _SeNBReleaseRequest_protocolIEs,
        SeNBReleaseRequest,
        SeNBReleaseRequest_IEs,
        _SeNBReleaseRequest_IEs_val_Value_0,
        _SeNBReleaseRequest_IEs_val_Value_1,
        _SeNBReleaseRequest_IEs_val_Value_2,
        _SeNBReleaseRequest_IEs_val_Value_3,
        _SeNBReleaseRequest_IEs_val_Value_4,
        _SeNBReleaseRequest_IEs_val_Value_5,
        _SeNBReleaseRequest_IEs_val_Value_6,
        ___E_RABs_ToBeReleased_List_RelReq__item__id_tab,
        ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_RelReq__item__id,
        __E_RABs_ToBeReleased_List_RelReq__item__criticality,
        __E_RABs_ToBeReleased_List_RelReq__item__value,
        _E_RABs_ToBeReleased_List_RelReq__item_,
        E_RABs_ToBeReleased_List_RelReq,
        E_RABs_ToBeReleased_RelReqItemIEs,
        _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_RelReqItem_sCG_Bearer,
        _E_RABs_ToBeReleased_RelReqItem_split_Bearer,
        E_RABs_ToBeReleased_RelReqItem,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_uL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelReqItem_SCG_Bearer,
        E_RABs_ToBeReleased_RelReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelReqItem_Split_Bearer,
        E_RABs_ToBeReleased_RelReqItem_Split_BearerExtIEs,
        ____SeNBReleaseRequired_protocolIEs__item__id_tab,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4,
        ___SeNBReleaseRequired_protocolIEs__item__id,
        ___SeNBReleaseRequired_protocolIEs__item__criticality,
        ___SeNBReleaseRequired_protocolIEs__item__value,
        __SeNBReleaseRequired_protocolIEs__item_,
        _SeNBReleaseRequired_protocolIEs,
        SeNBReleaseRequired,
        SeNBReleaseRequired_IEs,
        _SeNBReleaseRequired_IEs_val_Value_0,
        _SeNBReleaseRequired_IEs_val_Value_1,
        _SeNBReleaseRequired_IEs_val_Value_2,
        _SeNBReleaseRequired_IEs_val_Value_3,
        _SeNBReleaseRequired_IEs_val_Value_4,
        ____SeNBReleaseConfirm_protocolIEs__item__id_tab,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBReleaseConfirm_protocolIEs__item__id,
        ___SeNBReleaseConfirm_protocolIEs__item__criticality,
        ___SeNBReleaseConfirm_protocolIEs__item__value,
        __SeNBReleaseConfirm_protocolIEs__item_,
        _SeNBReleaseConfirm_protocolIEs,
        SeNBReleaseConfirm,
        SeNBReleaseConfirm_IEs,
        _SeNBReleaseConfirm_IEs_val_Value_0,
        _SeNBReleaseConfirm_IEs_val_Value_1,
        _SeNBReleaseConfirm_IEs_val_Value_2,
        _SeNBReleaseConfirm_IEs_val_Value_3,
        _SeNBReleaseConfirm_IEs_val_Value_4,
        _SeNBReleaseConfirm_IEs_val_Value_5,
        ___E_RABs_ToBeReleased_List_RelConf__item__id_tab,
        ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_RelConf__item__id,
        __E_RABs_ToBeReleased_List_RelConf__item__criticality,
        __E_RABs_ToBeReleased_List_RelConf__item__value,
        _E_RABs_ToBeReleased_List_RelConf__item_,
        E_RABs_ToBeReleased_List_RelConf,
        E_RABs_ToBeReleased_RelConfItemIEs,
        _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_RelConfItem_sCG_Bearer,
        _E_RABs_ToBeReleased_RelConfItem_split_Bearer,
        E_RABs_ToBeReleased_RelConfItem,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_uL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelConfItem_SCG_Bearer,
        E_RABs_ToBeReleased_RelConfItem_SCG_BearerExtIEs,
        _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelConfItem_Split_Bearer,
        E_RABs_ToBeReleased_RelConfItem_Split_BearerExtIEs,
        ____SeNBCounterCheckRequest_protocolIEs__item__id_tab,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_4,
        ___SeNBCounterCheckRequest_protocolIEs__item__id,
        ___SeNBCounterCheckRequest_protocolIEs__item__criticality,
        ___SeNBCounterCheckRequest_protocolIEs__item__value,
        __SeNBCounterCheckRequest_protocolIEs__item_,
        _SeNBCounterCheckRequest_protocolIEs,
        SeNBCounterCheckRequest,
        SeNBCounterCheckRequest_IEs,
        _SeNBCounterCheckRequest_IEs_val_Value_0,
        _SeNBCounterCheckRequest_IEs_val_Value_1,
        _SeNBCounterCheckRequest_IEs_val_Value_2,
        _SeNBCounterCheckRequest_IEs_val_Value_3,
        _SeNBCounterCheckRequest_IEs_val_Value_4,
        ___E_RABs_SubjectToCounterCheck_List__item__id_tab,
        ____E_RABs_SubjectToCounterCheck_List__item__id_tab_val_Value_0,
        __E_RABs_SubjectToCounterCheck_List__item__id,
        __E_RABs_SubjectToCounterCheck_List__item__criticality,
        __E_RABs_SubjectToCounterCheck_List__item__value,
        _E_RABs_SubjectToCounterCheck_List__item_,
        E_RABs_SubjectToCounterCheck_List,
        E_RABs_SubjectToCounterCheckItemIEs,
        _E_RABs_SubjectToCounterCheckItemIEs_val_Value_0,
        _E_RABs_SubjectToCounterCheckItem_e_RAB_ID,
        _E_RABs_SubjectToCounterCheckItem_uL_Count,
        _E_RABs_SubjectToCounterCheckItem_dL_Count,
        ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab,
        ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id,
        ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality,
        ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue,
        __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_,
        _E_RABs_SubjectToCounterCheckItem_iE_Extensions,
        E_RABs_SubjectToCounterCheckItem,
        E_RABs_SubjectToCounterCheckItemExtIEs,
        ____X2RemovalRequest_protocolIEs__item__id_tab,
        _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_0,
        _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_1,
        ___X2RemovalRequest_protocolIEs__item__id,
        ___X2RemovalRequest_protocolIEs__item__criticality,
        ___X2RemovalRequest_protocolIEs__item__value,
        __X2RemovalRequest_protocolIEs__item_,
        _X2RemovalRequest_protocolIEs,
        X2RemovalRequest,
        X2RemovalRequest_IEs,
        _X2RemovalRequest_IEs_val_Value_0,
        _X2RemovalRequest_IEs_val_Value_1,
        ____X2RemovalResponse_protocolIEs__item__id_tab,
        _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_0,
        _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_1,
        ___X2RemovalResponse_protocolIEs__item__id,
        ___X2RemovalResponse_protocolIEs__item__criticality,
        ___X2RemovalResponse_protocolIEs__item__value,
        __X2RemovalResponse_protocolIEs__item_,
        _X2RemovalResponse_protocolIEs,
        X2RemovalResponse,
        X2RemovalResponse_IEs,
        _X2RemovalResponse_IEs_val_Value_0,
        _X2RemovalResponse_IEs_val_Value_1,
        ____X2RemovalFailure_protocolIEs__item__id_tab,
        _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_0,
        _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_1,
        ___X2RemovalFailure_protocolIEs__item__id,
        ___X2RemovalFailure_protocolIEs__item__criticality,
        ___X2RemovalFailure_protocolIEs__item__value,
        __X2RemovalFailure_protocolIEs__item_,
        _X2RemovalFailure_protocolIEs,
        X2RemovalFailure,
        X2RemovalFailure_IEs,
        _X2RemovalFailure_IEs_val_Value_0,
        _X2RemovalFailure_IEs_val_Value_1,
        ____RetrieveUEContextRequest_protocolIEs__item__id_tab,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_4,
        ___RetrieveUEContextRequest_protocolIEs__item__id,
        ___RetrieveUEContextRequest_protocolIEs__item__criticality,
        ___RetrieveUEContextRequest_protocolIEs__item__value,
        __RetrieveUEContextRequest_protocolIEs__item_,
        _RetrieveUEContextRequest_protocolIEs,
        RetrieveUEContextRequest,
        RetrieveUEContextRequest_IEs,
        _RetrieveUEContextRequest_IEs_val_Value_0,
        _RetrieveUEContextRequest_IEs_val_Value_1,
        _RetrieveUEContextRequest_IEs_val_Value_2,
        _RetrieveUEContextRequest_IEs_val_Value_3,
        _RetrieveUEContextRequest_IEs_val_Value_4,
        ____RetrieveUEContextResponse_protocolIEs__item__id_tab,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_3,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_4,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_5,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_6,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_7,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_8,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_9,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_10,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_11,
        ___RetrieveUEContextResponse_protocolIEs__item__id,
        ___RetrieveUEContextResponse_protocolIEs__item__criticality,
        ___RetrieveUEContextResponse_protocolIEs__item__value,
        __RetrieveUEContextResponse_protocolIEs__item_,
        _RetrieveUEContextResponse_protocolIEs,
        RetrieveUEContextResponse,
        RetrieveUEContextResponse_IEs,
        _RetrieveUEContextResponse_IEs_val_Value_0,
        _RetrieveUEContextResponse_IEs_val_Value_1,
        _RetrieveUEContextResponse_IEs_val_Value_2,
        _RetrieveUEContextResponse_IEs_val_Value_3,
        _RetrieveUEContextResponse_IEs_val_Value_4,
        _RetrieveUEContextResponse_IEs_val_Value_5,
        _RetrieveUEContextResponse_IEs_val_Value_6,
        _RetrieveUEContextResponse_IEs_val_Value_7,
        _RetrieveUEContextResponse_IEs_val_Value_8,
        _RetrieveUEContextResponse_IEs_val_Value_9,
        _RetrieveUEContextResponse_IEs_val_Value_10,
        _RetrieveUEContextResponse_IEs_val_Value_11,
        _UE_ContextInformationRetrieve_mME_UE_S1AP_ID,
        _UE_ContextInformationRetrieve_uESecurityCapabilities,
        _UE_ContextInformationRetrieve_aS_SecurityInformation,
        _UE_ContextInformationRetrieve_uEaggregateMaximumBitRate,
        _UE_ContextInformationRetrieve_subscriberProfileIDforRFP,
        _UE_ContextInformationRetrieve_e_RABs_ToBeSetup_ListRetrieve,
        _UE_ContextInformationRetrieve_rRC_Context,
        _UE_ContextInformationRetrieve_handoverRestrictionList,
        _UE_ContextInformationRetrieve_locationReportingInformation,
        _UE_ContextInformationRetrieve_managBasedMDTallowed,
        _UE_ContextInformationRetrieve_managBasedMDTPLMNList,
        ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab,
        ___UE_ContextInformationRetrieve_iE_Extensions__item__id,
        ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality,
        ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue,
        __UE_ContextInformationRetrieve_iE_Extensions__item_,
        _UE_ContextInformationRetrieve_iE_Extensions,
        UE_ContextInformationRetrieve,
        UE_ContextInformationRetrieve_ExtIEs,
        ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab,
        ____E_RABs_ToBeSetup_ListRetrieve__item__id_tab_val_Value_0,
        __E_RABs_ToBeSetup_ListRetrieve__item__id,
        __E_RABs_ToBeSetup_ListRetrieve__item__criticality,
        __E_RABs_ToBeSetup_ListRetrieve__item__value,
        _E_RABs_ToBeSetup_ListRetrieve__item_,
        E_RABs_ToBeSetup_ListRetrieve,
        E_RABs_ToBeSetupRetrieve_ItemIEs,
        _E_RABs_ToBeSetupRetrieve_ItemIEs_val_Value_0,
        _E_RABs_ToBeSetupRetrieve_Item_e_RAB_ID,
        _E_RABs_ToBeSetupRetrieve_Item_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeSetupRetrieve_Item_bearerType,
        ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id,
        ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality,
        ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_,
        _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions,
        E_RABs_ToBeSetupRetrieve_Item,
        E_RABs_ToBeSetupRetrieve_ItemExtIEs,
        ____RetrieveUEContextFailure_protocolIEs__item__id_tab,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RetrieveUEContextFailure_protocolIEs__item__id,
        ___RetrieveUEContextFailure_protocolIEs__item__criticality,
        ___RetrieveUEContextFailure_protocolIEs__item__value,
        __RetrieveUEContextFailure_protocolIEs__item_,
        _RetrieveUEContextFailure_protocolIEs,
        RetrieveUEContextFailure,
        RetrieveUEContextFailure_IEs,
        _RetrieveUEContextFailure_IEs_val_Value_0,
        _RetrieveUEContextFailure_IEs_val_Value_1,
        _RetrieveUEContextFailure_IEs_val_Value_2,
        _RetrieveUEContextFailure_IEs_val_Value_3,
    ]

class X2AP_PDU_Descriptions:

    _name_  = u'X2AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 0]
    
    _obj_ = [
        u'X2AP-ELEMENTARY-PROCEDURE',
        u'X2AP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'X2AP-ELEMENTARY-PROCEDURES',
        u'X2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'X2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'handoverPreparation',
        u'snStatusTransfer',
        u'uEContextRelease',
        u'handoverCancel',
        u'handoverReport',
        u'errorIndication',
        u'reset',
        u'x2Setup',
        u'loadIndication',
        u'eNBConfigurationUpdate',
        u'resourceStatusReportingInitiation',
        u'resourceStatusReporting',
        u'rLFIndication',
        u'privateMessage',
        u'mobilitySettingsChange',
        u'cellActivation',
        u'x2Release',
        u'x2APMessageTransfer',
        u'seNBAdditionPreparation',
        u'seNBReconfigurationCompletion',
        u'meNBinitiatedSeNBModificationPreparation',
        u'seNBinitiatedSeNBModification',
        u'meNBinitiatedSeNBRelease',
        u'seNBinitiatedSeNBRelease',
        u'seNBCounterCheck',
        u'x2Removal',
        u'retrieveUEContext',
        ]
    _type_ = [
        u'X2AP-ELEMENTARY-PROCEDURE',
        u'X2AP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        ]
    _set_ = [
        u'X2AP-ELEMENTARY-PROCEDURES',
        u'X2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'X2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        u'handoverPreparation',
        u'snStatusTransfer',
        u'uEContextRelease',
        u'handoverCancel',
        u'handoverReport',
        u'errorIndication',
        u'reset',
        u'x2Setup',
        u'loadIndication',
        u'eNBConfigurationUpdate',
        u'resourceStatusReportingInitiation',
        u'resourceStatusReporting',
        u'rLFIndication',
        u'privateMessage',
        u'mobilitySettingsChange',
        u'cellActivation',
        u'x2Release',
        u'x2APMessageTransfer',
        u'seNBAdditionPreparation',
        u'seNBReconfigurationCompletion',
        u'meNBinitiatedSeNBModificationPreparation',
        u'seNBinitiatedSeNBModification',
        u'meNBinitiatedSeNBRelease',
        u'seNBinitiatedSeNBRelease',
        u'seNBCounterCheck',
        u'x2Removal',
        u'retrieveUEContext',
        ]
    _class_ = [
        u'X2AP-ELEMENTARY-PROCEDURE',
        u'X2AP-ELEMENTARY-PROCEDURES',
        u'X2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'X2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'handoverPreparation',
        u'snStatusTransfer',
        u'uEContextRelease',
        u'handoverCancel',
        u'handoverReport',
        u'errorIndication',
        u'reset',
        u'x2Setup',
        u'loadIndication',
        u'eNBConfigurationUpdate',
        u'resourceStatusReportingInitiation',
        u'resourceStatusReporting',
        u'rLFIndication',
        u'privateMessage',
        u'mobilitySettingsChange',
        u'cellActivation',
        u'x2Release',
        u'x2APMessageTransfer',
        u'seNBAdditionPreparation',
        u'seNBReconfigurationCompletion',
        u'meNBinitiatedSeNBModificationPreparation',
        u'seNBinitiatedSeNBModification',
        u'meNBinitiatedSeNBRelease',
        u'seNBinitiatedSeNBRelease',
        u'seNBCounterCheck',
        u'x2Removal',
        u'retrieveUEContext',
        ]
    _param_ = [
        ]
    
    #-----< X2AP-ELEMENTARY-PROCEDURE >-----#
    X2AP_ELEMENTARY_PROCEDURE = CLASS(name=u'X2AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _X2AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _X2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _X2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _X2AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _X2AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')), default=u'ignore')
    X2AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'procedureCode', _X2AP_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _X2AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< X2AP-PDU >-----#
    X2AP_PDU = CHOICE(name=u'X2AP-PDU', mode=MODE_TYPE)
    _X2AP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'InitiatingMessage')))
    _X2AP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _X2AP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    X2AP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _X2AP_PDU_initiatingMessage),
        (u'successfulOutcome', _X2AP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _X2AP_PDU_unsuccessfulOutcome),
        ])
    X2AP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_X2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 15), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 19), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9), (u'procedureCode', 22), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 24), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 18), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 25), (u'criticality', u'reject')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_X2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 15), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 19), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), (u'procedureCode', 22), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 24), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 18), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 25), (u'criticality', u'reject')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_X2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 15), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), (u'procedureCode', 19), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), (u'procedureCode', 22), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 24), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 18), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 25), (u'criticality', u'reject')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< X2AP-ELEMENTARY-PROCEDURES >-----#
    X2AP_ELEMENTARY_PROCEDURES = CLASS(name=u'X2AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    X2AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), (u'procedureCode', 15), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), (u'procedureCode', 19), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9), (u'procedureCode', 22), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), (u'procedureCode', 24), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), (u'procedureCode', 18), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), (u'procedureCode', 26), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), (u'procedureCode', 25), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< X2AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    X2AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'X2AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    X2AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), (u'procedureCode', 12), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), (u'procedureCode', 15), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), (u'procedureCode', 19), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), (u'procedureCode', 22), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'procedureCode', 24), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), (u'procedureCode', 18), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), (u'SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), (u'procedureCode', 26), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< X2AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    X2AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'X2AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    X2AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 5), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 1), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), (u'procedureCode', 25), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< handoverPreparation >-----#
    handoverPreparation = CLASS(name=u'handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    _handoverPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _handoverPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    handoverPreparation._val = dict([(u'InitiatingMessage', _handoverPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _handoverPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 0), (u'criticality', u'reject')])
    
    #-----< snStatusTransfer >-----#
    snStatusTransfer = CLASS(name=u'snStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _snStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    snStatusTransfer._val = dict([(u'InitiatingMessage', _snStatusTransfer_val_InitiatingMessage), (u'procedureCode', 4), (u'criticality', u'ignore')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name=u'uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    uEContextRelease._val = dict([(u'InitiatingMessage', _uEContextRelease_val_InitiatingMessage), (u'procedureCode', 5), (u'criticality', u'ignore')])
    
    #-----< handoverCancel >-----#
    handoverCancel = CLASS(name=u'handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    handoverCancel._val = dict([(u'InitiatingMessage', _handoverCancel_val_InitiatingMessage), (u'procedureCode', 1), (u'criticality', u'ignore')])
    
    #-----< handoverReport >-----#
    handoverReport = CLASS(name=u'handoverReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    handoverReport._val = dict([(u'InitiatingMessage', _handoverReport_val_InitiatingMessage), (u'procedureCode', 14), (u'criticality', u'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 3), (u'criticality', u'ignore')])
    
    #-----< reset >-----#
    reset = CLASS(name=u'reset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    _reset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    reset._val = dict([(u'InitiatingMessage', _reset_val_InitiatingMessage), (u'SuccessfulOutcome', _reset_val_SuccessfulOutcome), (u'procedureCode', 7), (u'criticality', u'reject')])
    
    #-----< x2Setup >-----#
    x2Setup = CLASS(name=u'x2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2Setup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    _x2Setup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    _x2Setup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    x2Setup._val = dict([(u'InitiatingMessage', _x2Setup_val_InitiatingMessage), (u'SuccessfulOutcome', _x2Setup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _x2Setup_val_UnsuccessfulOutcome), (u'procedureCode', 6), (u'criticality', u'reject')])
    
    #-----< loadIndication >-----#
    loadIndication = CLASS(name=u'loadIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _loadIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    loadIndication._val = dict([(u'InitiatingMessage', _loadIndication_val_InitiatingMessage), (u'procedureCode', 2), (u'criticality', u'ignore')])
    
    #-----< eNBConfigurationUpdate >-----#
    eNBConfigurationUpdate = CLASS(name=u'eNBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _eNBConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _eNBConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _eNBConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    eNBConfigurationUpdate._val = dict([(u'InitiatingMessage', _eNBConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _eNBConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _eNBConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 8), (u'criticality', u'reject')])
    
    #-----< resourceStatusReportingInitiation >-----#
    resourceStatusReportingInitiation = CLASS(name=u'resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReportingInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    _resourceStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    _resourceStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    resourceStatusReportingInitiation._val = dict([(u'InitiatingMessage', _resourceStatusReportingInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _resourceStatusReportingInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _resourceStatusReportingInitiation_val_UnsuccessfulOutcome), (u'procedureCode', 9), (u'criticality', u'reject')])
    
    #-----< resourceStatusReporting >-----#
    resourceStatusReporting = CLASS(name=u'resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    resourceStatusReporting._val = dict([(u'InitiatingMessage', _resourceStatusReporting_val_InitiatingMessage), (u'procedureCode', 10), (u'criticality', u'ignore')])
    
    #-----< rLFIndication >-----#
    rLFIndication = CLASS(name=u'rLFIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _rLFIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    rLFIndication._val = dict([(u'InitiatingMessage', _rLFIndication_val_InitiatingMessage), (u'procedureCode', 13), (u'criticality', u'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 11), (u'criticality', u'ignore')])
    
    #-----< mobilitySettingsChange >-----#
    mobilitySettingsChange = CLASS(name=u'mobilitySettingsChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _mobilitySettingsChange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    _mobilitySettingsChange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    _mobilitySettingsChange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    mobilitySettingsChange._val = dict([(u'InitiatingMessage', _mobilitySettingsChange_val_InitiatingMessage), (u'SuccessfulOutcome', _mobilitySettingsChange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _mobilitySettingsChange_val_UnsuccessfulOutcome), (u'procedureCode', 12), (u'criticality', u'reject')])
    
    #-----< cellActivation >-----#
    cellActivation = CLASS(name=u'cellActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _cellActivation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    _cellActivation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    _cellActivation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    cellActivation._val = dict([(u'InitiatingMessage', _cellActivation_val_InitiatingMessage), (u'SuccessfulOutcome', _cellActivation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _cellActivation_val_UnsuccessfulOutcome), (u'procedureCode', 15), (u'criticality', u'reject')])
    
    #-----< x2Release >-----#
    x2Release = CLASS(name=u'x2Release', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2Release_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    x2Release._val = dict([(u'InitiatingMessage', _x2Release_val_InitiatingMessage), (u'procedureCode', 16), (u'criticality', u'reject')])
    
    #-----< x2APMessageTransfer >-----#
    x2APMessageTransfer = CLASS(name=u'x2APMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2APMessageTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    x2APMessageTransfer._val = dict([(u'InitiatingMessage', _x2APMessageTransfer_val_InitiatingMessage), (u'procedureCode', 17), (u'criticality', u'reject')])
    
    #-----< seNBAdditionPreparation >-----#
    seNBAdditionPreparation = CLASS(name=u'seNBAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBAdditionPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    _seNBAdditionPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    _seNBAdditionPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    seNBAdditionPreparation._val = dict([(u'InitiatingMessage', _seNBAdditionPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _seNBAdditionPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _seNBAdditionPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 19), (u'criticality', u'reject')])
    
    #-----< seNBReconfigurationCompletion >-----#
    seNBReconfigurationCompletion = CLASS(name=u'seNBReconfigurationCompletion', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBReconfigurationCompletion_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    seNBReconfigurationCompletion._val = dict([(u'InitiatingMessage', _seNBReconfigurationCompletion_val_InitiatingMessage), (u'procedureCode', 20), (u'criticality', u'ignore')])
    
    #-----< meNBinitiatedSeNBModificationPreparation >-----#
    meNBinitiatedSeNBModificationPreparation = CLASS(name=u'meNBinitiatedSeNBModificationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _meNBinitiatedSeNBModificationPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    _meNBinitiatedSeNBModificationPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    _meNBinitiatedSeNBModificationPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    meNBinitiatedSeNBModificationPreparation._val = dict([(u'InitiatingMessage', _meNBinitiatedSeNBModificationPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _meNBinitiatedSeNBModificationPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _meNBinitiatedSeNBModificationPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 21), (u'criticality', u'reject')])
    
    #-----< seNBinitiatedSeNBModification >-----#
    seNBinitiatedSeNBModification = CLASS(name=u'seNBinitiatedSeNBModification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBinitiatedSeNBModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    _seNBinitiatedSeNBModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    _seNBinitiatedSeNBModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    seNBinitiatedSeNBModification._val = dict([(u'InitiatingMessage', _seNBinitiatedSeNBModification_val_InitiatingMessage), (u'SuccessfulOutcome', _seNBinitiatedSeNBModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _seNBinitiatedSeNBModification_val_UnsuccessfulOutcome), (u'procedureCode', 22), (u'criticality', u'reject')])
    
    #-----< meNBinitiatedSeNBRelease >-----#
    meNBinitiatedSeNBRelease = CLASS(name=u'meNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _meNBinitiatedSeNBRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    meNBinitiatedSeNBRelease._val = dict([(u'InitiatingMessage', _meNBinitiatedSeNBRelease_val_InitiatingMessage), (u'procedureCode', 23), (u'criticality', u'ignore')])
    
    #-----< seNBinitiatedSeNBRelease >-----#
    seNBinitiatedSeNBRelease = CLASS(name=u'seNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBinitiatedSeNBRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    _seNBinitiatedSeNBRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    seNBinitiatedSeNBRelease._val = dict([(u'InitiatingMessage', _seNBinitiatedSeNBRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _seNBinitiatedSeNBRelease_val_SuccessfulOutcome), (u'procedureCode', 24), (u'criticality', u'reject')])
    
    #-----< seNBCounterCheck >-----#
    seNBCounterCheck = CLASS(name=u'seNBCounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBCounterCheck_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    seNBCounterCheck._val = dict([(u'InitiatingMessage', _seNBCounterCheck_val_InitiatingMessage), (u'procedureCode', 25), (u'criticality', u'reject')])
    
    #-----< x2Removal >-----#
    x2Removal = CLASS(name=u'x2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2Removal_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    _x2Removal_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    _x2Removal_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    x2Removal._val = dict([(u'InitiatingMessage', _x2Removal_val_InitiatingMessage), (u'SuccessfulOutcome', _x2Removal_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _x2Removal_val_UnsuccessfulOutcome), (u'procedureCode', 18), (u'criticality', u'reject')])
    
    #-----< retrieveUEContext >-----#
    retrieveUEContext = CLASS(name=u'retrieveUEContext', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _retrieveUEContext_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    _retrieveUEContext_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    _retrieveUEContext_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    retrieveUEContext._val = dict([(u'InitiatingMessage', _retrieveUEContext_val_InitiatingMessage), (u'SuccessfulOutcome', _retrieveUEContext_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _retrieveUEContext_val_UnsuccessfulOutcome), (u'procedureCode', 26), (u'criticality', u'reject')])
    
    _all_ = [
        _X2AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _X2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _X2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _X2AP_ELEMENTARY_PROCEDURE_procedureCode,
        _X2AP_ELEMENTARY_PROCEDURE_criticality,
        X2AP_ELEMENTARY_PROCEDURE,
        _X2AP_PDU_initiatingMessage,
        _X2AP_PDU_successfulOutcome,
        _X2AP_PDU_unsuccessfulOutcome,
        X2AP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        X2AP_ELEMENTARY_PROCEDURES,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        X2AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        X2AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        handoverPreparation,
        _handoverPreparation_val_InitiatingMessage,
        _handoverPreparation_val_SuccessfulOutcome,
        _handoverPreparation_val_UnsuccessfulOutcome,
        snStatusTransfer,
        _snStatusTransfer_val_InitiatingMessage,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        handoverCancel,
        _handoverCancel_val_InitiatingMessage,
        handoverReport,
        _handoverReport_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        x2Setup,
        _x2Setup_val_InitiatingMessage,
        _x2Setup_val_SuccessfulOutcome,
        _x2Setup_val_UnsuccessfulOutcome,
        loadIndication,
        _loadIndication_val_InitiatingMessage,
        eNBConfigurationUpdate,
        _eNBConfigurationUpdate_val_InitiatingMessage,
        _eNBConfigurationUpdate_val_SuccessfulOutcome,
        _eNBConfigurationUpdate_val_UnsuccessfulOutcome,
        resourceStatusReportingInitiation,
        _resourceStatusReportingInitiation_val_InitiatingMessage,
        _resourceStatusReportingInitiation_val_SuccessfulOutcome,
        _resourceStatusReportingInitiation_val_UnsuccessfulOutcome,
        resourceStatusReporting,
        _resourceStatusReporting_val_InitiatingMessage,
        rLFIndication,
        _rLFIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        mobilitySettingsChange,
        _mobilitySettingsChange_val_InitiatingMessage,
        _mobilitySettingsChange_val_SuccessfulOutcome,
        _mobilitySettingsChange_val_UnsuccessfulOutcome,
        cellActivation,
        _cellActivation_val_InitiatingMessage,
        _cellActivation_val_SuccessfulOutcome,
        _cellActivation_val_UnsuccessfulOutcome,
        x2Release,
        _x2Release_val_InitiatingMessage,
        x2APMessageTransfer,
        _x2APMessageTransfer_val_InitiatingMessage,
        seNBAdditionPreparation,
        _seNBAdditionPreparation_val_InitiatingMessage,
        _seNBAdditionPreparation_val_SuccessfulOutcome,
        _seNBAdditionPreparation_val_UnsuccessfulOutcome,
        seNBReconfigurationCompletion,
        _seNBReconfigurationCompletion_val_InitiatingMessage,
        meNBinitiatedSeNBModificationPreparation,
        _meNBinitiatedSeNBModificationPreparation_val_InitiatingMessage,
        _meNBinitiatedSeNBModificationPreparation_val_SuccessfulOutcome,
        _meNBinitiatedSeNBModificationPreparation_val_UnsuccessfulOutcome,
        seNBinitiatedSeNBModification,
        _seNBinitiatedSeNBModification_val_InitiatingMessage,
        _seNBinitiatedSeNBModification_val_SuccessfulOutcome,
        _seNBinitiatedSeNBModification_val_UnsuccessfulOutcome,
        meNBinitiatedSeNBRelease,
        _meNBinitiatedSeNBRelease_val_InitiatingMessage,
        seNBinitiatedSeNBRelease,
        _seNBinitiatedSeNBRelease_val_InitiatingMessage,
        _seNBinitiatedSeNBRelease_val_SuccessfulOutcome,
        seNBCounterCheck,
        _seNBCounterCheck_val_InitiatingMessage,
        x2Removal,
        _x2Removal_val_InitiatingMessage,
        _x2Removal_val_SuccessfulOutcome,
        _x2Removal_val_UnsuccessfulOutcome,
        retrieveUEContext,
        _retrieveUEContext_val_InitiatingMessage,
        _retrieveUEContext_val_SuccessfulOutcome,
        _retrieveUEContext_val_UnsuccessfulOutcome,
    ]

init_modules(X2AP_CommonDataTypes, X2AP_Constants, X2AP_Containers, X2AP_IEs, X2AP_PDU_Contents, X2AP_PDU_Descriptions)
